
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


// AlgoDlg.cpp : implementation file
//




#include "stdafx.h"
#include "FractMus.h"
#include "AlgoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAlgoDlg dialog


CAlgoDlg::CAlgoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAlgoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAlgoDlg)
	m_ginger = TRUE;
	m_henon = TRUE;
	m_hopalong = TRUE;
	m_logmap = TRUE;
	m_lorentz = TRUE;
	m_martin = TRUE;
	m_morsethue = TRUE;
	m_noise = TRUE;
	m_random = TRUE;
	m_wolfram = TRUE;
	m_hailstone = TRUE;
	m_earthworm = TRUE;
	//}}AFX_DATA_INIT

	numchoices = 12;
}


void CAlgoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAlgoDlg)
	DDX_Check(pDX, IDC_GINGER_CHK, m_ginger);
	DDX_Check(pDX, IDC_HENON_CHK, m_henon);
	DDX_Check(pDX, IDC_HOPALONG_CHK, m_hopalong);
	DDX_Check(pDX, IDC_LOGMAP_CHK, m_logmap);
	DDX_Check(pDX, IDC_LORENZ_CHK, m_lorentz);
	DDX_Check(pDX, IDC_MARTIN_CHK, m_martin);
	DDX_Check(pDX, IDC_MORSETHUE_CHK, m_morsethue);
	DDX_Check(pDX, IDC_NOISE_CHK, m_noise);
	DDX_Check(pDX, IDC_RANDOM_CHK, m_random);
	DDX_Check(pDX, IDC_WOLFRAM_CHK, m_wolfram);
	DDX_Check(pDX, IDC_HAILSTONE_CHK, m_hailstone);
	DDX_Check(pDX, IDC_EARTHWORM_CHK, m_earthworm);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAlgoDlg, CDialog)
	//{{AFX_MSG_MAP(CAlgoDlg)
	ON_BN_CLICKED(IDC_HENON_CHK, OnHenonChk)
	ON_BN_CLICKED(IDC_HOPALONG_CHK, OnHopalongChk)
	ON_BN_CLICKED(IDC_LOGMAP_CHK, OnLogmapChk)
	ON_BN_CLICKED(IDC_LORENZ_CHK, OnLorenzChk)
	ON_BN_CLICKED(IDC_MARTIN_CHK, OnMartinChk)
	ON_BN_CLICKED(IDC_MORSETHUE_CHK, OnMorsethueChk)
	ON_BN_CLICKED(IDC_NOISE_CHK, OnNoiseChk)
	ON_BN_CLICKED(IDC_GINGER_CHK, OnGingerChk)
	ON_BN_CLICKED(IDC_ALL, OnAll)
	ON_BN_CLICKED(IDC_NONE, OnNone)
	ON_BN_CLICKED(IDC_EARTHWORM_CHK, OnEarthwormChk)
	ON_BN_CLICKED(IDC_HAILSTONE_CHK, OnHailstoneChk)
	ON_BN_CLICKED(IDC_RANDOM_CHK, OnRandomChk)
	ON_BN_CLICKED(IDC_WOLFRAM_CHK, OnWolframChk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAlgoDlg message handlers

void CAlgoDlg::OnCancel() 
{
	
}

void CAlgoDlg::OnHenonChk() 
{
	UpdateData();

	numchoices = m_henon ? ++numchoices : --numchoices;
	
}

void CAlgoDlg::OnHopalongChk() 
{
	UpdateData();

	numchoices = m_hopalong ? ++numchoices : --numchoices;
	
}

void CAlgoDlg::OnLogmapChk() 
{
	UpdateData();

	numchoices = m_logmap ? ++numchoices : --numchoices;
	
}

void CAlgoDlg::OnLorenzChk() 
{
	UpdateData();

	numchoices = m_lorentz ? ++numchoices : --numchoices;
	
}

void CAlgoDlg::OnMartinChk() 
{
	UpdateData();

	numchoices = m_martin ? ++numchoices : --numchoices;
	
}

void CAlgoDlg::OnMorsethueChk() 
{
	UpdateData();

	numchoices = m_morsethue ? ++numchoices : --numchoices;
	
}

void CAlgoDlg::OnNoiseChk() 
{
	UpdateData();

	numchoices = m_noise ? ++numchoices : --numchoices;
	
}

void CAlgoDlg::OnGingerChk() 
{
	UpdateData();

	numchoices = m_ginger ? ++numchoices : --numchoices;
	
}

void CAlgoDlg::OnOK() 
{
	if (numchoices<1)
	{
		MessageBox("Please choose at least one algorithm", "Error", MB_OK+MB_ICONEXCLAMATION);
		return;
	}
	
	CDialog::OnOK();
}

void CAlgoDlg::OnAll() 
{
	m_ginger = TRUE;
	m_henon = TRUE;
	m_hopalong = TRUE;
	m_logmap = TRUE;
	m_lorentz = TRUE;
	m_martin = TRUE;
	m_morsethue = TRUE;
	m_noise = TRUE;
	m_random = TRUE;
	m_wolfram = TRUE;
	m_hailstone = TRUE;
	m_earthworm = TRUE;

	UpdateData(FALSE);

	numchoices = 12;
	
}

void CAlgoDlg::OnNone() 
{
	m_ginger = FALSE;
	m_henon = FALSE;
	m_hopalong = FALSE;
	m_logmap = FALSE;
	m_lorentz = FALSE;
	m_martin = FALSE;
	m_morsethue = FALSE;
	m_noise = FALSE;
	m_random = FALSE;
	m_wolfram = FALSE;
	m_hailstone = FALSE;
	m_earthworm = FALSE;

	UpdateData(FALSE);

	numchoices = 0;
	
}

void CAlgoDlg::OnEarthwormChk() 
{
	UpdateData();

	numchoices = m_earthworm ? ++numchoices : --numchoices;
	
}

void CAlgoDlg::OnHailstoneChk() 
{
	UpdateData();

	numchoices = m_hailstone ? ++numchoices : --numchoices;
	
}

void CAlgoDlg::OnRandomChk() 
{
	UpdateData();

	numchoices = m_random ? ++numchoices : --numchoices;
	
}

void CAlgoDlg::OnWolframChk() 
{
	UpdateData();

	numchoices = m_wolfram ? ++numchoices : --numchoices;
	
}
