
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


#ifndef _ALGO_H
#define _ALGO_H

// AlgoDlg.h : header file 
//

/////////////////////////////////////////////////////////////////////////////
// CAlgoDlg dialog



class CAlgoDlg : public CDialog
{
// Construction
public:
	CAlgoDlg(CWnd* pParent = NULL);   // standard constructor

	int numchoices;

// Dialog Data
	//{{AFX_DATA(CAlgoDlg)
	enum { IDD = IDD_ALGO_DLG };
	BOOL	m_ginger;
	BOOL	m_henon;
	BOOL	m_hopalong;
	BOOL	m_logmap;
	BOOL	m_lorentz;
	BOOL	m_martin;
	BOOL	m_morsethue;
	BOOL	m_noise;
	BOOL	m_random;
	BOOL	m_wolfram;
	BOOL	m_hailstone;
	BOOL	m_earthworm;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAlgoDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CAlgoDlg)
	virtual void OnCancel();
	afx_msg void OnHenonChk();
	afx_msg void OnHopalongChk();
	afx_msg void OnLogmapChk();
	afx_msg void OnLorenzChk();
	afx_msg void OnMartinChk();
	afx_msg void OnMorsethueChk();
	afx_msg void OnNoiseChk();
	afx_msg void OnGingerChk();
	virtual void OnOK();
	afx_msg void OnAll();
	afx_msg void OnNone();
	afx_msg void OnEarthwormChk();
	afx_msg void OnHailstoneChk();
	afx_msg void OnRandomChk();
	afx_msg void OnWolframChk();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif
