
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


// ChangePassword.cpp : implementation file
//



#include "stdafx.h"
#include "FractMus.h"
#include "ChangePassword.h"
#include "FractMusView.h"
#include "FractMusDoc.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChangePassword dialog


CChangePassword::CChangePassword(CWnd* pParent /*=NULL*/)
	: CDialog(CChangePassword::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChangePassword)
	m_copyright = _T("");
	m_newpassword = _T("");
	m_oldpassword = _T("");
	m_retypepassword = _T("");
	//}}AFX_DATA_INIT
}


void CChangePassword::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChangePassword)
	DDX_Text(pDX, IDC_COPYRIGHT, m_copyright);
	DDV_MaxChars(pDX, m_copyright, 64);
	DDX_Text(pDX, IDC_NEWPASS, m_newpassword);
	DDV_MaxChars(pDX, m_newpassword, 8);
	DDX_Text(pDX, IDC_OLDPASS, m_oldpassword);
	DDV_MaxChars(pDX, m_oldpassword, 8);
	DDX_Text(pDX, IDC_RETYPEPASS, m_retypepassword);
	DDV_MaxChars(pDX, m_retypepassword, 8);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CChangePassword, CDialog)
	//{{AFX_MSG_MAP(CChangePassword)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChangePassword message handlers

BOOL CChangePassword::OnInitDialog() 
{
	CDialog::OnInitDialog();

	CFractMusDoc* pDoc = pView->GetDocument();

	m_copyright = pDoc->m_Copyright;

	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CChangePassword::OnOK() 
{
	if(!UpdateData(TRUE))
		return;

	CFractMusDoc* pDoc = pView->GetDocument();

	if (m_oldpassword!=pDoc->m_Password)
	{
		MessageBox("The password you entered is incorrect!","FractMus", MB_OK+MB_ICONEXCLAMATION);
		return;
	}

	if ((pDoc->m_Password!="")&&(m_newpassword.GetLength()<3)&&(m_newpassword!=""))
	{
		MessageBox("Passwords have to have at least 3 characters","FractMus", MB_OK+MB_ICONEXCLAMATION);
		return;
	}

	if (m_newpassword!=m_retypepassword)
	{
		MessageBox("Passwords do not match, please recheck!", "FractMus", MB_OK+MB_ICONEXCLAMATION);
		return;
	}

	pDoc->m_Password = m_newpassword;
	pDoc->m_Copyright = m_copyright;

	CDialog::OnOK();
}

void CChangePassword::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}
