
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


#ifndef _CHANGES_H
#define _CHANGES_H
// ChangesDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CChangesDlg dialog

#include "V1UsrSclDlg.h"
#include "defs.h"

class CFractMusView;

class CChangesDlg : public CDialog
{
// Construction
public:
	CChangesDlg(CWnd* pParent = NULL);   // standard constructor
	~CChangesDlg();


	CFractMusView* pView;
	int* UserScale;
	CV1UsrSclDlg UsrScl;
	BOOL* IsSelected;

	BOOL	m_VoiceOn[MAXVOICES];
	UINT	m_VoiceID[MAXVOICES];

	BOOL	m_ModulRandom;
	int		m_ModulNum;
	float	m_LogMapVar;
	float	m_FNoiseVar;
	float	m_HenonA;
	float	m_HenonB;
	float	m_HopalongVar;
	float	m_MartinVar;
	float	m_GingerX;
	float	m_GingerY;
	float	m_LorentzVar;
	unsigned long m_EarthWormVar;
	unsigned long m_EarthWormMulti;
	unsigned m_EarthWormTruncator;
	double	m_RandomMin;
	double	m_RandomMax;

	BYTE	m_WolframRule;
	unsigned long m_WolframInit;
	int	m_WolframSize;
	long	m_Hailstone;
	int		m_othernoteval;


	void InitUserScale();
	void SetUserScale();


// Dialog Data
	//{{AFX_DATA(CChangesDlg)
	enum { IDD = IDD_GLOBAL_DLG };
	BOOL	m_bAlgorithm;
	BOOL	m_bCoeff;
	BOOL	m_bDynamic;
	BOOL	m_bInstrument;
	BOOL	m_bInverted;
	BOOL	m_bMatch;
	BOOL	m_bMode;
	BOOL	m_bModulate;
	BOOL	m_Modulates;
	BOOL	m_bNote;
	BOOL	m_bNoteval;
	BOOL	m_bOctaves;
	BOOL	m_bPan;
	long	m_Base;
	long	m_Multi;
	BOOL	m_bScale;
	int		m_Dynamic;
	int		m_Pan;
	BOOL	m_Inverted;
	BOOL	m_MatchScale;
	BOOL	m_bPercussion;
	int		m_voiceonoff;
	BOOL	m_AllActiveVoices;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CChangesDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CChangesDlg)
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	afx_msg void OnEvents();
	afx_msg void OnEventAll();
	afx_msg void OnEventNone();
	afx_msg void OnAlgorithmChk();
	afx_msg void OnCoefficientChk();
	afx_msg void OnDynamicChk();
	afx_msg void OnInstrumentChk();
	afx_msg void OnInvChk();
	afx_msg void OnMatchChk();
	afx_msg void OnModeChk();
	afx_msg void OnModulChk();
	afx_msg void OnModulateChk();
	afx_msg void OnNoteChk();
	afx_msg void OnNotevalChk();
	afx_msg void OnOctavesChk();
	afx_msg void OnPanChk();
	afx_msg void OnScaleChk();
	afx_msg void OnAll();
	afx_msg void OnNone();
	afx_msg void OnCoeffButt();
	afx_msg void OnCloseupScaleCombo();
	afx_msg void OnSettings();
	afx_msg void OnCloseupNotevalueCombo();
	afx_msg void OnInverted();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnPanZero();
	afx_msg void OnPercussionChk();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


#endif
