
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


// CommentsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FractMus.h"
#include "CommentsDlg.h"
#include "FractMusView.h"
#include "FractMusDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCommentsDlg dialog


CCommentsDlg::CCommentsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCommentsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCommentsDlg)
	m_comment = _T("");
	//}}AFX_DATA_INIT
}


void CCommentsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCommentsDlg)
	DDX_Text(pDX, IDC_COMMENTS_ED, m_comment);
	DDV_MaxChars(pDX, m_comment, 1024);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCommentsDlg, CDialog)
	//{{AFX_MSG_MAP(CCommentsDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCommentsDlg message handlers

void CCommentsDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CCommentsDlg::OnOK() 
{
	if(!UpdateData())
		return;

	CFractMusDoc* pDoc = pView->GetDocument();

	if (m_comment!=pDoc->m_Comment)
	{

		UINT id = MessageBox("Save changes","FractMus", MB_YESNOCANCEL+MB_ICONQUESTION);


		if (id == IDYES)
		{
			pDoc->m_Comment = m_comment;
			pDoc->SetModifiedFlag(TRUE);
			CDialog::OnOK();
		}
		else if (id == IDNO)
			CDialog::OnOK();
	}
	else
		CDialog::OnOK();


	
}


BOOL CCommentsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CFractMusDoc* pDoc = pView->GetDocument();

	m_comment = pDoc->m_Comment;

	UpdateData(FALSE);

	GetDlgItem(IDOK)->EnableWindow(m_canedit);
	CEdit* pE = (CEdit*)GetDlgItem(IDC_COMMENTS_ED);

	pE->SetReadOnly(!m_canedit);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

