// CountDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FractMus.h"
#include "FractMusView.h"
#include "CountDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCountDlg dialog

extern BOOL m_Playing;
extern BOOL m_Rewinding;
extern BOOL m_FastForwarding;



CCountDlg::CCountDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCountDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCountDlg)
	m_VoiceChoice = 0;
	//}}AFX_DATA_INIT

	for(int i=VOICE1; i<MAXVOICES; i++)
	{
		m_Counter[i] = 0;
	}

	m_pParent = pParent;
	m_nID = CCountDlg::IDD;
	m_IsActive = FALSE;

	m_CounterID[VOICE1] = IDC_COUNTERS_V1_ED;
	m_CounterID[VOICE2] = IDC_COUNTERS_V2_ED;
	m_CounterID[VOICE3] = IDC_COUNTERS_V3_ED;
	m_CounterID[VOICE4] = IDC_COUNTERS_V4_ED;
	m_CounterID[VOICE5] = IDC_COUNTERS_V5_ED;
	m_CounterID[VOICE6] = IDC_COUNTERS_V6_ED;
	m_CounterID[VOICE7] = IDC_COUNTERS_V7_ED;
	m_CounterID[VOICE8] = IDC_COUNTERS_V8_ED;
}


void CCountDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCountDlg)
	DDX_Radio(pDX, IDC_V1_RAD, m_VoiceChoice);
	//}}AFX_DATA_MAP

	DDX_Text(pDX, IDC_COUNTERS_V1_ED, m_Counter[VOICE1]);
	DDV_MinMaxLong(pDX, m_Counter[VOICE1], 0, 1000000000);

	DDX_Text(pDX, IDC_COUNTERS_V2_ED, m_Counter[VOICE2]);
	DDV_MinMaxLong(pDX, m_Counter[VOICE2], 0, 1000000000);

	DDX_Text(pDX, IDC_COUNTERS_V3_ED, m_Counter[VOICE3]);
	DDV_MinMaxLong(pDX, m_Counter[VOICE3], 0, 1000000000);

	DDX_Text(pDX, IDC_COUNTERS_V4_ED, m_Counter[VOICE4]);
	DDV_MinMaxLong(pDX, m_Counter[VOICE4], 0, 1000000000);

	DDX_Text(pDX, IDC_COUNTERS_V5_ED, m_Counter[VOICE5]);
	DDV_MinMaxLong(pDX, m_Counter[VOICE5], 0, 1000000000);

	DDX_Text(pDX, IDC_COUNTERS_V6_ED, m_Counter[VOICE6]);
	DDV_MinMaxLong(pDX, m_Counter[VOICE6], 0, 1000000000);

	DDX_Text(pDX, IDC_COUNTERS_V7_ED, m_Counter[VOICE7]);
	DDV_MinMaxLong(pDX, m_Counter[VOICE7], 0, 1000000000);

	DDX_Text(pDX, IDC_COUNTERS_V8_ED, m_Counter[VOICE8]);
	DDV_MinMaxLong(pDX, m_Counter[VOICE8], 0, 1000000000);
	

}


BEGIN_MESSAGE_MAP(CCountDlg, CDialog)
	//{{AFX_MSG_MAP(CCountDlg)
	ON_BN_CLICKED(IDC_CLOSE, OnClose)
	ON_EN_KILLFOCUS(IDC_COUNTERS_V1_ED, OnKillfocusCountersV1Ed)
	ON_EN_KILLFOCUS(IDC_COUNTERS_V2_ED, OnKillfocusCountersV2Ed)
	ON_EN_KILLFOCUS(IDC_COUNTERS_V3_ED, OnKillfocusCountersV3Ed)
	ON_EN_KILLFOCUS(IDC_COUNTERS_V4_ED, OnKillfocusCountersV4Ed)
	ON_EN_KILLFOCUS(IDC_COUNTERS_V5_ED, OnKillfocusCountersV5Ed)
	ON_EN_KILLFOCUS(IDC_COUNTERS_V6_ED, OnKillfocusCountersV6Ed)
	ON_EN_KILLFOCUS(IDC_COUNTERS_V7_ED, OnKillfocusCountersV7Ed)
	ON_EN_KILLFOCUS(IDC_COUNTERS_V8_ED, OnKillfocusCountersV8Ed)
	ON_BN_CLICKED(IDC_EQUALIZE, OnEqualize)
	ON_BN_CLICKED(IDC_START, OnStart)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCountDlg message handlers

BOOL CCountDlg::Create()
{
	return CDialog::Create(m_nID, m_pParent);
}


void CCountDlg::OnClose() 
{
	CFractMusView* pView = (CFractMusView*)m_pParent;
	if(!UpdateData(TRUE))
		return;

	((CFractMusView*)m_pParent)->CountersDone();
	DestroyWindow();
	
}

void CCountDlg::PostNcDestroy() 
{
	delete this;
	
}


BOOL CCountDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	CMenu* pM = this->GetSystemMenu(FALSE);

	ASSERT(pM!=NULL);

	pM->EnableMenuItem(SC_CLOSE, MF_GRAYED);
	pM->EnableMenuItem(SC_SIZE, MF_GRAYED);
	pM->EnableMenuItem(SC_MAXIMIZE, MF_GRAYED);

	
	CFractMusView* pView = (CFractMusView*)m_pParent;
	CFractMusDoc* pDoc = pView->GetDocument();

	for (int i = VOICE1; i<MAXVOICES; i++)
			m_Counter[i] = pDoc->m_Counter[i];

	UpdateData(FALSE);

	GetDlgItem(IDC_EQUALIZE)->EnableWindow(!m_Playing);


	GetDlgItem(IDC_V1_RAD)->EnableWindow(pView->m_IsActive[VOICE1]);
	GetDlgItem(IDC_COUNTERS_V1_ED)->EnableWindow(pView->m_IsActive[VOICE1]);

	GetDlgItem(IDC_V2_RAD)->EnableWindow(pView->m_IsActive[VOICE2]);
	GetDlgItem(IDC_COUNTERS_V2_ED)->EnableWindow(pView->m_IsActive[VOICE2]);

	GetDlgItem(IDC_V3_RAD)->EnableWindow(pView->m_IsActive[VOICE3]);
	GetDlgItem(IDC_COUNTERS_V3_ED)->EnableWindow(pView->m_IsActive[VOICE3]);

	GetDlgItem(IDC_V4_RAD)->EnableWindow(pView->m_IsActive[VOICE4]);
	GetDlgItem(IDC_COUNTERS_V4_ED)->EnableWindow(pView->m_IsActive[VOICE4]);

	GetDlgItem(IDC_V5_RAD)->EnableWindow(pView->m_IsActive[VOICE5]);
	GetDlgItem(IDC_COUNTERS_V5_ED)->EnableWindow(pView->m_IsActive[VOICE5]);

	GetDlgItem(IDC_V6_RAD)->EnableWindow(pView->m_IsActive[VOICE6]);
	GetDlgItem(IDC_COUNTERS_V6_ED)->EnableWindow(pView->m_IsActive[VOICE6]);

	GetDlgItem(IDC_V7_RAD)->EnableWindow(pView->m_IsActive[VOICE7]);
	GetDlgItem(IDC_COUNTERS_V7_ED)->EnableWindow(pView->m_IsActive[VOICE7]);

	GetDlgItem(IDC_V8_RAD)->EnableWindow(pView->m_IsActive[VOICE8]);
	GetDlgItem(IDC_COUNTERS_V8_ED)->EnableWindow(pView->m_IsActive[VOICE8]);

	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CCountDlg::UpdateCounter(int voice)
{
	CFractMusDoc* pDoc = ((CFractMusView*)m_pParent)->GetDocument();

	
	if (UpdateData(TRUE))
	{
		pDoc->m_Counter[voice] = m_Counter[voice];
		pDoc->SetModifiedFlag();
	}
	else
	{
		m_Counter[voice] = pDoc->m_Counter[voice];
		UpdateData(FALSE);
		PostMessage(WM_SETFOCUS);
	}

}

void CCountDlg::OnEqualize() 
{
	CFractMusView* pView = (CFractMusView*)m_pParent;
	CFractMusDoc* pDoc = pView->GetDocument();
	if(!UpdateData(TRUE))
		return;

	if (!pDoc->m_ActiveVoices)
	{
		MessageBox("No active voices!", "Error", MB_OK+MB_ICONEXCLAMATION);
		return;
	}

	
	for (int i = VOICE1; i<MAXVOICES; i++)
	{
		if (pDoc->m_IsActive[i])
		{
			if (i != m_VoiceChoice)
			{
				pDoc->m_Counter[i] =long(((m_Counter[m_VoiceChoice])*pDoc->m_NoteValue[m_VoiceChoice])/(pDoc->m_NoteValue[i]));
				m_Counter[i] = pDoc->m_Counter[i];
			}

		}

	}


	UpdateData(FALSE);

}



void CCountDlg::OnKillfocusCountersV1Ed() 
{
	UpdateCounter(VOICE1);
	
}

void CCountDlg::OnKillfocusCountersV2Ed() 
{
	UpdateCounter(VOICE2);
	
}

void CCountDlg::OnKillfocusCountersV3Ed() 
{
	UpdateCounter(VOICE3);
	
}

void CCountDlg::OnKillfocusCountersV4Ed() 
{
	UpdateCounter(VOICE4);
	
}

void CCountDlg::OnKillfocusCountersV5Ed() 
{
	UpdateCounter(VOICE5);
	
}

void CCountDlg::OnKillfocusCountersV6Ed() 
{
	UpdateCounter(VOICE6);
	
}

void CCountDlg::OnKillfocusCountersV7Ed() 
{
	UpdateCounter(VOICE7);
	
}

void CCountDlg::OnKillfocusCountersV8Ed() 
{
	UpdateCounter(VOICE8);
	
}


void CCountDlg::OnStart() 
{
	if(!UpdateData(TRUE))
		return;
	CFractMusView* pView = (CFractMusView*)m_pParent;
	CFractMusDoc* pDoc = pView->GetDocument();
	
	for(int i = VOICE1; i<MAXVOICES; i++)
	{
		pDoc->m_StartCounter[i] = m_Counter[i];
	}
}
