
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


// DynamicsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FractMus.h"
#include "DynamicsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDynamicsDlg dialog


CDynamicsDlg::CDynamicsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDynamicsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDynamicsDlg)
	m_f = TRUE;
	m_ff = TRUE;
	m_mf = TRUE;
	m_mp = TRUE;
	m_p = TRUE;
	m_pp = TRUE;
	//}}AFX_DATA_INIT

	numchoices = 6;
}


void CDynamicsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDynamicsDlg)
	DDX_Check(pDX, IDC_F_CHK, m_f);
	DDX_Check(pDX, IDC_FF_CHK, m_ff);
	DDX_Check(pDX, IDC_MF_CHK, m_mf);
	DDX_Check(pDX, IDC_MP_CHK, m_mp);
	DDX_Check(pDX, IDC_P_CHK, m_p);
	DDX_Check(pDX, IDC_PP_CHK, m_pp);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDynamicsDlg, CDialog)
	//{{AFX_MSG_MAP(CDynamicsDlg)
	ON_BN_CLICKED(IDC_F_CHK, OnFChk)
	ON_BN_CLICKED(IDC_FF_CHK, OnFfChk)
	ON_BN_CLICKED(IDC_MF_CHK, OnMfChk)
	ON_BN_CLICKED(IDC_MP_CHK, OnMpChk)
	ON_BN_CLICKED(IDC_P_CHK, OnPChk)
	ON_BN_CLICKED(IDC_PP_CHK, OnPpChk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDynamicsDlg message handlers

void CDynamicsDlg::OnFChk() 
{
	UpdateData(TRUE);
	numchoices = m_f ? ++numchoices : --numchoices;
	
}

void CDynamicsDlg::OnFfChk() 
{
	UpdateData(TRUE);
	numchoices = m_ff ? ++numchoices : --numchoices;
	
}

void CDynamicsDlg::OnMfChk() 
{
	UpdateData(TRUE);
	numchoices = m_mf ? ++numchoices : --numchoices;
	
}

void CDynamicsDlg::OnMpChk() 
{
	UpdateData(TRUE);
	numchoices = m_mp ? ++numchoices : --numchoices;
	
}

void CDynamicsDlg::OnPChk() 
{
	UpdateData(TRUE);
	numchoices = m_p ? ++numchoices : --numchoices;
	
}

void CDynamicsDlg::OnPpChk() 
{
	UpdateData(TRUE);
	numchoices = m_pp ? ++numchoices : --numchoices;
	
}

void CDynamicsDlg::OnCancel() 
{
}

void CDynamicsDlg::OnOK() 
{
	if (numchoices<1)
	{
		MessageBox("Please make at least one selection", "Error", MB_OK+MB_ICONEXCLAMATION);
		return;
	}
	
	CDialog::OnOK();
	
	CDialog::OnOK();
}
