
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


// EventsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FractMus.h"
#include "FractMusView.h"
#include "FractMusDoc.h"
#include "EventsDlg.h"
#include "math.h"
#include "defs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEventsDlg dialog

extern int Tempo;
extern BOOL m_Playing;
extern BOOL IsDocumentLocked;
extern HMIDIOUT midiOut;
extern int DevChoice;
extern int PercussionChannel;
extern float LogMap[MAXVOICES];
extern float LogMap2[MAXVOICES];
extern float FNoise[MAXVOICES];
extern float HenonX[MAXVOICES];
extern float HenonY[MAXVOICES];
extern float HopalongX[MAXVOICES];
extern float HopalongY[MAXVOICES];
extern float MartinX[MAXVOICES];
extern float MartinY[MAXVOICES];
extern float GingerX[MAXVOICES];
extern float GingerY[MAXVOICES];
extern float LorentzX[MAXVOICES];
extern unsigned long EarthWorm[MAXVOICES];

extern BYTE* WolframArray1[MAXVOICES];
extern BYTE* WolframArray2[MAXVOICES];

extern __int64 HailStoneNumber[MAXVOICES];

extern int count1[MAXVOICES];
extern int count2[MAXVOICES];
extern int count3[MAXVOICES];
extern int count4[MAXVOICES];
extern int count5[MAXVOICES];
extern int count6[MAXVOICES];
extern int count7[MAXVOICES];
extern int count8[MAXVOICES];
extern int count9[MAXVOICES];
extern int count10[MAXVOICES];
extern int count11[MAXVOICES];
extern int count12[MAXVOICES];

extern const char* InstrumentNames[128];
extern const char* PercussionNames[47];
extern const char* dyn[6];
extern const char* AlgorithmNames[12];
extern const char* Pitches[12];
extern char* NoteNames[128];
extern const char* NoteValueNames[12];
extern const char* ScaleNames[16];



extern int __fastcall Morse_Thue(int voice, long counter, long test, const int* scale, 
				int numocts,long base, long startnum, 
				int startnote,BOOL modulate, BOOL modulrand, 
				int modulnum, BOOL inverted, float logmapvar, float oneoverf,
				float henonA, float henonB, float hopalong,
				float martin, float lorentz, unsigned long earthwormvar,
				unsigned long earthwormmulti, unsigned earthwormtruncator,
				double ranmin, double ranmax, BYTE wolframrule,
				int wolframsize, long hailstonestart);

extern int __fastcall LogisticMap(int voice, long counter, long test, const int* scale, 
				int numocts,long base, long startnum, 
				int startnote,BOOL modulate, BOOL modulrand, 
				int modulnum, BOOL inverted, float logmapvar, float oneoverf,
				float henonA, float henonB, float hopalong,
				float martin, float lorentz, unsigned long earthwormvar,
				unsigned long earthwormmulti, unsigned earthwormtruncator,
				double ranmin, double ranmax, BYTE wolframrule,
				int wolframsize, long hailstonestart);

extern int __fastcall OneOverF(int voice, long counter, long test, const int* scale, 
				int numocts,long base, long startnum, 
				int startnote,BOOL modulate, BOOL modulrand, 
				int modulnum, BOOL inverted, float logmapvar, float oneoverf,
				float henonA, float henonB, float hopalong,
				float martin, float lorentz, unsigned long earthwormvar,
				unsigned long earthwormmulti, unsigned earthwormtruncator,
				double ranmin, double ranmax, BYTE wolframrule,
				int wolframsize, long hailstonestart);

extern int __fastcall Henon(int voice, long counter, long test, const int* scale, 
				int numocts,long base, long startnum, 
				int startnote,BOOL modulate, BOOL modulrand, 
				int modulnum, BOOL inverted, float logmapvar, float oneoverf,
				float henonA, float henonB, float hopalong,
				float martin, float lorentz, unsigned long earthwormvar,
				unsigned long earthwormmulti, unsigned earthwormtruncator,
				double ranmin, double ranmax, BYTE wolframrule,
				int wolframsize, long hailstonestart);

extern int __fastcall Hopalong(int voice, long counter, long test, const int* scale, 
				int numocts,long base, long startnum, 
				int startnote,BOOL modulate, BOOL modulrand, 
				int modulnum, BOOL inverted, float logmapvar, float oneoverf,
				float henonA, float henonB, float hopalong,
				float martin, float lorentz, unsigned long earthwormvar,
				unsigned long earthwormmulti, unsigned earthwormtruncator,
				double ranmin, double ranmax, BYTE wolframrule,
				int wolframsize, long hailstonestart);

extern int __fastcall Martin(int voice, long counter, long test, const int* scale, 
				int numocts,long base, long startnum, 
				int startnote,BOOL modulate, BOOL modulrand, 
				int modulnum, BOOL inverted, float logmapvar, float oneoverf,
				float henonA, float henonB, float hopalong,
				float martin, float lorentz, unsigned long earthwormvar,
				unsigned long earthwormmulti, unsigned earthwormtruncator,
				double ranmin, double ranmax, BYTE wolframrule,
				int wolframsize, long hailstonestart);

extern int __fastcall Gingerbreadman(int voice, long counter, long test, const int* scale, 
				int numocts,long base, long startnum, 
				int startnote,BOOL modulate, BOOL modulrand, 
				int modulnum, BOOL inverted, float logmapvar, float oneoverf,
				float henonA, float henonB, float hopalong,
				float martin, float lorentz, unsigned long earthwormvar,
				unsigned long earthwormmulti, unsigned earthwormtruncator,
				double ranmin, double ranmax, BYTE wolframrule,
				int wolframsize, long hailstonestart);

extern int __fastcall Lorentz(int voice, long counter, long test, const int* scale, 
				int numocts,long base, long startnum, 
				int startnote,BOOL modulate, BOOL modulrand, 
				int modulnum, BOOL inverted, float logmapvar, float oneoverf,
				float henonA, float henonB, float hopalong,
				float martin, float lorentz, unsigned long earthwormvar,
				unsigned long earthwormmulti, unsigned earthwormtruncator,
				double ranmin, double ranmax, BYTE wolframrule,
				int wolframsize, long hailstonestart);

extern int __fastcall Earthworm(int voice, long counter, long test, const int* scale, 
				int numocts,long base, long startnum, 
				int startnote,BOOL modulate, BOOL modulrand, 
				int modulnum, BOOL inverted, float logmapvar, float oneoverf,
				float henonA, float henonB, float hopalong,
				float martin, float lorentz, unsigned long earthwormvar,
				unsigned long earthwormmulti, unsigned earthwormtruncator,
				double ranmin, double ranmax, BYTE wolframrule,
				int wolframsize, long hailstonestart);

extern int __fastcall RandomAlgorithm(int voice, long counter, long test, const int* scale, 
				int numocts,long base, long startnum, 
				int startnote,BOOL modulate, BOOL modulrand, 
				int modulnum, BOOL inverted, float logmapvar, float oneoverf,
				float henonA, float henonB, float hopalong,
				float martin, float lorentz, unsigned long earthwormvar,
				unsigned long earthwormmulti, unsigned earthwormtruncator,
				double ranmin, double ranmax, BYTE wolframrule,
				int wolframsize, long hailstonestart);

extern int __fastcall Hailstone(int voice, long counter, long test, const int* scale, 
				int numocts,long base, long startnum, 
				int startnote,BOOL modulate, BOOL modulrand, 
				int modulnum, BOOL inverted, float logmapvar, float oneoverf,
				float henonA, float henonB, float hopalong,
				float martin, float lorentz, unsigned long earthwormvar,
				unsigned long earthwormmulti, unsigned earthwormtruncator,
				double ranmin, double ranmax, BYTE wolframrule,
				int wolframsize, long hailstonestart);

extern int __fastcall Wolfram(int voice, long counter, long test, const int* scale, 
				int numocts,long base, long startnum, 
				int startnote,BOOL modulate, BOOL modulrand, 
				int modulnum, BOOL inverted, float logmapvar, float oneoverf,
				float henonA, float henonB, float hopalong,
				float martin, float lorentz, unsigned long earthwormvar,
				unsigned long earthwormmulti, unsigned earthwormtruncator,
				double ranmin, double ranmax, BYTE wolframrule,
				int wolframsize, long hailstonestart);

extern void ComputeTotal(long test, long base, long* total);
extern WORD noteOn(BYTE , BYTE , BYTE );
extern WORD noteOff(BYTE, BYTE, BYTE);
extern WORD progChange(BYTE , BYTE);
extern WORD modeChange(BYTE , BYTE , BYTE);

extern int (__fastcall*(Algorithm[12]))(int , long , long , const int* , 
				int ,long , long , 
				int ,BOOL , BOOL , 
				int, BOOL, float, float, float, float, float, float,
				float, unsigned long, unsigned long, unsigned,
				double, double, BYTE, int, long);

extern float RanDev();


CEventsDlg::CEventsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEventsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEventsDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_pParent = pParent;
	m_nID = CEventsDlg::IDD;

}


void CEventsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEventsDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEventsDlg, CDialog)
	//{{AFX_MSG_MAP(CEventsDlg)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_FUCKIT, OnFuckit)
	ON_BN_CLICKED(IDC_PLAY, OnPlay)
	ON_BN_CLICKED(IDC_REMOVE, OnRemove)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_LBN_SELCHANGE(IDC_EVENTLIST, OnSelchangeEventlist)
	ON_LBN_DBLCLK(IDC_EVENTLIST, OnDblclkEventlist)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	ON_BN_CLICKED(IDC_INSERT, OnInsert)
	ON_BN_CLICKED(IDC_REPLACE_BT, OnReplaceBt)
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEventsDlg message handlers

void CEventsDlg::OnOK() 
{
}

void CEventsDlg::OnCancel() 
{
}


BOOL CEventsDlg::Create()
{
	return CDialog::Create(m_nID, m_pParent);
}


void CEventsDlg::PostNcDestroy() 
{
	delete this;
}

void CEventsDlg::OnAdd() 
{
	CFractMusView* pView = (CFractMusView*)m_pParent;
	CFractMusDoc* pDoc = pView->GetDocument();
	CListBox* pList = (CListBox*)(this->GetDlgItem(IDC_EVENTLIST));
	CEdit* pE = (CEdit*)pView->GetDlgItem(IDC_GENCOUNTER_ED);
	CComboBox* pCB = (CComboBox*)pView->GetDlgItem(IDC_PLAYFROM_CMB);

	CString toAdd;
	int i;

	if(pDoc->m_NumEvents >= 999)
	{
		MessageBox("Sorry, you have reached the limit of events (1000)","FractMus",MB_OK|MB_ICONEXCLAMATION);
		return;
	}


	if(pDoc->dStartCounter>=pDoc->dGeneralCounter)
	{
		MessageBox("Minimum difference between Start and End counters  is 1", "Error", MB_OK+MB_ICONEXCLAMATION);
		return;
	}



 /// fill the event

	m_NumEvents++;

		pDoc->Event[m_NumEvents].genCount = pDoc->dGeneralCounter;
		pDoc->Event[m_NumEvents].count = pDoc->dStartCounter;
		pDoc->Event[m_NumEvents].Tempo = pDoc->m_TempoMarking;
		pDoc->Event[m_NumEvents].TimeSigNum= pDoc->m_TimeSigNum;
		pDoc->Event[m_NumEvents].TimeSigDen= pDoc->m_TimeSigDen;


		for(i=VOICE1; i<MAXVOICES; i++)
		{
			pDoc->Event[m_NumEvents].AlgorithmNum[i] = pDoc->AlgorithmNum[i];
			pDoc->Event[m_NumEvents].IsActive[i] = pDoc->m_IsActive[i];
			pDoc->Event[m_NumEvents].Base[i] = pDoc->m_Base[i];
			pDoc->Event[m_NumEvents].Multi[i] = pDoc->m_Multi[i];
			pDoc->Event[m_NumEvents].StartNum[i] = pDoc->m_StartNum[i];
			pDoc->Event[m_NumEvents].NumOcts[i] = pDoc->m_NumOcts[i];
			pDoc->Event[m_NumEvents].Modulates[i] = pDoc->m_Modulates[i];
			pDoc->Event[m_NumEvents].ModulRandom[i] = pDoc->m_ModulRandom[i];
			pDoc->Event[m_NumEvents].ModulNum[i] = pDoc->m_ModulNum[i];
			pDoc->Event[m_NumEvents].Note[i] = pDoc->m_Note[i];
			pDoc->Event[m_NumEvents].NoteValue[i] = pDoc->m_NoteValue[i];
			pDoc->Event[m_NumEvents].Instrument[i] = pDoc->m_Instrument[i];
			pDoc->Event[m_NumEvents].Channel[i] = pDoc->m_Channel[i];
			pDoc->Event[m_NumEvents].Mode[i] = pDoc->m_mode[i];
			pDoc->Event[m_NumEvents].ScaleID[i] = pDoc->m_ScaleID[i];
			pDoc->Event[m_NumEvents].NumOctsID[i] = pDoc->m_NumOctsID[i];
			pDoc->Event[m_NumEvents].NoteValueID[i] = pDoc->m_NoteValueID[i];
			pDoc->Event[m_NumEvents].Inverted[i] = pDoc->m_Inverted[i];
			pDoc->Event[m_NumEvents].MatchScale[i] = pDoc->m_MatchScale[i];
			pDoc->Event[m_NumEvents].Dynamic[i] = pDoc->m_Dynamic[i];
			pDoc->Event[m_NumEvents].DynChoice[i] = pDoc->m_DynChoice[i];
			pDoc->Event[m_NumEvents].LogMapVar[i] = pDoc->m_LogMapVar[i];
			pDoc->Event[m_NumEvents].FNoiseVar[i] = pDoc->m_FNoiseVar[i];
			pDoc->Event[m_NumEvents].LorentzVar[i] = pDoc->m_LorentzVar[i];
			pDoc->Event[m_NumEvents].HenonA[i] = pDoc->m_HenonA[i];
			pDoc->Event[m_NumEvents].HenonB[i] = pDoc->m_HenonB[i];
			pDoc->Event[m_NumEvents].HopalongVar[i] = pDoc->m_HopalongVar[i];
			pDoc->Event[m_NumEvents].MartinVar[i] = pDoc->m_MartinVar[i];
			pDoc->Event[m_NumEvents].GingerX[i] = pDoc->m_GingerX[i];
			pDoc->Event[m_NumEvents].GingerY[i] = pDoc->m_GingerY[i];
			pDoc->Event[m_NumEvents].EarthWormVar[i] = pDoc->m_EarthWormVar[i];
			pDoc->Event[m_NumEvents].EarthWormMulti[i] = pDoc->m_EarthWormMulti[i];
			pDoc->Event[m_NumEvents].EarthWormTruncator[i] = pDoc->m_EarthWormTruncator[i];
			pDoc->Event[m_NumEvents].RandomMin[i] = pDoc->m_RandomMin[i];
			pDoc->Event[m_NumEvents].RandomMax[i] = pDoc->m_RandomMax[i];
			pDoc->Event[m_NumEvents].WolframRule[i] = pDoc->m_WolframRule[i];
			pDoc->Event[m_NumEvents].WolframInit[i] = pDoc->m_WolframInit[i];
			pDoc->Event[m_NumEvents].WolframSize[i] = pDoc->m_WolframSize[i];

			pDoc->Event[m_NumEvents].Hailstone[i] = pDoc->m_Hailstone[i];			
			pDoc->Event[m_NumEvents].Pan[i] = pDoc->m_Pan[i];
			pDoc->Event[m_NumEvents].Percussion[i] = pDoc->m_Percussion[i];
		}


		for(i=0; i<MAXVOICES; i++)
		{
			if (pDoc->Event[m_NumEvents].pUserScale[i])
			{
				delete pDoc->Event[m_NumEvents].pUserScale[i];
				pDoc->Event[m_NumEvents].pUserScale[i] = NULL;
			}
			pDoc->Event[m_NumEvents].pUserScale[i] = new int[pDoc->m_pUserScale[i][0] +1];
			for(int j=0; j<=pDoc->m_pUserScale[i][0]; j++)
				pDoc->Event[m_NumEvents].pUserScale[i][j] = pDoc->m_pUserScale[i][j];
		}
	


		for(i=0; i<MAXVOICES; i++)
		{
			if (pDoc->Event[m_NumEvents].pScale[i])
			{
				delete pDoc->Event[m_NumEvents].pScale[i];
				pDoc->Event[m_NumEvents].pScale[i] = NULL;
			}
			pDoc->Event[m_NumEvents].pScale[i] = new int[pDoc->m_pScale[i][0] +1];
			for(int j=0; j<=pDoc->m_pScale[i][0]; j++)
				pDoc->Event[m_NumEvents].pScale[i][j] = pDoc->m_pScale[i][j];
		}


	pDoc->m_NumEvents = m_NumEvents;

	toAdd.Format("[%d -> %d]", pDoc->Event[m_NumEvents].count, pDoc->Event[m_NumEvents].genCount);

	pList->AddString(toAdd);

	toAdd.Format("%d", m_NumEvents);
	pCB->AddString(toAdd);

}

void CEventsDlg::OnFuckit() 
{
	CFractMusView* pView = (CFractMusView*)m_pParent;
	pView->EventsDone();
	DestroyWindow();
	
}

void CEventsDlg::OnPlay() 
{
	CListBox* pLB = (CListBox*)GetDlgItem(IDC_EVENTLIST);
	CFractMusView* pView = (CFractMusView*)m_pParent;


	int sel = pLB->GetCurSel();

	if ((sel == LB_ERR))
		return;

	UINT result = midiOutOpen(&midiOut, DevChoice, NULL, NULL, CALLBACK_NULL);

	if( result!=MMSYSERR_NOERROR )
	{
		switch(result)
		{

		case MMSYSERR_ALLOCATED:
			AfxMessageBox("The device is already in use, free it and try again", MB_OK+MB_ICONHAND);
			break;
		case MMSYSERR_NOMEM:
			AfxMessageBox("Could not allocate memory for the device", MB_OK+MB_ICONHAND);
			break;
		case MMSYSERR_INVALPARAM:
			AfxMessageBox("Invalid pointer!", MB_OK+MB_ICONHAND);
			break;
		}

		return;

	}


	GetDlgItem(IDC_ADD)->EnableWindow(FALSE);
	GetDlgItem(IDC_REMOVE)->EnableWindow(FALSE);
	GetDlgItem(IDC_REPLACE_BT)->EnableWindow(FALSE);
	GetDlgItem(IDC_PLAY)->EnableWindow(FALSE);
	GetDlgItem(IDC_FUCKIT)->EnableWindow(FALSE);
	GetDlgItem(IDC_CLEAR)->EnableWindow(FALSE);
	//GetDlgItem(IDC_EVENTLIST)->EnableWindow(FALSE);
	GetDlgItem(IDC_INSERT)->EnableWindow(FALSE);
	pView->GetDlgItem(IDC_GLOBALTEMPO_BT)->EnableWindow(FALSE);
	pView->GetDlgItem(IDC_GLOBALTIMESIG_BT)->EnableWindow(FALSE);

	CMenu* pM = AfxGetMainWnd()->GetSystemMenu(FALSE);
	pM->EnableMenuItem(SC_CLOSE, MF_GRAYED);


	m_Playing = TRUE;

	AfxBeginThread(PlaySection, this);
	
}


void CEventsDlg::OnRemove() 
{
	if(m_NumEvents<0)
		return;

	CFractMusView* pView = (CFractMusView*)m_pParent;
	CFractMusDoc* pDoc = pView->GetDocument();
	CListBox* pList = (CListBox*)(this->GetDlgItem(IDC_EVENTLIST));
	CListBox* pEvInfo = (CListBox*)(GetDlgItem(IDC_EVENTINFOLIST));
	CComboBox* pCB = (CComboBox*)pView->GetDlgItem(IDC_PLAYFROM_CMB);

	int oldsel, sel, i;

	oldsel = sel = pList->GetCurSel();

	if (sel == LB_ERR)
		return;

	int answer = MessageBox("Are you sure?", "Delete", MB_YESNO);

	if (answer == IDNO)
		return;

	if (sel < m_NumEvents)
	{
		while((sel+1)<=m_NumEvents)
		{

			pDoc->Event[sel].Tempo = pDoc->Event[sel+1].Tempo;
			pDoc->Event[sel].TimeSigNum= pDoc->Event[sel+1].TimeSigNum;
			pDoc->Event[sel].TimeSigDen= pDoc->Event[sel+1].TimeSigDen;
			pDoc->Event[sel].count = pDoc->Event[sel+1].count;
			pDoc->Event[sel].genCount = pDoc->Event[sel+1].genCount;



			for(i=VOICE1; i<MAXVOICES; i++)
			{
				pDoc->Event[sel].AlgorithmNum[i] = pDoc->Event[sel+1].AlgorithmNum[i];
				pDoc->Event[sel].IsActive[i] = pDoc->Event[sel+1].IsActive[i];
				pDoc->Event[sel].Base[i] = pDoc->Event[sel+1].Base[i];
				pDoc->Event[sel].Multi[i] = pDoc->Event[sel+1].Multi[i];
				pDoc->Event[sel].StartNum[i] = pDoc->Event[sel+1].StartNum[i];
				pDoc->Event[sel].NumOcts[i] = pDoc->Event[sel+1].NumOcts[i];
				pDoc->Event[sel].Modulates[i] = pDoc->Event[sel+1].Modulates[i];
				pDoc->Event[sel].ModulRandom[i] = pDoc->Event[sel+1].ModulRandom[i];
				pDoc->Event[sel].ModulNum[i] = pDoc->Event[sel+1].ModulNum[i];
				pDoc->Event[sel].Note[i] = pDoc->Event[sel+1].Note[i];
				pDoc->Event[sel].NoteValue[i] = pDoc->Event[sel+1].NoteValue[i];
				pDoc->Event[sel].Instrument[i] = pDoc->Event[sel+1].Instrument[i];
				pDoc->Event[sel].Channel[i] = pDoc->Event[sel+1].Channel[i];
				pDoc->Event[sel].Mode[i] = pDoc->Event[sel+1].Mode[i];
				pDoc->Event[sel].ScaleID[i] = pDoc->Event[sel+1].ScaleID[i];
				pDoc->Event[sel].NumOctsID[i] = pDoc->Event[sel+1].NumOctsID[i];
				pDoc->Event[sel].NoteValueID[i] = pDoc->Event[sel+1].NoteValueID[i];
				pDoc->Event[sel].Inverted[i] = pDoc->Event[sel+1].Inverted[i];
				pDoc->Event[sel].MatchScale[i] = pDoc->Event[sel+1].MatchScale[i];
				pDoc->Event[sel].Dynamic[i] = pDoc->Event[sel+1].Dynamic[i];
				pDoc->Event[sel].DynChoice[i] = pDoc->Event[sel+1].DynChoice[i];
				pDoc->Event[sel].LogMapVar[i] = pDoc->Event[sel+1].LogMapVar[i];
				pDoc->Event[sel].FNoiseVar[i] = pDoc->Event[sel+1].FNoiseVar[i];
				pDoc->Event[sel].LorentzVar[i] = pDoc->Event[sel+1].LorentzVar[i];
				pDoc->Event[sel].HenonA[i] = pDoc->Event[sel+1].HenonA[i];
				pDoc->Event[sel].HenonB[i] = pDoc->Event[sel+1].HenonB[i];
				pDoc->Event[sel].HopalongVar[i] = pDoc->Event[sel+1].HopalongVar[i];
				pDoc->Event[sel].MartinVar[i] = pDoc->Event[sel+1].MartinVar[i];
				pDoc->Event[sel].GingerX[i] = pDoc->Event[sel+1].GingerX[i];
				pDoc->Event[sel].GingerY[i] = pDoc->Event[sel+1].GingerY[i];
				pDoc->Event[sel].EarthWormVar[i] = pDoc->Event[sel+1].EarthWormVar[i];
				pDoc->Event[sel].EarthWormMulti[i] = pDoc->Event[sel+1].EarthWormMulti[i];
				pDoc->Event[sel].EarthWormTruncator[i] = pDoc->Event[sel+1].EarthWormTruncator[i];
				pDoc->Event[sel].RandomMin[i] = pDoc->Event[sel+1].RandomMin[i];
				pDoc->Event[sel].RandomMax[i] = pDoc->Event[sel+1].RandomMax[i];

				pDoc->Event[sel].WolframRule[i] = pDoc->Event[sel+1].WolframRule[i];
				pDoc->Event[sel].WolframInit[i] = pDoc->Event[sel+1].WolframInit[i];
				pDoc->Event[sel].WolframSize[i] = pDoc->Event[sel+1].WolframSize[i];

				pDoc->Event[sel].Hailstone[i] = pDoc->Event[sel+1].Hailstone[i];

				pDoc->Event[sel].Pan[i] = pDoc->Event[sel+1].Pan[i];
				pDoc->Event[sel].Percussion[i] = pDoc->Event[sel+1].Percussion[i];
			}
		
			for(i=0; i<MAXVOICES; i++)
			{
				if (pDoc->Event[sel].pUserScale[i])
				{
					delete pDoc->Event[sel].pUserScale[i];
					pDoc->Event[sel].pUserScale[i] = NULL;
				}
				pDoc->Event[sel].pUserScale[i] = new int[pDoc->Event[sel+1].pUserScale[i][0] +1];
				for(int j=0; j<=pDoc->Event[sel+1].pUserScale[i][0]; j++)
					pDoc->Event[sel].pUserScale[i][j] = pDoc->Event[sel+1].pUserScale[i][j];
			}

			for(i=0; i<MAXVOICES; i++)
			{
				if (pDoc->Event[sel].pScale[i])
				{
					delete pDoc->Event[sel].pScale[i];
					pDoc->Event[sel].pScale[i] = NULL;
				}
				pDoc->Event[sel].pScale[i] = new int[pDoc->Event[sel+1].pScale[i][0] +1];
				for(int j=0; j<=pDoc->Event[sel+1].pScale[i][0]; j++)
					pDoc->Event[sel].pScale[i][j] = pDoc->Event[sel+1].pScale[i][j];
			}

			++sel;

		} // while

		pList->DeleteString(oldsel);
		pCB->DeleteString(m_NumEvents);

		--m_NumEvents;
		--pDoc->m_NumEvents;

	}

	else
	{
		
		pList->DeleteString(m_NumEvents);
		pCB->DeleteString(m_NumEvents);

		--m_NumEvents;
		--pDoc->m_NumEvents;
	}

	if (pDoc->m_NumEvents<0)
	{
		pView->PlayChoice = CURRENT_SETTINGS;
		pView->GetDlgItem(IDC_PLAYFROM_CMB)->EnableWindow(FALSE);
		pView->GetDlgItem(IDC_PLAYFROM_BT)->EnableWindow(FALSE);
	}

	pEvInfo->ResetContent();
	

//	if(m_NumEvents>1)
//		pCB->SetCurSel(m_NumEvents-2);
//

	
}

void CEventsDlg::OnStop() 
{
	if (m_Playing)
		midiOutClose(midiOut);
	m_Playing = FALSE;
	CFractMusView* pView = (CFractMusView*)m_pParent;

	
	CMenu* pM = AfxGetMainWnd()->GetSystemMenu(FALSE);
	pM->EnableMenuItem(SC_CLOSE, MF_ENABLED);

	GetDlgItem(IDC_ADD)->EnableWindow(!IsDocumentLocked);
	GetDlgItem(IDC_REMOVE)->EnableWindow(!IsDocumentLocked);
	GetDlgItem(IDC_REPLACE_BT)->EnableWindow(!IsDocumentLocked);
	GetDlgItem(IDC_INSERT)->EnableWindow(!IsDocumentLocked);
	GetDlgItem(IDC_CLEAR)->EnableWindow(!IsDocumentLocked);
	GetDlgItem(IDC_PLAY)->EnableWindow(TRUE);
	GetDlgItem(IDC_FUCKIT)->EnableWindow(TRUE);
	GetDlgItem(IDC_EVENTLIST)->EnableWindow(TRUE);
	pView->GetDlgItem(IDC_GLOBALTEMPO_BT)->EnableWindow(TRUE);
	pView->GetDlgItem(IDC_GLOBALTIMESIG_BT)->EnableWindow(TRUE);
}

BOOL CEventsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	CMenu* pM = this->GetSystemMenu(FALSE);

	ASSERT(pM!=NULL);

	pM->EnableMenuItem(SC_CLOSE, MF_GRAYED);
	pM->EnableMenuItem(SC_SIZE, MF_GRAYED);
	pM->EnableMenuItem(SC_MAXIMIZE, MF_GRAYED);

	CFractMusView* pView = (CFractMusView*)m_pParent;
	CFractMusDoc* pDoc = pView->GetDocument();
	CListBox* pList = (CListBox*)(this->GetDlgItem(IDC_EVENTLIST));

	GetDlgItem(IDC_ADD)->EnableWindow(!IsDocumentLocked&&(!m_Playing));
	GetDlgItem(IDC_REMOVE)->EnableWindow(!IsDocumentLocked&&(!m_Playing));
	GetDlgItem(IDC_REPLACE_BT)->EnableWindow(!IsDocumentLocked&&(!m_Playing));
	GetDlgItem(IDC_INSERT)->EnableWindow(!IsDocumentLocked&&(!m_Playing));
	GetDlgItem(IDC_CLEAR)->EnableWindow(!IsDocumentLocked&&(!m_Playing));
	GetDlgItem(IDC_PLAY)->EnableWindow(!m_Playing);
	GetDlgItem(IDC_STOP)->EnableWindow(!m_Playing);


	m_NumEvents = pDoc->m_NumEvents;

	CString toAdd;
	int i;

	if (m_NumEvents>-1)
	{

		for(i=0; i<=m_NumEvents; i++)
		{
			toAdd.Format("[%d -> %d]", pDoc->Event[i].count, pDoc->Event[i].genCount);
			pList->AddString(toAdd);
		}
	}
		
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CEventsDlg::OnSelchangeEventlist() 
{
	CFractMusView* pView = (CFractMusView*)m_pParent;
	CFractMusDoc* pDoc = pView->GetDocument();
	CListBox* pList = (CListBox*)(GetDlgItem(IDC_EVENTLIST));
	CListBox* pEvInfo = (CListBox*)(GetDlgItem(IDC_EVENTINFOLIST));
	CComboBox* pB;


	int sel = pList->GetCurSel();

	if (sel == LB_ERR)
		return;

	pEvInfo->ResetContent();

	if (IsDocumentLocked)
	{
		pEvInfo->AddString("Document is protected");
		return;
	}

	CString msg, msg2;

	msg.Format("Event Number %d", sel);

	pEvInfo->AddString(msg);
	pEvInfo->AddString("******************");
	pEvInfo->AddString("");


	/// counters

	float dur = ((60.0f*float(pDoc->Event[sel].genCount-pDoc->Event[sel].count))/(float(pDoc->Event[sel].Tempo)*8.0f));



	if (dur>60.0f)
		msg.Format("Approximate duration: %d min. %d sec.", int(dur/60), int(dur)%60);
	else
		msg.Format("Approximate duration: %.2f sec.", dur);
	
	pEvInfo->AddString(msg);


	/// tempo

	msg.Format("Tempo: %d", pDoc->Event[sel].Tempo);
	pEvInfo->AddString(msg);

	/// time sig

	msg.Format("Time signature: %d/%d", pDoc->Event[sel].TimeSigNum, pDoc->Event[sel].TimeSigDen);
	pEvInfo->AddString(msg);

	pEvInfo->AddString("");
	pEvInfo->AddString("Active Voices:");
	pEvInfo->AddString("");


	
	for (int i = VOICE1; i<MAXVOICES; i++)
	{
		if (pDoc->Event[sel].IsActive[i])
		{
			msg.Format("VOICE %d:", i+1);
			pEvInfo->AddString(msg);


			///// channel

			if (pDoc->Event[sel].Channel[i] != PercussionChannel)
				msg.Format("\tChannel: %d", pDoc->Event[sel].Channel[i]);
			else
				msg.Format("\tChannel: Percussion");
			pEvInfo->AddString(msg);

			//////// algorithm

			switch (pDoc->Event[sel].AlgorithmNum[i])
			{
				case MORSE_THUE:
					msg.Format("\tAlgorithm: Morse-Thue (%d, %d)", pDoc->Event[sel].Base[i], pDoc->Event[sel].Multi[i]);
					pEvInfo->AddString(msg);
					break;
				case LOGMAP:
					msg.Format("\tAlgorithm: Log Map (%f)", pDoc->Event[sel].LogMapVar[i]);
					pEvInfo->AddString(msg);
					break;
				case ONE_OVER_F_NOISE:
					msg.Format("\tAlgorithm: 1/f Noise (%f)", pDoc->Event[sel].FNoiseVar[i]);
					pEvInfo->AddString(msg);
					break;
				case HENON:
					msg.Format("\tAlgorithm: Henon (%f, %f)", pDoc->Event[sel].HenonA[i], pDoc->Event[sel].HenonB[i]);
					pEvInfo->AddString(msg);
					break;
				case HOPALONG:
					msg.Format("\tAlgorithm: Hopalong (%f)", pDoc->Event[sel].HopalongVar[i]);
					pEvInfo->AddString(msg);
					break;
				case MARTIN:
					msg.Format("\tAlgorithm: Martin (%f)", pDoc->Event[sel].MartinVar[i]);
					pEvInfo->AddString(msg);
					break;
				case GINGERBREADMAN:
					msg.Format("\tAlgorithm: Gingerbread (%f, %f)", pDoc->Event[sel].GingerX[i], pDoc->Event[sel].GingerY[i]);
					pEvInfo->AddString(msg);
					break;
				case LORENTZ:
					msg.Format("\tAlgorithm: Lorenz (%f)", pDoc->Event[sel].LorentzVar[i]);
					pEvInfo->AddString(msg);
					break;
				case EARTHWORM:
					msg.Format("\tAlgorithm: Earthworm (%d, %d, %d)", pDoc->Event[sel].EarthWormVar[i], pDoc->Event[sel].EarthWormMulti[i], pDoc->Event[sel].EarthWormTruncator[i]);
					pEvInfo->AddString(msg);
					break;
				case RANDOM:
					msg.Format("\tAlgorithm: Random (%f, %f)", pDoc->Event[sel].RandomMin[i], pDoc->Event[sel].RandomMax[i]);
					pEvInfo->AddString(msg);
					break;
				case HAILSTONE:
					msg.Format("\tAlgorithm: 3n+1 numbers (%d)", pDoc->Event[sel].Hailstone[i]);
					pEvInfo->AddString(msg);
					break;
				case WOLFRAM:
					msg.Format("\tAlgorithm: Wolfram (Rule:%d, Size:%d, Init:%d)", pDoc->Event[sel].WolframRule[i], pDoc->Event[sel].WolframSize[i], pDoc->Event[sel].WolframInit[i]);
					pEvInfo->AddString(msg);
					break;
			}

			//// offset

			msg.Format("\tOffset value: %d", pDoc->Event[sel].StartNum[i]);
			pEvInfo->AddString(msg);

			//// modulation

			msg = "\tModulates: ";

			msg2 = pDoc->Event[sel].Modulates[i] ? "Yes" : "No";

			msg = msg + msg2;

			if (pDoc->Event[sel].Modulates[i])
			{
				if (pDoc->Event[sel].ModulRandom[i])
					msg2 = " (Randomly)";
				else
					msg2.Format(" (Every %d)", pDoc->Event[sel].ModulNum[i]);

				msg = msg + msg2;

			}

			pEvInfo->AddString(msg);

			/// octaves

			msg.Format("\tNumber of octaves: %d", pDoc->Event[sel].NumOcts[i]);
			pEvInfo->AddString(msg);


			/// start note

			msg.Format("\tStarting note: %s (MIDI note # %d)", (char*)NoteNames[pDoc->Event[sel].Note[i]], pDoc->Event[sel].Note[i]);
			pEvInfo->AddString(msg);

			/// scale

			msg = "\tScale: ";
			
			msg2.Format("%s ", (char*)ScaleNames[pDoc->Event[sel].ScaleID[i]]);
			msg = msg + msg2;

			if (pDoc->Event[sel].ScaleID[i] == USER_DEFINED)
			{
				msg = msg +"( ";
				for(int j = 1; j<=pDoc->Event[sel].pUserScale[i][0]; j++)
				{
					msg2.Format("%s ", (char*)Pitches[pDoc->Event[sel].pUserScale[i][j]]);
					msg = msg + msg2;
				}
				msg = msg +")";

			}

			pEvInfo->AddString(msg);

			/// note value

			msg.Format("\tNote Value: %s", (char*)NoteValueNames[pDoc->Event[sel].NoteValueID[i]]);

			if (pDoc->Event[sel].NoteValueID[i] == OTHER)
			{
				msg2.Format(" (%d)", int(pDoc->Event[sel].NoteValue[i]));
				msg += msg2;
			}

			pEvInfo->AddString(msg);

			/// instrument
			
			if (pDoc->Event[sel].Channel[i] != PercussionChannel)
				msg.Format("\tInstrument: %s", (char*)InstrumentNames[pDoc->Event[sel].Instrument[i]]);
			else
				msg.Format("\tInstrument: %s", (char*)PercussionNames[pDoc->Event[sel].Percussion[i]]);
			pEvInfo->AddString(msg);

			/// mode

			msg = "\tMode: ";
			msg += pDoc->Event[sel].Mode[i]? "Tied" : "All Notes";
			pEvInfo->AddString(msg);

			/// inverted & match scale

			msg = "\tInverted: ";
			msg += pDoc->Event[sel].Inverted[i]? "Yes" : "No";

			if(pDoc->Event[sel].Inverted[i])
			{
				msg += "  Match Scale: ";

				msg += pDoc->Event[sel].MatchScale[i]? "Yes" : "No";
			}

			pEvInfo->AddString(msg);

			/// pan

			msg.Format("\tPan value: %d", pDoc->Event[sel].Pan[i]);
			pEvInfo->AddString(msg);

			/// dynamic

			msg.Format("\tDynamic: %s", (char*)dyn[pDoc->Event[sel].DynChoice[i]]);
			pEvInfo->AddString(msg);

		}

	}
		
		


	
}

UINT PlaySection(LPVOID pEvObj)
{
	CEventsDlg* pEv = (CEventsDlg*)pEvObj;
	CFractMusView* pView = (CFractMusView*)(pEv->m_pParent);
	CFractMusDoc* pDoc = pView->GetDocument();
	CListBox* pLB = (CListBox*)pEv->GetDlgItem(IDC_EVENTLIST);

	int sel = pLB->GetCurSel();

	long test[MAXVOICES];
	int note[MAXVOICES];
	int lastnote[MAXVOICES];
	int prevnote[MAXVOICES];
	int i;
	register int j;
	int dracula[MAXVOICES];
	long duration; 
	long count = pDoc->Event[sel].count;

	duration = 60000/(8*pDoc->Event[sel].Tempo);

	for (i=VOICE1; i<MAXVOICES; i++)
		dracula[i] = int(pDoc->Event[sel].NoteValue[i]);

	for (i=VOICE1; i<MAXVOICES; i++) 
	{
		count1[i] = 0;
		count2[i] = 0;
		count3[i] = 0;
		count4[i] = 0;
		count5[i] = 0;
		count6[i] = 0;
		count7[i] = 0;
		count8[i] = 0;
		count9[i] = 0;
		count10[i] = 0;
		count11[i] =0;
		count12[i] =0;
		EarthWorm[i] = 0;
	}

	for (i=VOICE1; i<MAXVOICES; i++)
	{
		lastnote[i] = -1;
		prevnote[i] = -1;
	}

	for (i=VOICE1; i<MAXVOICES; i++)
		progChange(0xC0+pDoc->Event[sel].Channel[i], (BYTE)pDoc->Event[sel].Instrument[i]);

	for (i=VOICE1; i<MAXVOICES; i++)
		modeChange(0xb0+pDoc->Event[sel].Channel[i], (BYTE)0x0a, 64+(pDoc->Event[sel].Pan[i]));

	for (i=VOICE1; i<MAXVOICES; i++)
	{


		if(pDoc->Event[sel].AlgorithmNum[i]==MORSE_THUE)
		{

			for(j = 0; j<count+((pDoc->Event[sel].StartNum[i])*dracula[i]); j++)
			{
				if(!((((pDoc->Event[sel].StartNum[i])*dracula[i])+j)%dracula[i]))
				{

				test[i] = (((((pDoc->Event[sel].StartNum[i])*dracula[i])+j)/dracula[i])*pDoc->Event[sel].Multi[i]);

				(*(Algorithm[ pDoc->Event[sel].AlgorithmNum[i] ]))(i, (pDoc->Event[sel].StartNum[i]*dracula[i]+j)/dracula[i], test[i],
								pDoc->Event[sel].pScale[i], 
								pDoc->Event[sel].NumOcts[i], 
								pDoc->Event[sel].Base[i], 
								pDoc->Event[sel].StartNum[i],
								pDoc->Event[sel].Note[i], 
								pDoc->Event[sel].Modulates[i],
								pDoc->Event[sel].ModulRandom[i], 
								pDoc->Event[sel].ModulNum[i],
								pDoc->Event[sel].Inverted[i],
								pDoc->Event[sel].LogMapVar[i],
								pDoc->Event[sel].FNoiseVar[i],
								pDoc->Event[sel].HenonA[i],
								pDoc->Event[sel].HenonB[i],
								pDoc->Event[sel].HopalongVar[i],
								pDoc->Event[sel].MartinVar[i],
								pDoc->Event[sel].LorentzVar[i],
								pDoc->Event[sel].EarthWormVar[i],
								pDoc->Event[sel].EarthWormMulti[i],
								pDoc->Event[sel].EarthWormTruncator[i],
								pDoc->Event[sel].RandomMin[i],
								pDoc->Event[sel].RandomMax[i],
								pDoc->Event[sel].WolframRule[i],
								pDoc->Event[sel].WolframSize[i],
								pDoc->Event[sel].Hailstone[i]


					);
				}
			}
		}


		if(pDoc->Event[sel].AlgorithmNum[i]==LOGMAP)
		{
			LogMap[i] = 0.2f;

			for(j = 0; j<count+((pDoc->Event[sel].StartNum[i])*dracula[i]); j++)
			{
				if(!((((pDoc->Event[sel].StartNum[i])*dracula[i])+j)%dracula[i]))
				{

				(*(Algorithm[ pDoc->Event[sel].AlgorithmNum[i] ]))(i, (pDoc->Event[sel].StartNum[i]*dracula[i]+j)/dracula[i], 0,
								pDoc->Event[sel].pScale[i], 
								pDoc->Event[sel].NumOcts[i], 
								pDoc->Event[sel].Base[i], 
								pDoc->Event[sel].StartNum[i],
								pDoc->Event[sel].Note[i], 
								pDoc->Event[sel].Modulates[i],
								pDoc->Event[sel].ModulRandom[i], 
								pDoc->Event[sel].ModulNum[i],
								pDoc->Event[sel].Inverted[i],
								pDoc->Event[sel].LogMapVar[i],
								pDoc->Event[sel].FNoiseVar[i],
								pDoc->Event[sel].HenonA[i],
								pDoc->Event[sel].HenonB[i],
								pDoc->Event[sel].HopalongVar[i],
								pDoc->Event[sel].MartinVar[i],
								pDoc->Event[sel].LorentzVar[i],
								pDoc->Event[sel].EarthWormVar[i],
								pDoc->Event[sel].EarthWormMulti[i],
								pDoc->Event[sel].EarthWormTruncator[i],
								pDoc->Event[sel].RandomMin[i],
								pDoc->Event[sel].RandomMax[i],
								pDoc->Event[sel].WolframRule[i],
								pDoc->Event[sel].WolframSize[i],
								pDoc->Event[sel].Hailstone[i]

					);
				}
			}
		}

		if(pDoc->Event[sel].AlgorithmNum[i]==HENON)
		{
			HenonX[i] = HenonY[i] = 0.0f;

			for(j = 0; j<count+((pDoc->Event[sel].StartNum[i])*dracula[i]); j++)
			{
				if(!((((pDoc->Event[sel].StartNum[i])*dracula[i])+j)%dracula[i]))
				{

				(*(Algorithm[ pDoc->Event[sel].AlgorithmNum[i] ]))(i, (pDoc->Event[sel].StartNum[i]*dracula[i]+j)/dracula[i], 0,
								pDoc->Event[sel].pScale[i], 
								pDoc->Event[sel].NumOcts[i], 
								pDoc->Event[sel].Base[i], 
								pDoc->Event[sel].StartNum[i],
								pDoc->Event[sel].Note[i], 
								pDoc->Event[sel].Modulates[i],
								pDoc->Event[sel].ModulRandom[i], 
								pDoc->Event[sel].ModulNum[i],
								pDoc->Event[sel].Inverted[i],
								pDoc->Event[sel].LogMapVar[i],
								pDoc->Event[sel].FNoiseVar[i],
								pDoc->Event[sel].HenonA[i],
								pDoc->Event[sel].HenonB[i],
								pDoc->Event[sel].HopalongVar[i],
								pDoc->Event[sel].MartinVar[i],
								pDoc->Event[sel].LorentzVar[i],
								pDoc->Event[sel].EarthWormVar[i],
								pDoc->Event[sel].EarthWormMulti[i],
								pDoc->Event[sel].EarthWormTruncator[i],
								pDoc->Event[sel].RandomMin[i],
								pDoc->Event[sel].RandomMax[i],
								pDoc->Event[sel].WolframRule[i],
								pDoc->Event[sel].WolframSize[i],
								pDoc->Event[sel].Hailstone[i]
					);
				}
			}
		}


		if(pDoc->Event[sel].AlgorithmNum[i]==ONE_OVER_F_NOISE)
		{
			LogMap2[i] = 0.2f;
			FNoise[i] = 0.0f;

			for(j = 0; j<count+((pDoc->Event[sel].StartNum[i])*dracula[i]); j++)
			{
				if(!((((pDoc->Event[sel].StartNum[i])*dracula[i])+j)%dracula[i]))
				{

				(*(Algorithm[ pDoc->Event[sel].AlgorithmNum[i] ]))(i, (pDoc->Event[sel].StartNum[i]*dracula[i]+j)/dracula[i], 0,
								pDoc->Event[sel].pScale[i], 
								pDoc->Event[sel].NumOcts[i], 
								pDoc->Event[sel].Base[i], 
								pDoc->Event[sel].StartNum[i],
								pDoc->Event[sel].Note[i], 
								pDoc->Event[sel].Modulates[i],
								pDoc->Event[sel].ModulRandom[i], 
								pDoc->Event[sel].ModulNum[i],
								pDoc->Event[sel].Inverted[i],
								pDoc->Event[sel].LogMapVar[i],
								pDoc->Event[sel].FNoiseVar[i],
								pDoc->Event[sel].HenonA[i],
								pDoc->Event[sel].HenonB[i],
								pDoc->Event[sel].HopalongVar[i],
								pDoc->Event[sel].MartinVar[i],
								pDoc->Event[sel].LorentzVar[i],
								pDoc->Event[sel].EarthWormVar[i],
								pDoc->Event[sel].EarthWormMulti[i],
								pDoc->Event[sel].EarthWormTruncator[i],
								pDoc->Event[sel].RandomMin[i],
								pDoc->Event[sel].RandomMax[i],
								pDoc->Event[sel].WolframRule[i],
								pDoc->Event[sel].WolframSize[i],
								pDoc->Event[sel].Hailstone[i]
					);
				}
			}
		}

		if(pDoc->Event[sel].AlgorithmNum[i]==HOPALONG)
		{
			HopalongX[i] = HopalongY[i] = 0.0f;

			for(j = 0; j<count+((pDoc->Event[sel].StartNum[i])*dracula[i]); j++)
			{
				if(!((((pDoc->Event[sel].StartNum[i])*dracula[i])+j)%dracula[i]))
				{

				(*(Algorithm[ pDoc->Event[sel].AlgorithmNum[i] ]))(i, (pDoc->Event[sel].StartNum[i]*dracula[i]+j)/dracula[i], 0,
								pDoc->Event[sel].pScale[i], 
								pDoc->Event[sel].NumOcts[i], 
								pDoc->Event[sel].Base[i], 
								pDoc->Event[sel].StartNum[i],
								pDoc->Event[sel].Note[i], 
								pDoc->Event[sel].Modulates[i],
								pDoc->Event[sel].ModulRandom[i], 
								pDoc->Event[sel].ModulNum[i],
								pDoc->Event[sel].Inverted[i],
								pDoc->Event[sel].LogMapVar[i],
								pDoc->Event[sel].FNoiseVar[i],
								pDoc->Event[sel].HenonA[i],
								pDoc->Event[sel].HenonB[i],
								pDoc->Event[sel].HopalongVar[i],
								pDoc->Event[sel].MartinVar[i],
								pDoc->Event[sel].LorentzVar[i],
								pDoc->Event[sel].EarthWormVar[i],
								pDoc->Event[sel].EarthWormMulti[i],
								pDoc->Event[sel].EarthWormTruncator[i],
								pDoc->Event[sel].RandomMin[i],
								pDoc->Event[sel].RandomMax[i],
								pDoc->Event[sel].WolframRule[i],
								pDoc->Event[sel].WolframSize[i],
								pDoc->Event[sel].Hailstone[i]
					);
				}
			}
		}


		if(pDoc->Event[sel].AlgorithmNum[i]==MARTIN)
		{
			MartinX[i] = MartinY[i] = 0.0f;

			for(j = 0; j<count+((pDoc->Event[sel].StartNum[i])*dracula[i]); j++)
			{
				if(!((((pDoc->Event[sel].StartNum[i])*dracula[i])+j)%dracula[i]))
				{

				(*(Algorithm[ pDoc->Event[sel].AlgorithmNum[i] ]))(i, (pDoc->Event[sel].StartNum[i]*dracula[i]+j)/dracula[i], 0,
								pDoc->Event[sel].pScale[i], 
								pDoc->Event[sel].NumOcts[i], 
								pDoc->Event[sel].Base[i], 
								pDoc->Event[sel].StartNum[i],
								pDoc->Event[sel].Note[i], 
								pDoc->Event[sel].Modulates[i],
								pDoc->Event[sel].ModulRandom[i], 
								pDoc->Event[sel].ModulNum[i],
								pDoc->Event[sel].Inverted[i],
								pDoc->Event[sel].LogMapVar[i],
								pDoc->Event[sel].FNoiseVar[i],
								pDoc->Event[sel].HenonA[i],
								pDoc->Event[sel].HenonB[i],
								pDoc->Event[sel].HopalongVar[i],
								pDoc->Event[sel].MartinVar[i],
								pDoc->Event[sel].LorentzVar[i],
								pDoc->Event[sel].EarthWormVar[i],
								pDoc->Event[sel].EarthWormMulti[i],
								pDoc->Event[sel].EarthWormTruncator[i],
								pDoc->Event[sel].RandomMin[i],
								pDoc->Event[sel].RandomMax[i],
								pDoc->Event[sel].WolframRule[i],
								pDoc->Event[sel].WolframSize[i],
								pDoc->Event[sel].Hailstone[i]
					);
				}
			}
		}


		if(pDoc->Event[sel].AlgorithmNum[i]==GINGERBREADMAN)
		{
			GingerX[i] = pDoc->Event[sel].GingerX[i];
			GingerY[i] = pDoc->Event[sel].GingerY[i];

			for(j = 0; j<count+((pDoc->Event[sel].StartNum[i])*dracula[i]); j++)
			{
				if(!((((pDoc->Event[sel].StartNum[i])*dracula[i])+j)%dracula[i]))
				{

				(*(Algorithm[ pDoc->Event[sel].AlgorithmNum[i] ]))(i, (pDoc->Event[sel].StartNum[i]*dracula[i]+j)/dracula[i], 0,
								pDoc->Event[sel].pScale[i], 
								pDoc->Event[sel].NumOcts[i], 
								pDoc->Event[sel].Base[i], 
								pDoc->Event[sel].StartNum[i],
								pDoc->Event[sel].Note[i], 
								pDoc->Event[sel].Modulates[i],
								pDoc->Event[sel].ModulRandom[i], 
								pDoc->Event[sel].ModulNum[i],
								pDoc->Event[sel].Inverted[i],
								pDoc->Event[sel].LogMapVar[i],
								pDoc->Event[sel].FNoiseVar[i],
								pDoc->Event[sel].HenonA[i],
								pDoc->Event[sel].HenonB[i],
								pDoc->Event[sel].HopalongVar[i],
								pDoc->Event[sel].MartinVar[i],
								pDoc->Event[sel].LorentzVar[i],
								pDoc->Event[sel].EarthWormVar[i],
								pDoc->Event[sel].EarthWormMulti[i],
								pDoc->Event[sel].EarthWormTruncator[i],
								pDoc->Event[sel].RandomMin[i],
								pDoc->Event[sel].RandomMax[i],
								pDoc->Event[sel].WolframRule[i],
								pDoc->Event[sel].WolframSize[i],
								pDoc->Event[sel].Hailstone[i]
					);
				}
			}
		}


		if(pDoc->Event[sel].AlgorithmNum[i]==LORENTZ)
		{
			LorentzX[i] = 1.0f;

			for(j = 0; j<count+((pDoc->Event[sel].StartNum[i])*dracula[i]); j++)
			{
				if(!((((pDoc->Event[sel].StartNum[i])*dracula[i])+j)%dracula[i]))
				{

				(*(Algorithm[ pDoc->Event[sel].AlgorithmNum[i] ]))(i, (pDoc->Event[sel].StartNum[i]*dracula[i]+j)/dracula[i], 0,
								pDoc->Event[sel].pScale[i], 
								pDoc->Event[sel].NumOcts[i], 
								pDoc->Event[sel].Base[i], 
								pDoc->Event[sel].StartNum[i],
								pDoc->Event[sel].Note[i], 
								pDoc->Event[sel].Modulates[i],
								pDoc->Event[sel].ModulRandom[i], 
								pDoc->Event[sel].ModulNum[i],
								pDoc->Event[sel].Inverted[i],
								pDoc->Event[sel].LogMapVar[i],
								pDoc->Event[sel].FNoiseVar[i],
								pDoc->Event[sel].HenonA[i],
								pDoc->Event[sel].HenonB[i],
								pDoc->Event[sel].HopalongVar[i],
								pDoc->Event[sel].MartinVar[i],
								pDoc->Event[sel].LorentzVar[i],
								pDoc->Event[sel].EarthWormVar[i],
								pDoc->Event[sel].EarthWormMulti[i],
								pDoc->Event[sel].EarthWormTruncator[i],
								pDoc->Event[sel].RandomMin[i],
								pDoc->Event[sel].RandomMax[i],
								pDoc->Event[sel].WolframRule[i],
								pDoc->Event[sel].WolframSize[i],
								pDoc->Event[sel].Hailstone[i]
					);
				}
			}
		}


		if(pDoc->Event[sel].AlgorithmNum[i]==EARTHWORM)
		{
			EarthWorm[i] = pDoc->Event[sel].EarthWormVar[i];

			for(j = 0; j<count+((pDoc->Event[sel].StartNum[i])*dracula[i]); j++)
			{
				if(!((((pDoc->Event[sel].StartNum[i])*dracula[i])+j)%dracula[i]))
				{

				(*(Algorithm[ pDoc->Event[sel].AlgorithmNum[i] ]))(i, (pDoc->Event[sel].StartNum[i]*dracula[i]+j)/dracula[i], 0,
								pDoc->Event[sel].pScale[i], 
								pDoc->Event[sel].NumOcts[i], 
								pDoc->Event[sel].Base[i], 
								pDoc->Event[sel].StartNum[i],
								pDoc->Event[sel].Note[i], 
								pDoc->Event[sel].Modulates[i],
								pDoc->Event[sel].ModulRandom[i], 
								pDoc->Event[sel].ModulNum[i],
								pDoc->Event[sel].Inverted[i],
								pDoc->Event[sel].LogMapVar[i],
								pDoc->Event[sel].FNoiseVar[i],
								pDoc->Event[sel].HenonA[i],
								pDoc->Event[sel].HenonB[i],
								pDoc->Event[sel].HopalongVar[i],
								pDoc->Event[sel].MartinVar[i],
								pDoc->Event[sel].LorentzVar[i],
								pDoc->Event[sel].EarthWormVar[i],
								pDoc->Event[sel].EarthWormMulti[i],
								pDoc->Event[sel].EarthWormTruncator[i],
								pDoc->Event[sel].RandomMin[i],
								pDoc->Event[sel].RandomMax[i],
								pDoc->Event[sel].WolframRule[i],
								pDoc->Event[sel].WolframSize[i],
								pDoc->Event[sel].Hailstone[i]
					);
				}
			}
		}


		if(pDoc->Event[sel].AlgorithmNum[i]==HAILSTONE)
		{
			HailStoneNumber[i] = pDoc->Event[sel].Hailstone[i];

			for(j = 0; j<count+((pDoc->Event[sel].StartNum[i])*dracula[i]); j++)
			{
				if(!((((pDoc->Event[sel].StartNum[i])*dracula[i])+j)%dracula[i]))
				{

				(*(Algorithm[ pDoc->Event[sel].AlgorithmNum[i] ]))(i, (pDoc->Event[sel].StartNum[i]*dracula[i]+j)/dracula[i], 0,
								pDoc->Event[sel].pScale[i], 
								pDoc->Event[sel].NumOcts[i], 
								pDoc->Event[sel].Base[i], 
								pDoc->Event[sel].StartNum[i],
								pDoc->Event[sel].Note[i], 
								pDoc->Event[sel].Modulates[i],
								pDoc->Event[sel].ModulRandom[i], 
								pDoc->Event[sel].ModulNum[i],
								pDoc->Event[sel].Inverted[i],
								pDoc->Event[sel].LogMapVar[i],
								pDoc->Event[sel].FNoiseVar[i],
								pDoc->Event[sel].HenonA[i],
								pDoc->Event[sel].HenonB[i],
								pDoc->Event[sel].HopalongVar[i],
								pDoc->Event[sel].MartinVar[i],
								pDoc->Event[sel].LorentzVar[i],
								pDoc->Event[sel].EarthWormVar[i],
								pDoc->Event[sel].EarthWormMulti[i],
								pDoc->Event[sel].EarthWormTruncator[i],
								pDoc->Event[sel].RandomMin[i],
								pDoc->Event[sel].RandomMax[i],
								pDoc->Event[sel].WolframRule[i],
								pDoc->Event[sel].WolframSize[i],
								pDoc->Event[sel].Hailstone[i]
					);
				}
			}
		}


		if(pDoc->Event[sel].AlgorithmNum[i]==WOLFRAM)
		{
			if (WolframArray1[i])
			{
				delete WolframArray1[i];
				WolframArray1[i] = NULL;
			}
			if (WolframArray2[i])
			{
				delete WolframArray2[i];
				WolframArray2[i] = NULL;
			}

			WolframArray1[i] = new BYTE[pDoc->Event[sel].WolframSize[i]];
			WolframArray2[i] = new BYTE[pDoc->Event[sel].WolframSize[i]];

			for (int idx = 0; idx<32; idx++)
				WolframArray1[i][idx] = pDoc->Event[sel].WolframInit[i] & unsigned long (pow(2, idx)) ? 1 : 0;

			if (pDoc->Event[sel].WolframSize[i]>32)
			{
				for (idx = 32; idx<pDoc->Event[sel].WolframSize[i]; idx++)
				WolframArray1[i][idx] = 0;
			}

			for(j = 0; j<count+((pDoc->Event[sel].StartNum[i])*dracula[i]); j++)
			{
				if(!((((pDoc->Event[sel].StartNum[i])*dracula[i])+j)%dracula[i]))
				{

				(*(Algorithm[ pDoc->Event[sel].AlgorithmNum[i] ]))(i, (pDoc->Event[sel].StartNum[i]*dracula[i]+j)/dracula[i], 0,
								pDoc->Event[sel].pScale[i], 
								pDoc->Event[sel].NumOcts[i], 
								pDoc->Event[sel].Base[i], 
								pDoc->Event[sel].StartNum[i],
								pDoc->Event[sel].Note[i], 
								pDoc->Event[sel].Modulates[i],
								pDoc->Event[sel].ModulRandom[i], 
								pDoc->Event[sel].ModulNum[i],
								pDoc->Event[sel].Inverted[i],
								pDoc->Event[sel].LogMapVar[i],
								pDoc->Event[sel].FNoiseVar[i],
								pDoc->Event[sel].HenonA[i],
								pDoc->Event[sel].HenonB[i],
								pDoc->Event[sel].HopalongVar[i],
								pDoc->Event[sel].MartinVar[i],
								pDoc->Event[sel].LorentzVar[i],
								pDoc->Event[sel].EarthWormVar[i],
								pDoc->Event[sel].EarthWormMulti[i],
								pDoc->Event[sel].EarthWormTruncator[i],
								pDoc->Event[sel].RandomMin[i],
								pDoc->Event[sel].RandomMax[i],
								pDoc->Event[sel].WolframRule[i],
								pDoc->Event[sel].WolframSize[i],
								pDoc->Event[sel].Hailstone[i]
					);
				}
			}
		}

	
	}

	while(m_Playing&&(count<pDoc->Event[sel].genCount))
	{
		for (i=VOICE1; i<MAXVOICES; i++)
		{
			if(((pDoc->Event[sel].StartNum[i]*dracula[i])+count)>=0)
			{

			if(!((((pDoc->Event[sel].StartNum[i])*dracula[i])+count)%dracula[i]))
			{
				test[i] = (((((pDoc->Event[sel].StartNum[i])*dracula[i])+count)/dracula[i])*pDoc->Event[sel].Multi[i]);
				note[i] = (*(Algorithm[ pDoc->Event[sel].AlgorithmNum[i] ]))(i, (((pDoc->Event[sel].StartNum[i])*dracula[i])+count)/dracula[i], test[i],
									pDoc->Event[sel].pScale[i], 
									pDoc->Event[sel].NumOcts[i], 
									pDoc->Event[sel].Base[i], 
									pDoc->Event[sel].StartNum[i],
									pDoc->Event[sel].Note[i], 
									pDoc->Event[sel].Modulates[i],
									pDoc->Event[sel].ModulRandom[i], 
									pDoc->Event[sel].ModulNum[i],
									pDoc->Event[sel].Inverted[i],
									pDoc->Event[sel].LogMapVar[i],
									pDoc->Event[sel].FNoiseVar[i],
									pDoc->Event[sel].HenonA[i],
									pDoc->Event[sel].HenonB[i],
									pDoc->Event[sel].HopalongVar[i],
									pDoc->Event[sel].MartinVar[i],
									pDoc->Event[sel].LorentzVar[i],
									pDoc->Event[sel].EarthWormVar[i],
									pDoc->Event[sel].EarthWormMulti[i],
									pDoc->Event[sel].EarthWormTruncator[i],
									pDoc->Event[sel].RandomMin[i],
									pDoc->Event[sel].RandomMax[i],
									pDoc->Event[sel].WolframRule[i],
									pDoc->Event[sel].WolframSize[i],
									pDoc->Event[sel].Hailstone[i]
					);
			}

			}
		}


		for (i=VOICE1; i<MAXVOICES; i++)
		{
			if(((pDoc->Event[sel].StartNum[i]*dracula[i])+count)>=0)
			{

				if(!((((pDoc->Event[sel].StartNum[i])*dracula[i])+count)%dracula[i]))
				{
					if ((lastnote[i]!=note[i]))
					{
						noteOff(0x80+pDoc->Event[sel].Channel[i], (BYTE)prevnote[i], (BYTE)(pDoc->Event[sel].Dynamic[i]*pDoc->Event[sel].IsActive[i]));
						if (pDoc->Event[sel].Channel[i] == PercussionChannel)
							noteOn(0x90+pDoc->Event[sel].Channel[i], (BYTE)pDoc->Event[sel].Percussion[i]+35, (BYTE)(pDoc->Event[sel].Dynamic[i]*pDoc->Event[sel].IsActive[i]));
						else
							noteOn(0x90+pDoc->Event[sel].Channel[i], (BYTE)note[i], (BYTE)(pDoc->Event[sel].Dynamic[i]*pDoc->Event[sel].IsActive[i]));
						lastnote[i] = pDoc->Event[sel].Mode[i]? note[i] : -1;
						prevnote[i] = pDoc->Event[sel].Channel[i] == PercussionChannel? pDoc->Event[sel].Percussion[i]+35 : note[i];
					}

				}

			}

		}

		count++;
		Sleep(duration);
	}

	for (i=VOICE1; i<MAXVOICES; i++)
		for(int j=0; j<128; j++)
			noteOff(0x80+/*pDoc->Event[sel].Channel[i]*/i, (BYTE)j, (BYTE)0/*(pDoc->Event[sel].Dynamic[i]*pDoc->Event[sel].IsActive[i])*/);

	pEv->OnStop();

	return 0;
}


void CEventsDlg::OnDblclkEventlist() 
{
	if (m_Playing)
		return;

	CFractMusView* pView = (CFractMusView*)m_pParent;
	CFractMusDoc* pDoc = pView->GetDocument();
	CListBox* pList = (CListBox*)(this->GetDlgItem(IDC_EVENTLIST));
	CComboBox* pB;
	CButton* pButt;
	CEdit* pE;
	CScrollBar* pS;
	CStatic* pSt = (CStatic*)(pView->GetDlgItem(IDC_TEMPO_STATIC));


	int sel = pList->GetCurSel();

	if (sel == LB_ERR)
		return;

	Tempo = pView->m_TempoMarking = pDoc->m_TempoMarking = pDoc->Event[sel].Tempo;
	pView->GeneralCounter = pDoc->dGeneralCounter = pDoc->Event[sel].genCount;
	pView->StartCounter = pView->m_StartFrom = pDoc->dStartCounter = pDoc->Event[sel].count;
	pView->m_StartFrom = pDoc->Event[sel].count;
	pDoc->m_TimeSigNum = pDoc->Event[sel].TimeSigNum;
	pDoc->m_TimeSigDen = pDoc->Event[sel].TimeSigDen;

	pS = (CScrollBar*)(pView->GetDlgItem(IDC_TEMPO_SLIDER2));
	pS->SetScrollPos(Tempo);


	char s[10];

	itoa(Tempo, s, 10);
	pSt->SetWindowText(s);

	pB = (CComboBox*)(pView->GetDlgItem(IDC_TIMESIGNUM_CMB));
	pB->SetCurSel((pDoc->m_TimeSigNum)-1);
	pB = (CComboBox*)(pView->GetDlgItem(IDC_TIMESIGDEN_CMB));
	pB->SetCurSel(int(log10(double(pDoc->m_TimeSigDen))/log10((double)2)));

	for(int i = VOICE1; i<MAXVOICES; i++)
	{
		pDoc->AlgorithmNum[i] = pDoc->Event[sel].AlgorithmNum[i];
		pDoc->m_IsActive[i] = pView->m_IsActive[i] = pDoc->Event[sel].IsActive[i];
		pDoc->m_Base[i]  = pDoc->Event[sel].Base[i];
		pDoc->m_Multi[i] = pDoc->Event[sel].Multi[i];
		pDoc->m_StartNum[i] = pView->m_StartNum[i] = pDoc->Event[sel].StartNum[i];
		pDoc->m_NumOcts[i] = pDoc->Event[sel].NumOcts[i];
		pDoc->m_Modulates[i] = pView->m_Modulates[i] = pDoc->Event[sel].Modulates[i] ;
		pDoc->m_ModulRandom[i] = pView->m_V1Modul[i].m_V1ModulDlgChoice = pDoc->Event[sel].ModulRandom[i] ;
		pDoc->m_ModulNum[i] = pView->m_V1Modul[i].m_V1ModulDlgNum = pDoc->Event[sel].ModulNum[i] ;
		pDoc->m_Note[i] = pView->m_Note[i] = pDoc->Event[sel].Note[i] ;
		pDoc->m_NoteValue[i] = pDoc->Event[sel].NoteValue[i] ;
		pDoc->m_Instrument[i] = pView->m_V1MidiSet[i].m_instrument  = pDoc->Event[sel].Instrument[i];
		pDoc->m_Channel[i] = pDoc->Event[sel].Channel[i];
		pDoc->m_mode[i] = pView->m_V1MidiSet[i].m_mode = pDoc->Event[sel].Mode[i];
		pDoc->m_ScaleID[i] = pView->m_ScaleID[i] = pDoc->Event[sel].ScaleID[i];
		pDoc->m_NumOctsID[i] = pView->m_NumOctsID[i] = pDoc->Event[sel].NumOctsID[i];
		pDoc->m_NoteValueID[i] = pView->m_NoteValueID[i] = pDoc->Event[sel].NoteValueID[i];
		pDoc->m_Inverted[i] = pDoc->Event[sel].Inverted[i];
		pDoc->m_MatchScale[i] = pDoc->Event[sel].MatchScale[i];
		pDoc->m_Dynamic[i] = pDoc->Event[sel].Dynamic[i];
		pDoc->m_DynChoice[i] = pDoc->Event[sel].DynChoice[i];
		pDoc->m_LogMapVar[i] = pDoc->Event[sel].LogMapVar[i];
		pDoc->m_FNoiseVar[i] = pDoc->Event[sel].FNoiseVar[i];
		pDoc->m_LorentzVar[i] = pDoc->Event[sel].LorentzVar[i];
		pDoc->m_HenonA[i] = pDoc->Event[sel].HenonA[i];
		pDoc->m_HenonB[i] = pDoc->Event[sel].HenonB[i];
		pDoc->m_HopalongVar[i] = pDoc->Event[sel].HopalongVar[i];
		pDoc->m_MartinVar[i] = pDoc->Event[sel].MartinVar[i];
		pDoc->m_GingerX[i] = pDoc->Event[sel].GingerX[i];
		pDoc->m_GingerY[i] = pDoc->Event[sel].GingerY[i];
		pDoc->m_EarthWormVar[i] = pDoc->Event[sel].EarthWormVar[i];
		pDoc->m_EarthWormMulti[i] = pDoc->Event[sel].EarthWormMulti[i];
		pDoc->m_EarthWormTruncator[i] = pDoc->Event[sel].EarthWormTruncator[i];
		pDoc->m_RandomMin[i] = pDoc->Event[sel].RandomMin[i];
		pDoc->m_RandomMax[i] = pDoc->Event[sel].RandomMax[i];

		pDoc->m_WolframRule[i] = pDoc->Event[sel].WolframRule[i];
		pDoc->m_WolframInit[i] = pDoc->Event[sel].WolframInit[i];
		pDoc->m_WolframSize[i] = pDoc->Event[sel].WolframSize[i];
		pDoc->m_Hailstone[i] = pDoc->Event[sel].Hailstone[i];

		pDoc->m_Pan[i] = pDoc->Event[sel].Pan[i];
		pDoc->m_Percussion[i] = pDoc->Event[sel].Percussion[i];

		pButt = (CButton*)(pView->GetDlgItem(pView->ActiveID[i]));

		if (pDoc->m_Channel[i] == PercussionChannel)
		{
			pButt->SetWindowText(PercussionNames[ pDoc->m_Percussion[i] ]);
		}
		else
			pButt->SetWindowText(InstrumentNames[ pDoc->m_Instrument[i] ]);


	}

	pView->UpdateData(FALSE);


	for(i = VOICE1; i<MAXVOICES; i++)
	{

		pE = (CEdit*)(pView->GetDlgItem(pView->StartNumID[i]))->EnableWindow(pView->m_IsActive[i]&&(!IsDocumentLocked));
		pButt = (CButton*)(pView->GetDlgItem(pView->ModulatesID[i]))->EnableWindow(pView->m_IsActive[i]&&(!IsDocumentLocked));
		pB = (CComboBox*)(pView->GetDlgItem(pView->NumOctsID[i]));
		pB->SetCurSel(pView->m_NumOctsID[i]);
		pB = (CComboBox*)(pView->GetDlgItem(pView->NumOctsID[i]))->EnableWindow(pView->m_IsActive[i]&&(!IsDocumentLocked));
		pB = (CComboBox*)(pView->GetDlgItem(pView->NoteID[i]));
		pB->SetCurSel(pView->m_Note[i]);
		pB = (CComboBox*)(pView->GetDlgItem(pView->NoteID[i]))->EnableWindow(pView->m_IsActive[i]&&(!IsDocumentLocked));
		pB = (CComboBox*)(pView->GetDlgItem(pView->ScaleID[i]));
		pB->SetCurSel(pView->m_ScaleID[i]);
		pB = (CComboBox*)(pView->GetDlgItem(pView->ScaleID[i]))->EnableWindow(pView->m_IsActive[i]&&(!IsDocumentLocked));
		pB = (CComboBox*)(pView->GetDlgItem(pView->NoteValueID[i]));
		pB->SetCurSel(pView->m_NoteValueID[i]);
		pB = (CComboBox*)(pView->GetDlgItem(pView->NoteValueID[i]))->EnableWindow(pView->m_IsActive[i]&&(!IsDocumentLocked));
		pButt = (CButton*)(pView->GetDlgItem(pView->MidiButtonID[i]))->EnableWindow(pView->m_IsActive[i]&&(!IsDocumentLocked));
	}

	for (i = VOICE1; i<MAXVOICES; i++)
	{
		CString nval;

		if (pView->m_NoteValueID[i] == OTHER)
		{
			nval.Format("Other (%d)", (long)pDoc->m_NoteValue[i]);
			pB = (CComboBox*)(pView->GetDlgItem(pView->NoteValueID[i]));
			pB->DeleteString(OTHER);
			pB->AddString(nval);
			pB->SetCurSel(OTHER);
		}
	}



	for(i = VOICE1; i<MAXVOICES; i++)
	{
		if (pDoc->m_pUserScale[i])
		{
			delete pDoc->m_pUserScale[i];
			pDoc->m_pUserScale[i] = NULL;
		}
		pDoc->m_pUserScale[i] = new int[pDoc->Event[sel].pUserScale[i][0] + 1];
		pDoc->m_pUserScale[i][0] = pDoc->Event[sel].pUserScale[i][0];
		for(int j = 1; j<=pDoc->Event[sel].pUserScale[i][0]; j++)
			pDoc->m_pUserScale[i][j] = pDoc->Event[sel].pUserScale[i][j];
	}


	for(i = VOICE1; i<MAXVOICES; i++)
	{
		if (pDoc->m_pScale[i])
		{
			delete pDoc->m_pScale[i];
			pDoc->m_pScale[i] = NULL;
		}
		pDoc->m_pScale[i] = new int[pDoc->Event[sel].pScale[i][0] + 1];
		pDoc->m_pScale[i][0] = pDoc->Event[sel].pScale[i][0];
		for(int j = 1; j<=pDoc->Event[sel].pScale[i][0]; j++)
			pDoc->m_pScale[i][j] = pDoc->Event[sel].pScale[i][j];
/*		if (pDoc->m_ScaleID[i] == USER_DEFINED)
		{
			pView->InitUserScale(i);
			pView->SetUserScale(i);
		}*/
	}

	pB = (CComboBox*)pView->GetDlgItem(IDC_PLAYFROM_CMB);
	pB->SetCurSel(sel);

	
}

void CEventsDlg::OnClear() 
{

	CFractMusView* pView = (CFractMusView*)m_pParent;
	CFractMusDoc* pDoc = pView->GetDocument();
	CListBox* pList = (CListBox*)(this->GetDlgItem(IDC_EVENTLIST));
	CListBox* pEvInfo = (CListBox*)(GetDlgItem(IDC_EVENTINFOLIST));
	CComboBox* pCB = (CComboBox*)pView->GetDlgItem(IDC_PLAYFROM_CMB);

	int answer = MessageBox("Are you sure?", "Delete All", MB_YESNO);

	if (answer == IDNO)
		return;

	while (m_NumEvents>-1)
	{

		pList->DeleteString(m_NumEvents);
		pCB->DeleteString(m_NumEvents);

		--m_NumEvents;
		--pDoc->m_NumEvents;



	}

	pView->PlayChoice = CURRENT_SETTINGS;
	pView->GetDlgItem(IDC_PLAYFROM_CMB)->EnableWindow(FALSE);
	pView->GetDlgItem(IDC_PLAYFROM_BT)->EnableWindow(FALSE);

	pEvInfo->ResetContent();

	pDoc->SetModifiedFlag();
	
}

void CEventsDlg::OnInsert() 
{
	if(m_NumEvents<0)
		return;

	CFractMusView* pView = (CFractMusView*)m_pParent;
	CFractMusDoc* pDoc = pView->GetDocument();
	CListBox* pList = (CListBox*)(this->GetDlgItem(IDC_EVENTLIST));
	CComboBox* pCB = (CComboBox*)pView->GetDlgItem(IDC_PLAYFROM_CMB);

	int track, sel, i;

	sel = pList->GetCurSel();

	if (sel == LB_ERR)
		return;

	if(pDoc->dStartCounter>=pDoc->dGeneralCounter)
	{
		MessageBox("Minimum difference between Start and End counters  is 1", "Error", MB_OK+MB_ICONEXCLAMATION);
		return;
	}

	++pDoc->m_NumEvents;

	track = ++m_NumEvents;

	while(track>sel)
	{

		pDoc->Event[track].Tempo = pDoc->Event[track-1].Tempo;
		pDoc->Event[track].TimeSigNum= pDoc->Event[track-1].TimeSigNum;
		pDoc->Event[track].TimeSigDen= pDoc->Event[track-1].TimeSigDen;
		pDoc->Event[track].count = pDoc->Event[track-1].count;
		pDoc->Event[track].genCount = pDoc->Event[track-1].genCount;



		for(i=VOICE1; i<MAXVOICES; i++)
		{
			pDoc->Event[track].AlgorithmNum[i] = pDoc->Event[track-1].AlgorithmNum[i];
			pDoc->Event[track].IsActive[i] = pDoc->Event[track-1].IsActive[i];
			pDoc->Event[track].Base[i] = pDoc->Event[track-1].Base[i];
			pDoc->Event[track].Multi[i] = pDoc->Event[track-1].Multi[i];
			pDoc->Event[track].StartNum[i] = pDoc->Event[track-1].StartNum[i];
			pDoc->Event[track].NumOcts[i] = pDoc->Event[track-1].NumOcts[i];
			pDoc->Event[track].Modulates[i] = pDoc->Event[track-1].Modulates[i];
			pDoc->Event[track].ModulRandom[i] = pDoc->Event[track-1].ModulRandom[i];
			pDoc->Event[track].ModulNum[i] = pDoc->Event[track-1].ModulNum[i];
			pDoc->Event[track].Note[i] = pDoc->Event[track-1].Note[i];
			pDoc->Event[track].NoteValue[i] = pDoc->Event[track-1].NoteValue[i];
			pDoc->Event[track].Instrument[i] = pDoc->Event[track-1].Instrument[i];
			pDoc->Event[track].Channel[i] = pDoc->Event[track-1].Channel[i];
			pDoc->Event[track].Mode[i] = pDoc->Event[track-1].Mode[i];
			pDoc->Event[track].ScaleID[i] = pDoc->Event[track-1].ScaleID[i];
			pDoc->Event[track].NumOctsID[i] = pDoc->Event[track-1].NumOctsID[i];
			pDoc->Event[track].NoteValueID[i] = pDoc->Event[track-1].NoteValueID[i];
			pDoc->Event[track].Inverted[i] = pDoc->Event[track-1].Inverted[i];
			pDoc->Event[track].MatchScale[i] = pDoc->Event[track-1].MatchScale[i];
			pDoc->Event[track].Dynamic[i] = pDoc->Event[track-1].Dynamic[i];
			pDoc->Event[track].DynChoice[i] = pDoc->Event[track-1].DynChoice[i];
			pDoc->Event[track].LogMapVar[i] = pDoc->Event[track-1].LogMapVar[i];
			pDoc->Event[track].FNoiseVar[i] = pDoc->Event[track-1].FNoiseVar[i];
			pDoc->Event[track].LorentzVar[i] = pDoc->Event[track-1].LorentzVar[i];
			pDoc->Event[track].HenonA[i] = pDoc->Event[track-1].HenonA[i];
			pDoc->Event[track].HenonB[i] = pDoc->Event[track-1].HenonB[i];
			pDoc->Event[track].HopalongVar[i] = pDoc->Event[track-1].HopalongVar[i];
			pDoc->Event[track].MartinVar[i] = pDoc->Event[track-1].MartinVar[i];
			pDoc->Event[track].GingerX[i] = pDoc->Event[track-1].GingerX[i];
			pDoc->Event[track].GingerY[i] = pDoc->Event[track-1].GingerY[i];

			pDoc->Event[track].EarthWormVar[i] = pDoc->Event[track-1].EarthWormVar[i];
			pDoc->Event[track].EarthWormMulti[i] = pDoc->Event[track-1].EarthWormMulti[i];
			pDoc->Event[track].EarthWormTruncator[i] = pDoc->Event[track-1].EarthWormTruncator[i];
			pDoc->Event[track].RandomMin[i] = pDoc->Event[track-1].RandomMin[i];
			pDoc->Event[track].RandomMax[i] = pDoc->Event[track-1].RandomMax[i];
			pDoc->Event[track].WolframRule[i] = pDoc->Event[track-1].WolframRule[i];
			pDoc->Event[track].WolframInit[i] = pDoc->Event[track-1].WolframInit[i];
			pDoc->Event[track].WolframSize[i] = pDoc->Event[track-1].WolframSize[i];

			pDoc->Event[track].Hailstone[i] = pDoc->Event[track-1].Hailstone[i];
			pDoc->Event[track].Pan[i] = pDoc->Event[track-1].Pan[i];
			pDoc->Event[track].Percussion[i] = pDoc->Event[track-1].Percussion[i];
		}
		
		for(i=0; i<MAXVOICES; i++)
		{
			if (pDoc->Event[track].pUserScale[i])
			{
				delete pDoc->Event[track].pUserScale[i];
				pDoc->Event[track].pUserScale[i] = NULL;
			}
			pDoc->Event[track].pUserScale[i] = new int[pDoc->Event[track-1].pUserScale[i][0] +1];
			for(int j=0; j<=pDoc->Event[track-1].pUserScale[i][0]; j++)
				pDoc->Event[track].pUserScale[i][j] = pDoc->Event[track-1].pUserScale[i][j];
		}

		for(i=0; i<MAXVOICES; i++)
		{
			if (pDoc->Event[track].pScale[i])
			{
				delete pDoc->Event[track].pScale[i];
				pDoc->Event[track].pScale[i] = NULL;
			}
			pDoc->Event[track].pScale[i] = new int[pDoc->Event[track-1].pScale[i][0] +1];
			for(int j=0; j<=pDoc->Event[track-1].pScale[i][0]; j++)
				pDoc->Event[track].pScale[i][j] = pDoc->Event[track-1].pScale[i][j];
		}

		--track;

	} // while


	pDoc->Event[sel].Tempo = pDoc->m_TempoMarking;
	pDoc->Event[sel].TimeSigNum= pDoc->m_TimeSigNum;
	pDoc->Event[sel].TimeSigDen= pDoc->m_TimeSigDen;
	pDoc->Event[sel].count = pDoc->dStartCounter;
	pDoc->Event[sel].genCount = pDoc->dGeneralCounter;



	for(i=VOICE1; i<MAXVOICES; i++)
	{
		pDoc->Event[sel].AlgorithmNum[i] = pDoc->AlgorithmNum[i];
		pDoc->Event[sel].IsActive[i] = pDoc->m_IsActive[i];
		pDoc->Event[sel].Base[i] = pDoc->m_Base[i];
		pDoc->Event[sel].Multi[i] = pDoc->m_Multi[i];
		pDoc->Event[sel].StartNum[i] = pDoc->m_StartNum[i];
		pDoc->Event[sel].NumOcts[i] = pDoc->m_NumOcts[i];
		pDoc->Event[sel].Modulates[i] = pDoc->m_Modulates[i];
		pDoc->Event[sel].ModulRandom[i] = pDoc->m_ModulRandom[i];
		pDoc->Event[sel].ModulNum[i] = pDoc->m_ModulNum[i];
		pDoc->Event[sel].Note[i] = pDoc->m_Note[i];
		pDoc->Event[sel].NoteValue[i] = pDoc->m_NoteValue[i];
		pDoc->Event[sel].Instrument[i] = pDoc->m_Instrument[i];
		pDoc->Event[sel].Channel[i] = pDoc->m_Channel[i];
		pDoc->Event[sel].Mode[i] = pDoc->m_mode[i];
		pDoc->Event[sel].ScaleID[i] = pDoc->m_ScaleID[i];
		pDoc->Event[sel].NumOctsID[i] = pDoc->m_NumOctsID[i];
		pDoc->Event[sel].NoteValueID[i] = pDoc->m_NoteValueID[i];
		pDoc->Event[sel].Inverted[i] = pDoc->m_Inverted[i];
		pDoc->Event[sel].MatchScale[i] = pDoc->m_MatchScale[i];
		pDoc->Event[sel].Dynamic[i] = pDoc->m_Dynamic[i];
		pDoc->Event[sel].DynChoice[i] = pDoc->m_DynChoice[i];
		pDoc->Event[sel].LogMapVar[i] = pDoc->m_LogMapVar[i];
		pDoc->Event[sel].FNoiseVar[i] = pDoc->m_FNoiseVar[i];
		pDoc->Event[sel].LorentzVar[i] = pDoc->m_LorentzVar[i];
		pDoc->Event[sel].HenonA[i] = pDoc->m_HenonA[i];
		pDoc->Event[sel].HenonB[i] = pDoc->m_HenonB[i];
		pDoc->Event[sel].HopalongVar[i] = pDoc->m_HopalongVar[i];
		pDoc->Event[sel].MartinVar[i] = pDoc->m_MartinVar[i];
		pDoc->Event[sel].GingerX[i] = pDoc->m_GingerX[i];
		pDoc->Event[sel].GingerY[i] = pDoc->m_GingerY[i];
		pDoc->Event[sel].EarthWormVar[i] = pDoc->m_EarthWormVar[i];
		pDoc->Event[sel].EarthWormMulti[i] = pDoc->m_EarthWormMulti[i];
		pDoc->Event[sel].EarthWormTruncator[i] = pDoc->m_EarthWormTruncator[i];
		pDoc->Event[sel].RandomMin[i] = pDoc->m_RandomMin[i];
		pDoc->Event[sel].RandomMax[i] = pDoc->m_RandomMax[i];

		pDoc->Event[sel].WolframRule[i] = pDoc->m_WolframRule[i];
		pDoc->Event[sel].WolframInit[i] = pDoc->m_WolframInit[i];
		pDoc->Event[sel].WolframSize[i] = pDoc->m_WolframSize[i];

		pDoc->Event[sel].Hailstone[i] = pDoc->m_Hailstone[i];

		pDoc->Event[sel].Pan[i] = pDoc->m_Pan[i];
		pDoc->Event[sel].Percussion[i] = pDoc->m_Percussion[i];
	}

	for(i=0; i<MAXVOICES; i++)
	{
		if (pDoc->Event[sel].pUserScale[i])
		{
			delete pDoc->Event[sel].pUserScale[i];
			pDoc->Event[sel].pUserScale[i] = NULL;
		}
		pDoc->Event[sel].pUserScale[i] = new int[pDoc->m_pUserScale[i][0] +1];
		for(int j=0; j<=pDoc->m_pUserScale[i][0]; j++)
			pDoc->Event[sel].pUserScale[i][j] = pDoc->m_pUserScale[i][j];
	}

	for(i=0; i<MAXVOICES; i++)
	{
		if (pDoc->Event[sel].pScale[i])
		{
			delete pDoc->Event[sel].pScale[i];
			pDoc->Event[sel].pScale[i] = NULL;
		}
		pDoc->Event[sel].pScale[i] = new int[pDoc->m_pScale[i][0] +1];
		for(int j=0; j<=pDoc->m_pScale[i][0]; j++)
			pDoc->Event[sel].pScale[i][j] = pDoc->m_pScale[i][j];
	}


	CString toAdd;

	toAdd.Format("[%d -> %d]", pDoc->Event[sel].count, pDoc->Event[sel].genCount);

	pList->InsertString(sel, toAdd);

	toAdd.Format("%d", m_NumEvents);

	pCB->AddString(toAdd);





	
}

void CEventsDlg::OnReplaceBt() 
{
	CListBox* pList = (CListBox*)(GetDlgItem(IDC_EVENTLIST));
	CFractMusView* pView = (CFractMusView*)m_pParent;
	CFractMusDoc* pDoc = pView->GetDocument();

	int sel = pList->GetCurSel();

	if ((sel == LB_ERR))
	{
		return;
	}

	if(pDoc->dStartCounter>=pDoc->dGeneralCounter)
	{
		MessageBox("Minimum difference between Start and End counters  is 1", "Error", MB_OK+MB_ICONEXCLAMATION);
		return;
	}

	CString msg;
	
	msg.Format("Replace Event %d with current settings?", sel);

	if((MessageBox(msg,"Edit Event", MB_YESNO)) == IDYES)
	{
		
		pDoc->Event[sel].Tempo = pDoc->m_TempoMarking;
		pDoc->Event[sel].TimeSigNum= pDoc->m_TimeSigNum;
		pDoc->Event[sel].TimeSigDen= pDoc->m_TimeSigDen;
		pDoc->Event[sel].count = pDoc->dStartCounter;
		pDoc->Event[sel].genCount = pDoc->dGeneralCounter;



		for(int i=VOICE1; i<MAXVOICES; i++)
		{
			pDoc->Event[sel].AlgorithmNum[i] = pDoc->AlgorithmNum[i];
			pDoc->Event[sel].IsActive[i] = pDoc->m_IsActive[i];
			pDoc->Event[sel].Base[i] = pDoc->m_Base[i];
			pDoc->Event[sel].Multi[i] = pDoc->m_Multi[i];
			pDoc->Event[sel].StartNum[i] = pDoc->m_StartNum[i];
			pDoc->Event[sel].NumOcts[i] = pDoc->m_NumOcts[i];
			pDoc->Event[sel].Modulates[i] = pDoc->m_Modulates[i];
			pDoc->Event[sel].ModulRandom[i] = pDoc->m_ModulRandom[i];
			pDoc->Event[sel].ModulNum[i] = pDoc->m_ModulNum[i];
			pDoc->Event[sel].Note[i] = pDoc->m_Note[i];
			pDoc->Event[sel].NoteValue[i] = pDoc->m_NoteValue[i];
			pDoc->Event[sel].Instrument[i] = pDoc->m_Instrument[i];
			pDoc->Event[sel].Channel[i] = pDoc->m_Channel[i];
			pDoc->Event[sel].Mode[i] = pDoc->m_mode[i];
			pDoc->Event[sel].ScaleID[i] = pDoc->m_ScaleID[i];
			pDoc->Event[sel].NumOctsID[i] = pDoc->m_NumOctsID[i];
			pDoc->Event[sel].NoteValueID[i] = pDoc->m_NoteValueID[i];
			pDoc->Event[sel].Inverted[i] = pDoc->m_Inverted[i];
			pDoc->Event[sel].MatchScale[i] = pDoc->m_MatchScale[i];
			pDoc->Event[sel].Dynamic[i] = pDoc->m_Dynamic[i];
			pDoc->Event[sel].DynChoice[i] = pDoc->m_DynChoice[i];
			pDoc->Event[sel].LogMapVar[i] = pDoc->m_LogMapVar[i];
			pDoc->Event[sel].FNoiseVar[i] = pDoc->m_FNoiseVar[i];
			pDoc->Event[sel].LorentzVar[i] = pDoc->m_LorentzVar[i];
			pDoc->Event[sel].HenonA[i] = pDoc->m_HenonA[i];
			pDoc->Event[sel].HenonB[i] = pDoc->m_HenonB[i];
			pDoc->Event[sel].HopalongVar[i] = pDoc->m_HopalongVar[i];
			pDoc->Event[sel].MartinVar[i] = pDoc->m_MartinVar[i];
			pDoc->Event[sel].GingerX[i] = pDoc->m_GingerX[i];
			pDoc->Event[sel].GingerY[i] = pDoc->m_GingerY[i];

			pDoc->Event[sel].EarthWormVar[i] = pDoc->m_EarthWormVar[i];
			pDoc->Event[sel].EarthWormMulti[i] = pDoc->m_EarthWormMulti[i];
			pDoc->Event[sel].EarthWormTruncator[i] = pDoc->m_EarthWormTruncator[i];

			pDoc->Event[sel].RandomMin[i] = pDoc->m_RandomMin[i];
			pDoc->Event[sel].RandomMax[i] = pDoc->m_RandomMax[i];

			pDoc->Event[sel].WolframRule[i] = pDoc->m_WolframRule[i];
			pDoc->Event[sel].WolframInit[i] = pDoc->m_WolframInit[i];
			pDoc->Event[sel].WolframSize[i] = pDoc->m_WolframSize[i];

			pDoc->Event[sel].Hailstone[i] = pDoc->m_Hailstone[i];

			pDoc->Event[sel].Pan[i] = pDoc->m_Pan[i];
			pDoc->Event[sel].Percussion[i] = pDoc->m_Percussion[i];
		}
	
		for(i=0; i<MAXVOICES; i++)
		{
			if (pDoc->Event[sel].pUserScale[i])
			{
				delete pDoc->Event[sel].pUserScale[i];
				pDoc->Event[sel].pUserScale[i] = NULL;
			}
			pDoc->Event[sel].pUserScale[i] = new int[pDoc->m_pUserScale[i][0] +1];
			for(int j=0; j<=pDoc->m_pUserScale[i][0]; j++)
				pDoc->Event[sel].pUserScale[i][j] = pDoc->m_pUserScale[i][j];
		}

		for(i=0; i<MAXVOICES; i++)
		{
			if (pDoc->Event[sel].pScale[i])
			{
				delete pDoc->Event[sel].pScale[i];
				pDoc->Event[sel].pScale[i] = NULL;
			}
			pDoc->Event[sel].pScale[i] = new int[pDoc->m_pScale[i][0] +1];
			for(int j=0; j<=pDoc->m_pScale[i][0]; j++)
				pDoc->Event[sel].pScale[i][j] = pDoc->m_pScale[i][j];
		}

			pList->DeleteString(sel);

			CString toAdd;

			toAdd.Format("[%d -> %d]", pDoc->Event[sel].count, pDoc->Event[sel].genCount);
			pList->InsertString(sel, toAdd);
	}
	
}

void CEventsDlg::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	if (nChar = VK_DELETE)
		OnRemove();

	CDialog::OnKeyDown(nChar, nRepCnt, nFlags);
}
