
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


// FractMusDoc.cpp : implementation of the CFractMusDoc class
//

#include "stdafx.h"
#include "FractMus.h"

#include "defs.h"

#include "FractMusDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const float FractMusVersion = 3.00f;

float FileVersion;
extern BOOL IsDocumentLocked;


/////////////////////////////////////////////////////////////////////////////
// CFractMusDoc

IMPLEMENT_DYNCREATE(CFractMusDoc, CDocument)

BEGIN_MESSAGE_MAP(CFractMusDoc, CDocument)
	//{{AFX_MSG_MAP(CFractMusDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFractMusDoc construction/destruction

CFractMusDoc::CFractMusDoc()
{
	// TODO: add one-time construction code here

	for(int i=VOICE1; i<MAXVOICES; i++)
		m_pScale[i]	= NULL;

	for(i=VOICE1; i<MAXVOICES; i++)
		m_pUserScale[i]	= NULL;

	m_TempoMarking		= 96;
	m_ActiveVoices		= 1;
	dGeneralCounter		= 0;
	dStartCounter		= 0;

	m_IsActive[VOICE1]=TRUE;
	for (i=VOICE2; i<MAXVOICES; i++)
		m_IsActive[i]=FALSE;
	
	for (i=VOICE1; i<MAXVOICES; i++)
		m_Modulates[i]	= FALSE;

	for (i=VOICE1; i<MAXVOICES; i++)
		m_ModulRandom[i]= FALSE;

	for (i=VOICE1; i<MAXVOICES; i++)
		m_ModulNum[i]	= 5;

	for (i=VOICE1; i<MAXVOICES; i++)
		m_Base[i]	= 2;

	for (i=VOICE1; i<MAXVOICES; i++)
		m_Multi[i]	= 1;

	for (i=VOICE1; i<MAXVOICES; i++)
		m_StartNum[i]	= 0;

	for (i=VOICE1; i<MAXVOICES; i++)
		m_ScaleID[i]	= MAJOR;

	for (i=VOICE1; i<MAXVOICES; i++)
		m_NumOcts[i]	= 1;

	for (i=VOICE1; i<MAXVOICES; i++)
		m_NumOctsID[i]	= ONE_OCT;

	for (i=VOICE1; i<MAXVOICES; i++)
		m_Note[i]	= 48;

	for (i=VOICE1; i<MAXVOICES; i++)
		m_NoteValue[i]	= 8.00f;

	for (i=VOICE1; i<MAXVOICES; i++)
		m_NoteValueID[i]= 2;

	for (i=VOICE1; i<MAXVOICES; i++)
		m_Instrument[i]	= 0;

	for (i=VOICE1; i<MAXVOICES; i++)
		m_Channel[i] = i;

	for (i=VOICE1; i<MAXVOICES; i++)
		m_mode[i] = 1;

	for (i=VOICE1; i<MAXVOICES; i++)
	{
		m_Inverted[i] = FALSE;
		m_Dynamic[i] = MEZZO_FORTE;
		m_DynChoice[i] = MF;
	}

	for (i=VOICE1; i<MAXVOICES; i++)
		m_Pan[i] = 0;


	for (i=VOICE1; i<MAXVOICES; i++)
		AlgorithmNum[i] = MORSE_THUE;



	m_NumEvents = 0;

	m_Password = "";
	m_Copyright = "";


}

CFractMusDoc::~CFractMusDoc()
{
	
	int i;
	for(i=VOICE1; i<MAXVOICES; i++)

		if (m_pScale[i])
		{
			delete [] m_pScale[i];
			m_pScale[i]=NULL;
		}

	for(i=VOICE1; i<MAXVOICES; i++)

		if (m_pUserScale[i])
		{
			delete [] m_pUserScale[i];
			m_pUserScale[i]=NULL;
		}
}	

BOOL CFractMusDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	int i, j;

	m_TempoMarking		= 96;
	m_ActiveVoices		= 1;
	dGeneralCounter		= 0;
	dStartCounter		= 0;
	m_TimeSigNum		= 4;
	m_TimeSigDen		= 4;

	m_Password = "";
	m_Copyright = "";
	m_Comment = "";

	m_IsActive[VOICE1]=TRUE;
	for (i=VOICE2; i<MAXVOICES; i++)
		m_IsActive[i]=FALSE;

	
	for (i=VOICE1; i<MAXVOICES; i++)
		m_Modulates[i]	= FALSE;

	for (i=VOICE1; i<MAXVOICES; i++)
		m_ModulRandom[i]= FALSE;

	for (i=VOICE1; i<MAXVOICES; i++)
		m_ModulNum[i]	= 5;

	for (i=VOICE1; i<MAXVOICES; i++)
		m_Base[i]	= 2;

	for (i=VOICE1; i<MAXVOICES; i++)
		m_Multi[i]	= 1;

	for (i=VOICE1; i<MAXVOICES; i++)
		m_StartNum[i]	= 0;

	for (i=VOICE1; i<MAXVOICES; i++)
		m_ScaleID[i]	= MAJOR;

	for (i=VOICE1; i<MAXVOICES; i++)
		m_NumOcts[i]	= 1;

	for (i=VOICE1; i<MAXVOICES; i++)
		m_NumOctsID[i]	= ONE_OCT;

	for (i=VOICE1; i<MAXVOICES; i++)
		m_Note[i]	= 60;

	for (i=VOICE1; i<MAXVOICES; i++)
		m_NoteValue[i]	= 8.00f;

	for (i=VOICE1; i<MAXVOICES; i++)
		m_NoteValueID[i]= 2;

	for (i=VOICE1; i<MAXVOICES; i++)
		m_Instrument[i]	= 0;

	for (i=VOICE1; i<MAXVOICES; i++)
		m_Channel[i] = i;

	for (i=VOICE1; i<MAXVOICES; i++)
		m_mode[i] = 1;

	for (i=VOICE1; i<MAXVOICES; i++)
		m_Percussion[i] = 0;

	for (i=VOICE1; i<MAXVOICES; i++)
	{
		m_Inverted[i] = FALSE;
		m_MatchScale[i] = TRUE;
		m_Dynamic[i] = MEZZO_FORTE;
		m_DynChoice[i] = MF;
	}

	for (i=VOICE1; i<MAXVOICES; i++)
	{
		m_LogMapVar[i] = 3.9f;
		m_FNoiseVar[i] = 0.5f;
		m_HenonA[i] = 1.7f;
		m_HenonB[i] = 0.4f;
		m_HopalongVar[i] = 3.14159265359f;
		m_MartinVar[i] = 3.14159265359f;
		m_GingerX[i] = -0.1f;
		m_GingerY[i] = 0.0f;
		m_LorentzVar[i] = 0.8f;
		m_EarthWormVar[i] = 2;
		m_EarthWormMulti[i] = 3;
		m_EarthWormTruncator[i] = 6;
		m_RandomMin[i] = 0.0;
		m_RandomMax[i] = 1.0;
		m_WolframRule[i] = 30;
		m_WolframInit[i] = 1;
		m_WolframSize[i] = 128;
		m_Hailstone[i] = 27;
	}

	for (i=VOICE1; i<MAXVOICES; i++)
		m_Pan[i] = 0;


	for (i=VOICE1; i<MAXVOICES; i++)
		AlgorithmNum[i] = MORSE_THUE;


	for (i=VOICE1; i<MAXVOICES; i++)
		if (m_pScale[i])
		{
			delete [] m_pScale[i];
			m_pScale[i]=NULL;
		}
	
	for (i=VOICE1; i<MAXVOICES; i++)
		m_pScale[i] = new int [Major[0] + 1];

	for (i=VOICE1; i<MAXVOICES; i++)
		m_ScaleNotes[i] = Major[0];

	for (i=VOICE1; i<MAXVOICES; i++)
		for (j=0; j<=Major[0]; j++)
			m_pScale[i][j]=Major[j];




	for (i=VOICE1; i<MAXVOICES; i++)
		if (m_pUserScale[i])
		{
			delete [] m_pUserScale[i];
			m_pUserScale[i]=NULL;
		}
	
	for (i=VOICE1; i<MAXVOICES; i++)
		m_pUserScale[i] = new int [Major[0] + 1];

	for (i=VOICE1; i<MAXVOICES; i++)
		m_UserScaleNotes[i] = Major[0];

	for (i=VOICE1; i<MAXVOICES; i++)
		for (j=0; j<=Major[0]; j++)
			m_pUserScale[i][j]=Major[j];


	m_NumEvents = -1;



	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)


	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CFractMusDoc serialization

void CFractMusDoc::Serialize(CArchive& ar)
{
	int i, j;


	if (ar.IsStoring())
	{
		// TODO: add storing code here


		ar << FractMusVersion;


		if (m_Copyright!="")
		{

			CString cop = m_Copyright;

			for(i = 0; i<cop.GetLength(); i++)
			{
				int sign;

				if (i == 0)
					sign = 0;

				if (i%2)
					sign = 1;
				else
					sign = -1;
				cop.SetAt(i, cop.GetAt(i)+sign);
			}
			ar << cop;
		}
		else 
			ar << m_Copyright;

		
		ar << m_Comment;

		ar << m_TempoMarking;
		ar << m_ActiveVoices;
		ar << dGeneralCounter;
		ar << dStartCounter;
		ar << m_TimeSigNum;
		ar << m_TimeSigDen;


		for (i=VOICE1; i<MAXVOICES; i++)
			ar << AlgorithmNum[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar << m_IsActive[i];
		
		for (i=VOICE1; i<MAXVOICES; i++)
			ar << m_Base[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar << m_Multi[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar << m_StartNum[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar << m_Modulates[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar << m_ScaleID[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar << m_Note[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar << m_NoteValueID[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar << m_NoteValue[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar << m_NumOctsID[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar << m_NumOcts[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar << m_Instrument[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar << m_Channel[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar << m_mode[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar << m_ModulNum[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar << m_ModulRandom[i];

		for (i=VOICE1; i<MAXVOICES; i++)
		{
			ar << m_Inverted[i];
			ar << m_MatchScale[i];
			ar << m_Dynamic[i];
			ar << m_DynChoice[i];
		}

		for (i=VOICE1; i<MAXVOICES; i++)
		{
			ar << m_LogMapVar[i];
			ar << m_FNoiseVar[i];
			ar << m_HenonA[i];
			ar << m_HenonB[i];
			ar << m_HopalongVar[i];
			ar << m_MartinVar[i];
			ar << m_GingerX[i];
			ar << m_GingerY[i];
			ar << m_LorentzVar[i];
			ar << m_EarthWormVar[i];
			ar << m_EarthWormMulti[i];
			ar << m_EarthWormTruncator[i];
			ar << m_RandomMin[i];
			ar << m_RandomMax[i];
			ar << m_WolframRule[i];
			ar << m_WolframInit[i];
			ar << m_WolframSize[i];
			ar << m_Hailstone[i];

		}

		for (i=VOICE1; i<MAXVOICES; i++)
			ar << m_Pan[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar << m_Percussion[i];
	
		for (i=VOICE1; i<MAXVOICES; i++)
			ar << m_pScale[i][0];

		for (i=VOICE1; i<MAXVOICES; i++)
			for (j=1; j<=m_pScale[i][0]; j++)
				ar << m_pScale[i][j];



		for (i=VOICE1; i<MAXVOICES; i++)
			ar << m_pUserScale[i][0];

		for (i=VOICE1; i<MAXVOICES; i++)
			for (j=1; j<=m_pUserScale[i][0]; j++)
				ar << m_pUserScale[i][j];


		if (m_Password!="")
		{

			CString piss = m_Password;

			for(i = 0; i<piss.GetLength(); i++)
			{
				piss.SetAt(i, piss.GetAt(i)+i);
			}

			ar << piss;
		}
		else
			ar << m_Password;



		ar << m_NumEvents;

		if(m_NumEvents>-1)
		{



		for (i=0; i<=m_NumEvents; i++)
		{
			ar << Event[i].count;
			ar << Event[i].Tempo;
			ar << Event[i].genCount;
			ar << Event[i].TimeSigNum;
			ar << Event[i].TimeSigDen;
		}

		for (i=0; i<=m_NumEvents; i++)
			for(j=VOICE1; j<MAXVOICES; j++)
			{
				ar << Event[i].AlgorithmNum[j];
				ar << Event[i].IsActive[j];
				ar << Event[i].Base[j];
				ar << Event[i].Multi[j];
				ar << Event[i].StartNum[j];
				ar << Event[i].NumOcts[j];
				ar << Event[i].Modulates[j];
				ar << Event[i].ModulRandom[j];
				ar << Event[i].ModulNum[j];
				ar << Event[i].Note[j];
				ar << Event[i].NoteValue[j];
				ar << Event[i].Instrument[j];
				ar << Event[i].Channel[j];
				ar << Event[i].Mode[j];
				ar << Event[i].ScaleID[j];
				ar << Event[i].NumOctsID[j];
				ar << Event[i].NoteValueID[j];
				ar << Event[i].Inverted[j];
				ar << Event[i].MatchScale[j];
				ar << Event[i].Dynamic[j];
				ar << Event[i].DynChoice[j];
				ar << Event[i].LogMapVar[j];
				ar << Event[i].FNoiseVar[j];
				ar << Event[i].LorentzVar[j];
				ar << Event[i].HenonA[j];
				ar << Event[i].HenonB[j];
				ar << Event[i].HopalongVar[j];
				ar << Event[i].MartinVar[j];
				ar << Event[i].GingerX[j];
				ar << Event[i].GingerY[j];
				ar << Event[i].EarthWormVar[j];
				ar << Event[i].EarthWormMulti[j];
				ar << Event[i].EarthWormTruncator[j];
				ar << Event[i].RandomMin[j];
				ar << Event[i].RandomMax[j];
				ar << Event[i].WolframRule[j];
				ar << Event[i].WolframInit[j];
				ar << Event[i].WolframSize[j];
				ar << Event[i].Hailstone[j];
				ar << Event[i].Pan[j];
				ar << Event[i].Percussion[j];

			}

		for (i=0; i<=m_NumEvents; i++)
			for(j=VOICE1; j<MAXVOICES; j++)
				ar << Event[i].pScale[j][0];

		for (i=0; i<=m_NumEvents; i++)
			for(j=VOICE1; j<MAXVOICES; j++)
				for(int k=1; k<=Event[i].pScale[j][0]; k++)
					ar << Event[i].pScale[j][k];


		for (i=0; i<=m_NumEvents; i++)
			for(j=VOICE1; j<MAXVOICES; j++)
				ar << Event[i].pUserScale[j][0];

		for (i=0; i<=m_NumEvents; i++)
			for(j=VOICE1; j<MAXVOICES; j++)
				for(int k=1; k<=Event[i].pUserScale[j][0]; k++)
					ar << Event[i].pUserScale[j][k];

		}
			
	}
	else
	{
		// TODO: add loading code here

		ar >> FileVersion;

		if (FileVersion == 1.00f)

		{

		m_Copyright = "";

		m_Comment = "";

		long m_EventsCounter[1000];
		ar >> m_TempoMarking;
		ar >> m_ActiveVoices;
		ar >> dGeneralCounter;
		dStartCounter = 0;
		m_TimeSigNum = 4;
		m_TimeSigDen = 4;


		for (i=VOICE1; i<8; i++)
			ar >> AlgorithmNum[i];

		for (i=VOICE9; i<MAXVOICES; i++)
			AlgorithmNum[i] = MORSE_THUE;

		for (i=VOICE1; i<8; i++)
			ar >> m_IsActive[i];

		for (i=VOICE9; i<MAXVOICES; i++)
			m_IsActive[i] = FALSE;
		
		for (i=VOICE1; i<8; i++)
			ar >> m_Base[i];

		for (i=VOICE9; i<MAXVOICES; i++)
			m_Base[i] = 2;

		for (i=VOICE1; i<8; i++)
			ar >> m_Multi[i];

		for (i=VOICE9; i<MAXVOICES; i++)
			m_Multi[i] = 1;

		for (i=VOICE1; i<8; i++)
			ar >> m_StartNum[i];

		for (i=VOICE9; i<MAXVOICES; i++)
			m_StartNum[i] = 0;

		for (i=VOICE1; i<8; i++)
			ar >> m_Modulates[i];

		for (i=VOICE9; i<MAXVOICES; i++)
			m_Modulates[i] = FALSE;

		for (i=VOICE1; i<8; i++)
			ar >> m_ScaleID[i];

		for (i=VOICE9; i<MAXVOICES; i++)
			m_ScaleID[i] = MAJOR;

		for (i=VOICE1; i<8; i++)
			ar >> m_Note[i];

		for (i=VOICE9; i<MAXVOICES; i++)
			m_Note[i] = 60;

		for (i=VOICE1; i<8; i++)
			ar >> m_NoteValueID[i];

		for (i=VOICE9; i<MAXVOICES; i++)
			m_NoteValueID[i]  = 2;

		for (i=VOICE1; i<8; i++)
			ar >> m_NoteValue[i];

		for (i=VOICE9; i<MAXVOICES; i++)
			m_NoteValue[i] = 8.00f;

		for (i=VOICE1; i<8; i++)
			ar >> m_NumOctsID[i];

		for (i=VOICE9; i<MAXVOICES; i++)
			m_NumOctsID[i] = ONE_OCT;

		for (i=VOICE1; i<8; i++)
			ar >> m_NumOcts[i];

		for (i=VOICE9; i<MAXVOICES; i++)
			m_NumOcts[i] = 1;

		for (i=VOICE1; i<8; i++)
			ar >> m_Instrument[i];

		for (i=VOICE9; i<MAXVOICES; i++)
			m_Instrument[i] = 0;

		for (i=VOICE1; i<8; i++)
			ar >> m_Channel[i];

		for (i=VOICE9; i<MAXVOICES; i++)
			m_Channel[i] = i;

		for (i=VOICE1; i<8; i++)
			ar >> m_mode[i];

		for (i=VOICE9; i<MAXVOICES; i++)
			m_mode[i] = 1;

	
		for (i=VOICE1; i<8; i++)
			ar >> m_ModulNum[i];

		for (i=VOICE9; i<MAXVOICES; i++)
			m_ModulNum[i] = 5;

		for (i=VOICE1; i<8; i++)
			ar >> m_ModulRandom[i];

		for (i=VOICE9; i<MAXVOICES; i++)
			m_ModulRandom[i] = FALSE;

		for (i=VOICE1; i<8; i++)
		{
			ar >> m_Inverted[i];
			m_MatchScale[i] = TRUE;
			ar >> m_Dynamic[i];
			ar >> m_DynChoice[i];
		}

		for (i=VOICE9; i<MAXVOICES; i++)
		{
			m_Inverted[i] = FALSE;
			m_MatchScale[i] = TRUE;
			m_Dynamic[i] = MEZZO_FORTE;
			m_DynChoice[i] = MF;
		}


		for (i=VOICE1; i<8; i++)
		{
			ar >> m_LogMapVar[i];
			ar >> m_FNoiseVar[i];
			m_HenonA[i] = 1.4f;
			m_HenonB[i] = 0.3f;
			m_HopalongVar[i] = 3.14159265359f;
			m_MartinVar[i] = 3.14159265359f;
			m_GingerX[i] = -0.1f;
			m_GingerY[i] = 0.0f;
			m_LorentzVar[i] = 0.8f;
			m_EarthWormVar[i] = 2;
			m_EarthWormMulti[i] = 3;
			m_EarthWormTruncator[i] = 6;
			m_RandomMin[i] = 0.0;
			m_RandomMax[i] = 1.0;
			m_WolframRule[i] = 30;
			m_WolframInit[i] = 1;
			m_WolframSize[i] = 128;
			m_Hailstone[i] = 27;

		}

		for (i=VOICE9; i<MAXVOICES; i++)
		{
			m_LogMapVar[i] = 3.9f;
			m_FNoiseVar[i] = 0.5f;
			m_HenonA[i] = 1.4f;
			m_HenonB[i] = 0.3f;
			m_HopalongVar[i] = 3.14159265359f;
			m_MartinVar[i] = 3.14159265359f;
			m_GingerX[i] = -0.1f;
			m_GingerY[i] = 0.0f;
			m_LorentzVar[i] = 0.8f;
			m_EarthWormVar[i] = 2;
			m_EarthWormMulti[i] = 3;
			m_EarthWormTruncator[i] = 6;
			m_RandomMin[i] = 0.0;
			m_RandomMax[i] = 1.0;
			m_WolframRule[i] = 30;
			m_WolframInit[i] = 1;
			m_WolframSize[i] = 128;
			m_Hailstone[i] = 27;
		}

		for (i=VOICE1; i<MAXVOICES; i++)
			m_Pan[i] = 0;

		for (i=VOICE1; i<MAXVOICES; i++)
			m_Percussion[i] = 0;

		for (i=VOICE1; i<8; i++)
				ar >> m_ScaleNotes[i];

		for (i=VOICE9; i<MAXVOICES; i++)
			m_ScaleNotes[i] = Major[0];


		for (i=VOICE1; i<8; i++)
			if (m_pScale[i])
			{
				delete m_pScale[i];
				m_pScale[i] = NULL;
			}

		for (i=VOICE9; i<MAXVOICES; i++)
			if (m_pScale[i])
			{
				delete [] m_pScale[i];
				m_pScale[i]=NULL;
			}



		for (i=VOICE1; i<8; i++)
		{

			m_pScale[i] = new int [ m_ScaleNotes[i] + 1 ];

			m_pScale[i][0] = m_ScaleNotes[i];

			for (j=1; j<=m_pScale[i][0]; j++)
				ar >> m_pScale[i][j];
		}

		for (i=VOICE9; i<MAXVOICES; i++)
			m_pScale[i] = new int [Major[0] + 1];

		for (i=VOICE9; i<MAXVOICES; i++)
			for (j=0; j<=Major[0]; j++)
				m_pScale[i][j]=Major[j];

		for (i=VOICE1; i<MAXVOICES; i++)
			m_UserScaleNotes[i] = Major[0];



		for (i=VOICE1; i<MAXVOICES; i++)
			if (m_pUserScale[i])
			{
				delete [] m_pUserScale[i];
				m_pUserScale[i]=NULL;
			}

		for (i=VOICE1; i<MAXVOICES; i++)
			m_pUserScale[i] = new int [Major[0] + 1];

		for (i=VOICE1; i<MAXVOICES; i++)
			for (j=0; j<=Major[0]; j++)
				m_pUserScale[i][j]=Major[j];

		m_Password = "";
		ar >> m_NumEvents;

		if(m_NumEvents>1)

		{


		for (i=0; i<m_NumEvents; i++)
			ar >> m_EventsCounter[i];

		for (i=0; i<m_NumEvents; i++)
		{
			ar >> Event[i].count;
			ar >> Event[i].Tempo;
			ar >> Event[i].genCount;
			Event[i].TimeSigNum = 4;
			Event[i].TimeSigDen = 4;
		}

		for (i=0; i<m_NumEvents; i++)
			for(j=VOICE1; j<8; j++)
			{
				ar >> Event[i].AlgorithmNum[j];
				ar >> Event[i].IsActive[j];
				ar >> Event[i].Base[j];
				ar >> Event[i].Multi[j];
				ar >> Event[i].StartNum[j];
				ar >> Event[i].NumOcts[j];
				ar >> Event[i].Modulates[j];
				ar >> Event[i].ModulRandom[j];
				ar >> Event[i].ModulNum[j];
				ar >> Event[i].Note[j];
				ar >> Event[i].NoteValue[j];
				ar >> Event[i].Instrument[j];
				ar >> Event[i].Channel[j];
				ar >> Event[i].Mode[j];
				ar >> Event[i].ScaleID[j];
				ar >> Event[i].NumOctsID[j];
				ar >> Event[i].NoteValueID[j];
				ar >> Event[i].Inverted[j];
				Event[i].MatchScale[j] = TRUE;
				ar >> Event[i].Dynamic[j];
				ar >> Event[i].DynChoice[j];
				ar >> Event[i].LogMapVar[j];
				ar >> Event[i].FNoiseVar[j];
				Event[i].LorentzVar[j] = 0.8f;
				Event[i].HenonA[j] = 1.4f;
				Event[i].HenonB[j] = 0.3f;
				Event[i].HopalongVar[j] = 3.14159265359f;
				Event[i].MartinVar[j] = 3.14159265359f;
				Event[i].GingerX[j] = -0.1f;
				Event[i].GingerY[j] = 0.0f;
				Event[i].EarthWormVar[j] = 2;
				Event[i].EarthWormMulti[j] = 3;
				Event[i].EarthWormTruncator[j] = 6;
				Event[i].RandomMin[j] = 0.0;
				Event[i].RandomMax[j] = 1.0;
				Event[i].WolframRule[j] = 30;
				Event[i].WolframInit[j] = 1;
				Event[i].WolframSize[j] = 128;
				Event[i].Hailstone[j] = 27;

				Event[i].Pan[j] = 0;
				Event[i].Percussion[j] = 0;
			}



		for (i=0; i<m_NumEvents; i++)
			for(j=VOICE9; j<MAXVOICES; j++)
			{
				Event[i].AlgorithmNum[j] = MORSE_THUE;
				Event[i].IsActive[j] = FALSE;
				Event[i].Base[j] = 2;
				Event[i].Multi[j] = 1;
				Event[i].StartNum[j] = 0;
				Event[i].NumOcts[j] = 1;
				Event[i].Modulates[j] = FALSE;
				Event[i].ModulRandom[j] = FALSE;
				Event[i].ModulNum[j] = 5;
				Event[i].Note[j] = 48;
				Event[i].NoteValue[j] = 8.00f;
				Event[i].Instrument[j] = 0;
				Event[i].Channel[j] = j;
				Event[i].Mode[j] = 1;
				Event[i].ScaleID[j] = MAJOR;
				Event[i].NumOctsID[j] = ONE_OCT;
				Event[i].NoteValueID[j] = 2;
				Event[i].Inverted[j] = FALSE;
				Event[i].MatchScale[j] = TRUE;
				Event[i].Dynamic[j] = MEZZO_FORTE;
				Event[i].DynChoice[j] = MF;
				Event[i].LogMapVar[j] = 3.9f;
				Event[i].FNoiseVar[j] = 0.5f;
				Event[i].LorentzVar[j] = 0.8f;
				Event[i].HenonA[j] = 1.4f;
				Event[i].HenonB[j] = 0.3f;
				Event[i].HopalongVar[j] = 3.14159265359f;
				Event[i].MartinVar[j] = 3.14159265359f;
				Event[i].GingerX[j] = -0.1f;
				Event[i].GingerY[j] = 0.0f;
				Event[i].EarthWormVar[j] = 2;
				Event[i].EarthWormMulti[j] = 3;
				Event[i].EarthWormTruncator[j] = 6;
				Event[i].RandomMin[j] = 0.0;
				Event[i].RandomMax[j] = 1.0;
				Event[i].WolframRule[j] = 30;
				Event[i].WolframInit[j] = 1;
				Event[i].WolframSize[j] = 128;
				Event[i].Hailstone[j] = 27;
				Event[i].Pan[j] = 0;
				Event[i].Percussion[j] = 0;
			}



		for (i=0; i<m_NumEvents-1; i++)
			for(j=VOICE1; j<8; j++)
				ar >> m_EventScaleNotes[i][j];


		for (i=0; i<m_NumEvents-1; i++)
			for(j=VOICE9; j<MAXVOICES; j++)
				m_EventScaleNotes[i][j] = Major[0];


		for (i=0; i<m_NumEvents-1; i++)
			for(j=VOICE1; j<8; j++)
				if(Event[i].pScale[j])
				{
					delete Event[i].pScale[j];
					Event[i].pScale[j] = NULL;
				}

		for (i=0; i<m_NumEvents-1; i++)
			for(j=VOICE9; j<MAXVOICES; j++)
				if(Event[i].pScale[j])
				{
					delete Event[i].pScale[j];
					Event[i].pScale[j] = NULL;
				}

		for (i=0; i<m_NumEvents-1; i++)
			for(j=VOICE1; j<8; j++)
			{
				Event[i].pScale[j] = new int [m_EventScaleNotes[i][j] + 1];
				Event[i].pScale[j][0] = m_EventScaleNotes[i][j];

				for(int k=1; k<=Event[i].pScale[j][0]; k++)
					ar >> Event[i].pScale[j][k];
			}

		for (i=0; i<m_NumEvents-1; i++)
			for(j=VOICE9; j<MAXVOICES; j++)
			{
				Event[i].pScale[j] = new int [ Major[0] + 1];
				Event[i].pScale[j][0] = Major[0];

				for(int k=1; k<=Major[0]; k++)
					Event[i].pScale[j][k] = Major[k];
			}




		///////////////////////////////////////


		for (i=0; i<m_NumEvents-1; i++)
			for(j=VOICE1; j<MAXVOICES; j++)
			{
				if (Event[i].ScaleID[j] != USER_DEFINED)
					m_EventUserScaleNotes[i][j] = Major[0];
				else
					m_EventUserScaleNotes[i][j] = Event[i].pScale[j][0];
			}

		for (i=0; i<m_NumEvents-1; i++)
			for(j=VOICE1; j<MAXVOICES; j++)
				if(Event[i].pUserScale[j])
				{
					delete Event[i].pUserScale[j];
					Event[i].pUserScale[j] = NULL;
				}


		for (i=0; i<m_NumEvents-1; i++)
		{
				for(j=VOICE1; j<MAXVOICES; j++)
				{
					if (Event[i].ScaleID[j] != USER_DEFINED)
					{
						Event[i].pUserScale[j] = new int [ Major[0] + 1];
						Event[i].pUserScale[j][0] = Major[0];

						for(int k=1; k<=Major[0]; k++)
							Event[i].pUserScale[j][k] = Major[k];
					}
					else
					{
						Event[i].pUserScale[j] = new int [ Event[i].pScale[j][0] + 1];
						Event[i].pUserScale[j][0] = Event[i].pScale[j][0];

						for(int k=1; k<=Event[i].pScale[j][0]; k++)
							Event[i].pUserScale[j][k] = Event[i].pScale[j][k];
					}
				}
		}

		m_NumEvents -= 2;

		for(i=0; i<=m_NumEvents; i++)
			Event[i].count = i>0 ? Event[i-1].genCount : 0;

		}

		}

		else if (FileVersion == 2.00)
		{

		m_Copyright = "";

		m_Comment = "";

		ar >> m_TempoMarking;
		ar >> m_ActiveVoices;
		ar >> dGeneralCounter;
		ar >> dStartCounter;
		ar >> m_TimeSigNum;
		ar >> m_TimeSigDen;


		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> AlgorithmNum[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_IsActive[i];
		
		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_Base[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_Multi[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_StartNum[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_Modulates[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_ScaleID[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_Note[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_NoteValueID[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_NoteValue[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_NumOctsID[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_NumOcts[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_Instrument[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_Channel[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_mode[i];
	
		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_ModulNum[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_ModulRandom[i];

		for (i=VOICE1; i<MAXVOICES; i++)
		{
			ar >> m_Inverted[i];
			ar >> m_MatchScale[i];
			ar >> m_Dynamic[i];
			ar >> m_DynChoice[i];
		}

		for (i=VOICE1; i<MAXVOICES; i++)
		{
			ar >> m_LogMapVar[i];
			ar >> m_FNoiseVar[i];
			ar >> m_HenonA[i];
			ar >> m_HenonB[i];
			ar >> m_HopalongVar[i];
			ar >> m_MartinVar[i];
			ar >> m_GingerX[i];
			ar >> m_GingerY[i];
			ar >> m_LorentzVar[i];
			m_EarthWormVar[i] = 2;
			m_EarthWormMulti[i] = 3;
			m_EarthWormTruncator[i] = 6;
			m_RandomMin[i] = 0.0;
			m_RandomMax[i] = 1.0;
			m_WolframRule[i] = 30;
			m_WolframInit[i] = 1;
			m_WolframSize[i] = 128;
			m_Hailstone[i] = 27;
		}

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_Pan[i];
		
		for (i=VOICE1; i<MAXVOICES; i++)
			m_Percussion[i] = 0;

		for (i=VOICE1; i<MAXVOICES; i++)
				ar >> m_ScaleNotes[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			if (m_pScale[i])
			{
				delete m_pScale[i];
				m_pScale[i] = NULL;
			}
		for (i=VOICE1; i<MAXVOICES; i++)
		{

			m_pScale[i] = new int [ m_ScaleNotes[i] + 1 ];

			m_pScale[i][0] = m_ScaleNotes[i];

			for (j=1; j<=m_pScale[i][0]; j++)
				ar >> m_pScale[i][j];
		}





		for (i=VOICE1; i<MAXVOICES; i++)
				ar >> m_UserScaleNotes[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			if (m_pUserScale[i])
			{
				delete m_pUserScale[i];
				m_pUserScale[i] = NULL;
			}
		for (i=VOICE1; i<MAXVOICES; i++)
		{

			m_pUserScale[i] = new int [ m_UserScaleNotes[i] + 1 ];

			m_pUserScale[i][0] = m_UserScaleNotes[i];

			for (j=1; j<=m_pUserScale[i][0]; j++)
				ar >> m_pUserScale[i][j];
		}


		m_Password = "";

		ar >> m_NumEvents;

		if(m_NumEvents>-1)

		{



		for (i=0; i<=m_NumEvents; i++)
		{
			ar >> Event[i].count;
			ar >> Event[i].Tempo;
			ar >> Event[i].genCount;
			ar >> Event[i].TimeSigNum;
			ar >> Event[i].TimeSigDen;

		}

		for (i=0; i<=m_NumEvents; i++)
			for(j=VOICE1; j<MAXVOICES; j++)
			{
				ar >> Event[i].AlgorithmNum[j];
				ar >> Event[i].IsActive[j];
				ar >> Event[i].Base[j];
				ar >> Event[i].Multi[j];
				ar >> Event[i].StartNum[j];
				ar >> Event[i].NumOcts[j];
				ar >> Event[i].Modulates[j];
				ar >> Event[i].ModulRandom[j];
				ar >> Event[i].ModulNum[j];
				ar >> Event[i].Note[j];
				ar >> Event[i].NoteValue[j];
				ar >> Event[i].Instrument[j];
				ar >> Event[i].Channel[j];
				ar >> Event[i].Mode[j];
				ar >> Event[i].ScaleID[j];
				ar >> Event[i].NumOctsID[j];
				ar >> Event[i].NoteValueID[j];
				ar >> Event[i].Inverted[j];
				ar >> Event[i].MatchScale[j];
				ar >> Event[i].Dynamic[j];
				ar >> Event[i].DynChoice[j];
				ar >> Event[i].LogMapVar[j];
				ar >> Event[i].FNoiseVar[j];
				ar >> Event[i].LorentzVar[j];
				ar >> Event[i].HenonA[j];
				ar >> Event[i].HenonB[j];
				ar >> Event[i].HopalongVar[j];
				ar >> Event[i].MartinVar[j];
				ar >> Event[i].GingerX[j];
				ar >> Event[i].GingerY[j];
				Event[i].EarthWormVar[j] = 2;
				Event[i].EarthWormMulti[j] = 3;
				Event[i].EarthWormTruncator[j] = 6;
				Event[i].RandomMin[j] = 0.0;
				Event[i].RandomMax[j] = 1.0;
				Event[i].WolframRule[j] = 30;
				Event[i].WolframInit[j] = 1;
				Event[i].WolframSize[j] = 128;
				Event[i].Hailstone[j] = 27;
				ar >> Event[i].Pan[j];
				Event[i].Percussion[j] = 0;
			}

		for (i=0; i<=m_NumEvents; i++)
			for(j=VOICE1; j<MAXVOICES; j++)
				ar >> m_EventScaleNotes[i][j];

		for (i=0; i<=m_NumEvents; i++)
			for(j=VOICE1; j<MAXVOICES; j++)
				if(Event[i].pScale[j])
				{
					delete Event[i].pScale[j];
					Event[i].pScale[j] = NULL;
				}

		for (i=0; i<=m_NumEvents; i++)
			for(j=VOICE1; j<MAXVOICES; j++)
			{
				Event[i].pScale[j] = new int [m_EventScaleNotes[i][j] + 1];
				Event[i].pScale[j][0] = m_EventScaleNotes[i][j];

				for(int k=1; k<=Event[i].pScale[j][0]; k++)
					ar >> Event[i].pScale[j][k];
			}


		//////////////////////////////////////////



		for (i=0; i<=m_NumEvents; i++)
			for(j=VOICE1; j<MAXVOICES; j++)
				ar >> m_EventUserScaleNotes[i][j];

		for (i=0; i<=m_NumEvents; i++)
			for(j=VOICE1; j<MAXVOICES; j++)
				if(Event[i].pUserScale[j])
				{
					delete Event[i].pUserScale[j];
					Event[i].pUserScale[j] = NULL;
				}

		for (i=0; i<=m_NumEvents; i++)
			for(j=VOICE1; j<MAXVOICES; j++)
			{
				Event[i].pUserScale[j] = new int [m_EventUserScaleNotes[i][j] + 1];
				Event[i].pUserScale[j][0] = m_EventUserScaleNotes[i][j];

				for(int k=1; k<=Event[i].pUserScale[j][0]; k++)
					ar >> Event[i].pUserScale[j][k];
			}
		}

		}



		////////////////////////  version 3.00



		else if ( (FileVersion == 3.00) )
		{

		ar >> m_Copyright;

		if (m_Copyright!="")
		{

			for(i = 0; i<m_Copyright.GetLength(); i++)
			{
				int sign;

				if (i == 0)
					sign = 0;

				if (i%2)
					sign = 1;
				else
					sign = -1;
				m_Copyright.SetAt(i, m_Copyright.GetAt(i)-sign);
			}
		}

		ar >> m_Comment;

		ar >> m_TempoMarking;
		ar >> m_ActiveVoices;
		ar >> dGeneralCounter;
		ar >> dStartCounter;
		ar >> m_TimeSigNum;
		ar >> m_TimeSigDen;


		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> AlgorithmNum[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_IsActive[i];
		
		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_Base[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_Multi[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_StartNum[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_Modulates[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_ScaleID[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_Note[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_NoteValueID[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_NoteValue[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_NumOctsID[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_NumOcts[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_Instrument[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_Channel[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_mode[i];
	
		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_ModulNum[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_ModulRandom[i];

		for (i=VOICE1; i<MAXVOICES; i++)
		{
			ar >> m_Inverted[i];
			ar >> m_MatchScale[i];
			ar >> m_Dynamic[i];
			ar >> m_DynChoice[i];
		}

		for (i=VOICE1; i<MAXVOICES; i++)
		{
			ar >> m_LogMapVar[i];
			ar >> m_FNoiseVar[i];
			ar >> m_HenonA[i];
			ar >> m_HenonB[i];
			ar >> m_HopalongVar[i];
			ar >> m_MartinVar[i];
			ar >> m_GingerX[i];
			ar >> m_GingerY[i];
			ar >> m_LorentzVar[i];
			ar >> m_EarthWormVar[i];
			ar >> m_EarthWormMulti[i];
			ar >> m_EarthWormTruncator[i];
			ar >> m_RandomMin[i];
			ar >> m_RandomMax[i];
			ar >> m_WolframRule[i];
			ar >> m_WolframInit[i];
			ar >> m_WolframSize[i];
			ar >> m_Hailstone[i];
		}

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_Pan[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_Percussion[i];


		for (i=VOICE1; i<MAXVOICES; i++)
				ar >> m_ScaleNotes[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			if (m_pScale[i])
			{
				delete m_pScale[i];
				m_pScale[i] = NULL;
			}
		for (i=VOICE1; i<MAXVOICES; i++)
		{

			m_pScale[i] = new int [ m_ScaleNotes[i] + 1 ];

			m_pScale[i][0] = m_ScaleNotes[i];

			for (j=1; j<=m_pScale[i][0]; j++)
				ar >> m_pScale[i][j];
		}





		for (i=VOICE1; i<MAXVOICES; i++)
				ar >> m_UserScaleNotes[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			if (m_pUserScale[i])
			{
				delete m_pUserScale[i];
				m_pUserScale[i] = NULL;
			}
		for (i=VOICE1; i<MAXVOICES; i++)
		{

			m_pUserScale[i] = new int [ m_UserScaleNotes[i] + 1 ];

			m_pUserScale[i][0] = m_UserScaleNotes[i];

			for (j=1; j<=m_pUserScale[i][0]; j++)
				ar >> m_pUserScale[i][j];
		}


		ar >> m_Password;

		if (m_Password!="")
		{


			for(i = 0; i<m_Password.GetLength(); i++)
			{
				m_Password.SetAt(i, m_Password.GetAt(i)-i);
			}
		}



		ar >> m_NumEvents;

		if(m_NumEvents>-1)

		{



		for (i=0; i<=m_NumEvents; i++)
		{
			ar >> Event[i].count;
			ar >> Event[i].Tempo;
			ar >> Event[i].genCount;
			ar >> Event[i].TimeSigNum;
			ar >> Event[i].TimeSigDen;

		}

		for (i=0; i<=m_NumEvents; i++)
			for(j=VOICE1; j<MAXVOICES; j++)
			{
				ar >> Event[i].AlgorithmNum[j];
				ar >> Event[i].IsActive[j];
				ar >> Event[i].Base[j];
				ar >> Event[i].Multi[j];
				ar >> Event[i].StartNum[j];
				ar >> Event[i].NumOcts[j];
				ar >> Event[i].Modulates[j];
				ar >> Event[i].ModulRandom[j];
				ar >> Event[i].ModulNum[j];
				ar >> Event[i].Note[j];
				ar >> Event[i].NoteValue[j];
				ar >> Event[i].Instrument[j];
				ar >> Event[i].Channel[j];
				ar >> Event[i].Mode[j];
				ar >> Event[i].ScaleID[j];
				ar >> Event[i].NumOctsID[j];
				ar >> Event[i].NoteValueID[j];
				ar >> Event[i].Inverted[j];
				ar >> Event[i].MatchScale[j];
				ar >> Event[i].Dynamic[j];
				ar >> Event[i].DynChoice[j];
				ar >> Event[i].LogMapVar[j];
				ar >> Event[i].FNoiseVar[j];
				ar >> Event[i].LorentzVar[j];
				ar >> Event[i].HenonA[j];
				ar >> Event[i].HenonB[j];
				ar >> Event[i].HopalongVar[j];
				ar >> Event[i].MartinVar[j];
				ar >> Event[i].GingerX[j];
				ar >> Event[i].GingerY[j];
				ar >> Event[i].EarthWormVar[j];
				ar >> Event[i].EarthWormMulti[j];
				ar >> Event[i].EarthWormTruncator[j];
				ar >> Event[i].RandomMin[j];
				ar >> Event[i].RandomMax[j];
				ar >> Event[i].WolframRule[j];
				ar >> Event[i].WolframInit[j];
				ar >> Event[i].WolframSize[j];
				ar >> Event[i].Hailstone[j];
				ar >> Event[i].Pan[j];
				ar >> Event[i].Percussion[j];
			}

		for (i=0; i<=m_NumEvents; i++)
			for(j=VOICE1; j<MAXVOICES; j++)
				ar >> m_EventScaleNotes[i][j];

		for (i=0; i<=m_NumEvents; i++)
			for(j=VOICE1; j<MAXVOICES; j++)
				if(Event[i].pScale[j])
				{
					delete Event[i].pScale[j];
					Event[i].pScale[j] = NULL;
				}

		for (i=0; i<=m_NumEvents; i++)
			for(j=VOICE1; j<MAXVOICES; j++)
			{
				Event[i].pScale[j] = new int [m_EventScaleNotes[i][j] + 1];
				Event[i].pScale[j][0] = m_EventScaleNotes[i][j];

				for(int k=1; k<=Event[i].pScale[j][0]; k++)
					ar >> Event[i].pScale[j][k];
			}


		//////////////////////////////////////////



		for (i=0; i<=m_NumEvents; i++)
			for(j=VOICE1; j<MAXVOICES; j++)
				ar >> m_EventUserScaleNotes[i][j];

		for (i=0; i<=m_NumEvents; i++)
			for(j=VOICE1; j<MAXVOICES; j++)
				if(Event[i].pUserScale[j])
				{
					delete Event[i].pUserScale[j];
					Event[i].pUserScale[j] = NULL;
				}

		for (i=0; i<=m_NumEvents; i++)
			for(j=VOICE1; j<MAXVOICES; j++)
			{
				Event[i].pUserScale[j] = new int [m_EventUserScaleNotes[i][j] + 1];
				Event[i].pUserScale[j][0] = m_EventUserScaleNotes[i][j];

				for(int k=1; k<=Event[i].pUserScale[j][0]; k++)
					ar >> Event[i].pUserScale[j][k];
			}
		}

		}// if(Fileversion == 3.00 ...


		else if ( (FileVersion == 2.50) )
		{

		m_Copyright = "";

		m_Comment = "";

		ar >> m_TempoMarking;
		ar >> m_ActiveVoices;
		ar >> dGeneralCounter;
		ar >> dStartCounter;
		ar >> m_TimeSigNum;
		ar >> m_TimeSigDen;


		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> AlgorithmNum[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_IsActive[i];
		
		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_Base[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_Multi[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_StartNum[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_Modulates[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_ScaleID[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_Note[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_NoteValueID[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_NoteValue[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_NumOctsID[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_NumOcts[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_Instrument[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_Channel[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_mode[i];
	
		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_ModulNum[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_ModulRandom[i];

		for (i=VOICE1; i<MAXVOICES; i++)
		{
			ar >> m_Inverted[i];
			ar >> m_MatchScale[i];
			ar >> m_Dynamic[i];
			ar >> m_DynChoice[i];
		}

		for (i=VOICE1; i<MAXVOICES; i++)
		{
			ar >> m_LogMapVar[i];
			ar >> m_FNoiseVar[i];
			ar >> m_HenonA[i];
			ar >> m_HenonB[i];
			ar >> m_HopalongVar[i];
			ar >> m_MartinVar[i];
			ar >> m_GingerX[i];
			ar >> m_GingerY[i];
			ar >> m_LorentzVar[i];
			m_EarthWormVar[i] = 2;
			m_EarthWormMulti[i] = 3;
			m_EarthWormTruncator[i] = 6;
			m_RandomMin[i] = 0.0;
			m_RandomMax[i] = 1.0;
			m_WolframRule[i] = 30;
			m_WolframInit[i] = 1;
			m_WolframSize[i] = 128;
			m_Hailstone[i] = 27;
		}

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_Pan[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			ar >> m_Percussion[i];


		for (i=VOICE1; i<MAXVOICES; i++)
				ar >> m_ScaleNotes[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			if (m_pScale[i])
			{
				delete m_pScale[i];
				m_pScale[i] = NULL;
			}
		for (i=VOICE1; i<MAXVOICES; i++)
		{

			m_pScale[i] = new int [ m_ScaleNotes[i] + 1 ];

			m_pScale[i][0] = m_ScaleNotes[i];

			for (j=1; j<=m_pScale[i][0]; j++)
				ar >> m_pScale[i][j];
		}





		for (i=VOICE1; i<MAXVOICES; i++)
				ar >> m_UserScaleNotes[i];

		for (i=VOICE1; i<MAXVOICES; i++)
			if (m_pUserScale[i])
			{
				delete m_pUserScale[i];
				m_pUserScale[i] = NULL;
			}
		for (i=VOICE1; i<MAXVOICES; i++)
		{

			m_pUserScale[i] = new int [ m_UserScaleNotes[i] + 1 ];

			m_pUserScale[i][0] = m_UserScaleNotes[i];

			for (j=1; j<=m_pUserScale[i][0]; j++)
				ar >> m_pUserScale[i][j];
		}




		m_Password = "";


		ar >> m_NumEvents;

		if(m_NumEvents>-1)

		{



		for (i=0; i<=m_NumEvents; i++)
		{
			ar >> Event[i].count;
			ar >> Event[i].Tempo;
			ar >> Event[i].genCount;
			ar >> Event[i].TimeSigNum;
			ar >> Event[i].TimeSigDen;

		}

		for (i=0; i<=m_NumEvents; i++)
			for(j=VOICE1; j<MAXVOICES; j++)
			{
				ar >> Event[i].AlgorithmNum[j];
				ar >> Event[i].IsActive[j];
				ar >> Event[i].Base[j];
				ar >> Event[i].Multi[j];
				ar >> Event[i].StartNum[j];
				ar >> Event[i].NumOcts[j];
				ar >> Event[i].Modulates[j];
				ar >> Event[i].ModulRandom[j];
				ar >> Event[i].ModulNum[j];
				ar >> Event[i].Note[j];
				ar >> Event[i].NoteValue[j];
				ar >> Event[i].Instrument[j];
				ar >> Event[i].Channel[j];
				ar >> Event[i].Mode[j];
				ar >> Event[i].ScaleID[j];
				ar >> Event[i].NumOctsID[j];
				ar >> Event[i].NoteValueID[j];
				ar >> Event[i].Inverted[j];
				ar >> Event[i].MatchScale[j];
				ar >> Event[i].Dynamic[j];
				ar >> Event[i].DynChoice[j];
				ar >> Event[i].LogMapVar[j];
				ar >> Event[i].FNoiseVar[j];
				ar >> Event[i].LorentzVar[j];
				ar >> Event[i].HenonA[j];
				ar >> Event[i].HenonB[j];
				ar >> Event[i].HopalongVar[j];
				ar >> Event[i].MartinVar[j];
				ar >> Event[i].GingerX[j];
				ar >> Event[i].GingerY[j];
				Event[i].EarthWormVar[j] = 2;
				Event[i].EarthWormMulti[j] = 3;
				Event[i].EarthWormTruncator[j] = 6;
				Event[i].RandomMin[j] = 0.0;
				Event[i].RandomMax[j] = 1.0;
				Event[i].WolframRule[j] = 30;
				Event[i].WolframInit[j] = 1;
				Event[i].WolframSize[j] = 128;
				Event[i].Hailstone[j] = 27;
				ar >> Event[i].Pan[j];
				ar >> Event[i].Percussion[j];
			}

		for (i=0; i<=m_NumEvents; i++)
			for(j=VOICE1; j<MAXVOICES; j++)
				ar >> m_EventScaleNotes[i][j];

		for (i=0; i<=m_NumEvents; i++)
			for(j=VOICE1; j<MAXVOICES; j++)
				if(Event[i].pScale[j])
				{
					delete Event[i].pScale[j];
					Event[i].pScale[j] = NULL;
				}

		for (i=0; i<=m_NumEvents; i++)
			for(j=VOICE1; j<MAXVOICES; j++)
			{
				Event[i].pScale[j] = new int [m_EventScaleNotes[i][j] + 1];
				Event[i].pScale[j][0] = m_EventScaleNotes[i][j];

				for(int k=1; k<=Event[i].pScale[j][0]; k++)
					ar >> Event[i].pScale[j][k];
			}


		//////////////////////////////////////////



		for (i=0; i<=m_NumEvents; i++)
			for(j=VOICE1; j<MAXVOICES; j++)
				ar >> m_EventUserScaleNotes[i][j];

		for (i=0; i<=m_NumEvents; i++)
			for(j=VOICE1; j<MAXVOICES; j++)
				if(Event[i].pUserScale[j])
				{
					delete Event[i].pUserScale[j];
					Event[i].pUserScale[j] = NULL;
				}

		for (i=0; i<=m_NumEvents; i++)
			for(j=VOICE1; j<MAXVOICES; j++)
			{
				Event[i].pUserScale[j] = new int [m_EventUserScaleNotes[i][j] + 1];
				Event[i].pUserScale[j][0] = m_EventUserScaleNotes[i][j];

				for(int k=1; k<=Event[i].pUserScale[j][0]; k++)
					ar >> Event[i].pUserScale[j][k];
			}
		}

		}// if(Fileversion == 2.5 ...

		

	}
		UpdateAllViews(NULL);



}

/////////////////////////////////////////////////////////////////////////////
// CFractMusDoc diagnostics

#ifdef _DEBUG
void CFractMusDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CFractMusDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CFractMusDoc commands

BOOL CFractMusDoc::SaveModified() 
{
		if (IsDocumentLocked)
		{
			SetModifiedFlag(FALSE);
		}
	
	return CDocument::SaveModified();
}
