
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


// FractMusDoc.h : interface of the CFractMusDoc class
//
/////////////////////////////////////////////////////////////////////////////
#ifndef FRACTMUSDOC_H
#define FRACTMUSDOC_H


#include "defs.h"
#include "event.h"


class CFractMusDoc : public CDocument
{
protected: // create from serialization only
	CFractMusDoc();
	DECLARE_DYNCREATE(CFractMusDoc)

// Attributes
public:

	CString m_Password;
	CString m_Copyright;
	CString m_Comment;
	int		m_TempoMarking;
	int		m_ActiveVoices; 
	long	dGeneralCounter;
	long	dStartCounter;
	short	m_TimeSigNum;
	short	m_TimeSigDen;
	tagEvent Event[1000];


	BOOL	m_IsActive[MAXVOICES];
	BOOL	m_Modulates[MAXVOICES];
	BOOL	m_ModulRandom[MAXVOICES];
	int		m_ModulNum[MAXVOICES];
	long	m_Base[MAXVOICES];
	long	m_Multi[MAXVOICES];
	long	m_StartNum[MAXVOICES];
	int*	m_pScale[MAXVOICES];
	int*	m_pUserScale[MAXVOICES];
	int		m_ScaleNotes[MAXVOICES];
	int		m_UserScaleNotes[MAXVOICES];
	int		m_EventScaleNotes[1000][MAXVOICES];
	int		m_EventUserScaleNotes[1000][MAXVOICES];
	int		m_ScaleID[MAXVOICES];
	int		m_NumOcts[MAXVOICES];
	int		m_NumOctsID[MAXVOICES];
	int		m_Note[MAXVOICES];
	float	m_NoteValue[MAXVOICES];
	int		m_NoteValueID[MAXVOICES];
	int		m_Instrument[MAXVOICES];
	int		m_Channel[MAXVOICES];
	int		m_mode[MAXVOICES];
	BOOL	m_Inverted[MAXVOICES];
	int		m_Dynamic[MAXVOICES];
	int		m_DynChoice[MAXVOICES];
	float	m_LogMapVar[MAXVOICES];
	float	m_FNoiseVar[MAXVOICES];
	float	m_HenonA[MAXVOICES];
	float	m_HenonB[MAXVOICES];
	float	m_HopalongVar[MAXVOICES];
	float	m_MartinVar[MAXVOICES];
	float	m_GingerX[MAXVOICES];
	float	m_GingerY[MAXVOICES];
	float	m_LorentzVar[MAXVOICES];
	unsigned long m_EarthWormVar[MAXVOICES];
	unsigned long m_EarthWormMulti[MAXVOICES];
	unsigned m_EarthWormTruncator[MAXVOICES];
	double	m_RandomMin[MAXVOICES];
	double	m_RandomMax[MAXVOICES];

	BYTE	m_WolframRule[MAXVOICES];
	unsigned long m_WolframInit[MAXVOICES];
	int	m_WolframSize[MAXVOICES];
	long	m_Hailstone[MAXVOICES];

	int		m_Pan[MAXVOICES];
	BOOL	m_MatchScale[MAXVOICES];
	int		m_Percussion[MAXVOICES];


	short	AlgorithmNum[MAXVOICES];


	int		m_NumEvents;



// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFractMusDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	protected:
	virtual BOOL SaveModified();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CFractMusDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CFractMusDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif

/////////////////////////////////////////////////////////////////////////////
