
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


// GetNoteDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FractMus.h"
#include "GetNoteDlg.h"
#include "FractMusDoc.h"
#include "defs.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGetNoteDlg dialog

extern float LogMap[MAXVOICES];
extern float LogMap2[MAXVOICES];
extern float FNoise[MAXVOICES];
extern float HenonX[MAXVOICES];
extern float HenonY[MAXVOICES];
extern float HopalongX[MAXVOICES];
extern float HopalongY[MAXVOICES];
extern float MartinX[MAXVOICES];
extern float MartinY[MAXVOICES];
extern float GingerX[MAXVOICES];
extern float GingerY[MAXVOICES];
extern float LorentzX[MAXVOICES];
extern unsigned long EarthWorm[MAXVOICES];

extern BYTE* WolframArray1[MAXVOICES];
extern BYTE* WolframArray2[MAXVOICES];

extern __int64 HailStoneNumber[MAXVOICES];

extern int count1[MAXVOICES];
extern int count2[MAXVOICES];
extern int count3[MAXVOICES];
extern int count4[MAXVOICES];
extern int count5[MAXVOICES];
extern int count6[MAXVOICES];
extern int count7[MAXVOICES];
extern int count8[MAXVOICES];
extern int count9[MAXVOICES];
extern int count10[MAXVOICES];
extern int count11[MAXVOICES];
extern int count12[MAXVOICES];


extern WORD noteOn(BYTE Stat, BYTE Note, BYTE Vel);
extern WORD noteOff(BYTE Stat, BYTE Note, BYTE Vel);
extern WORD progChange(BYTE Stat, BYTE Instr);
extern WORD modeChange(BYTE Stat, BYTE type, BYTE val);

extern BOOL m_Playing;
extern HMIDIOUT midiOut;
extern int DevChoice;
extern int PercussionChannel;


extern int __fastcall Morse_Thue(int voice, long counter, long test, const int* scale, 
				int numocts,long base, long startnum, 
				int startnote,BOOL modulate, BOOL modulrand, 
				int modulnum, BOOL inverted, float logmapvar, float oneoverf,
				float henonA, float henonB, float hopalong,
				float martin, float lorentz, unsigned long earthwormvar,
				unsigned long earthwormmulti, unsigned earthwormtruncator,
				double ranmin, double ranmax, BYTE wolframrule,
				int wolframsize, long hailstonestart);

extern int __fastcall LogisticMap(int voice, long counter, long test, const int* scale, 
				int numocts,long base, long startnum, 
				int startnote,BOOL modulate, BOOL modulrand, 
				int modulnum, BOOL inverted, float logmapvar, float oneoverf,
				float henonA, float henonB, float hopalong,
				float martin, float lorentz, unsigned long earthwormvar,
				unsigned long earthwormmulti, unsigned earthwormtruncator,
				double ranmin, double ranmax, BYTE wolframrule,
				int wolframsize, long hailstonestart);

extern int __fastcall OneOverF(int voice, long counter, long test, const int* scale, 
				int numocts,long base, long startnum, 
				int startnote,BOOL modulate, BOOL modulrand, 
				int modulnum, BOOL inverted, float logmapvar, float oneoverf,
				float henonA, float henonB, float hopalong,
				float martin, float lorentz, unsigned long earthwormvar,
				unsigned long earthwormmulti, unsigned earthwormtruncator,
				double ranmin, double ranmax, BYTE wolframrule,
				int wolframsize, long hailstonestart);

extern int __fastcall Henon(int voice, long counter, long test, const int* scale, 
				int numocts,long base, long startnum, 
				int startnote,BOOL modulate, BOOL modulrand, 
				int modulnum, BOOL inverted, float logmapvar, float oneoverf,
				float henonA, float henonB, float hopalong,
				float martin, float lorentz, unsigned long earthwormvar,
				unsigned long earthwormmulti, unsigned earthwormtruncator,
				double ranmin, double ranmax, BYTE wolframrule,
				int wolframsize, long hailstonestart);

extern int __fastcall Hopalong(int voice, long counter, long test, const int* scale, 
				int numocts,long base, long startnum, 
				int startnote,BOOL modulate, BOOL modulrand, 
				int modulnum, BOOL inverted, float logmapvar, float oneoverf,
				float henonA, float henonB, float hopalong,
				float martin, float lorentz, unsigned long earthwormvar,
				unsigned long earthwormmulti, unsigned earthwormtruncator,
				double ranmin, double ranmax, BYTE wolframrule,
				int wolframsize, long hailstonestart);

extern int __fastcall Martin(int voice, long counter, long test, const int* scale, 
				int numocts,long base, long startnum, 
				int startnote,BOOL modulate, BOOL modulrand, 
				int modulnum, BOOL inverted, float logmapvar, float oneoverf,
				float henonA, float henonB, float hopalong,
				float martin, float lorentz, unsigned long earthwormvar,
				unsigned long earthwormmulti, unsigned earthwormtruncator,
				double ranmin, double ranmax, BYTE wolframrule,
				int wolframsize, long hailstonestart);

extern int __fastcall Gingerbreadman(int voice, long counter, long test, const int* scale, 
				int numocts,long base, long startnum, 
				int startnote,BOOL modulate, BOOL modulrand, 
				int modulnum, BOOL inverted, float logmapvar, float oneoverf,
				float henonA, float henonB, float hopalong,
				float martin, float lorentz, unsigned long earthwormvar,
				unsigned long earthwormmulti, unsigned earthwormtruncator,
				double ranmin, double ranmax, BYTE wolframrule,
				int wolframsize, long hailstonestart);

extern int __fastcall Lorentz(int voice, long counter, long test, const int* scale, 
				int numocts,long base, long startnum, 
				int startnote,BOOL modulate, BOOL modulrand, 
				int modulnum, BOOL inverted, float logmapvar, float oneoverf,
				float henonA, float henonB, float hopalong,
				float martin, float lorentz, unsigned long earthwormvar,
				unsigned long earthwormmulti, unsigned earthwormtruncator,
				double ranmin, double ranmax, BYTE wolframrule,
				int wolframsize, long hailstonestart);

extern int __fastcall Earthworm(int voice, long counter, long test, const int* scale, 
				int numocts,long base, long startnum, 
				int startnote,BOOL modulate, BOOL modulrand, 
				int modulnum, BOOL inverted, float logmapvar, float oneoverf,
				float henonA, float henonB, float hopalong,
				float martin, float lorentz, unsigned long earthwormvar,
				unsigned long earthwormmulti, unsigned earthwormtruncator,
				double ranmin, double ranmax, BYTE wolframrule,
				int wolframsize, long hailstonestart);

extern int __fastcall RandomAlgorithm(int voice, long counter, long test, const int* scale, 
				int numocts,long base, long startnum, 
				int startnote,BOOL modulate, BOOL modulrand, 
				int modulnum, BOOL inverted, float logmapvar, float oneoverf,
				float henonA, float henonB, float hopalong,
				float martin, float lorentz, unsigned long earthwormvar,
				unsigned long earthwormmulti, unsigned earthwormtruncator,
				double ranmin, double ranmax, BYTE wolframrule,
				int wolframsize, long hailstonestart);

extern int __fastcall Hailstone(int voice, long counter, long test, const int* scale, 
				int numocts,long base, long startnum, 
				int startnote,BOOL modulate, BOOL modulrand, 
				int modulnum, BOOL inverted, float logmapvar, float oneoverf,
				float henonA, float henonB, float hopalong,
				float martin, float lorentz, unsigned long earthwormvar,
				unsigned long earthwormmulti, unsigned earthwormtruncator,
				double ranmin, double ranmax, BYTE wolframrule,
				int wolframsize, long hailstonestart);

extern int __fastcall Wolfram(int voice, long counter, long test, const int* scale, 
				int numocts,long base, long startnum, 
				int startnote,BOOL modulate, BOOL modulrand, 
				int modulnum, BOOL inverted, float logmapvar, float oneoverf,
				float henonA, float henonB, float hopalong,
				float martin, float lorentz, unsigned long earthwormvar,
				unsigned long earthwormmulti, unsigned earthwormtruncator,
				double ranmin, double ranmax, BYTE wolframrule,
				int wolframsize, long hailstonestart);


extern void ComputeTotal(long test, long base, long* total);

extern int (__fastcall*(Algorithm[12]))(int , long , long , const int* , 
				int ,long , long , 
				int ,BOOL , BOOL , 
				int, BOOL, float, float, float, float, float, float,
				float, unsigned long, unsigned long, unsigned,
				double, double, BYTE, int, long);

extern float RanDev();


char* NoteNames[]={	"C0","C#0","D0","D#0","E0","F0","F#0","G0","G#0","A0","A#0","B0",
					"C1","C#1","D1","D#1","E1","F1","F#1","G1","G#1","A1","A#1","B1",
					"C2","C#2","D2","D#2","E2","F2","F#2","G2","G#2","A2","A#2","B2",
					"C3","C#3","D3","D#3","E3","F3","F#3","G3","G#3","A3","A#3","B3",
					"C4","C#4","D4","D#4","E4","F4","F#4","G4","G#4","A4","A#4","B4",
					"C5","C#5","D5","D#5","E5","F5","F#5","G5","G#5","A5","A#5","B5",
					"C6","C#6","D6","D#6","E6","F6","F#6","G6","G#6","A6","A#6","B6",
					"C7","C#7","D7","D#7","E7","F7","F#7","G7","G#7","A7","A#7","B7",
					"C8","C#8","D8","D#8","E8","F8","F#8","G8","G#8","A8","A#8","B8",
					"C9","C#9","D9","D#9","E9","F9","F#9","G9","G#9","A9","A#9","B9",
					"C10","C#10","D10","D#10","E10","F10","F#10","G10"
				  };
	 


CGetNoteDlg::CGetNoteDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGetNoteDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGetNoteDlg)
	m_StartCounterEdit = 0;
	m_playnotes = FALSE;
	//}}AFX_DATA_INIT

	pView = NULL;

	VoiceID[VOICE1] = IDC_V1_ST;
	VoiceID[VOICE2] = IDC_V2_ST;
	VoiceID[VOICE3] = IDC_V3_ST;
	VoiceID[VOICE4] = IDC_V4_ST;
	VoiceID[VOICE5] = IDC_V5_ST;
	VoiceID[VOICE6] = IDC_V6_ST;
	VoiceID[VOICE7] = IDC_V7_ST;
	VoiceID[VOICE8] = IDC_V8_ST;
	VoiceID[VOICE9] = IDC_V9_ST;
	VoiceID[VOICE10] = IDC_V10_ST;
	VoiceID[VOICE11] = IDC_V11_ST;
	VoiceID[VOICE12] = IDC_V12_ST;
	VoiceID[VOICE13] = IDC_V13_ST;
	VoiceID[VOICE14] = IDC_V14_ST;
	VoiceID[VOICE15] = IDC_V15_ST;
	VoiceID[VOICE16] = IDC_V16_ST;

	StaticID[VOICE1] = IDC_STATIC1;
	StaticID[VOICE2] = IDC_STATIC2;
	StaticID[VOICE3] = IDC_STATIC3;
	StaticID[VOICE4] = IDC_STATIC4;
	StaticID[VOICE5] = IDC_STATIC5;
	StaticID[VOICE6] = IDC_STATIC6;
	StaticID[VOICE7] = IDC_STATIC7;
	StaticID[VOICE8] = IDC_STATIC8;
	StaticID[VOICE9] = IDC_STATIC9;
	StaticID[VOICE10] = IDC_STATIC10;
	StaticID[VOICE11] = IDC_STATIC11;
	StaticID[VOICE12] = IDC_STATIC12;
	StaticID[VOICE13] = IDC_STATIC13;
	StaticID[VOICE14] = IDC_STATIC14;
	StaticID[VOICE15] = IDC_STATIC15;
	StaticID[VOICE16] = IDC_STATIC16;

}


void CGetNoteDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGetNoteDlg)
	DDX_Text(pDX, IDC_CHANGE_COUNTER, m_StartCounterEdit);
	DDV_MinMaxUInt(pDX, m_StartCounterEdit, 0, 50000);
	DDX_Check(pDX, IDC_PLAY_NOTES, m_playnotes);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGetNoteDlg, CDialog)
	//{{AFX_MSG_MAP(CGetNoteDlg)
	ON_EN_KILLFOCUS(IDC_CHANGE_COUNTER, OnKillfocusChangeCounter)
	ON_BN_CLICKED(IDC_DECREASE_COUNTER, OnDecreaseCounter)
	ON_BN_CLICKED(IDC_INCREASE_COUNTER, OnIncreaseCounter)
	ON_BN_CLICKED(IDC_UPDATE_ALL, OnUpdateAll)
	ON_BN_CLICKED(IDC_PLAY_NOTES, OnPlayNotes)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGetNoteDlg message handlers

void CGetNoteDlg::OnOK() 
{
	
	CDialog::OnOK();
}

void CGetNoteDlg::OnCancel() 
{
	
	CDialog::OnCancel();
}

BOOL CGetNoteDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CFractMusDoc* pDoc = pView->GetDocument();
	CStatic* pSt;

	m_StartCounterEdit = pDoc->dStartCounter;

	UpdateData(FALSE);


	for(int i = VOICE1; i<MAXVOICES; i++)
	{
		if (!pDoc->m_IsActive[i])
		{
			pSt = (CStatic*)GetDlgItem(VoiceID[i])->EnableWindow(FALSE);
			pSt = (CStatic*)GetDlgItem(StaticID[i])->EnableWindow(FALSE);

		}
	}



	ShowNotes();
	
	return FALSE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CGetNoteDlg::ShowNotes()
{
	CFractMusDoc* pDoc = pView->GetDocument();
	CStatic* pSt;



	long test[MAXVOICES];
	int note[MAXVOICES];
	int dracula[MAXVOICES];
	//long count;
	int voice;
	register int j;

	for (voice = VOICE1; voice<MAXVOICES; voice++)
		dracula[voice] = int(pDoc->m_NoteValue[voice]);

	for (voice = VOICE1; voice<MAXVOICES; voice++)
		note[voice] = -1;

	for (voice = VOICE1; voice<MAXVOICES; voice++)
	{
		count1[voice] = 0;
		count2[voice] = 0;
		count3[voice] = 0;
		count4[voice] = 0;
		count5[voice] = 0;
		count6[voice] = 0;
		count7[voice] = 0;
		count8[voice] = 0;
		count9[voice] = 0;
		count10[voice] = 0;
		count11[voice] = 0;
		count12[voice] = 0;
	}



	for (voice = VOICE1; voice<MAXVOICES; voice++)
	{
		if (pDoc->m_Modulates[voice]&&pDoc->m_ModulRandom[voice])
			continue;

			int n = m_StartCounterEdit+(pDoc->m_StartNum[voice]*dracula[voice]);

			if ( n<0)
			{
				continue;
			}

		if(pDoc->AlgorithmNum[voice]==MORSE_THUE)
		{

			for(j = 0; j<m_StartCounterEdit+(pDoc->m_StartNum[voice]*dracula[voice]); j++)
			{
				if(!((pDoc->m_StartNum[voice]*dracula[voice]+j)%dracula[voice]))
				{


				test[voice] = (((pDoc->m_StartNum[voice]*dracula[voice]+j)/dracula[voice])*pDoc->m_Multi[voice]);
				note[voice] = (*(Algorithm[ pDoc->AlgorithmNum[voice] ]))(voice, (pDoc->m_StartNum[voice]*dracula[voice]+j)/dracula[voice], test[voice],
									pDoc->m_pScale[voice], 
									pDoc->m_NumOcts[voice], 
									pDoc->m_Base[voice], 
									pDoc->m_StartNum[voice],
									pDoc->m_Note[voice], 
									pDoc->m_Modulates[voice],
									pDoc->m_ModulRandom[voice], 
									pDoc->m_ModulNum[voice],
									pDoc->m_Inverted[voice],
									pDoc->m_LogMapVar[voice],
									pDoc->m_FNoiseVar[voice],
									pDoc->m_HenonA[voice],
									pDoc->m_HenonB[voice],
									pDoc->m_HopalongVar[voice],
									pDoc->m_MartinVar[voice],
									pDoc->m_LorentzVar[voice],
									pDoc->m_EarthWormVar[voice],
									pDoc->m_EarthWormMulti[voice],
									pDoc->m_EarthWormTruncator[voice],
									pDoc->m_RandomMin[voice],
									pDoc->m_RandomMax[voice],
									pDoc->m_WolframRule[voice],
									pDoc->m_WolframSize[voice],
									pDoc->m_Hailstone[voice]
									
					);
				}
			}
		}


		if(pDoc->AlgorithmNum[voice]==LOGMAP)
		{
			LogMap[voice] = 0.2f;

			for(j = 0; j<m_StartCounterEdit+(pDoc->m_StartNum[voice]*dracula[voice]); j++)
			{
				if(!((pDoc->m_StartNum[voice]*dracula[voice]+j)%dracula[voice]))
				{

				note[voice] = (*(Algorithm[ pDoc->AlgorithmNum[voice] ]))(voice, (pDoc->m_StartNum[voice]*dracula[voice]+j)/dracula[voice], 0,
									pDoc->m_pScale[voice], 
									pDoc->m_NumOcts[voice], 
									pDoc->m_Base[voice], 
									pDoc->m_StartNum[voice],
									pDoc->m_Note[voice], 
									pDoc->m_Modulates[voice],
									pDoc->m_ModulRandom[voice], 
									pDoc->m_ModulNum[voice],
									pDoc->m_Inverted[voice],
									pDoc->m_LogMapVar[voice],
									pDoc->m_FNoiseVar[voice],
									pDoc->m_HenonA[voice],
									pDoc->m_HenonB[voice],
									pDoc->m_HopalongVar[voice],
									pDoc->m_MartinVar[voice],
									pDoc->m_LorentzVar[voice],
									pDoc->m_EarthWormVar[voice],
									pDoc->m_EarthWormMulti[voice],
									pDoc->m_EarthWormTruncator[voice],
									pDoc->m_RandomMin[voice],
									pDoc->m_RandomMax[voice],
									pDoc->m_WolframRule[voice],
									pDoc->m_WolframSize[voice],
									pDoc->m_Hailstone[voice]

									
					);
				}
			}
		}

		if(pDoc->AlgorithmNum[voice]==ONE_OVER_F_NOISE)
		{
			LogMap2[voice] = 0.2f;
			FNoise[voice] = 0.0f;

			for(j = 0; j<m_StartCounterEdit+(pDoc->m_StartNum[voice]*dracula[voice]); j++)
			{
				if(!((pDoc->m_StartNum[voice]*dracula[voice]+j)%dracula[voice]))
				{

				note[voice] = (*(Algorithm[ pDoc->AlgorithmNum[voice] ]))(voice, (pDoc->m_StartNum[voice]*dracula[voice]+j)/dracula[voice], 0,
									pDoc->m_pScale[voice], 
									pDoc->m_NumOcts[voice], 
									pDoc->m_Base[voice], 
									pDoc->m_StartNum[voice],
									pDoc->m_Note[voice], 
									pDoc->m_Modulates[voice],
									pDoc->m_ModulRandom[voice], 
									pDoc->m_ModulNum[voice],
									pDoc->m_Inverted[voice],
									pDoc->m_LogMapVar[voice],
									pDoc->m_FNoiseVar[voice],
									pDoc->m_HenonA[voice],
									pDoc->m_HenonB[voice],
									pDoc->m_HopalongVar[voice],
									pDoc->m_MartinVar[voice],
									pDoc->m_LorentzVar[voice],
									pDoc->m_EarthWormVar[voice],
									pDoc->m_EarthWormMulti[voice],
									pDoc->m_EarthWormTruncator[voice],
									pDoc->m_RandomMin[voice],
									pDoc->m_RandomMax[voice],
									pDoc->m_WolframRule[voice],
									pDoc->m_WolframSize[voice],
									pDoc->m_Hailstone[voice]

									
					);
				}
			}
		}

		if(pDoc->AlgorithmNum[voice]==HENON)
		{
			HenonX[voice] = HenonY[voice] = 0.0f;

			for(j = 0; j<m_StartCounterEdit+(pDoc->m_StartNum[voice]*dracula[voice]); j++)
			{
				if(!((pDoc->m_StartNum[voice]*dracula[voice]+j)%dracula[voice]))
				{

				note[voice] = (*(Algorithm[ pDoc->AlgorithmNum[voice] ]))(voice, (pDoc->m_StartNum[voice]*dracula[voice]+j)/dracula[voice], 0,
									pDoc->m_pScale[voice], 
									pDoc->m_NumOcts[voice], 
									pDoc->m_Base[voice], 
									pDoc->m_StartNum[voice],
									pDoc->m_Note[voice], 
									pDoc->m_Modulates[voice],
									pDoc->m_ModulRandom[voice], 
									pDoc->m_ModulNum[voice],
									pDoc->m_Inverted[voice],
									pDoc->m_LogMapVar[voice],
									pDoc->m_FNoiseVar[voice],
									pDoc->m_HenonA[voice],
									pDoc->m_HenonB[voice],
									pDoc->m_HopalongVar[voice],
									pDoc->m_MartinVar[voice],
									pDoc->m_LorentzVar[voice],
									pDoc->m_EarthWormVar[voice],
									pDoc->m_EarthWormMulti[voice],
									pDoc->m_EarthWormTruncator[voice],
									pDoc->m_RandomMin[voice],
									pDoc->m_RandomMax[voice],
									pDoc->m_WolframRule[voice],
									pDoc->m_WolframSize[voice],
									pDoc->m_Hailstone[voice]

									
					);
				}
			}
		}

		if(pDoc->AlgorithmNum[voice]==HOPALONG)
		{
			HopalongX[voice] = HopalongY[voice] = 0.0f;

			for(j = 0; j<m_StartCounterEdit+(pDoc->m_StartNum[voice]*dracula[voice]); j++)
			{
				if(!((pDoc->m_StartNum[voice]*dracula[voice]+j)%dracula[voice]))
				{

				note[voice] = (*(Algorithm[ pDoc->AlgorithmNum[voice] ]))(voice, (pDoc->m_StartNum[voice]*dracula[voice]+j)/dracula[voice], 0,
									pDoc->m_pScale[voice], 
									pDoc->m_NumOcts[voice], 
									pDoc->m_Base[voice], 
									pDoc->m_StartNum[voice],
									pDoc->m_Note[voice], 
									pDoc->m_Modulates[voice],
									pDoc->m_ModulRandom[voice], 
									pDoc->m_ModulNum[voice],
									pDoc->m_Inverted[voice],
									pDoc->m_LogMapVar[voice],
									pDoc->m_FNoiseVar[voice],
									pDoc->m_HenonA[voice],
									pDoc->m_HenonB[voice],
									pDoc->m_HopalongVar[voice],
									pDoc->m_MartinVar[voice],
									pDoc->m_LorentzVar[voice],
									pDoc->m_EarthWormVar[voice],
									pDoc->m_EarthWormMulti[voice],
									pDoc->m_EarthWormTruncator[voice],
									pDoc->m_RandomMin[voice],
									pDoc->m_RandomMax[voice],
									pDoc->m_WolframRule[voice],
									pDoc->m_WolframSize[voice],
									pDoc->m_Hailstone[voice]
									
					);
				}
			}
		}

		if(pDoc->AlgorithmNum[voice]==MARTIN)
		{
			MartinX[voice] = MartinY[voice] = 0.0f;

			for(j = 0; j<m_StartCounterEdit+(pDoc->m_StartNum[voice]*dracula[voice]); j++)
			{
				if(!((pDoc->m_StartNum[voice]*dracula[voice]+j)%dracula[voice]))
				{

				note[voice] = (*(Algorithm[ pDoc->AlgorithmNum[voice] ]))(voice, (pDoc->m_StartNum[voice]*dracula[voice]+j)/dracula[voice], 0,
									pDoc->m_pScale[voice], 
									pDoc->m_NumOcts[voice], 
									pDoc->m_Base[voice], 
									pDoc->m_StartNum[voice],
									pDoc->m_Note[voice], 
									pDoc->m_Modulates[voice],
									pDoc->m_ModulRandom[voice], 
									pDoc->m_ModulNum[voice],
									pDoc->m_Inverted[voice],
									pDoc->m_LogMapVar[voice],
									pDoc->m_FNoiseVar[voice],
									pDoc->m_HenonA[voice],
									pDoc->m_HenonB[voice],
									pDoc->m_HopalongVar[voice],
									pDoc->m_MartinVar[voice],
									pDoc->m_LorentzVar[voice],
									pDoc->m_EarthWormVar[voice],
									pDoc->m_EarthWormMulti[voice],
									pDoc->m_EarthWormTruncator[voice],
									pDoc->m_RandomMin[voice],
									pDoc->m_RandomMax[voice],
									pDoc->m_WolframRule[voice],
									pDoc->m_WolframSize[voice],
									pDoc->m_Hailstone[voice]
									
					);
				}
			}
		}

		if(pDoc->AlgorithmNum[voice]==GINGERBREADMAN)
		{
			GingerX[voice] = pDoc->m_GingerX[voice];
			GingerY[voice] = pDoc->m_GingerY[voice];;

			for(j = 0; j<m_StartCounterEdit+(pDoc->m_StartNum[voice]*dracula[voice]); j++)
			{
				if(!((pDoc->m_StartNum[voice]*dracula[voice]+j)%dracula[voice]))
				{

				note[voice] = (*(Algorithm[ pDoc->AlgorithmNum[voice] ]))(voice, (pDoc->m_StartNum[voice]*dracula[voice]+j)/dracula[voice], 0,
									pDoc->m_pScale[voice], 
									pDoc->m_NumOcts[voice], 
									pDoc->m_Base[voice], 
									pDoc->m_StartNum[voice],
									pDoc->m_Note[voice], 
									pDoc->m_Modulates[voice],
									pDoc->m_ModulRandom[voice], 
									pDoc->m_ModulNum[voice],
									pDoc->m_Inverted[voice],
									pDoc->m_LogMapVar[voice],
									pDoc->m_FNoiseVar[voice],
									pDoc->m_HenonA[voice],
									pDoc->m_HenonB[voice],
									pDoc->m_HopalongVar[voice],
									pDoc->m_MartinVar[voice],
									pDoc->m_LorentzVar[voice],
									pDoc->m_EarthWormVar[voice],
									pDoc->m_EarthWormMulti[voice],
									pDoc->m_EarthWormTruncator[voice],
									pDoc->m_RandomMin[voice],
									pDoc->m_RandomMax[voice],
									pDoc->m_WolframRule[voice],
									pDoc->m_WolframSize[voice],
									pDoc->m_Hailstone[voice]

									
					);
				}
			}
		}

		if(pDoc->AlgorithmNum[voice]==LORENTZ)
		{
			LorentzX[voice] = 1.0f;

			for(j = 0; j<m_StartCounterEdit+(pDoc->m_StartNum[voice]*dracula[voice]); j++)
			{
				if(!((pDoc->m_StartNum[voice]*dracula[voice]+j)%dracula[voice]))
				{

				note[voice] = (*(Algorithm[ pDoc->AlgorithmNum[voice] ]))(voice, (pDoc->m_StartNum[voice]*dracula[voice]+j)/dracula[voice], 0,
									pDoc->m_pScale[voice], 
									pDoc->m_NumOcts[voice], 
									pDoc->m_Base[voice], 
									pDoc->m_StartNum[voice],
									pDoc->m_Note[voice], 
									pDoc->m_Modulates[voice],
									pDoc->m_ModulRandom[voice], 
									pDoc->m_ModulNum[voice],
									pDoc->m_Inverted[voice],
									pDoc->m_LogMapVar[voice],
									pDoc->m_FNoiseVar[voice],
									pDoc->m_HenonA[voice],
									pDoc->m_HenonB[voice],
									pDoc->m_HopalongVar[voice],
									pDoc->m_MartinVar[voice],
									pDoc->m_LorentzVar[voice],
									pDoc->m_EarthWormVar[voice],
									pDoc->m_EarthWormMulti[voice],
									pDoc->m_EarthWormTruncator[voice],
									pDoc->m_RandomMin[voice],
									pDoc->m_RandomMax[voice],
									pDoc->m_WolframRule[voice],
									pDoc->m_WolframSize[voice],
									pDoc->m_Hailstone[voice]

									
					);
				}
			}
		}

		if(pDoc->AlgorithmNum[voice]==EARTHWORM)
		{
			EarthWorm[voice] = pDoc->m_EarthWormVar[voice];

			for(j = 0; j<m_StartCounterEdit+(pDoc->m_StartNum[voice]*dracula[voice]); j++)
			{
				if(!((pDoc->m_StartNum[voice]*dracula[voice]+j)%dracula[voice]))
				{

				note[voice] = (*(Algorithm[ pDoc->AlgorithmNum[voice] ]))(voice, (pDoc->m_StartNum[voice]*dracula[voice]+j)/dracula[voice], 0,
									pDoc->m_pScale[voice], 
									pDoc->m_NumOcts[voice], 
									pDoc->m_Base[voice], 
									pDoc->m_StartNum[voice],
									pDoc->m_Note[voice], 
									pDoc->m_Modulates[voice],
									pDoc->m_ModulRandom[voice], 
									pDoc->m_ModulNum[voice],
									pDoc->m_Inverted[voice],
									pDoc->m_LogMapVar[voice],
									pDoc->m_FNoiseVar[voice],
									pDoc->m_HenonA[voice],
									pDoc->m_HenonB[voice],
									pDoc->m_HopalongVar[voice],
									pDoc->m_MartinVar[voice],
									pDoc->m_LorentzVar[voice],
									pDoc->m_EarthWormVar[voice],
									pDoc->m_EarthWormMulti[voice],
									pDoc->m_EarthWormTruncator[voice],
									pDoc->m_RandomMin[voice],
									pDoc->m_RandomMax[voice],
									pDoc->m_WolframRule[voice],
									pDoc->m_WolframSize[voice],
									pDoc->m_Hailstone[voice]

									
					);
				}
			}
		}

		if(pDoc->AlgorithmNum[voice]==HAILSTONE)
		{
			HailStoneNumber[voice] = pDoc->m_Hailstone[voice];

			for(j = 0; j<m_StartCounterEdit+(pDoc->m_StartNum[voice]*dracula[voice]); j++)
			{
				if(!((pDoc->m_StartNum[voice]*dracula[voice]+j)%dracula[voice]))
				{

				note[voice] = (*(Algorithm[ pDoc->AlgorithmNum[voice] ]))(voice, (pDoc->m_StartNum[voice]*dracula[voice]+j)/dracula[voice], 0,
									pDoc->m_pScale[voice], 
									pDoc->m_NumOcts[voice], 
									pDoc->m_Base[voice], 
									pDoc->m_StartNum[voice],
									pDoc->m_Note[voice], 
									pDoc->m_Modulates[voice],
									pDoc->m_ModulRandom[voice], 
									pDoc->m_ModulNum[voice],
									pDoc->m_Inverted[voice],
									pDoc->m_LogMapVar[voice],
									pDoc->m_FNoiseVar[voice],
									pDoc->m_HenonA[voice],
									pDoc->m_HenonB[voice],
									pDoc->m_HopalongVar[voice],
									pDoc->m_MartinVar[voice],
									pDoc->m_LorentzVar[voice],
									pDoc->m_EarthWormVar[voice],
									pDoc->m_EarthWormMulti[voice],
									pDoc->m_EarthWormTruncator[voice],
									pDoc->m_RandomMin[voice],
									pDoc->m_RandomMax[voice],
									pDoc->m_WolframRule[voice],
									pDoc->m_WolframSize[voice],
									pDoc->m_Hailstone[voice]

									
					);
				}
			}
		}

		if(pDoc->AlgorithmNum[voice]==WOLFRAM)
		{
					if (WolframArray1[voice])
					{
						delete WolframArray1[voice];
						WolframArray1[voice] = NULL;
					}
					if (WolframArray2[voice])
					{
						delete WolframArray2[voice];
						WolframArray2[voice] = NULL;
					}

					WolframArray1[voice] = new BYTE[pDoc->m_WolframSize[voice]];
					WolframArray2[voice] = new BYTE[pDoc->m_WolframSize[voice]];

					for (int idx = 0; idx<32; idx++)
							WolframArray1[voice][idx] = pDoc->m_WolframInit[voice] & unsigned long (pow(2, idx)) ? 1 : 0;

					if (pDoc->m_WolframSize[voice]>32)
					{
						for (idx = 32; idx<pDoc->m_WolframSize[voice]; idx++)
							WolframArray1[voice][idx] = 0;
					}


			for(j = 0; j<m_StartCounterEdit+(pDoc->m_StartNum[voice]*dracula[voice]); j++)
			{
				if(!((pDoc->m_StartNum[voice]*dracula[voice]+j)%dracula[voice]))
				{

				note[voice] = (*(Algorithm[ pDoc->AlgorithmNum[voice] ]))(voice, (pDoc->m_StartNum[voice]*dracula[voice]+j)/dracula[voice], 0,
									pDoc->m_pScale[voice], 
									pDoc->m_NumOcts[voice], 
									pDoc->m_Base[voice], 
									pDoc->m_StartNum[voice],
									pDoc->m_Note[voice], 
									pDoc->m_Modulates[voice],
									pDoc->m_ModulRandom[voice], 
									pDoc->m_ModulNum[voice],
									pDoc->m_Inverted[voice],
									pDoc->m_LogMapVar[voice],
									pDoc->m_FNoiseVar[voice],
									pDoc->m_HenonA[voice],
									pDoc->m_HenonB[voice],
									pDoc->m_HopalongVar[voice],
									pDoc->m_MartinVar[voice],
									pDoc->m_LorentzVar[voice],
									pDoc->m_EarthWormVar[voice],
									pDoc->m_EarthWormMulti[voice],
									pDoc->m_EarthWormTruncator[voice],
									pDoc->m_RandomMin[voice],
									pDoc->m_RandomMax[voice],
									pDoc->m_WolframRule[voice],
									pDoc->m_WolframSize[voice],
									pDoc->m_Hailstone[voice]

									
					);
				}
			}
		}


	}

		for (voice = VOICE1; voice<MAXVOICES; voice++)
		{


			if (pDoc->m_Modulates[voice]&&pDoc->m_ModulRandom[voice])
				continue;

			int n = m_StartCounterEdit+(pDoc->m_StartNum[voice]*dracula[voice]);

			if ( n<0)
			{
				continue;
			}

			if((pDoc->m_StartNum[voice]*dracula[voice]+m_StartCounterEdit)>=0)
			{
			if(!((pDoc->m_StartNum[voice]*dracula[voice]+m_StartCounterEdit)%dracula[voice]))
			{
				test[voice]= (((pDoc->m_StartNum[voice]*dracula[voice]+m_StartCounterEdit)/dracula[voice])*pDoc->m_Multi[voice]);
				note[voice]= (*(Algorithm[ pDoc->AlgorithmNum[voice] ]))(voice, (pDoc->m_StartNum[voice]*dracula[voice]+m_StartCounterEdit)/dracula[voice], test[voice],
									pDoc->m_pScale[voice], 
									pDoc->m_NumOcts[voice], 
									pDoc->m_Base[voice], 
									pDoc->m_StartNum[voice],
									pDoc->m_Note[voice], 
									pDoc->m_Modulates[voice],
									pDoc->m_ModulRandom[voice], 
									pDoc->m_ModulNum[voice],
									pDoc->m_Inverted[voice],
									pDoc->m_LogMapVar[voice],
									pDoc->m_FNoiseVar[voice],
									pDoc->m_HenonA[voice],
									pDoc->m_HenonB[voice],
									pDoc->m_HopalongVar[voice],
									pDoc->m_MartinVar[voice],
									pDoc->m_LorentzVar[voice],
									pDoc->m_EarthWormVar[voice],
									pDoc->m_EarthWormMulti[voice],
									pDoc->m_EarthWormTruncator[voice],
									pDoc->m_RandomMin[voice],
									pDoc->m_RandomMax[voice],
									pDoc->m_WolframRule[voice],
									pDoc->m_WolframSize[voice],
									pDoc->m_Hailstone[voice]

					);
			}
			}
		}

		for (voice = VOICE1; voice<MAXVOICES; voice++)
		{

			int notenumber = (m_StartCounterEdit/dracula[voice])+pDoc->m_StartNum[voice];

			pSt = (CStatic*)GetDlgItem(VoiceID[voice]);

			if (pDoc->m_Modulates[voice]&&pDoc->m_ModulRandom[voice])
				pSt->SetWindowText("N/A");

			else if (note[voice]<0||note[voice]>127)
				pSt->SetWindowText("none");
			else
			{
				CString msg, msg2;
				msg = (char *)NoteNames[note[voice]];

				msg2.Format(" (%d)", notenumber);

				msg += msg2;
				pSt->SetWindowText(msg);
			}
		}

		if (!m_playnotes)
			return;


	UINT result = midiOutOpen(&midiOut, DevChoice, NULL, NULL, CALLBACK_NULL);

	if( result!=MMSYSERR_NOERROR )
	{
		switch(result)
		{

		case MMSYSERR_ALLOCATED:
			AfxMessageBox("The device is already in use, free it and try again", MB_OK+MB_ICONHAND);
			break;
		case MMSYSERR_NOMEM:
			AfxMessageBox("Could not allocate memory for the device", MB_OK+MB_ICONHAND);
			break;
		case MMSYSERR_INVALPARAM:
			AfxMessageBox("Invalid pointer!", MB_OK+MB_ICONHAND);
			break;
		}

	}

		if( result!=MMSYSERR_NOERROR )
			return;

		for(voice = VOICE1; voice<MAXVOICES; voice++)
			if(pDoc->m_IsActive[voice])
				if (!(pDoc->m_Modulates[voice]&&pDoc->m_ModulRandom[voice]))
					if (note[voice]>=0&&note[voice]<128)
						progChange(0xC0+pDoc->m_Channel[voice], (BYTE)pDoc->m_Instrument[voice]);

		for(voice = VOICE1; voice<MAXVOICES; voice++)
			if(pDoc->m_IsActive[voice])
				if (!(pDoc->m_Modulates[voice]&&pDoc->m_ModulRandom[voice]))
					if (note[voice]>=0&&note[voice]<128)
					{
						if (pDoc->m_Channel[voice] == PercussionChannel)
							noteOn(0x90+pDoc->m_Channel[voice], (BYTE)pDoc->m_Percussion[voice]+35, (BYTE)(pDoc->m_Dynamic[voice]/*pDoc->m_IsActive[i]*/));
						else
							noteOn(0x90+pDoc->m_Channel[voice], (BYTE)note[voice], (BYTE)(pDoc->m_Dynamic[voice]/*pDoc->m_IsActive[i]*/));

					}
		Sleep(500);

		midiOutReset(midiOut);
		midiOutClose(midiOut);
						



		




}


void CGetNoteDlg::OnKillfocusChangeCounter() 
{
	UpdateData();
	
}

void CGetNoteDlg::OnDecreaseCounter() 
{
	if(m_StartCounterEdit<1)
		return;

	CFractMusDoc* pDoc = pView->GetDocument();

	int SmallestValue = 1000L;

	for (int i = VOICE1; i<MAXVOICES; i++)
	{
		if (pDoc->m_IsActive[i])
		{
			if((int)pDoc->m_NoteValue[i]<SmallestValue)
				SmallestValue = pDoc->m_NoteValue[i];
		}
	}

	if (SmallestValue>999)
		SmallestValue = 1;
	m_StartCounterEdit--;

	while((m_StartCounterEdit%(long)SmallestValue)&&(m_StartCounterEdit>0))
		m_StartCounterEdit--;

	UpdateData(FALSE);
	ShowNotes();
	
}

void CGetNoteDlg::OnIncreaseCounter() 
{
	if(m_StartCounterEdit>49999)
		return;

	CFractMusDoc* pDoc = pView->GetDocument();

	int SmallestValue = 1000L;

	for (int i = VOICE1; i<MAXVOICES; i++)
	{
		if (pDoc->m_IsActive[i])
		{
			if((int)pDoc->m_NoteValue[i]<SmallestValue)
				SmallestValue = pDoc->m_NoteValue[i];
		}
	}

	if (SmallestValue>999)
		SmallestValue = 1;

	m_StartCounterEdit++;

	while((m_StartCounterEdit%(long)SmallestValue)&&(m_StartCounterEdit<50000))
		m_StartCounterEdit++;

	UpdateData(FALSE);
	ShowNotes();

}

void CGetNoteDlg::OnUpdateAll() 
{
		ShowNotes();
}

void CGetNoteDlg::OnPlayNotes() 
{
	UpdateData();
	ShowNotes();
	
}
