
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


// GraphWnd.cpp : implementation file
//

#include "stdafx.h"
#include "FractMus.h"
#include "FractMusView.h"
#include "GraphWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGraphWnd

IMPLEMENT_DYNCREATE(CGraphWnd, CFrameWnd)

CGraphWnd::CGraphWnd()
{
	m_pParent = NULL;

}

CGraphWnd::~CGraphWnd()
{
}


BEGIN_MESSAGE_MAP(CGraphWnd, CFrameWnd)
	//{{AFX_MSG_MAP(CGraphWnd)
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGraphWnd message handlers

BOOL CGraphWnd::Create(	LPCTSTR lpszClassName, 
						LPCTSTR lpszWindowName, 
						DWORD dwStyle, 
						const RECT& rect, 
						CWnd* pParentWnd, 
						LPCTSTR lpszMenuName,
						DWORD dwExStyle, 
						CCreateContext* pContext)
{

	return CFrameWnd::Create(	lpszClassName,lpszWindowName,
								dwStyle, rect, pParentWnd,
								lpszMenuName, dwExStyle,
								pContext
							);
}

void CGraphWnd::OnDestroy() 
{

	CFrameWnd::OnDestroy();
	
	((CFractMusView*)m_pParent)->m_pGraph = NULL;
	
}

void CGraphWnd::PostNcDestroy() 
{
	delete this;
	
}

void CGraphWnd::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	dc.BitBlt(0,0,500,500,&m_memDC,0,0,SRCCOPY);
	
}

void CGraphWnd::OnClose() 
{
	
	CFrameWnd::OnClose();
}
