
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


// GraphWnd.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CGraphWnd frame

#ifndef GRAPHWND_H
#define GRAPHWND_H

class CGraphWnd : public CFrameWnd
{
	DECLARE_DYNCREATE(CGraphWnd)
protected:

// Attributes
public:
	CGraphWnd();           // protected constructor used by dynamic creation
	CWnd* m_pParent;

	CDC m_memDC;
	CBitmap m_bmp;
	CBrush m_bkbrush;
	CPen m_Pen;

	// Operations
public:

	BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, 
				DWORD dwStyle = WS_OVERLAPPEDWINDOW, 
				const RECT& rect = rectDefault, 
				CWnd* pParentWnd = NULL, 
				LPCTSTR lpszMenuName = NULL, DWORD dwExStyle = 0, 
				CCreateContext* pContext = NULL );


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGraphWnd)
	protected:
	virtual void PostNcDestroy();
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CGraphWnd();

	// Generated message map functions
	//{{AFX_MSG(CGraphWnd)
	afx_msg void OnDestroy();
	afx_msg void OnPaint();
	afx_msg void OnClose();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif

/////////////////////////////////////////////////////////////////////////////
