
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


// InfoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FractMus.h"
#include "FractMusView.h"
#include "FractMusDoc.h"
#include "InfoDlg.h"

#include "defs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CInfoDlg dialog

extern float FileVersion;
extern int PercussionChannel;


extern char* NoteNames[128];
const char* Pitches[] = {"C", "Db", "D", "Eb", "E", "F" ,"Gb", "G",
						 "Ab", "A", "Bb", "B"};

const char* dyn[] =	{	"Pianissimo",
						"Piano", 
						"Mezzo-piano", 
						"Mezzo-forte",
						"Forte", 
						"Fortissimo"
					};


const char* ScaleNames[] = {"Major",
							"Minor Natural",
							"Minor Harmonic",
							"Minor Melodic",
							"Lydian",
							"Mixolydian",
							"Dorian",
							"Phrygian",
							"Locrian",
							"Octatonic 1",
							"Octatonic 2",
							"Accoustic",
							"Wholetone",
							"Pentatonic",
							"Chromatic",
							"User defined"};

const char* NoteValueNames[] = {"Whole",
								"Half",
								"Quarter",
								"8th",
								"16th",
								"32nd",
								"Dotted Whole",
								"Dotted Half",
								"Dotted Quarter",
								"Dotted 8th",
								"Dotted 16th",
								"User Defined"};

const char* InstrumentNames[] = {"Grand piano",
								"Bright piano",
								"Electric piano",
								"Honky tonk piano",
								"Rhodes piano",
								"Chorus piano",
								"Harpsichord",
								"Clavinet",
								"Celesta",
								"Glockenspiel",
								"Music Box",
								"Vibraphone",
								"Marimba",
								"Xilophone",
								"Tubular bells",
								"Dulcimer",
								"Hammond organ",
								"Percussive organ",
								"Rock organ",
								"Church organ",
								"Reed organ",
								"Accordion",
								"Harmonica",
								"Tango accordion",
								"Nylon string guitar",
								"Steel string guitar",
								"Electric guitar (jazz)",
								"Electric guitar (clean)",
								"Electric guitar (mute)",
								"Overdriven guitar",
								"Distorted guitar",
								"Guitar harmonics",
								"Accoustic bass",
								"Electric bass (finger)",
								"Electric bass (pick)",
								"Fretless bass",
								"Slap bass 1",
								"Slap bass 2",
								"Synth bass 1",
								"Synth bass 2",
								"Violin",
								"Viola",
								"'Cello",
								"Double bass",
								"Tremolo strings",
								"Pizzicato strings",
								"Orchestral harp",
								"Timpani",
								"String ensemble 1",
								"String ensemble 2",
								"Synth strings 1",
								"Synth strings 2",
								"Choir aahs",
								"Voice oohs",
								"Synth voices",
								"Orchestra hit",
								"Trumpet",
								"Trombone",
								"Tuba",
								"Muted trumpet",
								"French horn",
								"Brass section",
								"Synth brass 1",
								"Synth brass 2",
								"Soprano sax",
								"Alto sax",
								"Tenor sax",
								"Baritone sax",
								"Oboe",
								"English horn",
								"Bassoon",
								"Clarinet",
								"Piccolo",
								"Flute",
								"Recorder",
								"Pan flute",
								"Blown bottle",
								"Shakuhachi",
								"Whistle",
								"Ocarina",
								"Lead 1 (square)",
								"Lead 2 (sawtooth)",
								"Lead 3 (calliope)",
								"Lead 4 (chiff)",
								"Lead 5 (charang)",
								"Lead 6 (voice)",
								"Lead 7 (fifth)",
								"Lead 8 (bass +)",
								"Pad 1 (new age)",
								"Pad 2 (warm)",
								"Pad 3 (polysynth)",
								"Pad 4 (choir)",
								"Pad 5 (bowed)",
								"Pad 6 (metallic)",
								"Pad 7 (halo)",
								"Pad 8 (sweep)",
								"FX 1 (rain)",
								"FX 2 (soundtrack)",
								"FX 3 (crystal)",
								"FX 4 (atmosphere)",
								"FX 5 (brightness)",
								"FX 6 (goblins)",
								"FX 7 (echoes)",
								"FX 8 (sci-fi)",
								"Sitar",
								"Banjo",
								"Shamisen",
								"Koto",
								"Kalimba",
								"Bag pipe",
								"Fiddle",
								"Shanai",
								"Tinklebell",
								"Agogo bells",
								"Steel drum",
								"Wood block",
								"Taiko drum",
								"Melodic drum",
								"Synth drum",
								"Reverse cymbal",
								"Guitar fret noise",
								"Breath noise",
								"Seashore",
								"Bird tweet",
								"Telephone ring",
								"Helicopter",
								"Applause",
								"Gunshot"};

const char* PercussionNames[] = {"Base Drum 1",
								"Base Drum 2",
								"Side Stick",
								"Acoustic Snare",
								"Hand Clap",
								"Electric Snare",
								"Low Floor Tom",
								"Closed Hi-Hat",
								"Hi Floor Tom",
								"Pedal Hi-Hat",
								"Low Tom",
								"Open Hi-Hat",
								"Low-Mid Tom",
								"High-Mid Tom",
								"Crash Cymbal 1",
								"High Tom",
								"Ride Cymbal 1",
								"Chinese Cymbal",
								"Ride Bell",
								"Tambourine",
								"Splash Cymbal",
								"Cowbell",
								"Crash Cymbal 2",
								"Vibraslap",
								"Ride Cymbal 2",
								"High Bongo",
								"Low Bongo",
								"Muted High Conga",
								"Open High Conga",
								"Low Conga",
								"High Timbale",
								"Low Timbale",
								"High Agogo",
								"Low Agogo",
								"Cabase",
								"Maracas",
								"Short Whistle",
								"Long Whistle",
								"Short Guiro",
								"Long Guiro",
								"Claves",
								"High Wood Block",
								"Low Wood Block",
								"Muted Cuica",
								"Open Cuica",
								"Muted Triangle",
								"Open Triangle"
								};

const char* AlgorithmNames[] = {"Morse-Thue",
								"Logmap",
								"1/f noise",
								"Henon",
								"Hopalong",
								"Martin",
								"Gingerbread man",
								"Lorenz",
								"EarthWorm",
								"Random",
								"3n+1 numbers",
								"Wolfram CA"
								};



CInfoDlg::CInfoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CInfoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CInfoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_nID = CInfoDlg::IDD;
}


void CInfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CInfoDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CInfoDlg, CDialog)
	//{{AFX_MSG_MAP(CInfoDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CInfoDlg message handlers


BOOL CInfoDlg::Create()
{
	return CDialog::Create(m_nID, m_pParent);
}

void CInfoDlg::OnOK() 
{
}

void CInfoDlg::OnCancel() 
{
	CDialog::OnCancel();
}




BOOL CInfoDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	ShowGlobalInfo();	

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CInfoDlg::PostNcDestroy() 
{
	delete this;
}




void CInfoDlg::ShowGlobalInfo()
{
	CFractMusView* pView = (CFractMusView*)m_pParent;
	CFractMusDoc* pDoc = pView->GetDocument();
	
	CListBox* pGlInfo = (CListBox*)GetDlgItem(IDC_GLOBALINFO_LIST);

	BOOL Instr[128];
	BOOL Perc[47];

	pGlInfo->ResetContent();

	CString msg, msg2;
	BOOL active[MAXVOICES], mod = FALSE;
	int totvoices = 0;
	float dur = 0.0f;
	int major = 0, minornat = 0, minorhar = 0, minormel = 0, 
		lydian = 0, mixolyd = 0, dorian = 0, phrygian = 0, 
		locrian = 0, oct1 = 0, oct2 = 0, accoustic = 0, penta = 0,
		chroma = 0, wholetone = 0, user = 0, totscales = 0;

	int morse = 0, logmap = 0, noise = 0, henon = 0, hopalong = 0, 
		martin = 0, ginger = 0, lorentz = 0, earthworm =0,
		random =0, hailstone =0, wolfram =0, totalg = 0;

	int dwhole =0, dhalf=0, dquarter=0, d8=0, d16=0, whole=0, 
		half=0, quarter=0, _8=0, _16=0, _32=0, other =0, totnv=0;

	for(int i=VOICE1; i<MAXVOICES; i++)
		active[i] = FALSE;

	for(int j=0; j<=pDoc->m_NumEvents; j++)
		for(i=VOICE1; i<MAXVOICES; i++)
			if(pDoc->Event[j].IsActive[i])
				active[i] = TRUE;

	for(i=VOICE1; i<MAXVOICES; i++)
		if (active[i])
			++totvoices;

	for(i=0; i<128; i++)
		Instr[i] = FALSE;

	for(i=0; i<47; i++)
		Perc[i] = FALSE;

	for(j=0; j<=pDoc->m_NumEvents; j++)
			dur = dur + ((60.0f*float(pDoc->Event[j].genCount-pDoc->Event[j].count))/(float(pDoc->Event[j].Tempo)*8.0f));

	for(j=0; j<=pDoc->m_NumEvents; j++)
		for(i=VOICE1; i<MAXVOICES; i++)
			if (pDoc->Event[j].IsActive[i])
			{
				switch (pDoc->Event[j].ScaleID[i])
				{
					case MAJOR:
						++major;
						++totscales;
						break;
					case MINOR_NATURAL:
						++minornat;
						++totscales;
						break;
					case MINOR_HARMONIC:
						++minorhar;
						++totscales;
						break;
					case MINOR_MELODIC:
						++minormel;
						++totscales;
						break;
					case LYDIAN:
						++lydian;
						++totscales;
						break;
					case MIXOLYDIAN:
						++mixolyd;
						++totscales;
						break;
					case DORIAN:
						++dorian;
						++totscales;
						break;
					case PHRYGIAN:
						++phrygian;
						++totscales;
						break;
					case LOCRIAN:
						++locrian;
						++totscales;
						break;
					case OCTATONIC1:
						++oct1;
						++totscales;
						break;
					case OCTATONIC2:
						++oct2;
						++totscales;
						break;
					case ACCOUSTIC:
						++accoustic;
						++totscales;
						break;
					case WHOLETONE:
						++wholetone;
						++totscales;
						break;
					case PENTATONIC:
						++penta;
						++totscales;
						break;
					case CHROMATIC:
						++chroma;
						++totscales;
						break;
					case USER_DEFINED:
						++user;
						++totscales;
						break;
				}
			}

	for(j=0; j<=pDoc->m_NumEvents; j++)
		for(i=VOICE1; i<MAXVOICES; i++)
			if (pDoc->Event[j].IsActive[i])
			{
				switch (pDoc->Event[j].AlgorithmNum[i])
				{
					case MORSE_THUE:	
						++morse;
						++totalg;
						break;
					case LOGMAP:	
						++logmap;
						++totalg;
						break;
					case ONE_OVER_F_NOISE:	
						++noise;
						++totalg;
						break;
					case HENON:	
						++henon;
						++totalg;
						break;
					case HOPALONG:	
						++hopalong;
						++totalg;
						break;
					case MARTIN:	
						++martin;
						++totalg;
						break;
					case GINGERBREADMAN:	
						++ginger;
						++totalg;
						break;
					case LORENTZ:	
						++lorentz;
						++totalg;
						break;
					case EARTHWORM:	
						++earthworm;
						++totalg;
						break;
					case RANDOM:	
						++random;
						++totalg;
						break;
					case HAILSTONE:	
						++hailstone;
						++totalg;
						break;
					case WOLFRAM:	
						++wolfram;
						++totalg;
						break;

				}
			}


	for(j=0; j<=pDoc->m_NumEvents; j++)
		for(i=VOICE1; i<MAXVOICES; i++)
			if (pDoc->Event[j].IsActive[i])
			{
				switch (pDoc->Event[j].NoteValueID[i])
				{
					case WHOLE:
						++whole;
						++totnv;
						break;
					case HALF:
						++half;
						++totnv;
						break;
					case QUARTER:
						++quarter;
						++totnv;
						break;
					case EIGHT:
						++_8;
						++totnv;
						break;
					case SIXTEENTH:
						++_16;
						++totnv;
						break;
					case THIRTYSECOND:
						++_32;
						++totnv;
						break;
					case WHOLE_DOTTED:
						++dwhole;
						++totnv;
						break;
					case HALF_DOTTED:
						++dhalf;
						++totnv;
						break;
					case QUARTER_DOTTED:
						++dquarter;
						++totnv;
						break;
					case EIGHTH_DOTTED:
						++d8;
						++totnv;
						break;
					case SIXTEENTH_DOTTED:
						++d16;
						++totnv;
						break;
					case OTHER:
						++other;
						++totnv;
						break;
				}
			}
			
	pGlInfo->AddString(pDoc->GetTitle());
	pGlInfo->AddString("");

	msg2.Format("File version: %.2f", FileVersion);
	pGlInfo->AddString(msg2);

	msg2.Format("Number of total active voices: %d", totvoices);
	pGlInfo->AddString(msg2);
	msg2.Format("Number of events: %d", pDoc->m_NumEvents+1);
	pGlInfo->AddString(msg2);
	msg2.Format("Number of events left %d", 999 - (pDoc->m_NumEvents));
	pGlInfo->AddString(msg2);
	msg2.Format("Approximate duration: %d min. %d sec.", int(dur/60), int(dur)%60); 
	pGlInfo->AddString(msg2);
	pGlInfo->AddString("");


	pGlInfo->AddString("ALGORITHMS:");

	if (morse)
	{
		msg2.Format("\tMorse-Thue:\t %.2f%%",  ((float)morse/(float)totalg)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (logmap)
	{
		msg2.Format("\tLog Map:\t\t %.2f%%",  ((float)logmap/(float)totalg)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (noise)
	{
		msg2.Format("\t1/f Noise:\t\t %.2f%%",  ((float)noise/(float)totalg)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (henon)
	{
		msg2.Format("\tHenon:\t\t %.2f%%",  ((float)henon/(float)totalg)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (hopalong)
	{
		msg2.Format("\tHopalong:\t %.2f%%",  ((float)hopalong/(float)totalg)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (martin)
	{
		msg2.Format("\tMartin:\t\t %.2f%%",  ((float)martin/(float)totalg)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (ginger)
	{
		msg2.Format("\tGingerbreadman:\t %.2f%%",  ((float)ginger/(float)totalg)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (lorentz)
	{
		msg2.Format("\tLorentz:\t\t %.2f%%",  ((float)lorentz/(float)totalg)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (earthworm)
	{
		msg2.Format("\tEarthworm:\t %.2f%%",  ((float)earthworm/(float)totalg)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (random)
	{
		msg2.Format("\tRandom:\t\t %.2f%%",  ((float)random/(float)totalg)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (hailstone)
	{
		msg2.Format("\t3n+1 numbers:\t %.2f%%",  ((float)hailstone/(float)totalg)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (wolfram)
	{
		msg2.Format("\tWolfram:\t\t %.2f%%",  ((float)wolfram/(float)totalg)*100.0f);
		pGlInfo->AddString(msg2);
	}


	pGlInfo->AddString("");
	pGlInfo->AddString("SCALES:");
	
	if (major)
	{
		msg2.Format("\tMajor:\t\t %.2f%%",  ((float)major/(float)totscales)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (minornat)
	{
		msg2.Format("\tMinor Natural:\t %.2f%%",  ((float)minornat/(float)totscales)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (minorhar)
	{
		msg2.Format("\tMinor Harmonic:\t %.2f%%",  ((float)minorhar/(float)totscales)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (minormel)
	{
		msg2.Format("\tMinor Melodic:\t %.2f%%",  ((float)minormel/(float)totscales)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (lydian)
	{
		msg2.Format("\tLydian:\t\t %.2f%%",  ((float)lydian/(float)totscales)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (mixolyd)
	{
		msg2.Format("\tMixolydian:\t %.2f%%",  ((float)mixolyd/(float)totscales)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (dorian)
	{
		msg2.Format("\tDorian:\t\t %.2f%%",  ((float)dorian/(float)totscales)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (phrygian)
	{
		msg2.Format("\tPhrygian:\t\t %.2f%%", ((float)phrygian/(float)totscales)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (locrian)
	{
		msg2.Format("\tLocrian:\t\t %.2f%%", ((float)locrian/(float)totscales)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (oct1)
	{
		msg2.Format("\tOctatonic 1:\t %.2f%%",  ((float)oct1/(float)totscales)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (oct2)
	{
		msg2.Format("\tOctatonic 2:\t %.2f%%",  ((float)oct2/(float)totscales)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (accoustic)
	{
		msg2.Format("\tAccoustic:\t %.2f%%",  ((float)accoustic/(float)totscales)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (wholetone)
	{
		msg2.Format("\tWholetone:\t %.2f%%",  ((float)wholetone/(float)totscales)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (penta)
	{
		msg2.Format("\tPentatonic:\t %.2f%%",  ((float)penta/(float)totscales)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (chroma)
	{
		msg2.Format("\tChromatic:\t %.2f%%",  ((float)chroma/(float)totscales)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (user)
	{
		msg2.Format("\tUser defined:\t %.2f%%",  ((float)user/(float)totscales)*100.0f);
		pGlInfo->AddString(msg2);
	}

	pGlInfo->AddString("");
	pGlInfo->AddString("NOTE VALUES:");

	if (dwhole)
	{
		msg2.Format("\tDotted whole:\t %.2f%%",  ((float)dwhole/(float)totnv)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (whole)
	{
		msg2.Format("\tWhole:\t\t %.2f%%",  ((float)whole/(float)totnv)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (dhalf)
	{
		msg2.Format("\tDotted Half:\t %.2f%%",  ((float)dhalf/(float)totnv)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (half)
	{
		msg2.Format("\tHalf:\t\t %.2f%%", ((float)half/(float)totnv)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (dquarter)
	{
		msg2.Format("\tDotted quarter:\t %.2f%%",  ((float)dquarter/(float)totnv)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (quarter)
	{
		msg2.Format("\tQuarter:\t\t %.2f%%",  ((float)quarter/(float)totnv)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (d8)
	{
		msg2.Format("\tDotted eighth:\t %.2f%%",  ((float)d8/(float)totnv)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (_8)
	{
		msg2.Format("\tEighth:\t\t %.2f%%",  ((float)_8/(float)totnv)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (d16)
	{
		msg2.Format("\tDotted sixteenth:\t %.2f%%",  ((float)d16/(float)totnv)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (_16)
	{
		msg2.Format("\tSixteenth:\t\t %.2f%%",  ((float)_16/(float)totnv)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (_32)
	{
		msg2.Format("\tThirtysecond:\t %.2f%%",  ((float)_32/(float)totnv)*100.0f);
		pGlInfo->AddString(msg2);
	}
	if (other)
	{
		msg2.Format("\tOther:\t\t %.2f%%",  ((float)other/(float)totnv)*100.0f);
		pGlInfo->AddString(msg2);
	}








	/*pGlInfo->AddString("");
	pGlInfo->AddString("MODULATIONS:\t\t[Event]");

	pGlInfo->AddString("\tEvery [...]:");

	for(j=0; j<=pDoc->m_NumEvents; j++)
		for(i=VOICE1; i<MAXVOICES; i++)
			if (pDoc->Event[j].Modulates[i]&&(!pDoc->Event[j].ModulRandom[i]))
			{
				msg2.Format("\t\t\t%d", j);
				pGlInfo->AddString(msg2);
				mod = TRUE;
				break;
			}


	if (!mod)
	{
		pGlInfo->AddString("\t\t\tNone.");
	}

	mod = FALSE;
	pGlInfo->AddString("\tRandomly: ");

	for(j=0; j<=pDoc->m_NumEvents; j++)
		for(i=VOICE1; i<MAXVOICES; i++)
			if (pDoc->Event[j].Modulates[i]&&(pDoc->Event[j].ModulRandom[i]))
			{
				msg2.Format("\t\t\t%d", j);
				pGlInfo->AddString(msg2);
				mod = TRUE;
				break;
			}


	if (!mod)
	{
		pGlInfo->AddString("\t\t\tNone.");
	}*/

	pGlInfo->AddString("");
	pGlInfo->AddString("INSTRUMENTS used:");

	for(j=0; j<=pDoc->m_NumEvents; j++)
	{
		for(i=VOICE1; i<MAXVOICES; i++)
		{
			if (pDoc->Event[j].IsActive[i])
			{
				if(pDoc->Event[j].Channel[i] == PercussionChannel)
					Perc[ pDoc->Event[j].Percussion[i] ] = TRUE;
				else
				{
					Instr[ pDoc->Event[j].Instrument[i] ] = TRUE;
				}
			}
		}
	}

	for (i = 0; i<128; i++)
	{
		if (Instr[i])
		{
			msg2.Format("\t%s", InstrumentNames[i]);
			pGlInfo->AddString(msg2);
		}
	}

	for (i = 0; i<47; i++)
	{
		if (Perc[i])
		{
			msg2.Format("\t%s", PercussionNames[i]);
			pGlInfo->AddString(msg2);
		}
	}



}
