
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


// InstrumentationDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FractMus.h"
#include "FractMusDoc.h"
#include "InstrumentationDlg.h"
#include "FractMusView.h"
#include "defs.h"

extern int Tempo;
extern int PercussionChannel;
extern const char* InstrumentNames[128];
extern const char* PercussionNames[47];

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CInstrumentationDlg dialog


CInstrumentationDlg::CInstrumentationDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CInstrumentationDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CInstrumentationDlg)
	m_newpresetname = _T("");
	m_algorithm = TRUE;
	m_coeff = TRUE;
	m_counters = TRUE;
	m_dynamic = TRUE;
	m_instrument = TRUE;
	m_inverted = TRUE;
	m_matchscl = TRUE;
	m_mode = TRUE;
	m_modulate = TRUE;
	m_note = TRUE;
	m_noteval = TRUE;
	m_octaves = TRUE;
	m_pan = TRUE;
	m_percussion = TRUE;
	m_scale = TRUE;
	m_tempo = TRUE;
	m_timesig = TRUE;
	m_offset = TRUE;
	//}}AFX_DATA_INIT


	for (int k=0; k<50; k++)
	{
		

		Preset[k].m_TempoMarking = 96;
		Preset[k].dGeneralCounter = 0;
		Preset[k].dStartCounter = 0;
		Preset[k].m_TimeSigNum = 4;
		Preset[k].m_TimeSigDen = 4;

		Preset[k].m_IsActive[VOICE1] = TRUE;

		for(int i = VOICE2; i<MAXVOICES; i++)
			Preset[k].m_IsActive[i] = FALSE;


		for (i = VOICE1; i<MAXVOICES; i++)
		{
			Preset[k].m_Modulates[i] = FALSE;
			Preset[k].m_ModulRandom[i] = FALSE;
			Preset[k].m_ModulNum[i] = 5;
			Preset[k].m_Base[i] = 2;
			Preset[k].m_Multi[i] = 1;
			Preset[k].m_StartNum[i] = 0;
			Preset[k].m_ScaleID[i] = MAJOR;
			Preset[k].m_NumOcts[i] = 1;
			Preset[k].m_NumOctsID[i] = ONE_OCT;
			Preset[k].m_Note[i] = 60;
			Preset[k].m_NoteValue[i] = 8.0f;
			Preset[k].m_NoteValueID[i] = QUARTER;
			Preset[k].m_Instrument[i] = 0;
			Preset[k].m_Channel[i] = i;
			Preset[k].m_Mode[i] = 0;
			Preset[k].m_Inverted[i] = FALSE;
			Preset[k].m_Dynamic[i] = MEZZO_FORTE;
			Preset[k].m_DynChoice[i] = MF;
			Preset[k].m_LogMapVar[i] = 3.9f;
			Preset[k].m_FNoiseVar[i] = 0.5f;
			Preset[k].m_HenonA[i] = 1.7f;
			Preset[k].m_HenonB[i] = 0.4f;
			Preset[k].m_HopalongVar[i] = 3.14159265359f;
			Preset[k].m_MartinVar[i] = 3.14159265359f;
			Preset[k].m_GingerX[i] = -0.1f;
			Preset[k].m_GingerY[i] = 0.0f;
			Preset[k].m_LorentzVar[i] = 0.8f;
			Preset[k].m_Pan[i] = 0;
			Preset[k].m_EarthWormVar[i] = 2;
			Preset[k].m_EarthWormMulti[i] = 3;
			Preset[k].m_EarthWormTruncator[i] = 6;
			Preset[k].m_RandomMin[i] = 0.0;
			Preset[k].m_RandomMax[i] = 1.0;
			Preset[k].m_WolframRule[i] = 30;
			Preset[k].m_WolframInit[i] = 1;
			Preset[k].m_WolframSize[i] = 128;
			Preset[k].m_Hailstone[i] = 27;
			Preset[k].m_MatchScale[i] = FALSE;
			Preset[k].m_Percussion[i] = 0;


			Preset[k].AlgorithmNum[i] = MORSE_THUE;

		}
	}


		for(k = 0; k<50; k++)
		{
			for(int i = VOICE1; i<MAXVOICES; i++)
			{

					Preset[k].m_pScale[i] = NULL;
					Preset[k].m_pUserScale[i] = NULL;
			}
		}

		for(k = 0; k<50; k++)
		{
			for(int i = VOICE1; i<MAXVOICES; i++)
			{
				Preset[k].m_pScale[i] = new int[Major[0] + 1];
				Preset[k].m_pUserScale[i] = new int[Major[0] + 1];

				for(int j=0; j<=Major[0]; j++)
				{
					Preset[k].m_pScale[i][j] = Major[j];
					Preset[k].m_pUserScale[i][j] = Major[j];
				}
			}
		}


}


void CInstrumentationDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CInstrumentationDlg)
	DDX_Text(pDX, IDC_NEWPRESETNAME_ED, m_newpresetname);
	DDV_MaxChars(pDX, m_newpresetname, 128);
	DDX_Check(pDX, IDC_ALGORITHM_CHK, m_algorithm);
	DDX_Check(pDX, IDC_COEFF_CHK, m_coeff);
	DDX_Check(pDX, IDC_COUNTERS_CHK, m_counters);
	DDX_Check(pDX, IDC_DYNAMIC_CHK, m_dynamic);
	DDX_Check(pDX, IDC_INSTRUMENT_CHK, m_instrument);
	DDX_Check(pDX, IDC_INVERTED_CHK, m_inverted);
	DDX_Check(pDX, IDC_MATCHSCL_CHK, m_matchscl);
	DDX_Check(pDX, IDC_MODE_CHK, m_mode);
	DDX_Check(pDX, IDC_MODULATE_CHK, m_modulate);
	DDX_Check(pDX, IDC_NOTE_CHK, m_note);
	DDX_Check(pDX, IDC_NOTEVAL_CHK, m_noteval);
	DDX_Check(pDX, IDC_OCTAVES_CHK, m_octaves);
	DDX_Check(pDX, IDC_PAN_CHK, m_pan);
	DDX_Check(pDX, IDC_PERCUSSION_CHK, m_percussion);
	DDX_Check(pDX, IDC_SCALE_CHK, m_scale);
	DDX_Check(pDX, IDC_TEMPO_CHK, m_tempo);
	DDX_Check(pDX, IDC_TIMESIG_CHK, m_timesig);
	DDX_Check(pDX, IDC_OFFSET_CHK, m_offset);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CInstrumentationDlg, CDialog)
	//{{AFX_MSG_MAP(CInstrumentationDlg)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	ON_BN_CLICKED(IDC_LOAD, OnLoad)
	ON_LBN_DBLCLK(IDC_PARAMETERS_LIST, OnDblclkParametersList)
	ON_BN_CLICKED(IDC_REMOVE, OnRemove)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_ALL, OnAll)
	ON_BN_CLICKED(IDC_NONE, OnNone)
	ON_BN_CLICKED(IDC_REPLACE, OnReplace)
	ON_LBN_SELCHANGE(IDC_PARAMETERS_LIST, OnSelchangeParametersList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CInstrumentationDlg message handlers

void CInstrumentationDlg::OnAdd() 
{
	if(!UpdateData(TRUE))
		return;



	if (m_newpresetname.IsEmpty())
	{
		MessageBox("Please enter a name for the preset!", "FractMus", MB_OK+MB_ICONEXCLAMATION);
		return;
	}

	for(int k = 0; k<50; k++)
	{
		if(Preset[k].Name == m_newpresetname)
		{
			MessageBox("There is already a preset with that name, please choose another name", "FractMus", MB_OK+MB_ICONEXCLAMATION);
			return;
		}
	}


	for(k = 0; k<50; k++)
	{
		if(Preset[k].Name.IsEmpty())
			break;
	}

	if ((k>48)&&(!Preset[49].Name.IsEmpty()))
	{
		CString msg;

		msg.Format("You have reached the maximum number of presets, please delete some \nor clear the list (you can save your current presets");

		MessageBox(msg,"FractMus", MB_OK+MB_ICONINFORMATION);
		return;
	}


	CFractMusDoc* pDoc = pView->GetDocument();

	CListBox* pList = (CListBox*)GetDlgItem(IDC_PARAMETERS_LIST);
	pList->AddString(m_newpresetname);

	Preset[k].Name = m_newpresetname;


		Preset[k].m_TempoMarking = pDoc->m_TempoMarking;
		Preset[k].dGeneralCounter = pDoc->dGeneralCounter;
		Preset[k].dStartCounter = pDoc->dStartCounter;
		Preset[k].m_TimeSigNum = pDoc->m_TimeSigNum;
		Preset[k].m_TimeSigDen = pDoc->m_TimeSigDen;


		for(int i = VOICE1; i<MAXVOICES; i++)
			Preset[k].m_IsActive[i] = pDoc->m_IsActive[i];


		for (i = VOICE1; i<MAXVOICES; i++)
		{
			Preset[k].m_Modulates[i] = pDoc->m_Modulates[i];
			Preset[k].m_ModulRandom[i] = pDoc->m_ModulRandom[i];
			Preset[k].m_ModulNum[i] = pDoc->m_ModulNum[i];
			Preset[k].m_Base[i] = pDoc->m_Base[i];
			Preset[k].m_Multi[i] = pDoc->m_Multi[i];
			Preset[k].m_StartNum[i] = pDoc->m_StartNum[i];
			Preset[k].m_ScaleID[i] = pDoc->m_ScaleID[i];
			Preset[k].m_NumOcts[i] = pDoc->m_NumOcts[i];
			Preset[k].m_NumOctsID[i] = pDoc->m_NumOctsID[i];
			Preset[k].m_Note[i] = pDoc->m_Note[i];
			Preset[k].m_NoteValue[i] = pDoc->m_NoteValue[i];
			Preset[k].m_NoteValueID[i] = pDoc->m_NoteValueID[i];
			Preset[k].m_Instrument[i] = pDoc->m_Instrument[i];
			Preset[k].m_Channel[i] = pDoc->m_Channel[i];
			Preset[k].m_Mode[i] = pDoc->m_mode[i];
			Preset[k].m_Inverted[i] = pDoc->m_Inverted[i];
			Preset[k].m_Dynamic[i] = pDoc->m_Dynamic[i];
			Preset[k].m_DynChoice[i] = pDoc->m_DynChoice[i];
			Preset[k].m_LogMapVar[i] = pDoc->m_LogMapVar[i];
			Preset[k].m_FNoiseVar[i] = pDoc->m_FNoiseVar[i];
			Preset[k].m_HenonA[i] = pDoc->m_HenonA[i];
			Preset[k].m_HenonB[i] = pDoc->m_HenonB[i];
			Preset[k].m_HopalongVar[i] = pDoc->m_HopalongVar[i];
			Preset[k].m_MartinVar[i] = pDoc->m_MartinVar[i];
			Preset[k].m_GingerX[i] = pDoc->m_GingerX[i];
			Preset[k].m_GingerY[i] = pDoc->m_GingerY[i];
			Preset[k].m_LorentzVar[i] = pDoc->m_LorentzVar[i];
			Preset[k].m_EarthWormVar[i] = pDoc->m_EarthWormVar[i];
			Preset[k].m_EarthWormMulti[i] = pDoc->m_EarthWormMulti[i];
			Preset[k].m_EarthWormTruncator[i] = pDoc->m_EarthWormTruncator[i];
			Preset[k].m_RandomMin[i] = pDoc->m_RandomMin[i];
			Preset[k].m_RandomMax[i] = pDoc->m_RandomMax[i];
			Preset[k].m_WolframRule[i] = pDoc->m_WolframRule[i];
			Preset[k].m_WolframInit[i] = pDoc->m_WolframInit[i];
			Preset[k].m_WolframSize[i] = pDoc->m_WolframSize[i];
			Preset[k].m_Hailstone[i] = pDoc->m_Hailstone[i];

			Preset[k].m_Pan[i] = pDoc->m_Pan[i];

			Preset[k].m_MatchScale[i] = pDoc->m_MatchScale[i];
			Preset[k].m_Percussion[i] = pDoc->m_Percussion[i];


			Preset[k].AlgorithmNum[i] = pDoc->AlgorithmNum[i];

		}

		for(i = VOICE1; i<MAXVOICES; i++)
		{
			if (Preset[k].m_pScale[i])
			{
				delete [] Preset[k].m_pScale[i];

				Preset[k].m_pScale[i] = NULL;
			}
			if (Preset[k].m_pUserScale[i])
			{
				delete [] Preset[k].m_pUserScale[i];
				Preset[k].m_pUserScale[i] = NULL;
			}
		}

		for(i = VOICE1; i<MAXVOICES; i++)
		{
			Preset[k].m_pScale[i] = new int [pDoc->m_pScale[i][0] + 1];
			for(int j =0; j<=pDoc->m_pScale[i][0]; j++)
				Preset[k].m_pScale[i][j] = pDoc->m_pScale[i][j];
		}

		for(i = VOICE1; i<MAXVOICES; i++)
		{
			Preset[k].m_pUserScale[i] = new int [pDoc->m_pUserScale[i][0] + 1];
			for(int j =0; j<=pDoc->m_pUserScale[i][0]; j++)
				Preset[k].m_pUserScale[i][j] = pDoc->m_pUserScale[i][j];
		}

	

	
}

void CInstrumentationDlg::OnClear() 
{
	CListBox* pList = (CListBox*)GetDlgItem(IDC_PARAMETERS_LIST);

	if (MessageBox("Are you sure?", "Clear all presets", MB_YESNO+MB_ICONEXCLAMATION) ==IDYES)
	{
		for(int k = 0; k<50; k++)
			Preset[k].Name = "";

		pList->ResetContent();


	}
	
}

void CInstrumentationDlg::OnLoad() 
{
	char FileName[500];
	char FileTitle[100];

	OPENFILENAME ofn;
	memset(&ofn, 0, sizeof(ofn));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = NULL;
	ofn.hInstance = NULL;

	ofn.lpstrFilter = 
		TEXT("Event presets files *.evt\0*.evt\0\0");

	ofn.lpstrCustomFilter = NULL;
	ofn.nMaxCustFilter = 0;
	ofn.nFilterIndex = 1;
	ofn.lpstrFile = FileName;
	ofn.nMaxFile = 500;
	ofn.lpstrFileTitle = FileTitle;
	ofn.nMaxFileTitle = 99;
	ofn.lpstrInitialDir = NULL;
	ofn.lpstrTitle="Load Event Presets";
	ofn.Flags = OFN_FILEMUSTEXIST|OFN_LONGNAMES|OFN_PATHMUSTEXIST;
	ofn.lpstrDefExt = "evt";
	ofn.lCustData = NULL;
	ofn.lpfnHook = NULL;
	ofn.lpTemplateName = NULL;

	FileName[0] = '\0';

	if(!GetOpenFileName(&ofn))
		return;

	if(FileName[0] == '\0')
		return;


	int numpresets = 0;



	CFile file;

	file.Open(FileName, CFile::modeRead);

	union
	{
		int dataint;
		BYTE databyte[sizeof(int)];
	} num;


	LPSTR h = new char[8];

	file.Read((char*)h, 7);

	h[7] = '\0';

	LPSTR s = new char[8];

	s[0]= 'E'; s[1]='V';  s[2]='T';  s[3]='F'; s[4]='i';  s[5]='l';  s[6]='e';  s[7]='\0';

	CString s1 = (char*)h;
	
	CString s2 = (char*)s;

	if(s1!=s2)
	{
		MessageBox("This is not a valid *.evt file","FractMus", MB_OK+MB_ICONEXCLAMATION);
		return;
	}

	for(int k = 0; k<50; k++)
		Preset[k].Name = "";

	file.Read(num.databyte, sizeof(int));

	numpresets = num.dataint;


	for (k=0; k<numpresets; k++)
	{

			union
			{
				UINT bytesread;
				BYTE data[sizeof(BYTE)*sizeof(UINT)];
			} databytes;

			file.Read((BYTE*)databytes.data, sizeof(BYTE)*sizeof(UINT));

			LPSTR str = new char[databytes.bytesread + 1];

			file.Read((char*)str, databytes.bytesread);

			str[databytes.bytesread] = '\0';

			Preset[k].Name = (char*)str;


			union 
			{
				int data1;
				BYTE data2[sizeof(int)];
			} intvalue;

			union
			{
				BOOL data1;
				BYTE data2[sizeof(BOOL)];
			} boolvalue;

			union
			{
				long data1;
				BYTE data2[sizeof(long)];
			} longvalue;

			union
			{
				float data1;
				BYTE data2[sizeof(float)];
			} floatvalue;


			union
			{
				short data1;
				BYTE data2[sizeof(short)];
			} shortvalue;

			union
			{
				unsigned data1;
				BYTE data2[sizeof(unsigned)];
			} unsignedvalue;

			union
			{
				unsigned long data1;
				BYTE data2[sizeof(unsigned long)];
			} unsignedlongvalue;

			union
			{
				double data1;
				BYTE data2[sizeof(double)];
			} doublevalue;

			union
			{
				BYTE data1;
				BYTE data2[sizeof(BYTE)];
			} bytevalue;



			file.Read(intvalue.data2, sizeof(int));
			Preset[k].m_TempoMarking = intvalue.data1 ;

			file.Read(longvalue.data2, sizeof(long));
			Preset[k].dGeneralCounter = longvalue.data1 ;

			file.Read(longvalue.data2, sizeof(long));
			 Preset[k].dStartCounter = longvalue.data1;

			file.Read(shortvalue.data2, sizeof(short));
			Preset[k].m_TimeSigNum = shortvalue.data1 ;

			file.Read(shortvalue.data2, sizeof(short));
			 Preset[k].m_TimeSigDen = shortvalue.data1 ;

			for(int i = VOICE1; i<MAXVOICES; i++)
			{
				
				file.Read(boolvalue.data2, sizeof(BOOL));
				Preset[k].m_IsActive[i] = boolvalue.data1 ;

				file.Read(boolvalue.data2, sizeof(BOOL));
				Preset[k].m_Modulates[i] = boolvalue.data1 ;

				file.Read(boolvalue.data2, sizeof(BOOL));
				Preset[k].m_ModulRandom[i] = boolvalue.data1 ;

				file.Read(intvalue.data2, sizeof(int));
				Preset[k].m_ModulNum[i] = intvalue.data1 ;

				file.Read(longvalue.data2, sizeof(long));
				Preset[k].m_Base[i] = longvalue.data1 ;

				file.Read(longvalue.data2, sizeof(long));
				Preset[k].m_Multi[i] = longvalue.data1 ;

				file.Read(longvalue.data2, sizeof(long));
				 Preset[k].m_StartNum[i] = longvalue.data1;

				file.Read(intvalue.data2, sizeof(int));
				Preset[k].m_ScaleID[i] = intvalue.data1 ;

				file.Read(intvalue.data2, sizeof(int));
				Preset[k].m_NumOcts[i] = intvalue.data1 ;

				file.Read(intvalue.data2, sizeof(int));
				 Preset[k].m_NumOctsID[i] = intvalue.data1;

				file.Read(intvalue.data2, sizeof(int));
				Preset[k].m_Note[i] = intvalue.data1 ;

				file.Read(floatvalue.data2, sizeof(float));
				Preset[k].m_NoteValue[i] = floatvalue.data1 ;

				file.Read(intvalue.data2, sizeof(int));
				Preset[k].m_NoteValueID[i] = intvalue.data1 ;

				file.Read(intvalue.data2, sizeof(int));
				Preset[k].m_Instrument[i] = intvalue.data1 ;

				file.Read(intvalue.data2, sizeof(int));
				 Preset[k].m_Channel[i] = intvalue.data1;

				file.Read(intvalue.data2, sizeof(int));
				Preset[k].m_Mode[i] = intvalue.data1 ;

				file.Read(boolvalue.data2, sizeof(BOOL));
				Preset[k].m_Inverted[i] = boolvalue.data1 ;

				file.Read(intvalue.data2, sizeof(int));
				Preset[k].m_Dynamic[i] = intvalue.data1 ;

				file.Read(intvalue.data2, sizeof(int));
				Preset[k].m_DynChoice[i] = intvalue.data1 ;

				file.Read(floatvalue.data2, sizeof(float));
				Preset[k].m_LogMapVar[i] = floatvalue.data1 ;

				file.Read(floatvalue.data2, sizeof(float));
				Preset[k].m_FNoiseVar[i] = floatvalue.data1 ;

				file.Read(floatvalue.data2, sizeof(float));
				Preset[k].m_HenonA[i] = floatvalue.data1 ;

				file.Read(floatvalue.data2, sizeof(float));
				Preset[k].m_HenonB[i] = floatvalue.data1 ;

				file.Read(floatvalue.data2, sizeof(float));
				Preset[k].m_HopalongVar[i] = floatvalue.data1 ;

				file.Read(floatvalue.data2, sizeof(float));
				Preset[k].m_MartinVar[i] = floatvalue.data1 ;

				file.Read(floatvalue.data2, sizeof(float));
				Preset[k].m_GingerX[i] = floatvalue.data1 ;

				file.Read(floatvalue.data2, sizeof(float));
				Preset[k].m_GingerY[i] = floatvalue.data1 ;

				file.Read(floatvalue.data2, sizeof(float));
				Preset[k].m_LorentzVar[i] = floatvalue.data1 ;

				file.Read(unsignedlongvalue.data2, sizeof(unsigned long));
				Preset[k].m_EarthWormVar[i] = unsignedlongvalue.data1;

				file.Read(unsignedlongvalue.data2, sizeof(unsigned long));
				Preset[k].m_EarthWormMulti[i] = unsignedlongvalue.data1;

				file.Read(unsignedvalue.data2, sizeof(unsigned));
				Preset[k].m_EarthWormTruncator[i] = unsignedvalue.data1;

				file.Read(doublevalue.data2, sizeof(double));
				Preset[k].m_RandomMin[i] = doublevalue.data1;

				file.Read(doublevalue.data2, sizeof(double));
				Preset[k].m_RandomMax[i] = doublevalue.data1;

				file.Read(bytevalue.data2, sizeof(BYTE));
				Preset[k].m_WolframRule[i] = bytevalue.data1;

				file.Read(unsignedlongvalue.data2, sizeof(unsigned long));
				Preset[k].m_WolframInit[i] = unsignedlongvalue.data1;

				file.Read(intvalue.data2, sizeof(int));
				Preset[k].m_WolframSize[i] = intvalue.data1;

				file.Read(longvalue.data2, sizeof(long));
				Preset[k].m_Hailstone[i] = longvalue.data1;

				file.Read(intvalue.data2, sizeof(int));
				Preset[k].m_Pan[i] = intvalue.data1 ;

				file.Read(boolvalue.data2, sizeof(BOOL));
				Preset[k].m_MatchScale[i] = boolvalue.data1 ;

				file.Read(intvalue.data2, sizeof(int));
				Preset[k].m_Percussion[i] = intvalue.data1 ;

				file.Read(shortvalue.data2, sizeof(short));
				Preset[k].AlgorithmNum[i] = shortvalue.data1 ;


			}//for(int i

			for (i = VOICE1; i<MAXVOICES; i++)
			{

				if(Preset[k].m_pScale[i])
				{
					delete [] Preset[k].m_pScale[i];
					Preset[k].m_pScale[i] = NULL;
				}

				file.Read(intvalue.data2, sizeof(int));

				int numnotes = intvalue.data1;
				Preset[k].m_pScale[i] = new int[numnotes + 1];

				Preset[k].m_pScale[i][0] = numnotes;

				for(int v=1; v<=numnotes; v++)
				{
					file.Read(intvalue.data2, sizeof(int));
					Preset[k].m_pScale[i][v] = intvalue.data1;
				}

			}

			for (i = VOICE1; i<MAXVOICES; i++)
			{

				if(Preset[k].m_pUserScale[i])
				{
					delete [] Preset[k].m_pUserScale[i];
					Preset[k].m_pUserScale[i] = NULL;
				}

				file.Read(intvalue.data2, sizeof(int));

				int numnotes = intvalue.data1;
				Preset[k].m_pUserScale[i] = new int[numnotes + 1];

				Preset[k].m_pUserScale[i][0] = numnotes;

				for(int v=1; v<=numnotes; v++)
				{
					file.Read(intvalue.data2, sizeof(int));
					Preset[k].m_pUserScale[i][v] = intvalue.data1;
				}

			}

			delete str; str = NULL;



	}


	file.Close();

	CListBox* pList = (CListBox*)GetDlgItem(IDC_PARAMETERS_LIST);
	pList->ResetContent();

	UpdateList();

	delete s; s = NULL;
	delete h; h = NULL;
	
}

void CInstrumentationDlg::OnDblclkParametersList() 
{

	if(!UpdateData())
		return;

	CListBox* pList = (CListBox*)GetDlgItem(IDC_PARAMETERS_LIST);

	if (!pList->GetCount()||pList->GetCount() == LB_ERR)
		return;

	int sel = pList->GetCurSel();

	if (sel == LB_ERR)
		return;

	int numchoices = 0;

	if (m_algorithm)
		++numchoices;
	if (m_coeff)
		++numchoices;
	if (m_counters)
		++numchoices;
	if (m_dynamic)
		++numchoices;
	if (m_instrument)
		++numchoices;
	if (m_inverted)
		++numchoices;
	if (m_matchscl)
		++numchoices;
	if (m_mode)
		++numchoices;
	if (m_modulate)
		++numchoices;
	if (m_note)
		++numchoices;
	if (m_noteval)
		++numchoices;
	if (m_octaves)
		++numchoices;
	if (m_pan)
		++numchoices;
	if (m_percussion)
		++numchoices;
	if (m_scale)
		++numchoices;
	if (m_tempo)
		++numchoices;
	if (m_timesig)
		++numchoices;
	if(m_offset)
		++numchoices;

	if(!numchoices)
	{
		MessageBox("You have to include something!","FractMus", MB_OK+MB_ICONEXCLAMATION);
		return;
	}

	CString name;

	pList->GetText(sel, name);

	for (int k = 0; k<50; k++)
	{
		if (Preset[k].Name == name)
			break;
	}

	if ((k>48)&&(Preset[49].Name!=name))
	{
		MessageBox("Preset not found", "FractMus", MB_OK+MB_ICONEXCLAMATION);
		return;
	}

	CFractMusDoc* pDoc = pView->GetDocument();
	CComboBox* pB;
	CButton* pButt;
	CEdit* pE;
	CScrollBar* pS = (CScrollBar*)(pView->GetDlgItem(IDC_TEMPO_SLIDER2));
	CStatic* pSt = (CStatic*)(pView->GetDlgItem(IDC_TEMPO_STATIC));
	char s[20];



	if (m_tempo)
	{
		pDoc->m_TempoMarking = pView->m_TempoMarking = Tempo = Preset[k].m_TempoMarking;
		pS->SetScrollPos(pView->m_TempoMarking);
		itoa(pView->m_TempoMarking, s ,10);
		pSt->SetWindowText(s);

	}
	if (m_counters)
	{
		pDoc->dGeneralCounter = pView->GeneralCounter = Preset[k].dGeneralCounter;
		pDoc->dStartCounter = pView->StartCounter = Preset[k].dStartCounter;
		pView->m_StartFrom = Preset[k].dStartCounter;

	}
	if (m_timesig)
	{

		pDoc->m_TimeSigNum = Preset[k].m_TimeSigNum;
		pDoc->m_TimeSigDen = Preset[k].m_TimeSigDen;

		pB = (CComboBox*)(pView->GetDlgItem(IDC_TIMESIGNUM_CMB));
		pB->SetCurSel((pDoc->m_TimeSigNum)-1);

		pB = (CComboBox*)(pView->GetDlgItem(IDC_TIMESIGDEN_CMB));

		switch (pDoc->m_TimeSigDen)
		{
			case 1:
				pB->SetCurSel(0);
				break;
			case 2:
				pB->SetCurSel(1);
				break;
			case 4:
				pB->SetCurSel(2);
				break;
			case 8:
				pB->SetCurSel(3);
				break;
			case 16:
				pB->SetCurSel(4);
				break;
			case 32:
				pB->SetCurSel(5);
				break;
		}
	}


		for(int i = VOICE1; i<MAXVOICES; i++)
			pDoc->m_IsActive[i] = pView->m_IsActive[i] = Preset[k].m_IsActive[i];

		int numact = 0;

		for(i = VOICE1; i<MAXVOICES; i++)
			if (pDoc->m_IsActive[i])
				++numact;

		pDoc->m_ActiveVoices = numact;


		for (i = VOICE1; i<MAXVOICES; i++)
		{
			if (m_modulate)
			{
				 pView->m_Modulates[i] = pDoc->m_Modulates[i] = Preset[k].m_Modulates[i];
				 pDoc->m_ModulRandom[i] = Preset[k].m_ModulRandom[i];
				 pDoc->m_ModulNum[i] = Preset[k].m_ModulNum[i];

			}
			if (m_offset)
				 pDoc->m_StartNum[i] = pView->m_StartNum[i] = Preset[k].m_StartNum[i];
			if(m_octaves)
			{
				 pDoc->m_NumOcts[i] = Preset[k].m_NumOcts[i];
				 pDoc->m_NumOctsID[i] = pView->m_NumOctsID[i] = Preset[k].m_NumOctsID[i];
				 pB = (CComboBox*)pView->GetDlgItem(pView->NumOctsID[i]);
				 pB->SetCurSel(pView->m_NumOctsID[i]);
			}
			if(m_note)
			{
				 pDoc->m_Note[i] = pView->m_Note[i] = Preset[k].m_Note[i];
				 pB = (CComboBox*)pView->GetDlgItem(pView->NoteID[i]);
				 pB->SetCurSel(pView->m_Note[i]);
			}
			if(m_noteval)
			{
				 CString nval;
				 pDoc->m_NoteValue[i] =  Preset[k].m_NoteValue[i];
				 pDoc->m_NoteValueID[i] = pView->m_NoteValueID[i] = Preset[k].m_NoteValueID[i];
				 nval.Format("Other (%d)", (long)pDoc->m_NoteValue[i]);
				 pB = (CComboBox*)pView->GetDlgItem(pView->NoteValueID[i]);
				 pB->DeleteString(OTHER);
				 pB->AddString(nval);
				 pB = (CComboBox*)pView->GetDlgItem(pView->NoteValueID[i]);
				 pB->SetCurSel(pView->m_NoteValueID[i]);
			}
			if(m_instrument)
			{
				 pDoc->m_Instrument[i] = Preset[k].m_Instrument[i];
			}
			if(m_percussion)
				 pDoc->m_Percussion[i] = Preset[k].m_Percussion[i];
			pDoc->m_Channel[i] = Preset[k].m_Channel[i];

			pButt = (CButton*)(pView->GetDlgItem(pView->ActiveID[i]));

			if (pDoc->m_Channel[i] == PercussionChannel)
			{
				pButt->SetWindowText(PercussionNames[ pDoc->m_Percussion[i] ]);
			}
			else
				pButt->SetWindowText(InstrumentNames[ pDoc->m_Instrument[i] ]);
			if(m_mode)
				 pDoc->m_mode[i] = Preset[k].m_Mode[i];
			if(m_inverted)
				 pDoc->m_Inverted[i] = Preset[k].m_Inverted[i];
			if(m_dynamic)
			{
				 pDoc->m_Dynamic[i] = Preset[k].m_Dynamic[i];
				 pDoc->m_DynChoice[i] = Preset[k].m_DynChoice[i];
			}
			if(m_algorithm)
				 pDoc->AlgorithmNum[i] = Preset[k].AlgorithmNum[i];
			if(m_coeff)
			{
				 pDoc->m_Base[i] = Preset[k].m_Base[i];
				 pDoc->m_Multi[i] = Preset[k].m_Multi[i];
				 pDoc->m_LogMapVar[i] = Preset[k].m_LogMapVar[i];
				 pDoc->m_FNoiseVar[i] = Preset[k].m_FNoiseVar[i];
				 pDoc->m_HenonA[i] = Preset[k].m_HenonA[i];
				 pDoc->m_HenonB[i] = Preset[k].m_HenonB[i];
				 pDoc->m_HopalongVar[i] = Preset[k].m_HopalongVar[i];
				 pDoc->m_MartinVar[i] = Preset[k].m_MartinVar[i];
				 pDoc->m_GingerX[i] = Preset[k].m_GingerX[i];
				 pDoc->m_GingerY[i] = Preset[k].m_GingerY[i];
				 pDoc->m_LorentzVar[i] = Preset[k].m_LorentzVar[i];
				 pDoc->m_EarthWormVar[i] = Preset[k].m_EarthWormVar[i];
			     pDoc->m_EarthWormMulti[i] = Preset[k].m_EarthWormMulti[i];
				 pDoc->m_EarthWormTruncator[i] = Preset[k].m_EarthWormTruncator[i];
				 pDoc->m_RandomMin[i] = Preset[k].m_RandomMin[i];
				 pDoc->m_RandomMax[i] = Preset[k].m_RandomMax[i];
				 pDoc->m_WolframRule[i] = Preset[k].m_WolframRule[i];
				 pDoc->m_WolframInit[i] = Preset[k].m_WolframInit[i];
				 pDoc->m_WolframSize[i] = Preset[k].m_WolframSize[i];
				 pDoc->m_Hailstone[i] = Preset[k].m_Hailstone[i];
			}
			if(m_pan)
				 pDoc->m_Pan[i] = Preset[k].m_Pan[i];
			if(m_matchscl)
				 pDoc->m_MatchScale[i] = Preset[k].m_MatchScale[i];


		}

		if(m_scale)
		{
			for(i = VOICE1; i<MAXVOICES; i++)
			{
				pDoc->m_ScaleID[i] = pView->m_ScaleID[i] = Preset[k].m_ScaleID[i];


				pB = (CComboBox*)pView->GetDlgItem(pView->ScaleID[i]);
				pB->SetCurSel(pView->m_ScaleID[i]);

				if (pDoc->m_pScale[i])
				{
					delete [] pDoc->m_pScale[i];

					pDoc->m_pScale[i] = NULL;
				}
				if (pDoc->m_pUserScale[i])
				{
					delete [] pDoc->m_pUserScale[i];
					pDoc->m_pUserScale[i] = NULL;
				}

				pDoc->m_pScale[i] = new int [Preset[k].m_pScale[i][0] + 1];
				for(int j =0; j<=Preset[k].m_pScale[i][0]; j++)
					 pDoc->m_pScale[i][j] = Preset[k].m_pScale[i][j];

				pDoc->m_pUserScale[i] = new int [Preset[k].m_pUserScale[i][0] + 1];
				for(j =0; j<=Preset[k].m_pUserScale[i][0]; j++)
					 pDoc->m_pUserScale[i][j] = Preset[k].m_pUserScale[i][j];

				pView->InitUserScale(i);
				if (pDoc->m_ScaleID[i] == USER_DEFINED)
					pView->SetUserScale(i);
			}

		}

	for(i=VOICE1; i<MAXVOICES; i++)
	{
		pE = (CEdit*)pView->GetDlgItem(pView->StartNumID[i])->EnableWindow(pView->m_IsActive[i]);
		pButt = (CButton*)pView->GetDlgItem(pView->ModulatesID[i])->EnableWindow(pView->m_IsActive[i]);
		pB = (CComboBox*)pView->GetDlgItem(pView->NumOctsID[i])->EnableWindow(pView->m_IsActive[i]);
		pB = (CComboBox*)pView->GetDlgItem(pView->NoteID[i])->EnableWindow(pView->m_IsActive[i]);
		pB = (CComboBox*)pView->GetDlgItem(pView->ScaleID[i])->EnableWindow(pView->m_IsActive[i]);
		pB = (CComboBox*)pView->GetDlgItem(pView->NoteValueID[i])->EnableWindow(pView->m_IsActive[i]);
		pButt = (CButton*)pView->GetDlgItem(pView->MidiButtonID[i])->EnableWindow(pView->m_IsActive[i]);
		//pButt = (CButton*)GetDlgItem(ActiveID[i])->EnableWindow((!IsDocumentLocked));


	}

		pView->UpdateData(FALSE);

		pView->PlayChoice = CURRENT_SETTINGS;

		if (m_counters&&(!pView->LockGeneralCounter))
			pView->OnLockGencounter();


	
}

void CInstrumentationDlg::OnRemove() 
{
	CListBox* pList = (CListBox*)GetDlgItem(IDC_PARAMETERS_LIST);

	int sel = pList->GetCurSel();

	if (sel == LB_ERR)
		return;

	if (MessageBox("Are you sure?", "Remove Preset", MB_YESNO+MB_ICONEXCLAMATION) != IDYES)
		return;

	CString name;

	pList->GetText(sel, name);

	for (int k = 0; k<50; k++)
	{
		if (Preset[k].Name == name)
			break;
	}

	if ((k>48)&&(Preset[49].Name!=name))
	{
		MessageBox("Preset not found, BUG: this should not happen!", "FractMus", MB_OK+MB_ICONEXCLAMATION);
		return;
	}
	else
	{
		Preset[k].Name = "";
		pList->DeleteString(sel);
	}

	
}

void CInstrumentationDlg::OnSave() 
{
	int numpresets = 0;
	for (int k=0; k<50; k++)
	{
		if (!Preset[k].Name.IsEmpty())
			++numpresets;
	}

	if (!numpresets)
	{
		MessageBox("You have no presets to save", "FractMus", MB_OK+MB_ICONEXCLAMATION);
		return;
	}

	char FileName[500];
	char FileTitle[100];

	OPENFILENAME ofn;
	memset(&ofn, 0, sizeof(ofn));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = NULL;
	ofn.hInstance = NULL;

	ofn.lpstrFilter = 
		TEXT("event presets files *.evt\0*.evt\0\0");

	ofn.lpstrCustomFilter = NULL;
	ofn.nMaxCustFilter = 0;
	ofn.nFilterIndex = 1;
	ofn.lpstrFile = FileName;
	ofn.nMaxFile = 500;
	ofn.lpstrFileTitle = FileTitle;
	ofn.nMaxFileTitle = 99;
	ofn.lpstrInitialDir = NULL;
	ofn.lpstrTitle="Save Event Presets";
	ofn.Flags = OFN_OVERWRITEPROMPT|OFN_LONGNAMES;
	ofn.lpstrDefExt = "evt";
	ofn.lCustData = NULL;
	ofn.lpfnHook = NULL;
	ofn.lpTemplateName = NULL;

	FileName[0] = '\0';

	if(!GetSaveFileName(&ofn))
		return;

	if(FileName[0] == '\0')
		return;

	CFile file;

	file.Open(FileName, CFile::modeCreate | CFile::modeWrite );

	union 
	{
		int dataint;
		BYTE databyte[sizeof(int)];
	} num;

	CString header = "EVTFile";

	file.Write((char*)header.GetBuffer(1), 7);


	num.dataint = numpresets;

	file.Write(num.databyte, sizeof(int));


	for (k=0; k<50; k++)
	{
		if (!Preset[k].Name.IsEmpty())
		{
			//ar << Preset[k].Name;

			int numbytes = Preset[k].Name.GetLength();

			//numbytes; // string null terminator
			
			union
			{
				UINT bytes;
				BYTE data[sizeof(BYTE)*sizeof(UINT)];
			} databytes;

			databytes.bytes = numbytes;

			file.Write((BYTE*)databytes.data, sizeof(BYTE)*sizeof(UINT));

			file.Write((char*)Preset[k].Name.GetBuffer(1), numbytes);

			union 
			{
				int data1;
				BYTE data2[sizeof(int)];
			} intvalue;

			union
			{
				BOOL data1;
				BYTE data2[sizeof(BOOL)];
			} boolvalue;

			union
			{
				long data1;
				BYTE data2[sizeof(long)];
			} longvalue;

			union
			{
				float data1;
				BYTE data2[sizeof(float)];
			} floatvalue;

			union
			{
				short data1;
				BYTE data2[sizeof(short)];
			} shortvalue;

			union
			{
				unsigned data1;
				BYTE data2[sizeof(unsigned)];
			} unsignedvalue;

			union
			{
				unsigned long data1;
				BYTE data2[sizeof(unsigned long)];
			} unsignedlongvalue;

			union
			{
				double data1;
				BYTE data2[sizeof(double)];
			} doublevalue;

			union
			{
				BYTE data1;
				BYTE data2[sizeof(BYTE)];
			} bytevalue;


			intvalue.data1 = Preset[k].m_TempoMarking;
			file.Write(intvalue.data2, sizeof(int));

			longvalue.data1 = Preset[k].dGeneralCounter;
			file.Write(longvalue.data2, sizeof(long));

			longvalue.data1 = Preset[k].dStartCounter;
			file.Write(longvalue.data2, sizeof(long));

			shortvalue.data1 = Preset[k].m_TimeSigNum;
			file.Write(shortvalue.data2, sizeof(short));

			shortvalue.data1 = Preset[k].m_TimeSigDen;
			file.Write(shortvalue.data2, sizeof(short));

			for(int i = VOICE1; i<MAXVOICES; i++)
			{
				
				boolvalue.data1 = Preset[k].m_IsActive[i];
				file.Write(boolvalue.data2, sizeof(BOOL));

				boolvalue.data1 = Preset[k].m_Modulates[i];
				file.Write(boolvalue.data2, sizeof(BOOL));

				boolvalue.data1 = Preset[k].m_ModulRandom[i];
				file.Write(boolvalue.data2, sizeof(BOOL));

				intvalue.data1 = Preset[k].m_ModulNum[i];
				file.Write(intvalue.data2, sizeof(int));

				longvalue.data1 = Preset[k].m_Base[i];
				file.Write(longvalue.data2, sizeof(long));

				longvalue.data1 = Preset[k].m_Multi[i];
				file.Write(longvalue.data2, sizeof(long));

				longvalue.data1 = Preset[k].m_StartNum[i];
				file.Write(longvalue.data2, sizeof(long));

				intvalue.data1 = Preset[k].m_ScaleID[i];
				file.Write(intvalue.data2, sizeof(int));

				intvalue.data1 = Preset[k].m_NumOcts[i];
				file.Write(intvalue.data2, sizeof(int));

				intvalue.data1 = Preset[k].m_NumOctsID[i];
				file.Write(intvalue.data2, sizeof(int));

				intvalue.data1 = Preset[k].m_Note[i];
				file.Write(intvalue.data2, sizeof(int));

				floatvalue.data1 = Preset[k].m_NoteValue[i];
				file.Write(floatvalue.data2, sizeof(float));

				intvalue.data1 = Preset[k].m_NoteValueID[i];
				file.Write(intvalue.data2, sizeof(int));

				intvalue.data1 = Preset[k].m_Instrument[i];
				file.Write(intvalue.data2, sizeof(int));

				intvalue.data1 = Preset[k].m_Channel[i];
				file.Write(intvalue.data2, sizeof(int));

				intvalue.data1 = Preset[k].m_Mode[i];
				file.Write(intvalue.data2, sizeof(int));

				boolvalue.data1 = Preset[k].m_Inverted[i];
				file.Write(boolvalue.data2, sizeof(BOOL));

				intvalue.data1 = Preset[k].m_Dynamic[i];
				file.Write(intvalue.data2, sizeof(int));

				intvalue.data1 = Preset[k].m_DynChoice[i];
				file.Write(intvalue.data2, sizeof(int));

				floatvalue.data1 = Preset[k].m_LogMapVar[i];
				file.Write(floatvalue.data2, sizeof(float));

				floatvalue.data1 = Preset[k].m_FNoiseVar[i];
				file.Write(floatvalue.data2, sizeof(float));

				floatvalue.data1 = Preset[k].m_HenonA[i];
				file.Write(floatvalue.data2, sizeof(float));

				floatvalue.data1 = Preset[k].m_HenonB[i];
				file.Write(floatvalue.data2, sizeof(float));

				floatvalue.data1 = Preset[k].m_HopalongVar[i];
				file.Write(floatvalue.data2, sizeof(float));

				floatvalue.data1 = Preset[k].m_MartinVar[i];
				file.Write(floatvalue.data2, sizeof(float));

				floatvalue.data1 = Preset[k].m_GingerX[i];
				file.Write(floatvalue.data2, sizeof(float));

				floatvalue.data1 = Preset[k].m_GingerY[i];
				file.Write(floatvalue.data2, sizeof(float));

				floatvalue.data1 = Preset[k].m_LorentzVar[i];
				file.Write(floatvalue.data2, sizeof(float));

				unsignedlongvalue.data1 = Preset[k].m_EarthWormVar[i];
				file.Write(unsignedlongvalue.data2, sizeof(unsigned long));

				unsignedlongvalue.data1 = Preset[k].m_EarthWormMulti[i];
				file.Write(unsignedlongvalue.data2, sizeof(unsigned long));

				unsignedvalue.data1 = Preset[k].m_EarthWormTruncator[i];
				file.Write(unsignedvalue.data2, sizeof(unsigned));

				doublevalue.data1 = Preset[k].m_RandomMin[i];
				file.Write(doublevalue.data2, sizeof(double));

				doublevalue.data1 = Preset[k].m_RandomMax[i];
				file.Write(doublevalue.data2, sizeof(double));

				bytevalue.data1 = Preset[k].m_WolframRule[i];
				file.Write(bytevalue.data2, sizeof(BYTE));

				unsignedlongvalue.data1 = Preset[k].m_WolframInit[i];
				file.Write(unsignedlongvalue.data2, sizeof(unsigned long));

				intvalue.data1 = Preset[k].m_WolframSize[i];
				file.Write(intvalue.data2, sizeof(int));

				longvalue.data1 = Preset[k].m_Hailstone[i];
				file.Write(longvalue.data2, sizeof(long));

				intvalue.data1 = Preset[k].m_Pan[i];
				file.Write(intvalue.data2, sizeof(int));

				boolvalue.data1 = Preset[k].m_MatchScale[i];
				file.Write(boolvalue.data2, sizeof(BOOL));

				intvalue.data1 = Preset[k].m_Percussion[i];
				file.Write(intvalue.data2, sizeof(int));

				shortvalue.data1 = Preset[k].AlgorithmNum[i];
				file.Write(shortvalue.data2, sizeof(short));


			}//for(int i

			for (i = VOICE1; i<MAXVOICES; i++)
			{

				for(int v=0; v<=Preset[k].m_pScale[i][0]; v++)
				{
					intvalue.data1 = Preset[k].m_pScale[i][v];
					file.Write(intvalue.data2, sizeof(int));
				}

			}

			for (i = VOICE1; i<MAXVOICES; i++)
			{

				for(int v=0; v<=Preset[k].m_pUserScale[i][0]; v++)
				{
					intvalue.data1 = Preset[k].m_pUserScale[i][v];
					file.Write(intvalue.data2, sizeof(int));
				}

			}



		}//if (!Preset[k]

	}//for (k=0;

	file.Close();
}

void CInstrumentationDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CInstrumentationDlg::OnOK() 
{
	
}

BOOL CInstrumentationDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	
	CListBox* pList = (CListBox*)GetDlgItem(IDC_PARAMETERS_LIST);

	pList->SetHorizontalExtent(720);

	for (int k = 0; k<50; k++)
		if (Preset[k].Name!="")
			pList->AddString(Preset[k].Name);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CInstrumentationDlg::OnAll() 
{
	m_algorithm = TRUE;
	m_coeff = TRUE;
	m_counters = TRUE;
	m_dynamic = TRUE;
	m_instrument = TRUE;
	m_inverted = TRUE;
	m_matchscl = TRUE;
	m_mode = TRUE;
	m_modulate = TRUE;
	m_note = TRUE;
	m_noteval = TRUE;
	m_octaves = TRUE;
	m_pan = TRUE;
	m_percussion = TRUE;
	m_scale = TRUE;
	m_tempo = TRUE;
	m_timesig = TRUE;
	m_offset = TRUE;

	UpdateData(FALSE);
	
}

void CInstrumentationDlg::OnNone() 
{
	m_algorithm = FALSE;
	m_coeff = FALSE;
	m_counters = FALSE;
	m_dynamic = FALSE;
	m_instrument = FALSE;
	m_inverted = FALSE;
	m_matchscl = FALSE;
	m_mode = FALSE;
	m_modulate = FALSE;
	m_note = FALSE;
	m_noteval = FALSE;
	m_octaves = FALSE;
	m_pan = FALSE;
	m_percussion = FALSE;
	m_scale = FALSE;
	m_tempo = FALSE;
	m_timesig = FALSE;
	m_offset = FALSE;


	UpdateData(FALSE);
	
}


void CInstrumentationDlg::UpdateList()
{
	CListBox* pList = (CListBox*)GetDlgItem(IDC_PARAMETERS_LIST);

		for (int k = 0; k<50; k++)
			if (Preset[k].Name!="")
				pList->AddString(Preset[k].Name);
}


void CInstrumentationDlg::OnReplace() 
{

	if (!UpdateData())
		return;

	CListBox* pList = (CListBox*)GetDlgItem(IDC_PARAMETERS_LIST);

	int sel = pList->GetCurSel();

	if (sel == LB_ERR)
		return;


	CString name;

	pList->GetText(sel, name);

	for (int k = 0; k<50; k++)
	{
		if (Preset[k].Name == name)
			break;
	}

	if ((k>48)&&(Preset[49].Name!=name))
	{
		MessageBox("Preset not found, BUG: this should not happen!", "FractMus", MB_OK+MB_ICONEXCLAMATION);
		return;
	}

	if (m_newpresetname == "")
	{
		MessageBox("Please select a name for the preset","FractMus",MB_OK+MB_ICONEXCLAMATION);
		return;
	}

	for(int r = 0; r<50; r++)
	{
		if((Preset[r].Name == m_newpresetname)&&(r!=k))
		{
			MessageBox("There is another preset with that name, please choose another name", "FractMus", MB_OK+MB_ICONEXCLAMATION);
			return;
		}
	}

	if (MessageBox("Are you want to replace the preset with the current settings", "FractMus", MB_YESNO+MB_ICONEXCLAMATION) != IDYES)
		return;

	CFractMusDoc* pDoc = pView->GetDocument();


		Preset[k].Name = m_newpresetname;

		Preset[k].m_TempoMarking = pDoc->m_TempoMarking;
		Preset[k].dGeneralCounter = pDoc->dGeneralCounter;
		Preset[k].dStartCounter = pDoc->dStartCounter;
		Preset[k].m_TimeSigNum = pDoc->m_TimeSigNum;
		Preset[k].m_TimeSigDen = pDoc->m_TimeSigDen;


		for(int i = VOICE1; i<MAXVOICES; i++)
			Preset[k].m_IsActive[i] = pDoc->m_IsActive[i];


		for (i = VOICE1; i<MAXVOICES; i++)
		{
			Preset[k].m_Modulates[i] = pDoc->m_Modulates[i];
			Preset[k].m_ModulRandom[i] = pDoc->m_ModulRandom[i];
			Preset[k].m_ModulNum[i] = pDoc->m_ModulNum[i];
			Preset[k].m_Base[i] = pDoc->m_Base[i];
			Preset[k].m_Multi[i] = pDoc->m_Multi[i];
			Preset[k].m_StartNum[i] = pDoc->m_StartNum[i];
			Preset[k].m_ScaleID[i] = pDoc->m_ScaleID[i];
			Preset[k].m_NumOcts[i] = pDoc->m_NumOcts[i];
			Preset[k].m_NumOctsID[i] = pDoc->m_NumOctsID[i];
			Preset[k].m_Note[i] = pDoc->m_Note[i];
			Preset[k].m_NoteValue[i] = pDoc->m_NoteValue[i];
			Preset[k].m_NoteValueID[i] = pDoc->m_NoteValueID[i];
			Preset[k].m_Instrument[i] = pDoc->m_Instrument[i];
			Preset[k].m_Channel[i] = pDoc->m_Channel[i];
			Preset[k].m_Mode[i] = pDoc->m_mode[i];
			Preset[k].m_Inverted[i] = pDoc->m_Inverted[i];
			Preset[k].m_Dynamic[i] = pDoc->m_Dynamic[i];
			Preset[k].m_DynChoice[i] = pDoc->m_DynChoice[i];
			Preset[k].m_LogMapVar[i] = pDoc->m_LogMapVar[i];
			Preset[k].m_FNoiseVar[i] = pDoc->m_FNoiseVar[i];
			Preset[k].m_HenonA[i] = pDoc->m_HenonA[i];
			Preset[k].m_HenonB[i] = pDoc->m_HenonB[i];
			Preset[k].m_HopalongVar[i] = pDoc->m_HopalongVar[i];
			Preset[k].m_MartinVar[i] = pDoc->m_MartinVar[i];
			Preset[k].m_GingerX[i] = pDoc->m_GingerX[i];
			Preset[k].m_GingerY[i] = pDoc->m_GingerY[i];
			Preset[k].m_LorentzVar[i] = pDoc->m_LorentzVar[i];
			Preset[k].m_EarthWormVar[i] = pDoc->m_EarthWormVar[i];
			Preset[k].m_EarthWormMulti[i] = pDoc->m_EarthWormMulti[i];
			Preset[k].m_EarthWormTruncator[i] = pDoc->m_EarthWormTruncator[i];
			Preset[k].m_RandomMin[i] = pDoc->m_RandomMin[i];
			Preset[k].m_RandomMax[i] = pDoc->m_RandomMax[i];
			Preset[k].m_WolframRule[i] = pDoc->m_WolframRule[i];
			Preset[k].m_WolframInit[i] = pDoc->m_WolframInit[i];
			Preset[k].m_WolframSize[i] = pDoc->m_WolframSize[i];
			Preset[k].m_Hailstone[i] = pDoc->m_Hailstone[i];

			Preset[k].m_Pan[i] = pDoc->m_Pan[i];
			Preset[k].m_MatchScale[i] = pDoc->m_MatchScale[i];
			Preset[k].m_Percussion[i] = pDoc->m_Percussion[i];


			Preset[k].AlgorithmNum[i] = pDoc->AlgorithmNum[i];

		}

		for(i = VOICE1; i<MAXVOICES; i++)
		{
			if (Preset[k].m_pScale[i])
			{
				delete [] Preset[k].m_pScale[i];

				Preset[k].m_pScale[i] = NULL;
			}
			if (Preset[k].m_pUserScale[i])
			{
				delete [] Preset[k].m_pUserScale[i];
				Preset[k].m_pUserScale[i] = NULL;
			}
		}

		for(i = VOICE1; i<MAXVOICES; i++)
		{
			Preset[k].m_pScale[i] = new int [pDoc->m_pScale[i][0] + 1];
			for(int j =0; j<=pDoc->m_pScale[i][0]; j++)
				Preset[k].m_pScale[i][j] = pDoc->m_pScale[i][j];
		}

		for(i = VOICE1; i<MAXVOICES; i++)
		{
			Preset[k].m_pUserScale[i] = new int [pDoc->m_pUserScale[i][0] + 1];
			for(int j =0; j<=pDoc->m_pUserScale[i][0]; j++)
				Preset[k].m_pUserScale[i][j] = pDoc->m_pUserScale[i][j];
		}

		pList->DeleteString(sel);

		pList->InsertString(sel, (LPCTSTR)Preset[k].Name);

		
}

void CInstrumentationDlg::OnSelchangeParametersList() 
{
	if(!UpdateData())
		return;


	CListBox* pList = (CListBox*)GetDlgItem(IDC_PARAMETERS_LIST);

	if (!pList->GetCount()||pList->GetCount() == LB_ERR)
		return;

	int sel = pList->GetCurSel();

	if (sel == LB_ERR)
		return;

	CString name;

	pList->GetText(sel, name);

	m_newpresetname = name;

	UpdateData(FALSE);


	
}
