
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


// InstrumentsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FractMus.h"
#include "InstrumentsDlg.h"
#include "RandDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CInstrumentsDlg dialog


CInstrumentsDlg::CInstrumentsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CInstrumentsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CInstrumentsDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CInstrumentsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CInstrumentsDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CInstrumentsDlg, CDialog)
	//{{AFX_MSG_MAP(CInstrumentsDlg)
	ON_BN_CLICKED(IDC_NONE, OnNone)
	ON_BN_CLICKED(IDC_ALL, OnAll)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CInstrumentsDlg message handlers

void CInstrumentsDlg::OnCancel() 
{
}

void CInstrumentsDlg::OnOK() 
{
	CListBox* pList = (CListBox*)GetDlgItem(IDC_INSTRUMENT_LIST);

	int numchoices = pList->GetSelCount();

	if(numchoices<1)
	{
		MessageBox("Please select at least one instrument","Error",MB_OK+MB_ICONEXCLAMATION);
		return;
	}

	for (int i =0; i<128; i++)
		IsSelected[i] = FALSE;


	int* selectedItems = new int[numchoices];

	pList->GetSelItems(numchoices, selectedItems);

	for(i =0; i<numchoices; i++)
		IsSelected[ selectedItems[i] ] = TRUE;

	delete selectedItems;

    selectedItems = NULL;

	
	CDialog::OnOK();
}

void CInstrumentsDlg::OnNone() 
{
	CListBox* pList = (CListBox*)GetDlgItem(IDC_INSTRUMENT_LIST);

	pList->SelItemRange(FALSE, 0, 127);

}

BOOL CInstrumentsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CListBox* pList = (CListBox*)GetDlgItem(IDC_INSTRUMENT_LIST);

	pList->AddString("000 Grand piano");
	pList->AddString("001 Bright piano");
	pList->AddString("002 Electric piano");
	pList->AddString("003 Honky tonk piano");
	pList->AddString("004 Rhodes piano");
	pList->AddString("005 Chorus piano");
	pList->AddString("006 Harpsichord");
	pList->AddString("007 Clavinet");
	pList->AddString("008 Celesta");
	pList->AddString("009 Glockenspiel");
	pList->AddString("010 Music Box");
	pList->AddString("011 Vibraphone");
	pList->AddString("012 Marimba");
	pList->AddString("013 Xilophone");
	pList->AddString("014 Tubular bells");
	pList->AddString("015 Dulcimer");
	pList->AddString("016 Hammond organ");
	pList->AddString("017 Percussive organ");
	pList->AddString("018 Rock organ");
	pList->AddString("019 Church organ");
	pList->AddString("020 Reed organ");
	pList->AddString("021 Accordion");
	pList->AddString("022 Harmonica");
	pList->AddString("023 Tango accordion");
	pList->AddString("024 Nylon string guitar");
	pList->AddString("025 Steel string guitar");
	pList->AddString("026 Electric guitar (jazz)");
	pList->AddString("027 Electric guitar (clean)");
	pList->AddString("028 Electric guitar (mute)");
	pList->AddString("029 Overdriven guitar");
	pList->AddString("030 Distorted guitar");
	pList->AddString("031 Guitar harmonics");
	pList->AddString("032 Accoustic bass");
	pList->AddString("033 Electric bass (finger)");
	pList->AddString("034 Electric bass (pick)");
	pList->AddString("035 Fretless bass");
	pList->AddString("036 Slap bass 1");
	pList->AddString("037 Slap bass 2");
	pList->AddString("038 Synth bass 1");
	pList->AddString("039 Synth bass 2");
	pList->AddString("040 Violin");
	pList->AddString("041 Viola");
	pList->AddString("042 'Cello");
	pList->AddString("043 Double bass");
	pList->AddString("044 Tremolo strings ");
	pList->AddString("045 Pizzicato strings");
	pList->AddString("046 Orchestral harp");
	pList->AddString("047 Timpani");
	pList->AddString("048 String ensemble 1");
	pList->AddString("049 String ensemble 2");
	pList->AddString("050 Synth strings 1");
	pList->AddString("051 Synth strings 2");
	pList->AddString("052 Choir aahs");
	pList->AddString("053 Voice oohs");
	pList->AddString("054 Synth voices");
	pList->AddString("055 Orchestra hit");
	pList->AddString("056 Trumpet");
	pList->AddString("057 Trombone");
	pList->AddString("058 Tuba");
	pList->AddString("059 Muted trumpet");
	pList->AddString("060 French horn");
	pList->AddString("061 Brass section");
	pList->AddString("062 Synth brass 1");
	pList->AddString("063 Synth brass 2");
	pList->AddString("064 Soprano sax");
	pList->AddString("065 Alto sax");
	pList->AddString("066 Tenor sax");
	pList->AddString("067 Baritone sax");
	pList->AddString("068 Oboe");
	pList->AddString("069 English horn");
	pList->AddString("070 Bassoon");
	pList->AddString("071 Clarinet");
	pList->AddString("072 Piccolo");
	pList->AddString("073 Flute");
	pList->AddString("074 Recorder");
	pList->AddString("075 Pan flute");
	pList->AddString("076 Blown bottle");
	pList->AddString("077 Shakuhachi");
	pList->AddString("078 Whistle");
	pList->AddString("079 Ocarina");
	pList->AddString("080 Lead 1 (square)");
	pList->AddString("081 Lead 2 (sawtooth)");
	pList->AddString("082 Lead 3 (calliope)");
	pList->AddString("083 Lead 4 (chiff)");
	pList->AddString("084 Lead 5 (charang)");
	pList->AddString("085 Lead 6 (voice)");
	pList->AddString("086 Lead 7 (fifth)");
	pList->AddString("087 Lead 8 (bass +)");
	pList->AddString("088 Pad 1 (new age)");
	pList->AddString("089 Pad 2 (warm)");
	pList->AddString("090 Pad 3 (polysynth)");
	pList->AddString("091 Pad 4 (choir)");
	pList->AddString("092 Pad 5 (bowed)");
	pList->AddString("093 Pad 6 (metallic)");
	pList->AddString("094 Pad 7 (halo)");
	pList->AddString("095 Pad 8 (sweep)");
	pList->AddString("096 FX 1 (rain)");
	pList->AddString("097 FX 2 (soundtrack)");
	pList->AddString("098 FX 3 (crystal)");
	pList->AddString("099 FX 4 (atmosphere)");
	pList->AddString("100 FX 5 (brightness)");
	pList->AddString("101 FX 6 (goblins)");
	pList->AddString("102 FX 7 (echoes)");
	pList->AddString("103 FX 8 (sci-fi)");
	pList->AddString("104 Sitar");
	pList->AddString("105 Banjo");
	pList->AddString("106 Shamisen");
	pList->AddString("107 Koto");
	pList->AddString("108 Kalimba");
	pList->AddString("109 Bag pipe");
	pList->AddString("110 Fiddle");
	pList->AddString("111 Shanai");
	pList->AddString("112 Tinklebell");
	pList->AddString("113 Agogo bells");
	pList->AddString("114 Steel drum");
	pList->AddString("115 Wood block");
	pList->AddString("116 Taiko drum");
	pList->AddString("117 Melodic drum");
	pList->AddString("118 Synth drum");
	pList->AddString("119 Reverse cymbal");
	pList->AddString("120 Guitar fret noise");
	pList->AddString("121 Breath noise");
	pList->AddString("122 Seashore");
	pList->AddString("123 Bird tweet");
	pList->AddString("124 Telephone ring");
	pList->AddString("125 Helicopter");
	pList->AddString("126 Applause");
	pList->AddString("127 Gunshot");

	for (int i =0; i<128; i++)
		IsSelected[i] = FALSE;

	for (i =0; i<128; i++)
		IsSelected[i] = pRand->Instrument[i];

	for (i =0; i<128; i++)
		if (IsSelected[i])
			pList->SetSel(i);


	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CInstrumentsDlg::OnAll() 
{
	CListBox* pList = (CListBox*)GetDlgItem(IDC_INSTRUMENT_LIST);

	pList->SelItemRange(TRUE, 0, 127);

	
}
