
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


// MidiDevDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FractMus.h"
#include "MidiDevDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMidiDevDlg dialog

extern int numDevs;


CMidiDevDlg::CMidiDevDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMidiDevDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMidiDevDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_midiDevChoice = MIDI_MAPPER;
}


void CMidiDevDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMidiDevDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMidiDevDlg, CDialog)
	//{{AFX_MSG_MAP(CMidiDevDlg)
	ON_LBN_DBLCLK(IDC_LISTBOX, OnDblclkListbox)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMidiDevDlg message handlers

void CMidiDevDlg::OnCancel() 
{
	// do nothing
}

BOOL CMidiDevDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CListBox* pLB = (CListBox*)GetDlgItem(IDC_LISTBOX);

	MIDIOUTCAPS mCaps;

	pLB->AddString("Midi Mapper");

	if (numDevs)
	{
		for (int i = 0; i<numDevs; i++)
		{
			midiOutGetDevCaps(i, &mCaps, sizeof(mCaps));
			pLB->AddString(mCaps.szPname);
		}
	}

	pLB->SetCurSel(0);

	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CMidiDevDlg::OnOK() 
{

	CListBox* pLB = (CListBox*)GetDlgItem(IDC_LISTBOX);

	int i = pLB->GetCurSel();

	if (i == LB_ERR)
		return;

	m_midiDevChoice = i;

	--m_midiDevChoice;

	EndDialog(0);
	
}

void CMidiDevDlg::OnDblclkListbox() 
{
	CListBox* pLB = (CListBox*)GetDlgItem(IDC_LISTBOX);

	int i = pLB->GetCurSel();

	if (i == LB_ERR)
		return;

	m_midiDevChoice = i;

	--m_midiDevChoice;

	EndDialog(0);
	
	
}
