
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


// MorseThueDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FractMus.h"
#include "MorseThueDlg.h"
#include "MorseThueGraph.h"
#include "FractMusView.h"
#include "FractMusDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
UINT ShowThue(LPVOID pObj);
extern start;
extern running;
extern int count1[MAXVOICES];
extern WORD noteOn(BYTE , BYTE , BYTE );
extern WORD noteOff(BYTE, BYTE, BYTE);
extern WORD progChange(BYTE , BYTE);
extern WORD modeChange(BYTE , BYTE , BYTE);
extern HMIDIOUT midiOut;
extern int DevChoice;
extern int PercussionChannel;


extern int __fastcall Morse_Thue(int voice, long counter, long test, const int* scale, 
				int numocts,long base, long startnum, 
				int startnote,BOOL modulate, BOOL modulrand, 
				int modulnum, BOOL inverted, float logmapvar, float oneoverf,
				float henonA, float henonB, float hopalong,
				float martin, float lorentz, unsigned long earthwormvar,
				unsigned long earthwormmulti, unsigned earthwormtruncator,
				double ranmin, double ranmax, BYTE wolframrule,
				int wolframsize, long hailstonestart);


/////////////////////////////////////////////////////////////////////////////
// CMorseThueDlg dialog


CMorseThueDlg::CMorseThueDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMorseThueDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMorseThueDlg)
	m_base = 0;
	m_multi = 0;
	//}}AFX_DATA_INIT
	m_pGraph = NULL;
	start = TRUE;

}


void CMorseThueDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMorseThueDlg)
	DDX_Text(pDX, IDC_BASE_ED, m_base);
	DDV_MinMaxLong(pDX, m_base, 2, 2000000);
	DDX_Text(pDX, IDC_MULTI_ED, m_multi);
	DDV_MinMaxLong(pDX, m_multi, 1, 1000000000);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMorseThueDlg, CDialog)
	//{{AFX_MSG_MAP(CMorseThueDlg)
	ON_BN_CLICKED(IDC_VISUALIZE, OnVisualize)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMorseThueDlg message handlers

void CMorseThueDlg::OnVisualize() 
{
	if (!UpdateData())
		return;


	running = !running;

	
		

	if (m_pGraph!=NULL)
	{
		m_pGraph->SetForegroundWindow();
		if (running)
		{
			GetDlgItem(IDC_VISUALIZE)->SetWindowText("Stop");
			AfxBeginThread(ShowThue, this);
		}


		if (!running)
			GetDlgItem(IDC_VISUALIZE)->SetWindowText("Run");

		return;
	}
	start = TRUE;
	int maxX = 600 + ::GetSystemMetrics(SM_CXSIZEFRAME)*2;
	int maxY = 240 + ::GetSystemMetrics(SM_CYCAPTION)+::GetSystemMetrics(SM_CXSIZEFRAME);


	CClientDC dc(m_pGraph);
	m_pGraph = new CMorseThueGraph;
	CRect r(0,0,maxX,maxY);
	/*LOGBRUSH lb;

	lb.lbStyle = BS_SOLID;
	lb.lbColor = RGB(0,0,0);
	lb.lbHatch = HS_CROSS;*/


	m_pGraph->m_memDC.CreateCompatibleDC(&dc);
	m_pGraph->m_bmp.CreateCompatibleBitmap(&dc, 600, 240);
	m_pGraph->m_memDC.SelectObject(&(m_pGraph->m_bmp));
	m_pGraph->m_bkbrush.CreateSolidBrush(RGB(0,0,0));
	m_pGraph->m_memDC.SelectObject(&(m_pGraph->m_bkbrush));
	m_pGraph->m_Pen.CreatePen(PS_SOLID, 0, RGB(255,0,0));
	m_pGraph->m_memDC.SelectObject(&(m_pGraph->m_Pen));
	m_pGraph->m_memDC.PatBlt(0,0,600,240,PATCOPY);
	m_pGraph->m_pParent = this;
	m_pGraph->Create(	NULL, "",
						WS_CAPTION|WS_SYSMENU|WS_VISIBLE, r
						   );

	GetDlgItem(IDOK)->EnableWindow(FALSE);
	GetDlgItem(IDCANCEL)->EnableWindow(FALSE);

	running = TRUE;
	GetDlgItem(IDC_VISUALIZE)->SetWindowText("Stop");
	

	AfxBeginThread(ShowThue, this);

	
}

void CMorseThueDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CMorseThueDlg::OnOK() 
{
	if(!UpdateData())
		return;
	
	CDialog::OnOK();
}

UINT ShowThue(LPVOID pObj)
{
	CMorseThueDlg* Wp = (CMorseThueDlg*)pObj;
	CFractMusDoc* pDoc= Wp->pView->GetDocument();

	static counter=0;
	long test;
	static long count;
	static dracula;
	int result=0;
	int lastnote =0, note =0;


	UINT res = midiOutOpen(&midiOut, DevChoice, NULL, NULL, CALLBACK_NULL);

	if( res!=MMSYSERR_NOERROR )
	{
		switch(result)
		{

		case MMSYSERR_ALLOCATED:
			AfxMessageBox("The device is already in use, free it and try again", MB_OK+MB_ICONHAND);
			break;
		case MMSYSERR_NOMEM:
			AfxMessageBox("Could not allocate memory for the device", MB_OK+MB_ICONHAND);
			break;
		case MMSYSERR_INVALPARAM:
			AfxMessageBox("Invalid pointer!", MB_OK+MB_ICONHAND);
			break;
		}

	}

		if( res!=MMSYSERR_NOERROR )
			return 0;

		progChange(0xC0+pDoc->m_Channel[Wp->voicenum], (BYTE)pDoc->m_Instrument[Wp->voicenum]);


	if (start)
	{
		counter =0;
		count1[Wp->voicenum]=0;
		count = pDoc->dStartCounter;
		dracula = int(pDoc->m_NoteValue[Wp->voicenum]);


			for(int j = 0; j<count+(pDoc->m_StartNum[Wp->voicenum]*dracula); j++)
			{
				if(!((pDoc->m_StartNum[Wp->voicenum]*dracula+j)%dracula))
				{


				test = (((pDoc->m_StartNum[Wp->voicenum]*dracula+j)/dracula)*Wp->m_multi);
				result = Morse_Thue(Wp->voicenum, (pDoc->m_StartNum[Wp->voicenum]*dracula+j)/dracula, test,
									pDoc->m_pScale[Wp->voicenum], 
									pDoc->m_NumOcts[Wp->voicenum], 
									Wp->m_base, 
									pDoc->m_StartNum[Wp->voicenum],
									pDoc->m_Note[Wp->voicenum], 
									pDoc->m_Modulates[Wp->voicenum],
									pDoc->m_ModulRandom[Wp->voicenum], 
									pDoc->m_ModulNum[Wp->voicenum],
									pDoc->m_Inverted[Wp->voicenum],
									0,
									0,
									0,
									0,
									0,
									0,
									0,
									0,
									0,
									0,
									0,
									0,
									0,
									0,
									0
									
					);
				}
			}



		if (::IsWindow(Wp->m_pGraph->m_hWnd))
				Wp->m_pGraph->m_memDC.MoveTo(0,120);
	}

	while (running)
	{
			if((pDoc->m_StartNum[Wp->voicenum]*dracula+count)>=0)
			{
			if(!((pDoc->m_StartNum[Wp->voicenum]*dracula+count)%dracula))
			{
				test = (((pDoc->m_StartNum[Wp->voicenum]*dracula+count)/dracula)*Wp->m_multi);
				result = Morse_Thue(Wp->voicenum, (pDoc->m_StartNum[Wp->voicenum]*dracula+count)/dracula, test,
									pDoc->m_pScale[Wp->voicenum], 
									pDoc->m_NumOcts[Wp->voicenum], 
									Wp->m_base, 
									pDoc->m_StartNum[Wp->voicenum],
									pDoc->m_Note[Wp->voicenum], 
									pDoc->m_Modulates[Wp->voicenum],
									pDoc->m_ModulRandom[Wp->voicenum], 
									pDoc->m_ModulNum[Wp->voicenum],
									pDoc->m_Inverted[Wp->voicenum],
									0,
									0,
									0,
									0,
									0,
									0,
									0,
									0,
									0,
									0,
									0,
									0,
									0,
									0,
									0
									
					);

				if (result < 0)
					result =0;
				if (result>127)
					result = 127;

				note = result;

				result -= pDoc->m_Note[Wp->voicenum];

				COLORREF color = RGB(255,128,64);

				if (::IsWindow(Wp->m_pGraph->m_hWnd))
					Wp->m_pGraph->m_memDC.LineTo(counter, 120-(result*2));


				if ((note!=lastnote)||pDoc->m_mode[Wp->voicenum]==0)
				{
					if (pDoc->m_Channel[Wp->voicenum] == PercussionChannel)
						noteOff(0x80+pDoc->m_Channel[Wp->voicenum], (BYTE)pDoc->m_Percussion[Wp->voicenum]+35, (BYTE)0);
					else
						noteOff(0x80+pDoc->m_Channel[Wp->voicenum], (BYTE)lastnote, (BYTE)0);

					if (pDoc->m_Channel[Wp->voicenum] == PercussionChannel)
						noteOn(0x90+pDoc->m_Channel[Wp->voicenum], (BYTE)pDoc->m_Percussion[Wp->voicenum]+35, (BYTE)(pDoc->m_Dynamic[Wp->voicenum]/*pDoc->m_IsActive[i]*/));
					else
						noteOn(0x90+pDoc->m_Channel[Wp->voicenum], (BYTE)note, (BYTE)(pDoc->m_Dynamic[Wp->voicenum]/*pDoc->m_IsActive[i]*/));

					lastnote=note;

				}




				if (::IsWindow(Wp->m_pGraph->m_hWnd))
					Wp->m_pGraph->RedrawWindow(NULL,NULL,RDW_INVALIDATE|RDW_UPDATENOW|RDW_NOERASE);	
				counter += 3;
				Sleep(50);
				if (counter>599)
				{
					if (::IsWindow(Wp->m_pGraph->m_hWnd))
						Wp->m_pGraph->m_memDC.FillSolidRect(0, 0, 600, 240, RGB(0,0,0));
					counter =0;
					if (::IsWindow(Wp->m_pGraph->m_hWnd))
						Wp->m_pGraph->m_memDC.MoveTo(0,120-(result*2));
				}
			}
			}
			count++;

	}


	start = FALSE;

	midiOutReset(midiOut);
	midiOutClose(midiOut);


	return 0;



}

BOOL CMorseThueDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	SetWindowText(title);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
