
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


// NoteValsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FractMus.h"
#include "NoteValsDlg.h"
#include "P1RangeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNoteValsDlg dialog


CNoteValsDlg::CNoteValsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNoteValsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNoteValsDlg)
	m_8 = TRUE;
	m_dotted8 = TRUE;
	m_half = TRUE;
	m_dottedhalf = TRUE;
	m_other = FALSE;
	m_quarter = TRUE;
	m_dottedquarter = TRUE;
	m_16 = TRUE;
	m_dotted16 = TRUE;
	m_32 = TRUE;
	m_whole = TRUE;
	m_dottedwhole = TRUE;
	//}}AFX_DATA_INIT

	numchoices = 11;
	othermin = 1;
	othermax = 48;

	OtherRange.title = "Note Value Range";
	OtherRange.m_from = othermin;
	OtherRange.m_to = othermax;
	OtherRange.m_IsParam1 = FALSE;
	OtherRange.m_IsParam2 = FALSE;
	OtherRange.m_IsNoteVal = TRUE;
		


}


void CNoteValsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNoteValsDlg)
	DDX_Check(pDX, IDC_EIGHTH_CHK, m_8);
	DDX_Check(pDX, IDC_EIGHTHDOTTED_CHK, m_dotted8);
	DDX_Check(pDX, IDC_HALF_CHK, m_half);
	DDX_Check(pDX, IDC_HALFDOTTED_CHK, m_dottedhalf);
	DDX_Check(pDX, IDC_OTHER_CHK, m_other);
	DDX_Check(pDX, IDC_QUARTER_CHK, m_quarter);
	DDX_Check(pDX, IDC_QUARTERDOTTED_CHK, m_dottedquarter);
	DDX_Check(pDX, IDC_SIXTEENTH_CHK, m_16);
	DDX_Check(pDX, IDC_SIXTEENTHDOTTED_CHK, m_dotted16);
	DDX_Check(pDX, IDC_THIRTYSEC_CHK, m_32);
	DDX_Check(pDX, IDC_WHOLE_CHK, m_whole);
	DDX_Check(pDX, IDC_WHOLEDOTTED_CHK, m_dottedwhole);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CNoteValsDlg, CDialog)
	//{{AFX_MSG_MAP(CNoteValsDlg)
	ON_BN_CLICKED(IDC_EIGHTH_CHK, OnEighthChk)
	ON_BN_CLICKED(IDC_EIGHTHDOTTED_CHK, OnEighthdottedChk)
	ON_BN_CLICKED(IDC_HALF_CHK, OnHalfChk)
	ON_BN_CLICKED(IDC_HALFDOTTED_CHK, OnHalfdottedChk)
	ON_BN_CLICKED(IDC_OTHER_CHK, OnOtherChk)
	ON_BN_CLICKED(IDC_QUARTER_CHK, OnQuarterChk)
	ON_BN_CLICKED(IDC_QUARTERDOTTED_CHK, OnQuarterdottedChk)
	ON_BN_CLICKED(IDC_SIXTEENTH_CHK, OnSixteenthChk)
	ON_BN_CLICKED(IDC_SIXTEENTHDOTTED_CHK, OnSixteenthdottedChk)
	ON_BN_CLICKED(IDC_THIRTYSEC_CHK, OnThirtysecChk)
	ON_BN_CLICKED(IDC_WHOLE_CHK, OnWholeChk)
	ON_BN_CLICKED(IDC_WHOLEDOTTED_CHK, OnWholedottedChk)
	ON_BN_CLICKED(IDC_ALL, OnAll)
	ON_BN_CLICKED(IDC_NONE, OnNone)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNoteValsDlg message handlers

void CNoteValsDlg::OnCancel() 
{
}

void CNoteValsDlg::OnEighthChk() 
{
	UpdateData();
	
	numchoices = m_8 ? ++numchoices : --numchoices;
}

void CNoteValsDlg::OnEighthdottedChk() 
{
	UpdateData();
	
	numchoices = m_dotted8 ? ++numchoices : --numchoices;
	
}

void CNoteValsDlg::OnHalfChk() 
{
	UpdateData();
	
	numchoices = m_half ? ++numchoices : --numchoices;
	
}

void CNoteValsDlg::OnHalfdottedChk() 
{
	UpdateData();
	
	numchoices = m_dottedhalf ? ++numchoices : --numchoices;
	
}

void CNoteValsDlg::OnOtherChk() 
{
	UpdateData();
	
	numchoices = m_other ? ++numchoices : --numchoices;

	if (m_other)
	{
		OtherRange.DoModal();
		othermin = OtherRange.m_from;
		othermax = OtherRange.m_to;
	}
	
}

void CNoteValsDlg::OnQuarterChk() 
{
	UpdateData();
	
	numchoices = m_quarter ? ++numchoices : --numchoices;
	
}

void CNoteValsDlg::OnQuarterdottedChk() 
{
	UpdateData();
	
	numchoices = m_dottedquarter ? ++numchoices : --numchoices;
	
}

void CNoteValsDlg::OnSixteenthChk() 
{
	UpdateData();
	
	numchoices = m_16 ? ++numchoices : --numchoices;
	
}

void CNoteValsDlg::OnSixteenthdottedChk() 
{
	UpdateData();
	
	numchoices = m_dotted16 ? ++numchoices : --numchoices;
	
}

void CNoteValsDlg::OnThirtysecChk() 
{
	UpdateData();
	
	numchoices = m_32 ? ++numchoices : --numchoices;
	
}

void CNoteValsDlg::OnWholeChk() 
{
	UpdateData();
	
	numchoices = m_whole ? ++numchoices : --numchoices;
	
}

void CNoteValsDlg::OnWholedottedChk() 
{
	UpdateData();
	
	numchoices = m_dottedwhole ? ++numchoices : --numchoices;
	
}

void CNoteValsDlg::OnOK() 
{

	if (numchoices<1)
	{
		MessageBox("Please choose at least one value","Error", MB_OK+MB_ICONEXCLAMATION);
		return;
	}

	CDialog::OnOK();
}

void CNoteValsDlg::OnAll() 
{
	m_8 = TRUE;
	m_dotted8 = TRUE;
	m_half = TRUE;
	m_dottedhalf = TRUE;
	m_other = TRUE;
	m_quarter = TRUE;
	m_dottedquarter = TRUE;
	m_16 = TRUE;
	m_dotted16 = TRUE;
	m_32 = TRUE;
	m_whole = TRUE;
	m_dottedwhole = TRUE;

	UpdateData(FALSE);

	numchoices = 12;

	
}

void CNoteValsDlg::OnNone() 
{
	m_8 = FALSE;
	m_dotted8 = FALSE;
	m_half = FALSE;
	m_dottedhalf = FALSE;
	m_other = FALSE;
	m_quarter = FALSE;
	m_dottedquarter = FALSE;
	m_16 = FALSE;
	m_dotted16 = FALSE;
	m_32 = FALSE;
	m_whole = FALSE;
	m_dottedwhole = FALSE;

	UpdateData(FALSE);

	numchoices = 0;

	
}
