
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


// OctavesDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FractMus.h"
#include "OctavesDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COctavesDlg dialog


COctavesDlg::COctavesDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COctavesDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COctavesDlg)
	m_four = TRUE;
	m_one = TRUE;
	m_three = TRUE;
	m_two = TRUE;
	//}}AFX_DATA_INIT

	numchoices = 4;
}


void COctavesDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COctavesDlg)
	DDX_Check(pDX, IDC_FOUR_CHK, m_four);
	DDX_Check(pDX, IDC_ONE_CHK, m_one);
	DDX_Check(pDX, IDC_THREE_CHK, m_three);
	DDX_Check(pDX, IDC_TWO_CHK, m_two);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COctavesDlg, CDialog)
	//{{AFX_MSG_MAP(COctavesDlg)
	ON_BN_CLICKED(IDC_FOUR_CHK, OnFourChk)
	ON_BN_CLICKED(IDC_ONE_CHK, OnOneChk)
	ON_BN_CLICKED(IDC_THREE_CHK, OnThreeChk)
	ON_BN_CLICKED(IDC_TWO_CHK, OnTwoChk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COctavesDlg message handlers

void COctavesDlg::OnCancel() 
{
}

void COctavesDlg::OnOK() 
{
	if (numchoices<1)
	{
		MessageBox("Please make at least one selection", "Error", MB_OK+MB_ICONEXCLAMATION);
		return;
	}
	
	CDialog::OnOK();
}

void COctavesDlg::OnFourChk() 
{
	UpdateData(TRUE);
	
	numchoices  = m_four? ++numchoices : --numchoices;
}

void COctavesDlg::OnOneChk() 
{
	UpdateData(TRUE);
	
	numchoices  = m_one? ++numchoices : --numchoices;
	
}

void COctavesDlg::OnThreeChk() 
{
	UpdateData(TRUE);
	
	numchoices  = m_three? ++numchoices : --numchoices;
	
}

void COctavesDlg::OnTwoChk() 
{
	UpdateData(TRUE);
	
	numchoices  = m_two? ++numchoices : --numchoices;
	
}
