
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


// PercussionInstrumentDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FractMus.h"
#include "PercussionInstrumentDlg.h"
#include "RandDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPercussionInstrumentDlg dialog


CPercussionInstrumentDlg::CPercussionInstrumentDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPercussionInstrumentDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPercussionInstrumentDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CPercussionInstrumentDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPercussionInstrumentDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPercussionInstrumentDlg, CDialog)
	//{{AFX_MSG_MAP(CPercussionInstrumentDlg)
	ON_BN_CLICKED(IDC_ALL, OnAll)
	ON_BN_CLICKED(IDC_NONE, OnNone)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPercussionInstrumentDlg message handlers

void CPercussionInstrumentDlg::OnAll() 
{
	CListBox* pList = (CListBox*)GetDlgItem(IDC_INSTRUMENT_LIST);

	pList->SelItemRange(TRUE, 0, 46);
	
}

void CPercussionInstrumentDlg::OnNone() 
{
	CListBox* pList = (CListBox*)GetDlgItem(IDC_INSTRUMENT_LIST);

	pList->SelItemRange(FALSE, 0, 46);
	
}

void CPercussionInstrumentDlg::OnOK() 
{
	CListBox* pList = (CListBox*)GetDlgItem(IDC_INSTRUMENT_LIST);

	int numchoices = pList->GetSelCount();

	if(numchoices<1)
	{
		MessageBox("Please select at least one instrument","Error",MB_OK+MB_ICONEXCLAMATION);
		return;
	}

	for (int i =0; i<47; i++)
		IsSelected[i] = FALSE;


	int* selectedItems = new int[numchoices];

	pList->GetSelItems(numchoices, selectedItems);

	for(i =0; i<numchoices; i++)
		IsSelected[ selectedItems[i] ] = TRUE;

	delete selectedItems;

    selectedItems = NULL;
	
	CDialog::OnOK();
}

BOOL CPercussionInstrumentDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CListBox* pList = (CListBox*)GetDlgItem(IDC_INSTRUMENT_LIST);


		pList->AddString("Base Drum 1");
		pList->AddString("Base Drum 2");
		pList->AddString("Side Stick");
		pList->AddString("Acoustic Snare");
		pList->AddString("Hand Clap");
		pList->AddString("Electric Snare");
		pList->AddString("Low Floor Tom");
		pList->AddString("Closed Hi-Hat");
		pList->AddString("Hi Floor Tom");
		pList->AddString("Pedal Hi-Hat");
		pList->AddString("Low Tom");
		pList->AddString("Open Hi-Hat");
		pList->AddString("Low-Mid Tom");
		pList->AddString("High-Mid Tom");
		pList->AddString("Crash Cymbal 1");
		pList->AddString("High Tom");
		pList->AddString("Ride Cymbal 1");
		pList->AddString("Chinese Cymbal");
		pList->AddString("Ride Bell");
		pList->AddString("Tambourine");
		pList->AddString("Splash Cymbal");
		pList->AddString("Cowbell");
		pList->AddString("Crash Cymbal 2");
		pList->AddString("Vibraslap");
		pList->AddString("Ride Cymbal 2");
		pList->AddString("High Bongo");
		pList->AddString("Low Bongo");
		pList->AddString("Muted High Conga");
		pList->AddString("Open High Conga");
		pList->AddString("Low Conga");
		pList->AddString("High Timbale");
		pList->AddString("Low Timbale");
		pList->AddString("High Agogo");
		pList->AddString("Low Agogo");
		pList->AddString("Cabase");
		pList->AddString("Maracas");
		pList->AddString("Short Whistle");
		pList->AddString("Long Whistle");
		pList->AddString("Short Guiro");
		pList->AddString("Long Guiro");
		pList->AddString("Claves");
		pList->AddString("High Wood Block");
		pList->AddString("Low Wood Block");
		pList->AddString("Muted Cuica");
		pList->AddString("Open Cuica");
		pList->AddString("Muted Triangle");
		pList->AddString("Open Triangle");

	for (int i =0; i<47; i++)
		IsSelected[i] = FALSE;

	for (i =0; i<47; i++)
		IsSelected[i] = pRand->PercussionInstrument[i];

	for (i =0; i<47; i++)
		if (IsSelected[i])
			pList->SetSel(i);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPercussionInstrumentDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}
