
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


#ifndef _RAND_DLG_H
#define _RAND_DLG_H

// RandDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CRandDlg dialog

#include "AlgoDlg.h"
#include "NoteValsDlg.h"
#include "ScaleDlg.h"
#include "OctavesDlg.h"
#include "DynamicsDlg.h"
#include "RandomizerParametersDlg.h"



#include "defs.h"


class CFractMusView;

class CRandDlg : public CDialog
{
// Construction
public:
	CRandDlg(CWnd* pParent = NULL);   // standard constructor
	~CRandDlg();

	long m_P1From;
	long m_P1To;
	long m_P2From;
	long m_P2To;

	BOOL Instrument[128];
	BOOL Notes[97];
	BOOL Scales[15];
	BOOL m_Composition;
	BOOL PercussionInstrument[47];


// Dialog Data
	//{{AFX_DATA(CRandDlg)
	enum { IDD = IDD_RAND_CLG };
	BOOL	m_algorithm;
	BOOL	m_dynamic;
	BOOL	m_instrument;
	BOOL	m_inverted;
	BOOL	m_mode;
	BOOL	m_modulate;
	BOOL	m_note;
	BOOL	m_noteval;
	BOOL	m_octaves;
	BOOL	m_pan;
	BOOL	m_param1;
	BOOL	m_param2;
	BOOL	m_scale;
	BOOL	m_tempo;
	UINT	m_numberOfEvents;
	UINT	m_counterMin;
	UINT	m_counterMax;
	BOOL	m_allowSilence;
	BOOL	m_coeff;
	BOOL	m_onoff;
	BOOL	m_userscl;
	BOOL	m_onlyusrscl;
	BOOL	m_matchscl;
	int		m_minOnVoices;
	int		m_CountersChoice;
	int		m_CountersRandomMin;
	int		m_CountersRandomMax;
	BOOL	m_sequential;
	BOOL	m_AllActiveVoices;
	BOOL	m_percussion;
	int		m_exact;
	int		m_atmost;
	int		m_exactORatmost;
	//}}AFX_DATA
	BOOL	m_VoiceOn[MAXVOICES];
	UINT	m_VoiceID[MAXVOICES];
	CFractMusView* m_Parent;

	BOOL* IsSelected;


	CAlgoDlg Algorithms;
	CNoteValsDlg NoteValues;
	CScaleDlg ScalesChoice;
	COctavesDlg Octaves;
	CDynamicsDlg Dynamics;
	CRandomizerParametersDlg RandomizerParameters;


	


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRandDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:


	// Generated message map functions
	//{{AFX_MSG(CRandDlg)
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	afx_msg void OnRand();
	afx_msg void OnParam1Chk();
	afx_msg void OnParam2Chk();
	afx_msg void OnSelectall();
	afx_msg void OnSelectnone();
	virtual void OnCancel();
	afx_msg void OnKillfocusCounterMax();
	afx_msg void OnKillfocusCounterMin();
	afx_msg void OnKillfocusEventsNumber();
	afx_msg void OnCreateRandomComposition();
	afx_msg void OnNoteChk();
	afx_msg void OnOnoffChk();
	afx_msg void OnScaleChk();
	afx_msg void OnUserscl();
	afx_msg void OnInvertedChk();
	afx_msg void OnNosilence();
	afx_msg void OnAlgorithmChk();
	afx_msg void OnNotevalChk();
	afx_msg void OnInstrumentChk();
	afx_msg void OnOctavesChk();
	afx_msg void OnDynamicChk();
	afx_msg void OnRandomizeselectedevents();
	afx_msg void OnSelectallevents();
	afx_msg void OnSelectnoneevents();
	afx_msg void OnAllactivevoicesChk();
	afx_msg void OnPercussionChk();
	afx_msg void OnPresets();
	afx_msg void OnAtmostRd();
	afx_msg void OnExactRd();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


#endif
