
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


// RandomGraph.cpp : implementation file
//

#include "stdafx.h"
#include "FractMus.h"
#include "RandomGraph.h"
#include "RandomAlgorithmDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern running;
extern start;



/////////////////////////////////////////////////////////////////////////////
// CRandomGraph

IMPLEMENT_DYNCREATE(CRandomGraph, CFrameWnd)

CRandomGraph::CRandomGraph()
{
}

CRandomGraph::~CRandomGraph()
{
}


BEGIN_MESSAGE_MAP(CRandomGraph, CFrameWnd)
	//{{AFX_MSG_MAP(CRandomGraph)
	ON_WM_CLOSE()
	ON_WM_DESTROY()
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRandomGraph message handlers

void CRandomGraph::PostNcDestroy() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	delete this;
}

void CRandomGraph::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	
	running = FALSE;
	Sleep(100);
	CFrameWnd::OnClose();
}

void CRandomGraph::OnDestroy() 
{
	running = FALSE;
	start = TRUE;
	Sleep(100);
	CFrameWnd::OnDestroy();
	
	((CRandomAlgorithmDlg*)m_pParent)->m_pGraph = NULL;

	if (::IsWindow(m_pParent->m_hWnd))
	{
		((CRandomAlgorithmDlg*)m_pParent)->GetDlgItem(IDC_VISUALIZE)->SetWindowText("Visualize");	
		((CRandomAlgorithmDlg*)m_pParent)->GetDlgItem(IDOK)->EnableWindow(TRUE);
		((CRandomAlgorithmDlg*)m_pParent)->GetDlgItem(IDCANCEL)->EnableWindow(TRUE);
	}
	
	// TODO: Add your message handler code here
	
}

void CRandomGraph::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	if ( ::IsWindow(((CRandomAlgorithmDlg*)m_pParent)->m_pGraph->m_hWnd) )
		dc.BitBlt(0,0,600,240,&m_memDC,0,0,SRCCOPY);
}


BOOL CRandomGraph::Create(	LPCTSTR lpszClassName, 
						LPCTSTR lpszWindowName, 
						DWORD dwStyle, 
						const RECT& rect, 
						CWnd* pParentWnd, 
						LPCTSTR lpszMenuName,
						DWORD dwExStyle, 
						CCreateContext* pContext)
{

	return CFrameWnd::Create(	lpszClassName,lpszWindowName,
								dwStyle, rect, pParentWnd,
								lpszMenuName, dwExStyle,
								pContext
							);
}
