
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


// RandomizerParametersDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FractMus.h"
#include "FractMusView.h"
#include "FractMusDoc.h"
#include "RandomizerParametersDlg.h"
#include "RandDlg.h"
#include "defs.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern int Tempo;
extern const char* InstrumentNames[128];
extern const char* PercussionNames[47];
extern int PercussionChannel;

/////////////////////////////////////////////////////////////////////////////
// CRandomizerParametersDlg dialog



CRandomizerParametersDlg::CRandomizerParametersDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRandomizerParametersDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRandomizerParametersDlg)
	m_newpresetname = _T("");
	m_includesettings = FALSE;
	//}}AFX_DATA_INIT

	for(int k = 0; k<50; k++)
	{

		Preset[k].Name = "";

		Preset[k].m_P1From = 2;
		Preset[k].m_P1To = 100;
		Preset[k].m_P2From = 1;
		Preset[k].m_P2To = 100;

		for (int i = 0; i<128; i++)
			Preset[k].Instrument[i] = TRUE;

		for (i = 0; i<97; i++)
			Preset[k].Notes[i] = TRUE;

		for (i = 0; i<16; i++)
			Preset[k].Scales[i] = TRUE;

		for (i = 0; i<47; i++)
			Preset[k].PercussionInstrument[i] = TRUE;

		for (i = 0; i<12; i++)
			Preset[k].Algorithms[i] = TRUE;

		Preset[k].AlgorithmsNumchoices = 12;

		
		for (i = 0; i<4; i++)
			Preset[k].Octaves[i] = TRUE;

		Preset[k].OctavesNumchoices = 4;

		for (i = 0; i<12; i++)
			Preset[k].NoteValues[i] = TRUE;

		Preset[k].NoteValuesNumchoices = 12;

		Preset[k].NoteValuesOtherMin = 1;
		Preset[k].NoteValuesOtherMax = 48;


		for (i = 0; i<6; i++)
			Preset[k].Dynamics[i] = TRUE;

		Preset[k].DynamicsNumchoices = 6;

		Preset[k].m_algorithm = TRUE;
		Preset[k].m_dynamic = TRUE;
		Preset[k].m_instrument = TRUE;
		Preset[k].m_inverted = TRUE;
		Preset[k].m_mode = TRUE;
		Preset[k].m_modulate = TRUE;
		Preset[k].m_note = TRUE;
		Preset[k].m_noteval = TRUE;
		Preset[k].m_octaves = TRUE;
		Preset[k].m_pan = TRUE;
		Preset[k].m_param1 = TRUE;
		Preset[k].m_param2 = TRUE;
		Preset[k].m_scale = TRUE;
		Preset[k].m_tempo = TRUE;
		Preset[k].m_numberOfEvents = TRUE;
		Preset[k].m_counterMin = TRUE;
		Preset[k].m_counterMax = TRUE;
		Preset[k].m_allowSilence = TRUE;
		Preset[k].m_coeff = TRUE;
		Preset[k].m_onoff = TRUE;
		Preset[k].m_userscl = TRUE;
		Preset[k].m_onlyusrscl = FALSE;
		Preset[k].m_matchscl = TRUE;
		Preset[k].m_minOnVoices = TRUE;
		Preset[k].m_CountersChoice = TRUE;
		Preset[k].m_CountersRandomMin = TRUE;
		Preset[k].m_CountersRandomMax = TRUE;
		Preset[k].m_sequential = TRUE;
		Preset[k].m_percussion = TRUE;

	    Preset[k].m_exact = 6;
	    Preset[k].m_atmost = 12;
	    Preset[k].m_exactORatmost = 1;

		for(i = VOICE1; i<MAXVOICES; i++)
			Preset[k].m_VoiceOn[i] = FALSE;


		Preset[k].m_includesettings = FALSE;

		Preset[k].m_TempoMarking = 96;
		Preset[k].m_TimeSigNum = 4;
		Preset[k].m_TimeSigDen = 4;

		for(i = VOICE1; i<MAXVOICES; i++)
			Preset[k].m_IsActive[i] = FALSE;


		for (i = VOICE1; i<MAXVOICES; i++)
		{
			Preset[k].m_Modulates[i] = FALSE;
			Preset[k].m_ModulRandom[i] = FALSE;
			Preset[k].m_ModulNum[i] = 5;
			Preset[k].m_Base[i] = 2;
			Preset[k].m_Multi[i] = 1;
			Preset[k].m_StartNum[i] = 0;
			Preset[k].m_ScaleID[i] = MAJOR;
			Preset[k].m_NumOcts[i] = 1;
			Preset[k].m_NumOctsID[i] = ONE_OCT;
			Preset[k].m_Note[i] = 60;
			Preset[k].m_NoteValue[i] = 8.0f;
			Preset[k].m_NoteValueID[i] = QUARTER;
			Preset[k].m_Instrument[i] = 0;
			Preset[k].m_Channel[i] = i;
			Preset[k].m_Mode[i] = 0;
			Preset[k].m_Inverted[i] = FALSE;
			Preset[k].m_Dynamic[i] = MEZZO_FORTE;
			Preset[k].m_DynChoice[i] = MF;
			Preset[k].m_LogMapVar[i] = 3.9f;
			Preset[k].m_FNoiseVar[i] = 0.5f;
			Preset[k].m_HenonA[i] = 1.7f;
			Preset[k].m_HenonB[i] = 0.4f;
			Preset[k].m_HopalongVar[i] = 3.14159265359f;
			Preset[k].m_MartinVar[i] = 3.14159265359f;
			Preset[k].m_GingerX[i] = -0.1f;
			Preset[k].m_GingerY[i] = 0.0f;
			Preset[k].m_LorentzVar[i] = 0.8f;
			Preset[k].m_Pan[i] = 0;
			Preset[k].m_EarthWormVar[i] = 2;
			Preset[k].m_EarthWormMulti[i] = 3;
			Preset[k].m_EarthWormTruncator[i] = 6;
			Preset[k].m_RandomMin[i] = 0.0;
			Preset[k].m_RandomMax[i] = 1.0;
			Preset[k].m_WolframRule[i] = 30;
			Preset[k].m_WolframInit[i] = 1;
			Preset[k].m_WolframSize[i] = 128;
			Preset[k].m_Hailstone[i] = 27;
			Preset[k].m_MatchScale[i] = FALSE;
			Preset[k].m_Percussion[i] = 0;


			Preset[k].AlgorithmNum[i] = MORSE_THUE;

		}
	}


		for(k = 0; k<50; k++)
		{
			for(int i = VOICE1; i<MAXVOICES; i++)
			{

					Preset[k].m_pScale[i] = NULL;
					Preset[k].m_pUserScale[i] = NULL;
			}
		}

		for(k = 0; k<50; k++)
		{
			for(int i = VOICE1; i<MAXVOICES; i++)
			{
				Preset[k].m_pScale[i] = new int[Major[0] + 1];
				Preset[k].m_pUserScale[i] = new int[Major[0] + 1];

				for(int j=0; j<=Major[0]; j++)
				{
					Preset[k].m_pScale[i][j] = Major[j];
					Preset[k].m_pUserScale[i][j] = Major[j];
				}
			}
		}



}


void CRandomizerParametersDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRandomizerParametersDlg)
	DDX_Text(pDX, IDC_NEWPRESETNAME_ED, m_newpresetname);
	DDV_MaxChars(pDX, m_newpresetname, 128);
	DDX_Check(pDX, IDC_INCLUDEMAINSETTINGS, m_includesettings);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRandomizerParametersDlg, CDialog)
	//{{AFX_MSG_MAP(CRandomizerParametersDlg)
	ON_BN_CLICKED(IDC_LOAD, OnLoad)
	ON_LBN_DBLCLK(IDC_PARAMETERS_LIST, OnDblclkParametersList)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_REMOVE, OnRemove)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	ON_BN_CLICKED(IDC_REPLACE, OnReplace)
	ON_LBN_SELCHANGE(IDC_PARAMETERS_LIST, OnSelchangeParametersList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRandomizerParametersDlg message handlers

void CRandomizerParametersDlg::OnLoad() 
{
	char FileName[500];
	char FileTitle[100];

	OPENFILENAME ofn;
	memset(&ofn, 0, sizeof(ofn));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = NULL;
	ofn.hInstance = NULL;

	ofn.lpstrFilter = 
		TEXT("Randomizer Presets *.rps\0*.rps\0\0");

	ofn.lpstrCustomFilter = NULL;
	ofn.nMaxCustFilter = 0;
	ofn.nFilterIndex = 1;
	ofn.lpstrFile = FileName;
	ofn.nMaxFile = 500;
	ofn.lpstrFileTitle = FileTitle;
	ofn.nMaxFileTitle = 99;
	ofn.lpstrInitialDir = NULL;
	ofn.lpstrTitle="Load Randomizer Presets";
	ofn.Flags = OFN_FILEMUSTEXIST|OFN_LONGNAMES|OFN_PATHMUSTEXIST;
	ofn.lpstrDefExt = "rps";
	ofn.lCustData = NULL;
	ofn.lpfnHook = NULL;
	ofn.lpTemplateName = NULL;

	FileName[0] = '\0';

	if(!GetOpenFileName(&ofn))
		return;

	if(FileName[0] == '\0')
		return;


	int numpresets = 0;



	CFile file;

	file.Open(FileName, CFile::modeRead);

	union
	{
		int dataint;
		BYTE databyte[sizeof(int)];
	} num;


	LPSTR h = new char[8];

	file.Read((char*)h, 7);

	h[7] = '\0';

	LPSTR s = new char[8];

	s[0]= 'R'; s[1]='P';  s[2]='S';  s[3]='F'; s[4]='i';  s[5]='l';  s[6]='e';  s[7]='\0';

	CString s1 = (char*)h;
	
	CString s2 = (char*)s;

	if(s1!=s2)
	{
		MessageBox("This is not a valid *.rps file","FractMus", MB_OK+MB_ICONEXCLAMATION);
		return;
	}

	for(int k = 0; k<50; k++)
		Preset[k].Name = "";

	file.Read(num.databyte, sizeof(int));

	numpresets = num.dataint;



	for (k=0; k<numpresets; k++)
	{

			union
			{
				UINT bytesread;
				BYTE data[sizeof(BYTE)*sizeof(UINT)];
			} databytes;

			file.Read((BYTE*)databytes.data, sizeof(BYTE)*sizeof(UINT));

			LPSTR str = new char[databytes.bytesread + 1];

			file.Read((char*)str, databytes.bytesread);

			str[databytes.bytesread] = '\0';

			Preset[k].Name = (char*)str;


			union 
			{
				int data1;
				BYTE data2[sizeof(int)];
			} intvalue;

			union
			{
				BOOL data1;
				BYTE data2[sizeof(BOOL)];
			} boolvalue;

			union
			{
				long data1;
				BYTE data2[sizeof(long)];
			} longvalue;

			union
			{
				float data1;
				BYTE data2[sizeof(float)];
			} floatvalue;

			union
			{
				short data1;
				BYTE data2[sizeof(short)];
			} shortvalue;

			union
			{
				unsigned data1;
				BYTE data2[sizeof(unsigned)];
			} unsignedvalue;

			union
			{
				unsigned long data1;
				BYTE data2[sizeof(unsigned long)];
			} unsignedlongvalue;

			union
			{
				double data1;
				BYTE data2[sizeof(double)];
			} doublevalue;

			union
			{
				BYTE data1;
				BYTE data2[sizeof(BYTE)];
			} bytevalue;

			//ar << Preset[k].m_P1From;
			file.Read(longvalue.data2, sizeof(long)*sizeof(BYTE));
			Preset[k].m_P1From = longvalue.data1;

			//ar << Preset[k].m_P1To;
			file.Read(longvalue.data2, sizeof(long)*sizeof(BYTE));
			Preset[k].m_P1To = longvalue.data1;

			//ar << Preset[k].m_P2From;
			file.Read(longvalue.data2, sizeof(long)*sizeof(BYTE));
			Preset[k].m_P2From = longvalue.data1;

			//ar << Preset[k].m_P2To;
			file.Read(longvalue.data2, sizeof(long)*sizeof(BYTE));
			Preset[k].m_P2To = longvalue.data1;


			for (int i = 0; i<128; i++)
			{
				//ar << Preset[k].Instrument[i];
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				Preset[k].Instrument[i] = boolvalue.data1;

			}

			for (i = 0; i<97; i++)
				//ar << Preset[k].Notes[i];
			{
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				Preset[k].Notes[i] = boolvalue.data1;

			}

			for (i = 0; i<16; i++)
				//ar << Preset[k].Scales[i];
			{
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				Preset[k].Scales[i] = boolvalue.data1;

			}

			for (i = 0; i<47; i++)
				//ar << Preset[k].PercussionInstrument[i];
			{
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				Preset[k].PercussionInstrument[i] = boolvalue.data1;

			}

			for (i = 0; i<12; i++)
				//ar << Preset[k].Algorithms[i];
			{
				//ar << Preset[k].Instrument[i];
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				Preset[k].Algorithms[i] = boolvalue.data1;

			}

			//ar << Preset[k].AlgorithmsNumchoices;

			file.Read(intvalue.data2, sizeof(int)*sizeof(BYTE));
			Preset[k].AlgorithmsNumchoices = intvalue.data1;

			
			for (i = 0; i<4; i++)
				//ar << Preset[k].Octaves[i];
			{
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				Preset[k].Octaves[i] = boolvalue.data1;

			}

			//ar << Preset[k].OctavesNumchoices;
			file.Read(intvalue.data2, sizeof(int)*sizeof(BYTE));
			Preset[k].OctavesNumchoices = intvalue.data1;

			for (i = 0; i<12; i++)
				//ar << Preset[k].NoteValues[i];
			{
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				Preset[k].NoteValues[i] = boolvalue.data1;

			}

			//ar << Preset[k].NoteValuesNumchoices;
			file.Read(intvalue.data2, sizeof(int)*sizeof(BYTE));
			Preset[k].NoteValuesNumchoices = intvalue.data1;

			//ar << Preset[k].NoteValuesOtherMin;
			file.Read(intvalue.data2, sizeof(int)*sizeof(BYTE));
			Preset[k].NoteValuesOtherMin = intvalue.data1;

			//ar << Preset[k].NoteValuesOtherMax;
			file.Read(intvalue.data2, sizeof(int)*sizeof(BYTE));
			Preset[k].NoteValuesOtherMax = intvalue.data1;

			for (i = 0; i<6; i++)
				//ar << Preset[k].Dynamics[i];
			{
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				Preset[k].Dynamics[i] = boolvalue.data1;

			}

			//ar << Preset[k].DynamicsNumchoices;
				file.Read(intvalue.data2, sizeof(int)*sizeof(BYTE));
				Preset[k].DynamicsNumchoices = intvalue.data1;

			//ar << Preset[k].m_algorithm;
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				Preset[k].m_algorithm = boolvalue.data1;

			//ar << Preset[k].m_dynamic ;
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				Preset[k].m_dynamic = boolvalue.data1;

			//ar << Preset[k].m_instrument;
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				Preset[k].m_instrument = boolvalue.data1;

			//ar << Preset[k].m_inverted;
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				Preset[k].m_inverted = boolvalue.data1;

			//ar << Preset[k].m_mode;
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				Preset[k].m_mode = boolvalue.data1;

			//ar << Preset[k].m_modulate;
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				Preset[k].m_modulate = boolvalue.data1;

			//ar << Preset[k].m_note;
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				Preset[k].m_note = boolvalue.data1;

			//ar << Preset[k].m_noteval;
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				Preset[k].m_noteval = boolvalue.data1;

			//ar << Preset[k].m_octaves;
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				Preset[k].m_octaves = boolvalue.data1;

			//ar << Preset[k].m_pan;
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				Preset[k].m_pan = boolvalue.data1;

			//ar << Preset[k].m_param1;
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				Preset[k].m_param1 = boolvalue.data1;

			//ar << Preset[k].m_param2;
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				Preset[k].m_param2 = boolvalue.data1;

			//ar << Preset[k].m_scale;
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				Preset[k].m_scale = boolvalue.data1;

			//ar << Preset[k].m_tempo;
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				Preset[k].m_tempo = boolvalue.data1;

			//ar << Preset[k].m_numberOfEvents;
				file.Read(intvalue.data2, sizeof(int)*sizeof(BYTE));
				Preset[k].m_numberOfEvents = intvalue.data1 ;

			//ar << Preset[k].m_counterMin;
				file.Read(intvalue.data2, sizeof(int)*sizeof(BYTE));
				Preset[k].m_counterMin = intvalue.data1 ;

			//ar << Preset[k].m_counterMax;
				file.Read(intvalue.data2, sizeof(int)*sizeof(BYTE));
				Preset[k].m_counterMax = intvalue.data1;

			//ar << Preset[k].m_allowSilence;
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				Preset[k].m_allowSilence = boolvalue.data1;

			//ar << Preset[k].m_coeff;
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				Preset[k].m_coeff = boolvalue.data1;

			//ar << Preset[k].m_onoff;
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				 Preset[k].m_onoff = boolvalue.data1;

			//ar << Preset[k].m_userscl;
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				 Preset[k].m_userscl = boolvalue.data1;

			//ar << Preset[k].m_onlyusrscl;
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				 Preset[k].m_onlyusrscl = boolvalue.data1;

			//ar << Preset[k].m_matchscl;
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				Preset[k].m_matchscl = boolvalue.data1 ;

			//ar << Preset[k].m_minOnVoices;
				file.Read(intvalue.data2, sizeof(int)*sizeof(BYTE));
				 Preset[k].m_minOnVoices = intvalue.data1;

			//ar << Preset[k].m_CountersChoice;
				file.Read(intvalue.data2, sizeof(int)*sizeof(BYTE));
				Preset[k].m_CountersChoice = intvalue.data1 ;

			//ar << Preset[k].m_CountersRandomMin;
				file.Read(intvalue.data2, sizeof(int)*sizeof(BYTE));
				 Preset[k].m_CountersRandomMin = intvalue.data1;

			//ar << Preset[k].m_CountersRandomMax;
				file.Read(intvalue.data2, sizeof(int)*sizeof(BYTE));
				Preset[k].m_CountersRandomMax = intvalue.data1 ;

			//ar << Preset[k].m_sequential;
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				 Preset[k].m_sequential = boolvalue.data1;

			//ar << Preset[k].m_percussion;
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				Preset[k].m_percussion = boolvalue.data1;

				file.Read(intvalue.data2, sizeof(int)*sizeof(BYTE));
				Preset[k].m_exact = intvalue.data1;

				file.Read(intvalue.data2, sizeof(int)*sizeof(BYTE));
				Preset[k].m_atmost = intvalue.data1;

				file.Read(intvalue.data2, sizeof(int)*sizeof(BYTE));
				Preset[k].m_exactORatmost = intvalue.data1;




			for(i = VOICE1; i<MAXVOICES; i++)
				//ar << Preset[k].m_VoiceOn[i];
			{
				file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
				Preset[k].m_VoiceOn[i] = boolvalue.data1;
			}	



			file.Read(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
			Preset[k].m_includesettings = boolvalue.data1;



			file.Read(intvalue.data2, sizeof(int));
			Preset[k].m_TempoMarking = intvalue.data1 ;


			file.Read(shortvalue.data2, sizeof(short));
			Preset[k].m_TimeSigNum = shortvalue.data1 ;

			file.Read(shortvalue.data2, sizeof(short));
			 Preset[k].m_TimeSigDen = shortvalue.data1 ;

			for(i = VOICE1; i<MAXVOICES; i++)
			{
				
				file.Read(boolvalue.data2, sizeof(BOOL));
				Preset[k].m_IsActive[i] = boolvalue.data1 ;

				file.Read(boolvalue.data2, sizeof(BOOL));
				Preset[k].m_Modulates[i] = boolvalue.data1 ;

				file.Read(boolvalue.data2, sizeof(BOOL));
				Preset[k].m_ModulRandom[i] = boolvalue.data1 ;

				file.Read(intvalue.data2, sizeof(int));
				Preset[k].m_ModulNum[i] = intvalue.data1 ;

				file.Read(longvalue.data2, sizeof(long));
				Preset[k].m_Base[i] = longvalue.data1 ;

				file.Read(longvalue.data2, sizeof(long));
				Preset[k].m_Multi[i] = longvalue.data1 ;

				file.Read(longvalue.data2, sizeof(long));
				 Preset[k].m_StartNum[i] = longvalue.data1;

				file.Read(intvalue.data2, sizeof(int));
				Preset[k].m_ScaleID[i] = intvalue.data1 ;

				file.Read(intvalue.data2, sizeof(int));
				Preset[k].m_NumOcts[i] = intvalue.data1 ;

				file.Read(intvalue.data2, sizeof(int));
				 Preset[k].m_NumOctsID[i] = intvalue.data1;

				file.Read(intvalue.data2, sizeof(int));
				Preset[k].m_Note[i] = intvalue.data1 ;

				file.Read(floatvalue.data2, sizeof(float));
				Preset[k].m_NoteValue[i] = floatvalue.data1 ;

				file.Read(intvalue.data2, sizeof(int));
				Preset[k].m_NoteValueID[i] = intvalue.data1 ;

				file.Read(intvalue.data2, sizeof(int));
				Preset[k].m_Instrument[i] = intvalue.data1 ;

				file.Read(intvalue.data2, sizeof(int));
				 Preset[k].m_Channel[i] = intvalue.data1;

				file.Read(intvalue.data2, sizeof(int));
				Preset[k].m_Mode[i] = intvalue.data1 ;

				file.Read(boolvalue.data2, sizeof(BOOL));
				Preset[k].m_Inverted[i] = boolvalue.data1 ;

				file.Read(intvalue.data2, sizeof(int));
				Preset[k].m_Dynamic[i] = intvalue.data1 ;

				file.Read(intvalue.data2, sizeof(int));
				Preset[k].m_DynChoice[i] = intvalue.data1 ;

				file.Read(floatvalue.data2, sizeof(float));
				Preset[k].m_LogMapVar[i] = floatvalue.data1 ;

				file.Read(floatvalue.data2, sizeof(float));
				Preset[k].m_FNoiseVar[i] = floatvalue.data1 ;

				file.Read(floatvalue.data2, sizeof(float));
				Preset[k].m_HenonA[i] = floatvalue.data1 ;

				file.Read(floatvalue.data2, sizeof(float));
				Preset[k].m_HenonB[i] = floatvalue.data1 ;

				file.Read(floatvalue.data2, sizeof(float));
				Preset[k].m_HopalongVar[i] = floatvalue.data1 ;

				file.Read(floatvalue.data2, sizeof(float));
				Preset[k].m_MartinVar[i] = floatvalue.data1 ;

				file.Read(floatvalue.data2, sizeof(float));
				Preset[k].m_GingerX[i] = floatvalue.data1 ;

				file.Read(floatvalue.data2, sizeof(float));
				Preset[k].m_GingerY[i] = floatvalue.data1 ;

				file.Read(floatvalue.data2, sizeof(float));
				Preset[k].m_LorentzVar[i] = floatvalue.data1 ;



				file.Read(unsignedlongvalue.data2, sizeof(unsigned long));
				Preset[k].m_EarthWormVar[i] = unsignedlongvalue.data1;

				file.Read(unsignedlongvalue.data2, sizeof(unsigned long));
				Preset[k].m_EarthWormMulti[i] = unsignedlongvalue.data1;

				file.Read(unsignedvalue.data2, sizeof(unsigned));
				Preset[k].m_EarthWormTruncator[i] = unsignedvalue.data1;

				file.Read(doublevalue.data2, sizeof(double));
				Preset[k].m_RandomMin[i] = doublevalue.data1;

				file.Read(doublevalue.data2, sizeof(double));
				Preset[k].m_RandomMax[i] = doublevalue.data1;

				file.Read(bytevalue.data2, sizeof(BYTE));
				Preset[k].m_WolframRule[i] = bytevalue.data1;

				file.Read(unsignedlongvalue.data2, sizeof(unsigned long));
				Preset[k].m_WolframInit[i] = unsignedlongvalue.data1;

				file.Read(intvalue.data2, sizeof(int));
				Preset[k].m_WolframSize[i] = intvalue.data1;

				file.Read(longvalue.data2, sizeof(long));
				Preset[k].m_Hailstone[i] = longvalue.data1;




				file.Read(intvalue.data2, sizeof(int));
				Preset[k].m_Pan[i] = intvalue.data1 ;

				file.Read(boolvalue.data2, sizeof(BOOL));
				Preset[k].m_MatchScale[i] = boolvalue.data1 ;

				file.Read(intvalue.data2, sizeof(int));
				Preset[k].m_Percussion[i] = intvalue.data1 ;

				file.Read(shortvalue.data2, sizeof(short));
				Preset[k].AlgorithmNum[i] = shortvalue.data1 ;


			}//for(int i

			for (i = VOICE1; i<MAXVOICES; i++)
			{

				if(Preset[k].m_pScale[i])
				{
					delete [] Preset[k].m_pScale[i];
					Preset[k].m_pScale[i] = NULL;
				}

				file.Read(intvalue.data2, sizeof(int));

				int numnotes = intvalue.data1;
				Preset[k].m_pScale[i] = new int[numnotes + 1];

				Preset[k].m_pScale[i][0] = numnotes;

				for(int v=1; v<=numnotes; v++)
				{
					file.Read(intvalue.data2, sizeof(int));
					Preset[k].m_pScale[i][v] = intvalue.data1;
				}

			}

			for (i = VOICE1; i<MAXVOICES; i++)
			{

				if(Preset[k].m_pUserScale[i])
				{
					delete [] Preset[k].m_pUserScale[i];
					Preset[k].m_pUserScale[i] = NULL;
				}

				file.Read(intvalue.data2, sizeof(int));

				int numnotes = intvalue.data1;
				Preset[k].m_pUserScale[i] = new int[numnotes + 1];

				Preset[k].m_pUserScale[i][0] = numnotes;

				for(int v=1; v<=numnotes; v++)
				{
					file.Read(intvalue.data2, sizeof(int));
					Preset[k].m_pUserScale[i][v] = intvalue.data1;
				}

			}


			delete str; str = NULL;

		}


	file.Close();

	CListBox* pList = (CListBox*)GetDlgItem(IDC_PARAMETERS_LIST);
	pList->ResetContent();

	UpdateList();

	delete h; h=NULL;

	delete s; s=NULL;


	
}

void CRandomizerParametersDlg::OnDblclkParametersList() 
{


	CListBox* pList = (CListBox*)GetDlgItem(IDC_PARAMETERS_LIST);

	if (!pList->GetCount()||pList->GetCount() == LB_ERR)
		return;

	int sel = pList->GetCurSel();

	if (sel == LB_ERR)
		return;

	CString name;

	pList->GetText(sel, name);

	for (int k = 0; k<50; k++)
	{
		if (Preset[k].Name == name)
			break;
	}

	if ((k>48)&&(Preset[49].Name!=name))
	{
		MessageBox("Preset not found", "FractMus", MB_OK+MB_ICONEXCLAMATION);
		return;
	}
	else
	{
		pRand->m_P1From = Preset[k].m_P1From;
		pRand->m_P1To = Preset[k].m_P1To;
		pRand->m_P2From = Preset[k].m_P2From;
		pRand->m_P2To = Preset[k].m_P2To;

		for (int i = 0; i<128; i++)
			 pRand->Instrument[i] = Preset[k].Instrument[i];

		for (i = 0; i<97; i++)
			 pRand->Notes[i] = Preset[k].Notes[i];

		for (i = 0; i<15; i++)
			 pRand->Scales[i] = Preset[k].Scales[i];

			 pRand->ScalesChoice.m_user = Preset[k].Scales[15];

		for (i = 0; i<47; i++)
			 pRand->PercussionInstrument[i] = Preset[k].PercussionInstrument[i];

			 pRand->Algorithms.m_morsethue = Preset[k].Algorithms[0];
			 pRand->Algorithms.m_logmap = Preset[k].Algorithms[1];
		     pRand->Algorithms.m_noise = Preset[k].Algorithms[2] ;
			 pRand->Algorithms.m_henon = Preset[k].Algorithms[3];
			 pRand->Algorithms.m_hopalong = Preset[k].Algorithms[4];
			 pRand->Algorithms.m_martin = Preset[k].Algorithms[5];
			 pRand->Algorithms.m_ginger = Preset[k].Algorithms[6];
			 pRand->Algorithms.m_lorentz = Preset[k].Algorithms[7];
			 pRand->Algorithms.m_earthworm = Preset[k].Algorithms[8];
			 pRand->Algorithms.m_random = Preset[k].Algorithms[9];
			 pRand->Algorithms.m_hailstone = Preset[k].Algorithms[10];
			 pRand->Algorithms.m_wolfram = Preset[k].Algorithms[11];

		 pRand->Algorithms.numchoices = Preset[k].AlgorithmsNumchoices;

		
			 pRand->Octaves.m_one = Preset[k].Octaves[0];
			 pRand->Octaves.m_two = Preset[k].Octaves[1];
			 pRand->Octaves.m_three = Preset[k].Octaves[2];
			 pRand->Octaves.m_four = Preset[k].Octaves[3];


		 pRand->Octaves.numchoices = Preset[k].OctavesNumchoices;

			 pRand->NoteValues.m_whole = Preset[k].NoteValues[0];
			 pRand->NoteValues.m_half = Preset[k].NoteValues[1];
			 pRand->NoteValues.m_quarter = Preset[k].NoteValues[2];
			 pRand->NoteValues.m_8 = Preset[k].NoteValues[3];
			 pRand->NoteValues.m_16 = Preset[k].NoteValues[4];
			 pRand->NoteValues.m_32 = Preset[k].NoteValues[5];
			 pRand->NoteValues.m_dottedwhole = Preset[k].NoteValues[6];
			 pRand->NoteValues.m_dottedhalf = Preset[k].NoteValues[7];
			 pRand->NoteValues.m_dottedquarter = Preset[k].NoteValues[8];
			 pRand->NoteValues.m_dotted8 = Preset[k].NoteValues[9];
			 pRand->NoteValues.m_dotted16 = Preset[k].NoteValues[10];
			 pRand->NoteValues.m_other = Preset[k].NoteValues[11];


		 pRand->NoteValues.numchoices = Preset[k].NoteValuesNumchoices;

		 pRand->NoteValues.othermin = Preset[k].NoteValuesOtherMin;
		 pRand->NoteValues.othermax = Preset[k].NoteValuesOtherMax;

		 pRand->NoteValues.OtherRange.m_from = Preset[k].NoteValuesOtherMin;
		 pRand->NoteValues.OtherRange.m_to = Preset[k].NoteValuesOtherMax;

			 pRand->Dynamics.m_pp = Preset[k].Dynamics[0];
			 pRand->Dynamics.m_p = Preset[k].Dynamics[1] ;
			 pRand->Dynamics.m_mp = Preset[k].Dynamics[2];
			 pRand->Dynamics.m_mf = Preset[k].Dynamics[3];
			 pRand->Dynamics.m_f = Preset[k].Dynamics[4];
			 pRand->Dynamics.m_ff = Preset[k].Dynamics[5];

		pRand->Dynamics.numchoices = Preset[k].DynamicsNumchoices ;

		 pRand->m_algorithm = Preset[k].m_algorithm ;
		 pRand->m_dynamic = Preset[k].m_dynamic;
		 pRand->m_instrument = Preset[k].m_instrument ;
		 pRand->m_inverted = Preset[k].m_inverted;
		 pRand->m_mode = Preset[k].m_mode;
		 pRand->m_modulate = Preset[k].m_modulate;
		 pRand->m_note = Preset[k].m_note;
		 pRand->m_noteval = Preset[k].m_noteval;
		 pRand->m_octaves = Preset[k].m_octaves;
		 pRand->m_pan = Preset[k].m_pan;
		 pRand->m_param1 = Preset[k].m_param1;
		 pRand->m_param2 = Preset[k].m_param2;
		 pRand->m_scale = Preset[k].m_scale;
		 pRand->m_tempo = Preset[k].m_tempo;
		 pRand->m_numberOfEvents = Preset[k].m_numberOfEvents;
		 pRand->m_counterMin = Preset[k].m_counterMin;
		 pRand->m_counterMax = Preset[k].m_counterMax;
		 pRand->m_allowSilence = Preset[k].m_allowSilence;
		 pRand->m_coeff = Preset[k].m_coeff;
		 pRand->m_onoff = Preset[k].m_onoff;
		 pRand->m_userscl = Preset[k].m_userscl;
		 pRand->m_onlyusrscl = Preset[k].m_onlyusrscl;
		 pRand->m_matchscl = Preset[k].m_matchscl;
		 pRand->m_minOnVoices = Preset[k].m_minOnVoices;
		 pRand->m_CountersChoice = Preset[k].m_CountersChoice;
		 pRand->m_CountersRandomMin = Preset[k].m_CountersRandomMin;
		 pRand->m_CountersRandomMax = Preset[k].m_CountersRandomMax;
		 pRand->m_sequential = Preset[k].m_sequential;
		 pRand->m_percussion = Preset[k].m_percussion;

		 pRand->m_exact = Preset[k].m_exact;
		 pRand->m_atmost = Preset[k].m_atmost;
		 pRand->m_exactORatmost = Preset[k].m_exactORatmost;

		for(i = VOICE1; i<MAXVOICES; i++)
			 pRand->m_VoiceOn[i] = Preset[k].m_VoiceOn[i];

	pRand->UpdateData(FALSE);

	pRand->GetDlgItem(IDC_NOSILENCE)->EnableWindow(pRand->m_onoff);
	pRand->GetDlgItem(IDC_NUMVOICES_ED)->EnableWindow(pRand->m_onoff&&(!pRand->m_allowSilence));
	pRand->GetDlgItem(IDC_NUMVOICES_ST)->EnableWindow(pRand->m_onoff&&(!pRand->m_allowSilence));
	pRand->GetDlgItem(IDC_USERSCL)->EnableWindow(pRand->m_scale&&pRand->ScalesChoice.m_user);
	pRand->GetDlgItem(IDC_EXACT_RD)->EnableWindow(pRand->m_scale&&pRand->ScalesChoice.m_user&&pRand->m_userscl);
	pRand->GetDlgItem(IDC_EXACT_ED)->EnableWindow(pRand->m_scale&&pRand->ScalesChoice.m_user&&(pRand->m_exactORatmost == 0)&&pRand->m_userscl);
	pRand->GetDlgItem(IDC_EXACT_ST)->EnableWindow(pRand->m_scale&&pRand->ScalesChoice.m_user&&(pRand->m_exactORatmost == 0)&&pRand->m_userscl);
	pRand->GetDlgItem(IDC_ATMOST_RD)->EnableWindow(pRand->m_scale&&pRand->ScalesChoice.m_user&&pRand->m_userscl);
	pRand->GetDlgItem(IDC_ATMOST_ED)->EnableWindow(pRand->m_scale&&pRand->ScalesChoice.m_user&&(pRand->m_exactORatmost == 1)&&pRand->m_userscl);
	pRand->GetDlgItem(IDC_ATMOST_ST)->EnableWindow(pRand->m_scale&&pRand->ScalesChoice.m_user&&(pRand->m_exactORatmost == 1)&&pRand->m_userscl);
	pRand->GetDlgItem(IDC_ONLYUSERSCL)->EnableWindow(pRand->m_scale&&pRand->m_userscl);
	pRand->GetDlgItem(IDC_MATCHSCL_CHK)->EnableWindow(pRand->m_inverted);



	/////////////////

	UINT id = IDNO;

	if (Preset[k].m_includesettings)
		id = MessageBox("This preset includes Main Settings, Update?", "FractMus", MB_YESNO+MB_ICONQUESTION);


	if (id == IDYES)
	{

		CFractMusDoc* pDoc = pRand->m_Parent->GetDocument();
		CFractMusView* pView = (CFractMusView*)pRand->m_Parent;
		CComboBox* pB;
		CButton* pButt;
		CEdit* pE;
		CScrollBar* pS = (CScrollBar*)(pView->GetDlgItem(IDC_TEMPO_SLIDER2));
		CStatic* pSt = (CStatic*)(pView->GetDlgItem(IDC_TEMPO_STATIC));
		char s[20];



			pDoc->m_TempoMarking = pView->m_TempoMarking = Tempo = Preset[k].m_TempoMarking;
			pS->SetScrollPos(pView->m_TempoMarking);
			itoa(pView->m_TempoMarking, s ,10);
			pSt->SetWindowText(s);


			pDoc->m_TimeSigNum = Preset[k].m_TimeSigNum;
			pDoc->m_TimeSigDen = Preset[k].m_TimeSigDen;

			pB = (CComboBox*)(pView->GetDlgItem(IDC_TIMESIGNUM_CMB));
			pB->SetCurSel((pDoc->m_TimeSigNum)-1);

			pB = (CComboBox*)(pView->GetDlgItem(IDC_TIMESIGDEN_CMB));

			switch (pDoc->m_TimeSigDen)
			{
				case 1:
					pB->SetCurSel(0);
					break;
				case 2:
					pB->SetCurSel(1);
					break;
				case 4:
					pB->SetCurSel(2);
					break;
				case 8:
					pB->SetCurSel(3);
					break;
				case 16:
					pB->SetCurSel(4);
					break;
				case 32:
					pB->SetCurSel(5);
					break;
			}


			for(int i = VOICE1; i<MAXVOICES; i++)
				pDoc->m_IsActive[i] = pView->m_IsActive[i] = Preset[k].m_IsActive[i];

			int numact = 0;

			for(i = VOICE1; i<MAXVOICES; i++)
				if (pDoc->m_IsActive[i])
					++numact;

			pDoc->m_ActiveVoices = numact;


			for (i = VOICE1; i<MAXVOICES; i++)
			{
					 pView->m_Modulates[i] = pDoc->m_Modulates[i] = Preset[k].m_Modulates[i];
					 pDoc->m_ModulRandom[i] = Preset[k].m_ModulRandom[i];
					 pDoc->m_ModulNum[i] = Preset[k].m_ModulNum[i];

					 pDoc->m_Base[i] = Preset[k].m_Base[i];
					 pDoc->m_Multi[i] = Preset[k].m_Multi[i];
					 pDoc->m_StartNum[i] = pView->m_StartNum[i] = Preset[k].m_StartNum[i];
					 pDoc->m_NumOcts[i] = Preset[k].m_NumOcts[i];
					 pDoc->m_NumOctsID[i] = pView->m_NumOctsID[i] = Preset[k].m_NumOctsID[i];
					 pB = (CComboBox*)pView->GetDlgItem(pView->NumOctsID[i]);
					 pB->SetCurSel(pView->m_NumOctsID[i]);
					 pDoc->m_Note[i] = pView->m_Note[i] = Preset[k].m_Note[i];
					 pB = (CComboBox*)pView->GetDlgItem(pView->NoteID[i]);
					 pB->SetCurSel(pView->m_Note[i]);
					 CString nval;
					 pDoc->m_NoteValue[i] =  Preset[k].m_NoteValue[i];
					 pDoc->m_NoteValueID[i] = pView->m_NoteValueID[i] = Preset[k].m_NoteValueID[i];
					 nval.Format("Other (%d)", (long)pDoc->m_NoteValue[i]);
					 pB = (CComboBox*)pView->GetDlgItem(pView->NoteValueID[i]);
					 pB->DeleteString(OTHER);
					 pB->AddString(nval);
					 pB = (CComboBox*)pView->GetDlgItem(pView->NoteValueID[i]);
					 pB->SetCurSel(pView->m_NoteValueID[i]);
					 pDoc->m_Instrument[i] = Preset[k].m_Instrument[i];
					 pDoc->m_Percussion[i] = Preset[k].m_Percussion[i];
					pDoc->m_Channel[i] = Preset[k].m_Channel[i];
					 pDoc->m_mode[i] = Preset[k].m_Mode[i];
					 pDoc->m_Inverted[i] = Preset[k].m_Inverted[i];
					 pDoc->m_Dynamic[i] = Preset[k].m_Dynamic[i];
					 pDoc->m_DynChoice[i] = Preset[k].m_DynChoice[i];
					 pDoc->AlgorithmNum[i] = Preset[k].AlgorithmNum[i];

					 pDoc->m_LogMapVar[i] = Preset[k].m_LogMapVar[i];
					 pDoc->m_FNoiseVar[i] = Preset[k].m_FNoiseVar[i];
					 pDoc->m_HenonA[i] = Preset[k].m_HenonA[i];
					 pDoc->m_HenonB[i] = Preset[k].m_HenonB[i];
					 pDoc->m_HopalongVar[i] = Preset[k].m_HopalongVar[i];
					 pDoc->m_MartinVar[i] = Preset[k].m_MartinVar[i];
					 pDoc->m_GingerX[i] = Preset[k].m_GingerX[i];
					 pDoc->m_GingerY[i] = Preset[k].m_GingerY[i];
					 pDoc->m_LorentzVar[i] = Preset[k].m_LorentzVar[i];
					 pDoc->m_EarthWormVar[i] = Preset[k].m_EarthWormVar[i];
					 pDoc->m_EarthWormMulti[i] = Preset[k].m_EarthWormMulti[i];
					 pDoc->m_EarthWormTruncator[i] = Preset[k].m_EarthWormTruncator[i];
					 pDoc->m_RandomMin[i] = Preset[k].m_RandomMin[i];
					 pDoc->m_RandomMax[i] = Preset[k].m_RandomMax[i];
					 pDoc->m_WolframRule[i] = Preset[k].m_WolframRule[i];
					 pDoc->m_WolframInit[i] = Preset[k].m_WolframInit[i];
					 pDoc->m_WolframSize[i] = Preset[k].m_WolframSize[i];
					 pDoc->m_Hailstone[i] = Preset[k].m_Hailstone[i];

					 pDoc->m_Pan[i] = Preset[k].m_Pan[i];
					 pDoc->m_MatchScale[i] = Preset[k].m_MatchScale[i];

					pButt = (CButton*)(pView->GetDlgItem(pView->ActiveID[i]));

					if (pDoc->m_Channel[i] == PercussionChannel)
					{
						pButt->SetWindowText(PercussionNames[ pDoc->m_Percussion[i] ]);
					}
					else
						pButt->SetWindowText(InstrumentNames[ pDoc->m_Instrument[i] ]);


			}

				for(i = VOICE1; i<MAXVOICES; i++)
				{
					pDoc->m_ScaleID[i] = pView->m_ScaleID[i] = Preset[k].m_ScaleID[i];


					pB = (CComboBox*)pView->GetDlgItem(pView->ScaleID[i]);
					pB->SetCurSel(pView->m_ScaleID[i]);

					if (pDoc->m_pScale[i])
					{
						delete [] pDoc->m_pScale[i];

						pDoc->m_pScale[i] = NULL;
					}
					if (pDoc->m_pUserScale[i])
					{
						delete [] pDoc->m_pUserScale[i];
						pDoc->m_pUserScale[i] = NULL;
					}

					pDoc->m_pScale[i] = new int [Preset[k].m_pScale[i][0] + 1];
					for(int j =0; j<=Preset[k].m_pScale[i][0]; j++)
						 pDoc->m_pScale[i][j] = Preset[k].m_pScale[i][j];

					pDoc->m_pUserScale[i] = new int [Preset[k].m_pUserScale[i][0] + 1];
					for(j =0; j<=Preset[k].m_pUserScale[i][0]; j++)
						 pDoc->m_pUserScale[i][j] = Preset[k].m_pUserScale[i][j];

					pView->InitUserScale(i);
					if (pDoc->m_ScaleID[i] == USER_DEFINED)
						pView->SetUserScale(i);
				}


		for(i=VOICE1; i<MAXVOICES; i++)
		{
			pE = (CEdit*)pView->GetDlgItem(pView->StartNumID[i])->EnableWindow(pView->m_IsActive[i]);
			pButt = (CButton*)pView->GetDlgItem(pView->ModulatesID[i])->EnableWindow(pView->m_IsActive[i]);
			pB = (CComboBox*)pView->GetDlgItem(pView->NumOctsID[i])->EnableWindow(pView->m_IsActive[i]);
			pB = (CComboBox*)pView->GetDlgItem(pView->NoteID[i])->EnableWindow(pView->m_IsActive[i]);
			pB = (CComboBox*)pView->GetDlgItem(pView->ScaleID[i])->EnableWindow(pView->m_IsActive[i]);
			pB = (CComboBox*)pView->GetDlgItem(pView->NoteValueID[i])->EnableWindow(pView->m_IsActive[i]);
			pButt = (CButton*)pView->GetDlgItem(pView->MidiButtonID[i])->EnableWindow(pView->m_IsActive[i]);
			//pButt = (CButton*)GetDlgItem(ActiveID[i])->EnableWindow((!IsDocumentLocked));


		}

			pView->UpdateData(FALSE);
	}

	}

	
}

void CRandomizerParametersDlg::OnSave() 
{

	int numpresets = 0;
	for (int k=0; k<50; k++)
	{
		if (!Preset[k].Name.IsEmpty())
			++numpresets;
	}

	if (!numpresets)
	{
		MessageBox("You have no presets to save", "FractMus", MB_OK+MB_ICONEXCLAMATION);
		return;
	}

	char FileName[500];
	char FileTitle[100];

	OPENFILENAME ofn;
	memset(&ofn, 0, sizeof(ofn));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = NULL;
	ofn.hInstance = NULL;

	ofn.lpstrFilter = 
		TEXT("Randomizer presets *.rps\0*.rps\0\0");

	ofn.lpstrCustomFilter = NULL;
	ofn.nMaxCustFilter = 0;
	ofn.nFilterIndex = 1;
	ofn.lpstrFile = FileName;
	ofn.nMaxFile = 500;
	ofn.lpstrFileTitle = FileTitle;
	ofn.nMaxFileTitle = 99;
	ofn.lpstrInitialDir = NULL;
	ofn.lpstrTitle="Save Randomizer Presets";
	ofn.Flags = OFN_OVERWRITEPROMPT|OFN_LONGNAMES;
	ofn.lpstrDefExt = "rps";
	ofn.lCustData = NULL;
	ofn.lpfnHook = NULL;
	ofn.lpTemplateName = NULL;

	FileName[0] = '\0';

	if(!GetSaveFileName(&ofn))
		return;

	if(FileName[0] == '\0')
		return;

	CFile file;

	file.Open(FileName, CFile::modeCreate | CFile::modeWrite );

	union 
	{
		int dataint;
		BYTE databyte[sizeof(int)];
	} num;

	CString header = "RPSFile";

	file.Write((char*)header.GetBuffer(1), 7);


	num.dataint = numpresets;

	file.Write(num.databyte, sizeof(int));


	for (k=0; k<50; k++)
	{
		if (!Preset[k].Name.IsEmpty())
		{
			//ar << Preset[k].Name;

			int numbytes = Preset[k].Name.GetLength();

			//numbytes; // string null terminator
			
			union
			{
				UINT bytes;
				BYTE data[sizeof(BYTE)*sizeof(UINT)];
			} databytes;

			databytes.bytes = numbytes;

			file.Write((BYTE*)databytes.data, sizeof(BYTE)*sizeof(UINT));

			file.Write((char*)Preset[k].Name.GetBuffer(1), numbytes);

			union 
			{
				int data1;
				BYTE data2[sizeof(int)];
			} intvalue;

			union
			{
				BOOL data1;
				BYTE data2[sizeof(BOOL)];
			} boolvalue;

			union
			{
				long data1;
				BYTE data2[sizeof(long)];
			} longvalue;


			union
			{
				float data1;
				BYTE data2[sizeof(float)];
			} floatvalue;

			union
			{
				short data1;
				BYTE data2[sizeof(short)];
			} shortvalue;

			union
			{
				unsigned data1;
				BYTE data2[sizeof(unsigned)];
			} unsignedvalue;

			union
			{
				unsigned long data1;
				BYTE data2[sizeof(unsigned long)];
			} unsignedlongvalue;

			union
			{
				double data1;
				BYTE data2[sizeof(double)];
			} doublevalue;

			union
			{
				BYTE data1;
				BYTE data2[sizeof(BYTE)];
			} bytevalue;




			//ar << Preset[k].m_P1From;
			longvalue.data1 = Preset[k].m_P1From;
			file.Write(longvalue.data2, sizeof(long)*sizeof(BYTE));

			//ar << Preset[k].m_P1To;
			longvalue.data1 = Preset[k].m_P1To;
			file.Write(longvalue.data2, sizeof(long)*sizeof(BYTE));

			//ar << Preset[k].m_P2From;
			longvalue.data1 = Preset[k].m_P2From;
			file.Write(longvalue.data2, sizeof(long)*sizeof(BYTE));

			//ar << Preset[k].m_P2To;
			longvalue.data1 = Preset[k].m_P2To;
			file.Write(longvalue.data2, sizeof(long)*sizeof(BYTE));


			for (int i = 0; i<128; i++)
			{
				//ar << Preset[k].Instrument[i];
				boolvalue.data1 = Preset[k].Instrument[i];
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

			}

			for (i = 0; i<97; i++)
				//ar << Preset[k].Notes[i];
			{
				boolvalue.data1 = Preset[k].Notes[i];
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

			}

			for (i = 0; i<16; i++)
				//ar << Preset[k].Scales[i];
			{
				boolvalue.data1 = Preset[k].Scales[i];
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

			}

			for (i = 0; i<47; i++)
				//ar << Preset[k].PercussionInstrument[i];
			{
				boolvalue.data1 = Preset[k].PercussionInstrument[i];
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

			}

			for (i = 0; i<12; i++)
				//ar << Preset[k].Algorithms[i];
			{
				//ar << Preset[k].Instrument[i];
				boolvalue.data1 = Preset[k].Algorithms[i];
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

			}

			//ar << Preset[k].AlgorithmsNumchoices;

			intvalue.data1 = Preset[k].AlgorithmsNumchoices;
			file.Write(intvalue.data2, sizeof(int)*sizeof(BYTE));

			
			for (i = 0; i<4; i++)
				//ar << Preset[k].Octaves[i];
			{
				boolvalue.data1 = Preset[k].Octaves[i];
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

			}

			//ar << Preset[k].OctavesNumchoices;
			intvalue.data1 = Preset[k].OctavesNumchoices;
			file.Write(intvalue.data2, sizeof(int)*sizeof(BYTE));

			for (i = 0; i<12; i++)
				//ar << Preset[k].NoteValues[i];
			{
				boolvalue.data1 = Preset[k].NoteValues[i];
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

			}

			//ar << Preset[k].NoteValuesNumchoices;
			intvalue.data1 = Preset[k].NoteValuesNumchoices;
			file.Write(intvalue.data2, sizeof(int)*sizeof(BYTE));

			//ar << Preset[k].NoteValuesOtherMin;
			intvalue.data1 = Preset[k].NoteValuesOtherMin;
			file.Write(intvalue.data2, sizeof(int)*sizeof(BYTE));

			//ar << Preset[k].NoteValuesOtherMax;
			intvalue.data1 = Preset[k].NoteValuesOtherMax;
			file.Write(intvalue.data2, sizeof(int)*sizeof(BYTE));

			for (i = 0; i<6; i++)
				//ar << Preset[k].Dynamics[i];
			{
				boolvalue.data1 = Preset[k].Dynamics[i];
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

			}

			//ar << Preset[k].DynamicsNumchoices;
				intvalue.data1 = Preset[k].DynamicsNumchoices;
				file.Write(intvalue.data2, sizeof(int)*sizeof(BYTE));

			//ar << Preset[k].m_algorithm;
				boolvalue.data1 = Preset[k].m_algorithm;
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

			//ar << Preset[k].m_dynamic ;
				boolvalue.data1 = Preset[k].m_dynamic;
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

			//ar << Preset[k].m_instrument;
				boolvalue.data1 = Preset[k].m_instrument;
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

			//ar << Preset[k].m_inverted;
				boolvalue.data1 = Preset[k].m_inverted;
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

			//ar << Preset[k].m_mode;
				boolvalue.data1 = Preset[k].m_mode;
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

			//ar << Preset[k].m_modulate;
				boolvalue.data1 = Preset[k].m_modulate;
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

			//ar << Preset[k].m_note;
				boolvalue.data1 = Preset[k].m_note;
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

			//ar << Preset[k].m_noteval;
				boolvalue.data1 = Preset[k].m_noteval;
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

			//ar << Preset[k].m_octaves;
				boolvalue.data1 = Preset[k].m_octaves;
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

			//ar << Preset[k].m_pan;
				boolvalue.data1 = Preset[k].m_pan;
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

			//ar << Preset[k].m_param1;
				boolvalue.data1 = Preset[k].m_param1;
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

			//ar << Preset[k].m_param2;
				boolvalue.data1 = Preset[k].m_param2;
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

			//ar << Preset[k].m_scale;
				boolvalue.data1 = Preset[k].m_scale;
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

			//ar << Preset[k].m_tempo;
				boolvalue.data1 = Preset[k].m_tempo;
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

			//ar << Preset[k].m_numberOfEvents;
				intvalue.data1 = Preset[k].m_numberOfEvents;
				file.Write(intvalue.data2, sizeof(int)*sizeof(BYTE));

			//ar << Preset[k].m_counterMin;
				intvalue.data1 = Preset[k].m_counterMin;
				file.Write(intvalue.data2, sizeof(int)*sizeof(BYTE));

			//ar << Preset[k].m_counterMax;
				intvalue.data1 = Preset[k].m_counterMax;
				file.Write(intvalue.data2, sizeof(int)*sizeof(BYTE));

			//ar << Preset[k].m_allowSilence;
				boolvalue.data1 = Preset[k].m_allowSilence;
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

			//ar << Preset[k].m_coeff;
				boolvalue.data1 = Preset[k].m_coeff;
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

			//ar << Preset[k].m_onoff;
				boolvalue.data1 = Preset[k].m_onoff;
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

			//ar << Preset[k].m_userscl;
				boolvalue.data1 = Preset[k].m_userscl;
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

			//ar << Preset[k].m_onlyusrscl;
				boolvalue.data1 = Preset[k].m_onlyusrscl;
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

			//ar << Preset[k].m_matchscl;
				boolvalue.data1 = Preset[k].m_matchscl;
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

			//ar << Preset[k].m_minOnVoices;
				intvalue.data1 = Preset[k].m_minOnVoices;
				file.Write(intvalue.data2, sizeof(int)*sizeof(BYTE));

			//ar << Preset[k].m_CountersChoice;
				intvalue.data1 = Preset[k].m_CountersChoice;
				file.Write(intvalue.data2, sizeof(int)*sizeof(BYTE));

			//ar << Preset[k].m_CountersRandomMin;
				intvalue.data1 = Preset[k].m_CountersRandomMin;
				file.Write(intvalue.data2, sizeof(int)*sizeof(BYTE));

			//ar << Preset[k].m_CountersRandomMax;
				intvalue.data1 = Preset[k].m_CountersRandomMax;
				file.Write(intvalue.data2, sizeof(int)*sizeof(BYTE));

			//ar << Preset[k].m_sequential;
				boolvalue.data1 = Preset[k].m_sequential;
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

			//ar << Preset[k].m_percussion;
				boolvalue.data1 = Preset[k].m_percussion;
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));

				intvalue.data1 = Preset[k].m_exact;
				file.Write(intvalue.data2, sizeof(int)*sizeof(BYTE));

				intvalue.data1 = Preset[k].m_atmost;
				file.Write(intvalue.data2, sizeof(int)*sizeof(BYTE));

				intvalue.data1 = Preset[k].m_exactORatmost;
				file.Write(intvalue.data2, sizeof(int)*sizeof(BYTE));



			for(i = VOICE1; i<MAXVOICES; i++)
				//ar << Preset[k].m_VoiceOn[i];
			{
				boolvalue.data1 = Preset[k].m_VoiceOn[i];
				file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));
			}

			boolvalue.data1 = Preset[k].m_includesettings;
			file.Write(boolvalue.data2, sizeof(BOOL)*sizeof(BYTE));


			intvalue.data1 = Preset[k].m_TempoMarking;
			file.Write(intvalue.data2, sizeof(int));


			shortvalue.data1 = Preset[k].m_TimeSigNum;
			file.Write(shortvalue.data2, sizeof(short));

			shortvalue.data1 = Preset[k].m_TimeSigDen;
			file.Write(shortvalue.data2, sizeof(short));

			for(i = VOICE1; i<MAXVOICES; i++)
			{
				
				boolvalue.data1 = Preset[k].m_IsActive[i];
				file.Write(boolvalue.data2, sizeof(BOOL));

				boolvalue.data1 = Preset[k].m_Modulates[i];
				file.Write(boolvalue.data2, sizeof(BOOL));

				boolvalue.data1 = Preset[k].m_ModulRandom[i];
				file.Write(boolvalue.data2, sizeof(BOOL));

				intvalue.data1 = Preset[k].m_ModulNum[i];
				file.Write(intvalue.data2, sizeof(int));

				longvalue.data1 = Preset[k].m_Base[i];
				file.Write(longvalue.data2, sizeof(long));

				longvalue.data1 = Preset[k].m_Multi[i];
				file.Write(longvalue.data2, sizeof(long));

				longvalue.data1 = Preset[k].m_StartNum[i];
				file.Write(longvalue.data2, sizeof(long));

				intvalue.data1 = Preset[k].m_ScaleID[i];
				file.Write(intvalue.data2, sizeof(int));

				intvalue.data1 = Preset[k].m_NumOcts[i];
				file.Write(intvalue.data2, sizeof(int));

				intvalue.data1 = Preset[k].m_NumOctsID[i];
				file.Write(intvalue.data2, sizeof(int));

				intvalue.data1 = Preset[k].m_Note[i];
				file.Write(intvalue.data2, sizeof(int));

				floatvalue.data1 = Preset[k].m_NoteValue[i];
				file.Write(floatvalue.data2, sizeof(float));

				intvalue.data1 = Preset[k].m_NoteValueID[i];
				file.Write(intvalue.data2, sizeof(int));

				intvalue.data1 = Preset[k].m_Instrument[i];
				file.Write(intvalue.data2, sizeof(int));

				intvalue.data1 = Preset[k].m_Channel[i];
				file.Write(intvalue.data2, sizeof(int));

				intvalue.data1 = Preset[k].m_Mode[i];
				file.Write(intvalue.data2, sizeof(int));

				boolvalue.data1 = Preset[k].m_Inverted[i];
				file.Write(boolvalue.data2, sizeof(BOOL));

				intvalue.data1 = Preset[k].m_Dynamic[i];
				file.Write(intvalue.data2, sizeof(int));

				intvalue.data1 = Preset[k].m_DynChoice[i];
				file.Write(intvalue.data2, sizeof(int));

				floatvalue.data1 = Preset[k].m_LogMapVar[i];
				file.Write(floatvalue.data2, sizeof(float));

				floatvalue.data1 = Preset[k].m_FNoiseVar[i];
				file.Write(floatvalue.data2, sizeof(float));

				floatvalue.data1 = Preset[k].m_HenonA[i];
				file.Write(floatvalue.data2, sizeof(float));

				floatvalue.data1 = Preset[k].m_HenonB[i];
				file.Write(floatvalue.data2, sizeof(float));

				floatvalue.data1 = Preset[k].m_HopalongVar[i];
				file.Write(floatvalue.data2, sizeof(float));

				floatvalue.data1 = Preset[k].m_MartinVar[i];
				file.Write(floatvalue.data2, sizeof(float));

				floatvalue.data1 = Preset[k].m_GingerX[i];
				file.Write(floatvalue.data2, sizeof(float));

				floatvalue.data1 = Preset[k].m_GingerY[i];
				file.Write(floatvalue.data2, sizeof(float));

				floatvalue.data1 = Preset[k].m_LorentzVar[i];
				file.Write(floatvalue.data2, sizeof(float));


				unsignedlongvalue.data1 = Preset[k].m_EarthWormVar[i];
				file.Write(unsignedlongvalue.data2, sizeof(unsigned long));

				unsignedlongvalue.data1 = Preset[k].m_EarthWormMulti[i];
				file.Write(unsignedlongvalue.data2, sizeof(unsigned long));

				unsignedvalue.data1 = Preset[k].m_EarthWormTruncator[i];
				file.Write(unsignedvalue.data2, sizeof(unsigned));

				doublevalue.data1 = Preset[k].m_RandomMin[i];
				file.Write(doublevalue.data2, sizeof(double));

				doublevalue.data1 = Preset[k].m_RandomMax[i];
				file.Write(doublevalue.data2, sizeof(double));

				bytevalue.data1 = Preset[k].m_WolframRule[i];
				file.Write(bytevalue.data2, sizeof(BYTE));

				unsignedlongvalue.data1 = Preset[k].m_WolframInit[i];
				file.Write(unsignedlongvalue.data2, sizeof(unsigned long));

				intvalue.data1 = Preset[k].m_WolframSize[i];
				file.Write(intvalue.data2, sizeof(int));

				longvalue.data1 = Preset[k].m_Hailstone[i];
				file.Write(longvalue.data2, sizeof(long));


				intvalue.data1 = Preset[k].m_Pan[i];
				file.Write(intvalue.data2, sizeof(int));

				boolvalue.data1 = Preset[k].m_MatchScale[i];
				file.Write(boolvalue.data2, sizeof(BOOL));

				intvalue.data1 = Preset[k].m_Percussion[i];
				file.Write(intvalue.data2, sizeof(int));

				shortvalue.data1 = Preset[k].AlgorithmNum[i];
				file.Write(shortvalue.data2, sizeof(short));


			}//for(int i

			for (i = VOICE1; i<MAXVOICES; i++)
			{

				for(int v=0; v<=Preset[k].m_pScale[i][0]; v++)
				{
					intvalue.data1 = Preset[k].m_pScale[i][v];
					file.Write(intvalue.data2, sizeof(int));
				}

			}

			for (i = VOICE1; i<MAXVOICES; i++)
			{

				for(int v=0; v<=Preset[k].m_pUserScale[i][0]; v++)
				{
					intvalue.data1 = Preset[k].m_pUserScale[i][v];
					file.Write(intvalue.data2, sizeof(int));
				}

			}



		}
	}

	file.Close();


}

void CRandomizerParametersDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CRandomizerParametersDlg::OnOK() 
{
	// TODO: Add extra validation here
	
}

void CRandomizerParametersDlg::OnAdd() 
{
	if(!UpdateData(TRUE))
		return;

	CFractMusDoc* pDoc = pRand->m_Parent->GetDocument();

	if (m_newpresetname.IsEmpty())
	{
		MessageBox("Please enter a name for the preset!", "FractMus", MB_OK+MB_ICONEXCLAMATION);
		return;
	}

	for(int k = 0; k<50; k++)
	{
		if(Preset[k].Name == m_newpresetname)
		{
			MessageBox("There is already a preset with that name, please choose another name", "FractMus", MB_OK+MB_ICONEXCLAMATION);
			return;
		}
	}

	for(k = 0; k<50; k++)
	{
		if(Preset[k].Name.IsEmpty())
			break;
	}

	if ((k>48)&&(!Preset[49].Name.IsEmpty()))
	{
		CString msg;

		msg.Format("You have reached the maximum number of presets, please delete some \nor clear the list (you can save your current presets");

		MessageBox(msg,"FractMus", MB_OK+MB_ICONINFORMATION);
		return;
	}
	else
	{
		if (!(pRand->UpdateData(TRUE)))
			return;
		CListBox* pList = (CListBox*)GetDlgItem(IDC_PARAMETERS_LIST);
		pList->AddString(m_newpresetname);

		Preset[k].Name = m_newpresetname;

		//// fill preset

		Preset[k].m_P1From = pRand->m_P1From;
		Preset[k].m_P1To = pRand->m_P1To;
		Preset[k].m_P2From = pRand->m_P2From;
		Preset[k].m_P2To = pRand->m_P2To;

		for (int i = 0; i<128; i++)
			Preset[k].Instrument[i] = pRand->Instrument[i];

		for (i = 0; i<97; i++)
			Preset[k].Notes[i] = pRand->Notes[i];

		for (i = 0; i<15; i++)
			Preset[k].Scales[i] = pRand->Scales[i];

			Preset[k].Scales[15] = pRand->ScalesChoice.m_user;

		for (i = 0; i<47; i++)
			Preset[k].PercussionInstrument[i] = pRand->PercussionInstrument[i];

			Preset[k].Algorithms[0] = pRand->Algorithms.m_morsethue;
			Preset[k].Algorithms[1] = pRand->Algorithms.m_logmap;
			Preset[k].Algorithms[2] = pRand->Algorithms.m_noise;
			Preset[k].Algorithms[3] = pRand->Algorithms.m_henon;
			Preset[k].Algorithms[4] = pRand->Algorithms.m_hopalong;
			Preset[k].Algorithms[5] = pRand->Algorithms.m_martin;
			Preset[k].Algorithms[6] = pRand->Algorithms.m_ginger;
			Preset[k].Algorithms[7] = pRand->Algorithms.m_lorentz;
			Preset[k].Algorithms[8] = pRand->Algorithms.m_earthworm;
			Preset[k].Algorithms[9] = pRand->Algorithms.m_random;
			Preset[k].Algorithms[10] = pRand->Algorithms.m_hailstone;
			Preset[k].Algorithms[11] = pRand->Algorithms.m_wolfram;

		Preset[k].AlgorithmsNumchoices = pRand->Algorithms.numchoices;

		
			Preset[k].Octaves[0] = pRand->Octaves.m_one;
			Preset[k].Octaves[1] = pRand->Octaves.m_two;
			Preset[k].Octaves[2] = pRand->Octaves.m_three;
			Preset[k].Octaves[3] = pRand->Octaves.m_four;


		Preset[k].OctavesNumchoices = pRand->Octaves.numchoices;

			Preset[k].NoteValues[0] = pRand->NoteValues.m_whole;
			Preset[k].NoteValues[1] = pRand->NoteValues.m_half;
			Preset[k].NoteValues[2] = pRand->NoteValues.m_quarter;
			Preset[k].NoteValues[3] = pRand->NoteValues.m_8;
			Preset[k].NoteValues[4] = pRand->NoteValues.m_16;
			Preset[k].NoteValues[5] = pRand->NoteValues.m_32;
			Preset[k].NoteValues[6] = pRand->NoteValues.m_dottedwhole;
			Preset[k].NoteValues[7] = pRand->NoteValues.m_dottedhalf;
			Preset[k].NoteValues[8] = pRand->NoteValues.m_dottedquarter;
			Preset[k].NoteValues[9] = pRand->NoteValues.m_dotted8;
			Preset[k].NoteValues[10] = pRand->NoteValues.m_dotted16;
			Preset[k].NoteValues[11] = pRand->NoteValues.m_other;


		Preset[k].NoteValuesNumchoices = pRand->NoteValues.numchoices;

		Preset[k].NoteValuesOtherMin = pRand->NoteValues.othermin;
		Preset[k].NoteValuesOtherMax = pRand->NoteValues.othermax;


			Preset[k].Dynamics[0] = pRand->Dynamics.m_pp;
			Preset[k].Dynamics[1] = pRand->Dynamics.m_p;
			Preset[k].Dynamics[2] = pRand->Dynamics.m_mp;
			Preset[k].Dynamics[3] = pRand->Dynamics.m_mf;
			Preset[k].Dynamics[4] = pRand->Dynamics.m_f;
			Preset[k].Dynamics[5] = pRand->Dynamics.m_ff;

		Preset[k].DynamicsNumchoices = pRand->Dynamics.numchoices;

		Preset[k].m_algorithm = pRand->m_algorithm;
		Preset[k].m_dynamic = pRand->m_dynamic;
		Preset[k].m_instrument = pRand->m_instrument;
		Preset[k].m_inverted = pRand->m_inverted;
		Preset[k].m_mode = pRand->m_mode;
		Preset[k].m_modulate = pRand->m_modulate;
		Preset[k].m_note = pRand->m_note;
		Preset[k].m_noteval = pRand->m_noteval;
		Preset[k].m_octaves = pRand->m_octaves;
		Preset[k].m_pan = pRand->m_pan;
		Preset[k].m_param1 = pRand->m_param1;
		Preset[k].m_param2 = pRand->m_param2;
		Preset[k].m_scale = pRand->m_scale;
		Preset[k].m_tempo = pRand->m_tempo;
		Preset[k].m_numberOfEvents = pRand->m_numberOfEvents;
		Preset[k].m_counterMin = pRand->m_counterMin;
		Preset[k].m_counterMax = pRand->m_counterMax;
		Preset[k].m_allowSilence = pRand->m_allowSilence;
		Preset[k].m_coeff = pRand->m_coeff;
		Preset[k].m_onoff = pRand->m_onoff;
		Preset[k].m_userscl = pRand->m_userscl;
		Preset[k].m_onlyusrscl = pRand->m_onlyusrscl;
		Preset[k].m_matchscl = pRand->m_matchscl;
		Preset[k].m_minOnVoices = pRand->m_minOnVoices;
		Preset[k].m_CountersChoice = pRand->m_CountersChoice;
		Preset[k].m_CountersRandomMin = pRand->m_CountersRandomMin;
		Preset[k].m_CountersRandomMax = pRand->m_CountersRandomMax;
		Preset[k].m_sequential = pRand->m_sequential;
		Preset[k].m_percussion = pRand->m_percussion;

		Preset[k].m_exact = pRand->m_exact;
		Preset[k].m_atmost = pRand->m_atmost;
		Preset[k].m_exactORatmost = pRand->m_exactORatmost;

		for(i = VOICE1; i<MAXVOICES; i++)
			Preset[k].m_VoiceOn[i] = pRand->m_VoiceOn[i];

		Preset[k].m_includesettings = m_includesettings;

		Preset[k].m_TempoMarking = pDoc->m_TempoMarking;
		Preset[k].m_TimeSigNum = pDoc->m_TimeSigNum;
		Preset[k].m_TimeSigDen = pDoc->m_TimeSigDen;

		for(i = VOICE1; i<MAXVOICES; i++)
			Preset[k].m_IsActive[i] = pDoc->m_IsActive[i];


		for (i = VOICE1; i<MAXVOICES; i++)
		{
			Preset[k].m_Modulates[i] = pDoc->m_Modulates[i];
			Preset[k].m_ModulRandom[i] = pDoc->m_ModulRandom[i];
			Preset[k].m_ModulNum[i] = pDoc->m_ModulNum[i];
			Preset[k].m_Base[i] = pDoc->m_Base[i];
			Preset[k].m_Multi[i] = pDoc->m_Multi[i];
			Preset[k].m_StartNum[i] = pDoc->m_StartNum[i];
			Preset[k].m_ScaleID[i] = pDoc->m_ScaleID[i];
			Preset[k].m_NumOcts[i] = pDoc->m_NumOcts[i];
			Preset[k].m_NumOctsID[i] = pDoc->m_NumOctsID[i];
			Preset[k].m_Note[i] = pDoc->m_Note[i];
			Preset[k].m_NoteValue[i] = pDoc->m_NoteValue[i];
			Preset[k].m_NoteValueID[i] = pDoc->m_NoteValueID[i];
			Preset[k].m_Instrument[i] = pDoc->m_Instrument[i];
			Preset[k].m_Channel[i] = pDoc->m_Channel[i];
			Preset[k].m_Mode[i] = pDoc->m_mode[i];
			Preset[k].m_Inverted[i] = pDoc->m_Inverted[i];
			Preset[k].m_Dynamic[i] = pDoc->m_Dynamic[i];
			Preset[k].m_DynChoice[i] = pDoc->m_DynChoice[i];
			Preset[k].m_LogMapVar[i] = pDoc->m_LogMapVar[i];
			Preset[k].m_FNoiseVar[i] = pDoc->m_FNoiseVar[i];
			Preset[k].m_HenonA[i] = pDoc->m_HenonA[i];
			Preset[k].m_HenonB[i] = pDoc->m_HenonB[i];
			Preset[k].m_HopalongVar[i] = pDoc->m_HopalongVar[i];
			Preset[k].m_MartinVar[i] = pDoc->m_MartinVar[i];
			Preset[k].m_GingerX[i] = pDoc->m_GingerX[i];
			Preset[k].m_GingerY[i] = pDoc->m_GingerY[i];
			Preset[k].m_LorentzVar[i] = pDoc->m_LorentzVar[i];
			Preset[k].m_Pan[i] = pDoc->m_Pan[i];
			Preset[k].m_EarthWormVar[i] = pDoc->m_EarthWormVar[i];
			Preset[k].m_EarthWormMulti[i] = pDoc->m_EarthWormMulti[i];
			Preset[k].m_EarthWormTruncator[i] = pDoc->m_EarthWormTruncator[i];
			Preset[k].m_RandomMin[i] = pDoc->m_RandomMin[i];
			Preset[k].m_RandomMax[i] = pDoc->m_RandomMax[i];
			Preset[k].m_WolframRule[i] = pDoc->m_WolframRule[i];
			Preset[k].m_WolframInit[i] = pDoc->m_WolframInit[i];
			Preset[k].m_WolframSize[i] = pDoc->m_WolframSize[i];
			Preset[k].m_Hailstone[i] = pDoc->m_Hailstone[i];

			Preset[k].m_MatchScale[i] = pDoc->m_MatchScale[i];
			Preset[k].m_Percussion[i] = pDoc->m_Percussion[i];


			Preset[k].AlgorithmNum[i] = pDoc->AlgorithmNum[i];

		}

		for(i = VOICE1; i<MAXVOICES; i++)
		{
			if (Preset[k].m_pScale[i])
			{
				delete [] Preset[k].m_pScale[i];

				Preset[k].m_pScale[i] = NULL;
			}
			if (Preset[k].m_pUserScale[i])
			{
				delete [] Preset[k].m_pUserScale[i];
				Preset[k].m_pUserScale[i] = NULL;
			}
		}

		for(i = VOICE1; i<MAXVOICES; i++)
		{
			Preset[k].m_pScale[i] = new int [pDoc->m_pScale[i][0] + 1];
			for(int j =0; j<=pDoc->m_pScale[i][0]; j++)
				Preset[k].m_pScale[i][j] = pDoc->m_pScale[i][j];
		}

		for(i = VOICE1; i<MAXVOICES; i++)
		{
			Preset[k].m_pUserScale[i] = new int [pDoc->m_pUserScale[i][0] + 1];
			for(int j =0; j<=pDoc->m_pUserScale[i][0]; j++)
				Preset[k].m_pUserScale[i][j] = pDoc->m_pUserScale[i][j];
		}

	}

}

void CRandomizerParametersDlg::UpdateList()
{
	CListBox* pList = (CListBox*)GetDlgItem(IDC_PARAMETERS_LIST);

	

		for (int k = 0; k<50; k++)
			if (Preset[k].Name!="")
				pList->AddString(Preset[k].Name);
}


BOOL CRandomizerParametersDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	SetWindowText(WindowTitle);
	
	CListBox* pList = (CListBox*)GetDlgItem(IDC_PARAMETERS_LIST);

	pList->SetHorizontalExtent(720);

	for (int k = 0; k<50; k++)
		if (Preset[k].Name!="")
			pList->AddString(Preset[k].Name);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CRandomizerParametersDlg::OnRemove() 
{


	CListBox* pList = (CListBox*)GetDlgItem(IDC_PARAMETERS_LIST);

	int sel = pList->GetCurSel();

	if (sel == LB_ERR)
		return;

	if (MessageBox("Are you sure?", "Remove Preset", MB_YESNO+MB_ICONEXCLAMATION) != IDYES)
		return;

	CString name;

	pList->GetText(sel, name);

	for (int k = 0; k<50; k++)
	{
		if (Preset[k].Name == name)
			break;
	}

	if ((k>48)&&(Preset[49].Name!=name))
	{
		MessageBox("Preset not found, BUG: this should not happen!", "FractMus", MB_OK+MB_ICONEXCLAMATION);
		return;
	}
	else
	{
		Preset[k].Name = "";
		pList->DeleteString(sel);
	}



	
}

void CRandomizerParametersDlg::OnClear() 
{

	CListBox* pList = (CListBox*)GetDlgItem(IDC_PARAMETERS_LIST);

	if (MessageBox("Are you sure?", "Clear all presets", MB_YESNO+MB_ICONEXCLAMATION) ==IDYES)
	{
		for(int k = 0; k<50; k++)
			Preset[k].Name = "";

		pList->ResetContent();


	}
}

void CRandomizerParametersDlg::OnReplace() 
{
	CListBox* pList = (CListBox*)GetDlgItem(IDC_PARAMETERS_LIST);

	if (!UpdateData())
		return;


	if (!(pRand->UpdateData(TRUE)))
		return;


	if (!pList->GetCount()||pList->GetCount() == LB_ERR)
		return;

	int sel = pList->GetCurSel();

	if (sel == LB_ERR)
		return;

	CString name;

	pList->GetText(sel, name);

	for (int k = 0; k<50; k++)
	{
		if (Preset[k].Name == name)
			break;
	}

	CFractMusDoc* pDoc = pRand->m_Parent->GetDocument();

	if ((k>48)&&(Preset[49].Name!=name))
	{
		MessageBox("Preset not found: This is a BUG, please report it to the author!", "FractMus", MB_OK+MB_ICONEXCLAMATION);
		return;
	}
	else
	{
		if (m_newpresetname == "")
		{
			MessageBox("Please select a name for the preset","FractMus",MB_OK+MB_ICONEXCLAMATION);
			return;
		}

		for(int r = 0; r<50; r++)
		{
			if((Preset[r].Name == m_newpresetname)&&(r!=k))
			{
				MessageBox("There is another preset with that name, please choose another name", "FractMus", MB_OK+MB_ICONEXCLAMATION);
				return;
			}
		}

		if (MessageBox("Replace preset with current parameters?", "FractMus", MB_YESNO+MB_ICONQUESTION) != IDYES)
			return;

		Preset[k].Name	 = m_newpresetname;

	//// fill preset

		Preset[k].m_P1From = pRand->m_P1From;
		Preset[k].m_P1To = pRand->m_P1To;
		Preset[k].m_P2From = pRand->m_P2From;
		Preset[k].m_P2To = pRand->m_P2To;

		for (int i = 0; i<128; i++)
			Preset[k].Instrument[i] = pRand->Instrument[i];

		for (i = 0; i<97; i++)
			Preset[k].Notes[i] = pRand->Notes[i];

		for (i = 0; i<15; i++)
			Preset[k].Scales[i] = pRand->Scales[i];

			Preset[k].Scales[15] = pRand->ScalesChoice.m_user;

		for (i = 0; i<47; i++)
			Preset[k].PercussionInstrument[i] = pRand->PercussionInstrument[i];

			Preset[k].Algorithms[0] = pRand->Algorithms.m_morsethue;
			Preset[k].Algorithms[1] = pRand->Algorithms.m_logmap;
			Preset[k].Algorithms[2] = pRand->Algorithms.m_noise;
			Preset[k].Algorithms[3] = pRand->Algorithms.m_henon;
			Preset[k].Algorithms[4] = pRand->Algorithms.m_hopalong;
			Preset[k].Algorithms[5] = pRand->Algorithms.m_martin;
			Preset[k].Algorithms[6] = pRand->Algorithms.m_ginger;
			Preset[k].Algorithms[7] = pRand->Algorithms.m_lorentz;
			Preset[k].Algorithms[8] = pRand->Algorithms.m_earthworm;
			Preset[k].Algorithms[9] = pRand->Algorithms.m_random;
			Preset[k].Algorithms[10] = pRand->Algorithms.m_hailstone ;
			Preset[k].Algorithms[11] = pRand->Algorithms.m_wolfram;

		Preset[k].AlgorithmsNumchoices = pRand->Algorithms.numchoices;

		
			Preset[k].Octaves[0] = pRand->Octaves.m_one;
			Preset[k].Octaves[1] = pRand->Octaves.m_two;
			Preset[k].Octaves[2] = pRand->Octaves.m_three;
			Preset[k].Octaves[3] = pRand->Octaves.m_four;


		Preset[k].OctavesNumchoices = pRand->Octaves.numchoices;

			Preset[k].NoteValues[0] = pRand->NoteValues.m_whole;
			Preset[k].NoteValues[1] = pRand->NoteValues.m_half;
			Preset[k].NoteValues[2] = pRand->NoteValues.m_quarter;
			Preset[k].NoteValues[3] = pRand->NoteValues.m_8;
			Preset[k].NoteValues[4] = pRand->NoteValues.m_16;
			Preset[k].NoteValues[5] = pRand->NoteValues.m_32;
			Preset[k].NoteValues[6] = pRand->NoteValues.m_dottedwhole;
			Preset[k].NoteValues[7] = pRand->NoteValues.m_dottedhalf;
			Preset[k].NoteValues[8] = pRand->NoteValues.m_dottedquarter;
			Preset[k].NoteValues[9] = pRand->NoteValues.m_dotted8;
			Preset[k].NoteValues[10] = pRand->NoteValues.m_dotted16;
			Preset[k].NoteValues[11] = pRand->NoteValues.m_other;


		Preset[k].NoteValuesNumchoices = pRand->NoteValues.numchoices;

		Preset[k].NoteValuesOtherMin = pRand->NoteValues.othermin;
		Preset[k].NoteValuesOtherMax = pRand->NoteValues.othermax;


			Preset[k].Dynamics[0] = pRand->Dynamics.m_pp;
			Preset[k].Dynamics[1] = pRand->Dynamics.m_p;
			Preset[k].Dynamics[2] = pRand->Dynamics.m_mp;
			Preset[k].Dynamics[3] = pRand->Dynamics.m_mf;
			Preset[k].Dynamics[4] = pRand->Dynamics.m_f;
			Preset[k].Dynamics[5] = pRand->Dynamics.m_ff;

		Preset[k].DynamicsNumchoices = pRand->Dynamics.numchoices;

		Preset[k].m_algorithm = pRand->m_algorithm;
		Preset[k].m_dynamic = pRand->m_dynamic;
		Preset[k].m_instrument = pRand->m_instrument;
		Preset[k].m_inverted = pRand->m_inverted;
		Preset[k].m_mode = pRand->m_mode;
		Preset[k].m_modulate = pRand->m_modulate;
		Preset[k].m_note = pRand->m_note;
		Preset[k].m_noteval = pRand->m_noteval;
		Preset[k].m_octaves = pRand->m_octaves;
		Preset[k].m_pan = pRand->m_pan;
		Preset[k].m_param1 = pRand->m_param1;
		Preset[k].m_param2 = pRand->m_param2;
		Preset[k].m_scale = pRand->m_scale;
		Preset[k].m_tempo = pRand->m_tempo;
		Preset[k].m_numberOfEvents = pRand->m_numberOfEvents;
		Preset[k].m_counterMin = pRand->m_counterMin;
		Preset[k].m_counterMax = pRand->m_counterMax;
		Preset[k].m_allowSilence = pRand->m_allowSilence;
		Preset[k].m_coeff = pRand->m_coeff;
		Preset[k].m_onoff = pRand->m_onoff;
		Preset[k].m_userscl = pRand->m_userscl;
		Preset[k].m_onlyusrscl = pRand->m_onlyusrscl;
		Preset[k].m_matchscl = pRand->m_matchscl;
		Preset[k].m_minOnVoices = pRand->m_minOnVoices;
		Preset[k].m_CountersChoice = pRand->m_CountersChoice;
		Preset[k].m_CountersRandomMin = pRand->m_CountersRandomMin;
		Preset[k].m_CountersRandomMax = pRand->m_CountersRandomMax;
		Preset[k].m_sequential = pRand->m_sequential;
		Preset[k].m_percussion = pRand->m_percussion;

		Preset[k].m_exact = pRand->m_exact;
		Preset[k].m_atmost = pRand->m_atmost;
		Preset[k].m_exactORatmost = pRand->m_exactORatmost;

		for(i = VOICE1; i<MAXVOICES; i++)
			Preset[k].m_VoiceOn[i] = pRand->m_VoiceOn[i];

		Preset[k].m_includesettings = m_includesettings;

		Preset[k].m_TempoMarking = pDoc->m_TempoMarking;
		Preset[k].m_TimeSigNum = pDoc->m_TimeSigNum;
		Preset[k].m_TimeSigDen = pDoc->m_TimeSigDen;

		for(i = VOICE1; i<MAXVOICES; i++)
			Preset[k].m_IsActive[i] = pDoc->m_IsActive[i];


		for (i = VOICE1; i<MAXVOICES; i++)
		{
			Preset[k].m_Modulates[i] = pDoc->m_Modulates[i];
			Preset[k].m_ModulRandom[i] = pDoc->m_ModulRandom[i];
			Preset[k].m_ModulNum[i] = pDoc->m_ModulNum[i];
			Preset[k].m_Base[i] = pDoc->m_Base[i];
			Preset[k].m_Multi[i] = pDoc->m_Multi[i];
			Preset[k].m_StartNum[i] = pDoc->m_StartNum[i];
			Preset[k].m_ScaleID[i] = pDoc->m_ScaleID[i];
			Preset[k].m_NumOcts[i] = pDoc->m_NumOcts[i];
			Preset[k].m_NumOctsID[i] = pDoc->m_NumOctsID[i];
			Preset[k].m_Note[i] = pDoc->m_Note[i];
			Preset[k].m_NoteValue[i] = pDoc->m_NoteValue[i];
			Preset[k].m_NoteValueID[i] = pDoc->m_NoteValueID[i];
			Preset[k].m_Instrument[i] = pDoc->m_Instrument[i];
			Preset[k].m_Channel[i] = pDoc->m_Channel[i];
			Preset[k].m_Mode[i] = pDoc->m_mode[i];
			Preset[k].m_Inverted[i] = pDoc->m_Inverted[i];
			Preset[k].m_Dynamic[i] = pDoc->m_Dynamic[i];
			Preset[k].m_DynChoice[i] = pDoc->m_DynChoice[i];
			Preset[k].m_LogMapVar[i] = pDoc->m_LogMapVar[i];
			Preset[k].m_FNoiseVar[i] = pDoc->m_FNoiseVar[i];
			Preset[k].m_HenonA[i] = pDoc->m_HenonA[i];
			Preset[k].m_HenonB[i] = pDoc->m_HenonB[i];
			Preset[k].m_HopalongVar[i] = pDoc->m_HopalongVar[i];
			Preset[k].m_MartinVar[i] = pDoc->m_MartinVar[i];
			Preset[k].m_GingerX[i] = pDoc->m_GingerX[i];
			Preset[k].m_GingerY[i] = pDoc->m_GingerY[i];
			Preset[k].m_LorentzVar[i] = pDoc->m_LorentzVar[i];
			Preset[k].m_EarthWormVar[i] = pDoc->m_EarthWormVar[i];
			Preset[k].m_EarthWormMulti[i] = pDoc->m_EarthWormMulti[i];
			Preset[k].m_EarthWormTruncator[i] = pDoc->m_EarthWormTruncator[i];
			Preset[k].m_RandomMin[i] = pDoc->m_RandomMin[i];
			Preset[k].m_RandomMax[i] = pDoc->m_RandomMax[i];
			Preset[k].m_WolframRule[i] = pDoc->m_WolframRule[i];
			Preset[k].m_WolframInit[i] = pDoc->m_WolframInit[i];
			Preset[k].m_WolframSize[i] = pDoc->m_WolframSize[i];
			Preset[k].m_Hailstone[i] = pDoc->m_Hailstone[i];
			Preset[k].m_Pan[i] = pDoc->m_Pan[i];
			Preset[k].m_MatchScale[i] = pDoc->m_MatchScale[i];
			Preset[k].m_Percussion[i] = pDoc->m_Percussion[i];


			Preset[k].AlgorithmNum[i] = pDoc->AlgorithmNum[i];

		}

		for(i = VOICE1; i<MAXVOICES; i++)
		{
			if (Preset[k].m_pScale[i])
			{
				delete [] Preset[k].m_pScale[i];

				Preset[k].m_pScale[i] = NULL;
			}
			if (Preset[k].m_pUserScale[i])
			{
				delete [] Preset[k].m_pUserScale[i];
				Preset[k].m_pUserScale[i] = NULL;
			}
		}

		for(i = VOICE1; i<MAXVOICES; i++)
		{
			Preset[k].m_pScale[i] = new int [pDoc->m_pScale[i][0] + 1];
			for(int j =0; j<=pDoc->m_pScale[i][0]; j++)
				Preset[k].m_pScale[i][j] = pDoc->m_pScale[i][j];
		}

		for(i = VOICE1; i<MAXVOICES; i++)
		{
			Preset[k].m_pUserScale[i] = new int [pDoc->m_pUserScale[i][0] + 1];
			for(int j =0; j<=pDoc->m_pUserScale[i][0]; j++)
				Preset[k].m_pUserScale[i][j] = pDoc->m_pUserScale[i][j];
		}

		pList->DeleteString(sel);

		pList->InsertString(sel, (LPCTSTR)Preset[k].Name);

	}

	
}

void CRandomizerParametersDlg::OnSelchangeParametersList() 
{

	if(!UpdateData())
		return;

	CListBox* pList = (CListBox*)GetDlgItem(IDC_PARAMETERS_LIST);

	if (!pList->GetCount()||pList->GetCount() == LB_ERR)
		return;

	int sel = pList->GetCurSel();

	if (sel == LB_ERR)
		return;

	CString name;

	pList->GetText(sel, name);

	m_newpresetname = name;

	UpdateData(FALSE);


	
}
