
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


// RoundEventCountersDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FractMus.h"
#include "RoundEventCountersDlg.h"
#include "FractMusView.h"
#include "FractMusDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRoundEventCountersDlg dialog


CRoundEventCountersDlg::CRoundEventCountersDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRoundEventCountersDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRoundEventCountersDlg)
	m_largest = 0;
	m_up = 0;
	//}}AFX_DATA_INIT

	IsSelected = NULL;



}

CRoundEventCountersDlg::~CRoundEventCountersDlg()
{

	if (IsSelected)
	{
		delete IsSelected;
		IsSelected = NULL;
	}
}



void CRoundEventCountersDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRoundEventCountersDlg)
	DDX_Radio(pDX, IDC_ROUND_LARGEST, m_largest);
	DDX_Radio(pDX, IDC_ROUND_UP, m_up);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRoundEventCountersDlg, CDialog)
	//{{AFX_MSG_MAP(CRoundEventCountersDlg)
	ON_BN_CLICKED(IDC_SELECTALLEVENTS, OnSelectallevents)
	ON_BN_CLICKED(IDC_SELECTNONEEVENTS, OnSelectnoneevents)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRoundEventCountersDlg message handlers

void CRoundEventCountersDlg::OnSelectallevents() 
{
	CFractMusDoc* pDoc = pView->GetDocument();
	CListBox* pList = (CListBox*)GetDlgItem(IDC_EVENTS_LIST);

	pList->SelItemRange(TRUE, 0, pDoc->m_NumEvents);
	
}

void CRoundEventCountersDlg::OnSelectnoneevents() 
{
	CFractMusDoc* pDoc = pView->GetDocument();
	CListBox* pList = (CListBox*)GetDlgItem(IDC_EVENTS_LIST);

	pList->SelItemRange(FALSE, 0, pDoc->m_NumEvents);
	
}

void CRoundEventCountersDlg::OnOK() 
{
	UpdateData(TRUE);

	CFractMusDoc* pDoc = pView->GetDocument();	
	CListBox* pList = (CListBox*)GetDlgItem(IDC_EVENTS_LIST);


	int numchoices = pList->GetSelCount();

	if(numchoices<1)
	{
		MessageBox("No events selected!","Error",MB_OK+MB_ICONEXCLAMATION);
		return;
	}

	for (int i =0; i<=pDoc->m_NumEvents; i++)
		IsSelected[i] = FALSE;


	int* selectedItems = new int[numchoices];

	pList->GetSelItems(numchoices, selectedItems);

	for(i =0; i<numchoices; i++)
		IsSelected[ selectedItems[i] ] = TRUE;

	float LargestNoteValue, SmallestNoteValue;

	CWaitCursor wait;


	for (int k = 0; k<=pDoc->m_NumEvents; k++)
	{
		if (IsSelected[k])
		{
			LargestNoteValue = 1.0f;
			SmallestNoteValue = 1000.0f;

			for (int i = VOICE1; i<MAXVOICES; i++)
			{
				if (pDoc->Event[k].IsActive[i])
				{
					if (pDoc->Event[k].NoteValue[i]>LargestNoteValue)
						LargestNoteValue = pDoc->Event[k].NoteValue[i];

					if (pDoc->Event[k].NoteValue[i]<SmallestNoteValue)
						SmallestNoteValue = pDoc->Event[k].NoteValue[i];
				}
			}

			switch (m_largest)
			{
				case 0:
					switch (m_up)
					{
						case 0:
							while((pDoc->Event[k].count%(long)LargestNoteValue)&&(pDoc->Event[k].count<50000))
								pDoc->Event[k].count++;
							while((pDoc->Event[k].genCount%(long)LargestNoteValue)&&(pDoc->Event[k].genCount<50000))
								pDoc->Event[k].genCount++;
							if ((pDoc->Event[k].genCount<=pDoc->Event[k].count)&&((pDoc->Event[k].genCount+LargestNoteValue)<50000))
								pDoc->Event[k].genCount+=LargestNoteValue;
							else if ((pDoc->Event[k].genCount<=pDoc->Event[k].count)&&(pDoc->Event[k].count-LargestNoteValue)>-1)
								pDoc->Event[k].count-=LargestNoteValue;
							break;
						case 1:
							while((pDoc->Event[k].count%(long)LargestNoteValue)&&(pDoc->Event[k].count>-1))
								pDoc->Event[k].count--;
							while((pDoc->Event[k].genCount%(long)LargestNoteValue)&&(pDoc->Event[k].genCount>-1))
								pDoc->Event[k].genCount--;
							if ((pDoc->Event[k].genCount<=pDoc->Event[k].count)&&((pDoc->Event[k].genCount+LargestNoteValue)<50000))
								pDoc->Event[k].genCount+=LargestNoteValue;
							else if ((pDoc->Event[k].genCount<=pDoc->Event[k].count)&&(pDoc->Event[k].count-LargestNoteValue)>-1)
								pDoc->Event[k].count-=LargestNoteValue;
							break;

					}
					break;
				case 1:
					switch (m_up)
					{
						case 0:
							while((pDoc->Event[k].count%(long)SmallestNoteValue)&&(pDoc->Event[k].count<50000))
								pDoc->Event[k].count++;
							while((pDoc->Event[k].genCount%(long)SmallestNoteValue)&&(pDoc->Event[k].genCount<50000))
								pDoc->Event[k].genCount++;
							if ((pDoc->Event[k].genCount<=pDoc->Event[k].count)&&((pDoc->Event[k].genCount+SmallestNoteValue)<50000))
								pDoc->Event[k].genCount+=SmallestNoteValue;
							else if ((pDoc->Event[k].genCount<=pDoc->Event[k].count)&&(pDoc->Event[k].count-SmallestNoteValue)>-1)
								pDoc->Event[k].count-=SmallestNoteValue;

							break;
						case 1:
							while((pDoc->Event[k].count%(long)SmallestNoteValue)&&(pDoc->Event[k].count>-1))
								pDoc->Event[k].count--;
							while((pDoc->Event[k].genCount%(long)SmallestNoteValue)&&(pDoc->Event[k].genCount>-1))
								pDoc->Event[k].genCount--;
							if ((pDoc->Event[k].genCount<=pDoc->Event[k].count)&&((pDoc->Event[k].genCount+SmallestNoteValue)<50000))
								pDoc->Event[k].genCount+=SmallestNoteValue;
							else if ((pDoc->Event[k].genCount<=pDoc->Event[k].count)&&(pDoc->Event[k].count-SmallestNoteValue)>-1)
								pDoc->Event[k].count-=SmallestNoteValue;
							break;
					}
					break;
			}
		}
	}

		delete selectedItems;

        selectedItems = NULL;
	
}

BOOL CRoundEventCountersDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CFractMusDoc* pDoc = pView->GetDocument();
	
	CListBox* pList = (CListBox*)GetDlgItem(IDC_EVENTS_LIST);


	if (pView->m_pEvents)
	{
		pView->m_pEvents->DestroyWindow();
		pView->EventsDone();
	}


	if (pDoc->m_NumEvents>-1)
	{

		for (int i = 0; i<=pDoc->m_NumEvents; i++)
		{
			char s[55];

			itoa(i, s, 10);

			pList->AddString(s);
		}

		if(IsSelected)
		{
			delete IsSelected;
			IsSelected = NULL;
		}

		IsSelected = new BOOL [pDoc->m_NumEvents + 1];

		for (i=0; i<=pDoc->m_NumEvents; i++)
			IsSelected[i] = FALSE;
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
