
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


// ScaleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FractMus.h"
#include "ScaleDlg.h"
#include "RandDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CScaleDlg dialog


CScaleDlg::CScaleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CScaleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CScaleDlg)
	m_user = TRUE;
	//}}AFX_DATA_INIT

}


void CScaleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CScaleDlg)
	DDX_Check(pDX, IDC_USER_CHK, m_user);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CScaleDlg, CDialog)
	//{{AFX_MSG_MAP(CScaleDlg)
	ON_BN_CLICKED(IDC_USER_CHK, OnUserChk)
	ON_BN_CLICKED(IDC_ALL, OnAll)
	ON_BN_CLICKED(IDC_NONE, OnNone)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScaleDlg message handlers

void CScaleDlg::OnCancel() 
{
}

void CScaleDlg::OnOK() 
{
	UpdateData();
	
	CListBox* pList = (CListBox*)GetDlgItem(IDC_SCALES_LIST);

	int numchoices = pList->GetSelCount();

	if(numchoices<1&&(!m_user))
	{
		MessageBox("Please select at least one scale","Error",MB_OK+MB_ICONEXCLAMATION);
		return;
	}

	for (int i =0; i<15; i++)
		IsSelected[i] = FALSE;


	int* selectedItems = new int[numchoices];

	pList->GetSelItems(numchoices, selectedItems);

	for(i =0; i<numchoices; i++)
		IsSelected[ selectedItems[i] ] = TRUE;

	delete selectedItems;

    selectedItems = NULL;

	CDialog::OnOK();
}


void CScaleDlg::OnUserChk() 
{
	UpdateData();
	
}


BOOL CScaleDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CListBox* pList = (CListBox*)GetDlgItem(IDC_SCALES_LIST);

	pList->AddString("Major");
	pList->AddString("Minor Natural");
	pList->AddString("Minor Harmonic");
	pList->AddString("Minor Melodic");
	pList->AddString("Lydian");
	pList->AddString("Mixolydian");
	pList->AddString("Dorian");
	pList->AddString("Phrygian");
	pList->AddString("Locrian");
	pList->AddString("Octatonic 1");
	pList->AddString("Octatonic 2");
	pList->AddString("Accoustic");
	pList->AddString("Pentatonic");
	pList->AddString("Wholetone");
	pList->AddString("Chromatic");



	for (int i =0; i<15; i++)
		IsSelected[i] = FALSE;

	for (i =0; i<15; i++)
		IsSelected[i] = pRand->Scales[i];

	for (i =0; i<15; i++)
		if (IsSelected[i])
			pList->SetSel(i);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CScaleDlg::OnAll() 
{
	CListBox* pList = (CListBox*)GetDlgItem(IDC_SCALES_LIST);

	pList->SelItemRange(TRUE, 0, 14);

	m_user = TRUE;

	UpdateData(FALSE);
	
}

void CScaleDlg::OnNone() 
{
	CListBox* pList = (CListBox*)GetDlgItem(IDC_SCALES_LIST);

	pList->SelItemRange(FALSE, 0, 14);

	m_user = FALSE;

	UpdateData(FALSE);
	
}
