
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


// StartNoteDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FractMus.h"
#include "StartNoteDlg.h"
#include "RandDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CStartNoteDlg dialog


CStartNoteDlg::CStartNoteDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CStartNoteDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CStartNoteDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CStartNoteDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStartNoteDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CStartNoteDlg, CDialog)
	//{{AFX_MSG_MAP(CStartNoteDlg)
	ON_BN_CLICKED(IDC_ALL, OnAll)
	ON_BN_CLICKED(IDC_NONE, OnNone)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStartNoteDlg message handlers

void CStartNoteDlg::OnCancel() 
{
}

void CStartNoteDlg::OnOK() 
{
	CListBox* pList = (CListBox*)GetDlgItem(IDC_NOTES_LIST);

	int numchoices = pList->GetSelCount();

	if(numchoices<1)
	{
		MessageBox("Please select at least one note","Error",MB_OK+MB_ICONEXCLAMATION);
		return;
	}

	for (int i =0; i<97; i++)
		IsSelected[i] = FALSE;


	int* selectedItems = new int[numchoices];

	pList->GetSelItems(numchoices, selectedItems);

	for(i =0; i<numchoices; i++)
		IsSelected[ selectedItems[i] ] = TRUE;

    delete selectedItems;

    selectedItems = NULL;
	
	CDialog::OnOK();
}

void CStartNoteDlg::OnAll() 
{
	CListBox* pList = (CListBox*)GetDlgItem(IDC_NOTES_LIST);

	pList->SelItemRange(TRUE, 0, 96);
	
}

void CStartNoteDlg::OnNone() 
{
	CListBox* pList = (CListBox*)GetDlgItem(IDC_NOTES_LIST);

	pList->SelItemRange(FALSE, 0, 96);
	
}

BOOL CStartNoteDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CListBox* pList = (CListBox*)GetDlgItem(IDC_NOTES_LIST);

	pList->AddString("C0");
	pList->AddString("C#0");
	pList->AddString("D0");
	pList->AddString("D#0");
	pList->AddString("E0");
	pList->AddString("F0");
	pList->AddString("F#0");
	pList->AddString("G0");
	pList->AddString("G#0");
	pList->AddString("A0");
	pList->AddString("A#0");
	pList->AddString("B0");
	pList->AddString("C1");
	pList->AddString("C#1");
	pList->AddString("D1");
	pList->AddString("D#1");
	pList->AddString("E1");
	pList->AddString("F1");
	pList->AddString("F#1");
	pList->AddString("G1");
	pList->AddString("G#1");
	pList->AddString("A1");
	pList->AddString("A#1");
	pList->AddString("B1");
	pList->AddString("C2");
	pList->AddString("C#2");
	pList->AddString("D2");
	pList->AddString("D#2");
	pList->AddString("E2");
	pList->AddString("F2");
	pList->AddString("F#2");
	pList->AddString("G2");
	pList->AddString("G#2");
	pList->AddString("A2");
	pList->AddString("A#2");
	pList->AddString("B2");
	pList->AddString("C3");
	pList->AddString("C#3");
	pList->AddString("D3");
	pList->AddString("D#3");
	pList->AddString("E3");
	pList->AddString("F3");
	pList->AddString("F#3");
	pList->AddString("G3");
	pList->AddString("G#3");
	pList->AddString("A3");
	pList->AddString("A#3");
	pList->AddString("B3");
	pList->AddString("C4");
	pList->AddString("C#4");
	pList->AddString("D4");
	pList->AddString("D#4");
	pList->AddString("E4");
	pList->AddString("F4");
	pList->AddString("F#4");
	pList->AddString("G4");
	pList->AddString("G#4");
	pList->AddString("A4");
	pList->AddString("A#4");
	pList->AddString("B4");
	pList->AddString("C5");
	pList->AddString("C#5");
	pList->AddString("D5");
	pList->AddString("D#5");
	pList->AddString("E5");
	pList->AddString("F5");
	pList->AddString("F#5");
	pList->AddString("G5");
	pList->AddString("G#5");
	pList->AddString("A5");
	pList->AddString("A#5");
	pList->AddString("B5");
	pList->AddString("C6");
	pList->AddString("C#6");
	pList->AddString("D6");
	pList->AddString("D#6");
	pList->AddString("E6");
	pList->AddString("F6");
	pList->AddString("F#6");
	pList->AddString("G6");
	pList->AddString("G#6");
	pList->AddString("A6");
	pList->AddString("A#6");
	pList->AddString("B6");
	pList->AddString("C7");
	pList->AddString("C#7");
	pList->AddString("D7");
	pList->AddString("D#7");
	pList->AddString("E7");
	pList->AddString("F7");
	pList->AddString("F#7");
	pList->AddString("G7");
	pList->AddString("G#7");
	pList->AddString("A7");
	pList->AddString("A#7");
	pList->AddString("B7");
	pList->AddString("C8");


	for (int i =0; i<97; i++)
		IsSelected[i] = FALSE;

	for (i =0; i<97; i++)
		IsSelected[i] = pRand->Notes[i];

	for (i =0; i<97; i++)
		if (IsSelected[i])
			pList->SetSel(i);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
