
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


// TransposerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FractMus.h"
#include "FractMusView.h"
#include "FractMusDoc.h"
#include "TransposerDlg.h"
#include "defs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define DOWN	0
#define UP		1		


/////////////////////////////////////////////////////////////////////////////
// CTransposerDlg dialog


CTransposerDlg::CTransposerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTransposerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTransposerDlg)
	m_AllActiveVoices = FALSE;
	//}}AFX_DATA_INIT

	IsSelected = NULL;


}

CTransposerDlg::~CTransposerDlg()
{

	if (IsSelected)
	{
		delete IsSelected;
		IsSelected = NULL;
	}
}

void CTransposerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTransposerDlg)
	DDX_Check(pDX, IDC_ALLACTIVEVOICES_CHK, m_AllActiveVoices);
	//}}AFX_DATA_MAP

	DDX_Check(pDX, IDC_VC1_CHK, m_VoiceOn[VOICE1]);
	DDX_Check(pDX, IDC_VC2_CHK, m_VoiceOn[VOICE2]);
	DDX_Check(pDX, IDC_VC3_CHK, m_VoiceOn[VOICE3]);
	DDX_Check(pDX, IDC_VC4_CHK, m_VoiceOn[VOICE4]);
	DDX_Check(pDX, IDC_VC5_CHK, m_VoiceOn[VOICE5]);
	DDX_Check(pDX, IDC_VC6_CHK, m_VoiceOn[VOICE6]);
	DDX_Check(pDX, IDC_VC7_CHK, m_VoiceOn[VOICE7]);
	DDX_Check(pDX, IDC_VC8_CHK, m_VoiceOn[VOICE8]);
	DDX_Check(pDX, IDC_VC9_CHK, m_VoiceOn[VOICE9]);
	DDX_Check(pDX, IDC_VC10_CHK, m_VoiceOn[VOICE10]);
	DDX_Check(pDX, IDC_VC11_CHK, m_VoiceOn[VOICE11]);
	DDX_Check(pDX, IDC_VC12_CHK, m_VoiceOn[VOICE12]);
	DDX_Check(pDX, IDC_VC13_CHK, m_VoiceOn[VOICE13]);
	DDX_Check(pDX, IDC_VC14_CHK, m_VoiceOn[VOICE14]);
	DDX_Check(pDX, IDC_VC15_CHK, m_VoiceOn[VOICE15]);
	DDX_Check(pDX, IDC_VC16_CHK, m_VoiceOn[VOICE16]);

	m_VoiceID[VOICE1] = IDC_VC1_CHK;
	m_VoiceID[VOICE2] = IDC_VC2_CHK;
	m_VoiceID[VOICE3] = IDC_VC3_CHK;
	m_VoiceID[VOICE4] = IDC_VC4_CHK;
	m_VoiceID[VOICE5] = IDC_VC5_CHK;
	m_VoiceID[VOICE6] = IDC_VC6_CHK;
	m_VoiceID[VOICE7] = IDC_VC7_CHK;
	m_VoiceID[VOICE8] = IDC_VC8_CHK;
	m_VoiceID[VOICE9] = IDC_VC9_CHK;
	m_VoiceID[VOICE10] = IDC_VC10_CHK;
	m_VoiceID[VOICE11] = IDC_VC11_CHK;
	m_VoiceID[VOICE12] = IDC_VC12_CHK;
	m_VoiceID[VOICE13] = IDC_VC13_CHK;
	m_VoiceID[VOICE14] = IDC_VC14_CHK;
	m_VoiceID[VOICE15] = IDC_VC15_CHK;
	m_VoiceID[VOICE16] = IDC_VC16_CHK;

}


BEGIN_MESSAGE_MAP(CTransposerDlg, CDialog)
	//{{AFX_MSG_MAP(CTransposerDlg)
	ON_BN_CLICKED(IDC_ALLACTIVEVOICES_CHK, OnAllactivevoicesChk)
	ON_BN_CLICKED(IDC_ALL, OnAll)
	ON_BN_CLICKED(IDC_NONE, OnNone)
	ON_BN_CLICKED(IDC_TRANSPOSE, OnTranspose)
	ON_BN_CLICKED(IDC_TRANSPOSE_EVENTS, OnTransposeEvents)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTransposerDlg message handlers

void CTransposerDlg::OnAllactivevoicesChk() 
{
	UpdateData(TRUE);	
}

BOOL CTransposerDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CFractMusDoc* pDoc = pView->GetDocument();
	
	CListBox* pList = (CListBox*)GetDlgItem(IDC_EVENTS_LIST);

	if (pDoc->m_NumEvents>-1)
	{

		for (int i = 0; i<=pDoc->m_NumEvents; i++)
		{
			char s[55];

			itoa(i, s, 10);

			pList->AddString(s);
		}

		if(IsSelected)
		{
			delete IsSelected;
			IsSelected = NULL;
		}

		IsSelected = new BOOL [pDoc->m_NumEvents + 1];

		for (i=0; i<=pDoc->m_NumEvents; i++)
			IsSelected[i] = FALSE;
	}

	GetDlgItem(IDC_ALL)->EnableWindow(pDoc->m_NumEvents>-1);
	GetDlgItem(IDC_NONE)->EnableWindow(pDoc->m_NumEvents>-1);
	GetDlgItem(IDC_ALLACTIVEVOICES_CHK)->EnableWindow(pDoc->m_NumEvents>-1);
	GetDlgItem(IDC_TRANSPOSE_EVENTS)->EnableWindow(pDoc->m_NumEvents>-1);

	CComboBox* pCB = (CComboBox*)GetDlgItem(IDC_UPDOWN_COMBO);

	pCB->SetCurSel(1);

	pCB = (CComboBox*)GetDlgItem(IDC_INTERVAL_COMBO);

	pCB->SetCurSel(0);

	m_AllActiveVoices = FALSE;

	UpdateData(FALSE);



	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CTransposerDlg::OnAll() 
{
	CFractMusDoc* pDoc = pView->GetDocument();
	CListBox* pList = (CListBox*)GetDlgItem(IDC_EVENTS_LIST);

	pList->SelItemRange(TRUE, 0, pDoc->m_NumEvents);
	
}

void CTransposerDlg::OnNone() 
{
	CFractMusDoc* pDoc = pView->GetDocument();
	CListBox* pList = (CListBox*)GetDlgItem(IDC_EVENTS_LIST);

	pList->SelItemRange(FALSE, 0, pDoc->m_NumEvents);
	
}

void CTransposerDlg::OnTranspose() 
{
	UpdateData(TRUE);
	CFractMusDoc* pDoc = pView->GetDocument();	

	int numv = 0;

	for (int g = VOICE1; g<MAXVOICES; g++)
		if (m_VoiceOn[g])
			++numv;

	if ((!numv))
	{
		MessageBox("No voices selected!","Error",MB_OK+MB_ICONEXCLAMATION);
		return;
	}


	///////////////////////


	CComboBox* pB;

	int UpOrDown, Interval;

	pB = (CComboBox*)GetDlgItem(IDC_UPDOWN_COMBO);

	switch (pB->GetCurSel())
	{
		case DOWN:
			UpOrDown = -1;
			break;
		case UP:
			UpOrDown = 1;
			break;

	}

	pB = (CComboBox*)GetDlgItem(IDC_INTERVAL_COMBO);

	Interval = pB->GetCurSel(); 
	++Interval;

	for (int i = VOICE1; i<MAXVOICES; i++)
	{
		if (m_VoiceOn[i])
		{
			if( ((pDoc->m_Note[i] + (UpOrDown*Interval))>=0) && ((pDoc->m_Note[i] + (UpOrDown*Interval))<96) )
			{
				int sel = pDoc->m_Note[i] + (UpOrDown*Interval);
				pDoc->m_Note[i] += (UpOrDown*Interval);
				pView->m_Note[i] = pDoc->m_Note[i];
				pB = (CComboBox*)(pView->GetDlgItem(pView->NoteID[i]));
				pB->SetCurSel(sel);
			}
		}
	}
	
}

void CTransposerDlg::OnCancel() 
{
	UpdateData(TRUE);
	
	CDialog::OnCancel();
}

void CTransposerDlg::OnTransposeEvents() 
{

	UpdateData(TRUE);

	CFractMusDoc* pDoc = pView->GetDocument();	
	CListBox* pList = (CListBox*)GetDlgItem(IDC_EVENTS_LIST);


	int numchoices = pList->GetSelCount();

	if(numchoices<1)
	{
		MessageBox("No events selected!","Error",MB_OK+MB_ICONEXCLAMATION);
		return;
	}

	int numv = 0;

	for (int g = VOICE1; g<MAXVOICES; g++)
		if (m_VoiceOn[g])
			++numv;

	if ((!numv)&&(!m_AllActiveVoices))
	{
		MessageBox("No voices selected!","Error",MB_OK+MB_ICONEXCLAMATION);
		return;
	}

	for (int i =0; i<=pDoc->m_NumEvents; i++)
		IsSelected[i] = FALSE;


	int* selectedItems = new int[numchoices];

	pList->GetSelItems(numchoices, selectedItems);

	for(i =0; i<numchoices; i++)
		IsSelected[ selectedItems[i] ] = TRUE;


	///////////////////////


	CComboBox* pB;

	int UpOrDown, Interval;

	pB = (CComboBox*)GetDlgItem(IDC_UPDOWN_COMBO);

	switch (pB->GetCurSel())
	{
		case DOWN:
			UpOrDown = -1;
			break;
		case UP:
			UpOrDown = 1;
			break;

	}



	pB = (CComboBox*)GetDlgItem(IDC_INTERVAL_COMBO);

	Interval = pB->GetCurSel(); 
	++Interval;

	CWaitCursor wait;


	for (int k = 0; k<=pDoc->m_NumEvents; k++)
	{
		if (IsSelected[k])
		{
			for (int i = VOICE1; i<MAXVOICES; i++)
			{
				if (m_VoiceOn[i]||((pDoc->Event[k].IsActive[i])&&m_AllActiveVoices))
				{
					if( ((pDoc->Event[k].Note[i] + (UpOrDown*Interval))>=0) && ((pDoc->Event[k].Note[i] + (UpOrDown*Interval))<96) )
					{
						pDoc->Event[k].Note[i] += (UpOrDown*Interval);
					}
				}
			}
		}
	}

	delete selectedItems;

	selectedItems = NULL;

	
}
