
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


// V1MidiSetDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FractMus.h"
#include "FractMusView.h"
#include "V1MidiSetDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CV1MidiSetDlg dialog


extern int PercussionChannel;


CV1MidiSetDlg::CV1MidiSetDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CV1MidiSetDlg::IDD, pParent)
{

	
	//{{AFX_DATA_INIT(CV1MidiSetDlg)
	m_inv = FALSE;
	m_dynchoice = -1;
	m_pan = 0;
	m_matchscl = FALSE;
	m_percussion = FALSE;
	//}}AFX_DATA_INIT
}


void CV1MidiSetDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CV1MidiSetDlg)
	DDX_Check(pDX, IDC_INVERTED, m_inv);
	DDX_Radio(pDX, IDC_PIANISSIMO, m_dynchoice);
	DDX_Scroll(pDX, IDC_PAN, m_pan);
	DDX_Check(pDX, IDC_MATCHSCL, m_matchscl);
	DDX_Check(pDX, IDC_PERCUSSION_CHK, m_percussion);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CV1MidiSetDlg, CDialog)
	//{{AFX_MSG_MAP(CV1MidiSetDlg)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_PAN_ZERO, OnPanZero)
	ON_BN_CLICKED(IDC_INVERTED, OnInverted)
	ON_CBN_CLOSEUP(IDC_CHANNEL_CMB, OnCloseupChannelCmb)
	ON_BN_CLICKED(IDC_PERCUSSION_CHK, OnPercussionChk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CV1MidiSetDlg message handlers




void CV1MidiSetDlg::OnCancel() 
{
	CDialog::OnCancel();

}



void CV1MidiSetDlg::OnOK() 
{
	UpdateData(TRUE);
	
	CComboBox* pCB = (CComboBox*)GetDlgItem(IDC_VOICE1_INSTRUMENT_COMBO);
	m_instrument = pCB->GetCurSel();

	pCB = (CComboBox*)GetDlgItem(IDC_VOICE1_MODE_COMBO);
	m_mode = pCB->GetCurSel();

	pCB = (CComboBox*)GetDlgItem(IDC_CHANNEL_CMB);
	m_channel = pCB->GetCurSel();

	pCB = (CComboBox*)GetDlgItem(IDC_PERCUSSION_COMBO);
	m_perc = pCB->GetCurSel();

	CDialog::OnOK();
	
}



BOOL CV1MidiSetDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	SetWindowText(m_title);

	
	CComboBox* pCB = (CComboBox*)GetDlgItem(IDC_VOICE1_INSTRUMENT_COMBO);
	CScrollBar* pSC = (CScrollBar*)GetDlgItem(IDC_PAN);
	CStatic* pSt = (CStatic*)GetDlgItem(IDC_PAN_STATIC);
	char s[20];

	pSC->SetScrollRange(-64, 63);
	pSC->SetScrollPos(m_pan);

	itoa(m_pan, s ,10);
	pSt->SetWindowText(s);

	GetDlgItem(IDC_CHANNEL_CMB)->EnableWindow(FALSE);


	pCB->SetCurSel(m_instrument);

	pCB = (CComboBox*)GetDlgItem(IDC_VOICE1_MODE_COMBO);

	pCB->SetCurSel(m_mode);

	pCB = (CComboBox*)GetDlgItem(IDC_CHANNEL_CMB);

	pCB->SetCurSel(m_channel);
	
	GetDlgItem(IDC_MATCHSCL)->EnableWindow(m_inv);

	pCB = (CComboBox*)GetDlgItem(IDC_PERCUSSION_COMBO);

	pCB->SetCurSel(m_perc);

	pCB = (CComboBox*)GetDlgItem(IDC_CHANNEL_CMB);

	int sel = pCB->GetCurSel();

	m_percussion = (sel == PercussionChannel)? TRUE : FALSE;

	UpdateData(FALSE);


	GetDlgItem(IDC_VOICE1_INSTRUMENT_COMBO)->EnableWindow(!m_percussion);
	GetDlgItem(IDC_PERCUSSION_COMBO)->EnableWindow(m_percussion);




	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CV1MidiSetDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CScrollBar* pSC = (CScrollBar*)GetDlgItem(IDC_PAN);
	CStatic* pSt = (CStatic*)GetDlgItem(IDC_PAN_STATIC);
	char s[20];

	if (pScrollBar != (CScrollBar*)pSC)
		return;

	int pos = pSC->GetScrollPos();

	switch(nSBCode)
	{
		case SB_LINERIGHT:
			pos++;
			if(pos>63) pos = 63;
			break;
		case SB_LINELEFT:
			pos--;
			if(pos<-64) pos = -64;
			break;
		case SB_THUMBPOSITION:
		case SB_THUMBTRACK:
			pos = nPos;
			break;
		case SB_PAGERIGHT:
			pos +=5;
			if(pos>63) pos = 63;
			break;
		case SB_PAGELEFT:
			pos -= 5;
			if(pos<-64) pos = -64;
			break;
	}

	pSC->SetScrollPos(pos);

	m_pan = pos;
	itoa(m_pan, s ,10);
	pSt->SetWindowText(s);

	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CV1MidiSetDlg::OnPanZero() 
{
	CScrollBar* pSC = (CScrollBar*)GetDlgItem(IDC_PAN);
	CStatic* pSt = (CStatic*)GetDlgItem(IDC_PAN_STATIC);
	char s[20];


	pSC->SetScrollPos(0);

	m_pan = 0;
	itoa(m_pan, s ,10);
	pSt->SetWindowText(s);
	
}

void CV1MidiSetDlg::OnInverted() 
{
	UpdateData(TRUE);
	
	GetDlgItem(IDC_MATCHSCL)->EnableWindow(m_inv);
}

void CV1MidiSetDlg::OnCloseupChannelCmb() 
{
	CComboBox* pCB = (CComboBox*)GetDlgItem(IDC_CHANNEL_CMB);

	int sel = pCB->GetCurSel();

	m_percussion = (sel == PercussionChannel)? TRUE : FALSE;

	UpdateData(FALSE);

	GetDlgItem(IDC_VOICE1_INSTRUMENT_COMBO)->EnableWindow(!m_percussion);
	GetDlgItem(IDC_PERCUSSION_COMBO)->EnableWindow(m_percussion);

	
}

void CV1MidiSetDlg::OnPercussionChk() 
{
	CComboBox* pCB;


	UpdateData(TRUE);

	if (m_percussion)
	{
		pCB = (CComboBox*)GetDlgItem(IDC_CHANNEL_CMB);

		pCB->SetCurSel(PercussionChannel);


		GetDlgItem(IDC_VOICE1_INSTRUMENT_COMBO)->EnableWindow(!m_percussion);
		GetDlgItem(IDC_PERCUSSION_COMBO)->EnableWindow(m_percussion);
	}
	else
	{
		pCB = (CComboBox*)GetDlgItem(IDC_CHANNEL_CMB);

		pCB->SetCurSel(m_voice);

		if (m_voice == PercussionChannel)
		{
			m_percussion = TRUE;
			UpdateData(FALSE);
		}

		GetDlgItem(IDC_VOICE1_INSTRUMENT_COMBO)->EnableWindow(!m_percussion);
		GetDlgItem(IDC_PERCUSSION_COMBO)->EnableWindow(m_percussion);

	}

	
}
