
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


// V1UsrSclDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FractMus.h"
#include "FractMusView.h"

#include "defs.h"


#include "V1UsrSclDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CV1UsrSclDlg dialog


CV1UsrSclDlg::CV1UsrSclDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CV1UsrSclDlg::IDD, pParent)
{


	//{{AFX_DATA_INIT(CV1UsrSclDlg)
	m_A_ON = FALSE;
	m_Ab_ON = FALSE;
	m_B_ON = FALSE;
	m_Bb_ON = FALSE;
	m_C_ON = FALSE;
	m_D_ON = FALSE;
	m_Db_ON = FALSE;
	m_E_ON = FALSE;
	m_Eb_ON = FALSE;
	m_F_ON = FALSE;
	m_G_ON = FALSE;
	m_Gb_ON = FALSE;

	//}}AFX_DATA_INIT

	m_title = "";

	m_numnotes = 0;

	for (int i=0; i<12; i++)
		m_bUserScale[i]=FALSE;

}


void CV1UsrSclDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CV1UsrSclDlg)
	DDX_Check(pDX, IDC_VOICE1_USERSCALE_A_CHK, m_A_ON);
	DDX_Check(pDX, IDC_VOICE1_USERSCALE_Ab_CHK, m_Ab_ON);
	DDX_Check(pDX, IDC_VOICE1_USERSCALE_B_CHK, m_B_ON);
	DDX_Check(pDX, IDC_VOICE1_USERSCALE_Bb_CHK, m_Bb_ON);
	DDX_Check(pDX, IDC_VOICE1_USERSCALE_C_CHK, m_C_ON);
	DDX_Check(pDX, IDC_VOICE1_USERSCALE_D_CHK, m_D_ON);
	DDX_Check(pDX, IDC_VOICE1_USERSCALE_Db_CHK, m_Db_ON);
	DDX_Check(pDX, IDC_VOICE1_USERSCALE_E_CHK, m_E_ON);
	DDX_Check(pDX, IDC_VOICE1_USERSCALE_Eb_CHK, m_Eb_ON);
	DDX_Check(pDX, IDC_VOICE1_USERSCALE_F_CHK, m_F_ON);
	DDX_Check(pDX, IDC_VOICE1_USERSCALE_G_CHK, m_G_ON);
	DDX_Check(pDX, IDC_VOICE1_USERSCALE_Gb_CHK, m_Gb_ON);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CV1UsrSclDlg, CDialog)
	//{{AFX_MSG_MAP(CV1UsrSclDlg)
	ON_BN_CLICKED(IDC_VOICE1_USERSCALE_A_CHK, OnVoice1UserscaleAChk)
	ON_BN_CLICKED(IDC_VOICE1_USERSCALE_Ab_CHK, OnVOICE1USERSCALEAbCHK)
	ON_BN_CLICKED(IDC_VOICE1_USERSCALE_B_CHK, OnVoice1UserscaleBChk)
	ON_BN_CLICKED(IDC_VOICE1_USERSCALE_Bb_CHK, OnVOICE1USERSCALEBbCHK)
	ON_BN_CLICKED(IDC_VOICE1_USERSCALE_C_CHK, OnVoice1UserscaleCChk)
	ON_BN_CLICKED(IDC_VOICE1_USERSCALE_D_CHK, OnVoice1UserscaleDChk)
	ON_BN_CLICKED(IDC_VOICE1_USERSCALE_Db_CHK, OnVOICE1USERSCALEDbCHK)
	ON_BN_CLICKED(IDC_VOICE1_USERSCALE_E_CHK, OnVoice1UserscaleEChk)
	ON_BN_CLICKED(IDC_VOICE1_USERSCALE_Eb_CHK, OnVOICE1USERSCALEEbCHK)
	ON_BN_CLICKED(IDC_VOICE1_USERSCALE_F_CHK, OnVoice1UserscaleFChk)
	ON_BN_CLICKED(IDC_VOICE1_USERSCALE_G_CHK, OnVoice1UserscaleGChk)
	ON_BN_CLICKED(IDC_VOICE1_USERSCALE_Gb_CHK, OnVOICE1USERSCALEGbCHK)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CV1UsrSclDlg message handlers

BOOL CV1UsrSclDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	SetWindowText(m_title);

	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
} 

void CV1UsrSclDlg::OnCancel() 
{
	// Do nothing
	
}

void CV1UsrSclDlg::OnOK() 
{
	if (!UpdateData(TRUE))
		return;

	if (m_numnotes<1)
	{
		MessageBox("Please choose at least one note.","too few notes", MB_OK+MB_ICONINFORMATION);

		return;
	}

	
	CDialog::OnOK();
}

void CV1UsrSclDlg::OnVoice1UserscaleAChk() 
{
	UpdateData(TRUE);

	if ( m_A_ON )
	{
		++m_numnotes;
		m_bUserScale[LA]=TRUE;
	}
	else
	{
		--m_numnotes;
		m_bUserScale[LA]=FALSE;
	}

	
	
}

void CV1UsrSclDlg::OnVOICE1USERSCALEAbCHK() 
{
	UpdateData(TRUE);

	if ( m_Ab_ON )
	{
		++m_numnotes;
		m_bUserScale[LAb]=TRUE;
	}
	else
	{
		--m_numnotes;
		m_bUserScale[LAb]=FALSE;
	}
	
}

void CV1UsrSclDlg::OnVoice1UserscaleBChk() 
{
	UpdateData(TRUE);

	if ( m_B_ON )
	{
		++m_numnotes;
		m_bUserScale[SI]=TRUE;
	}
	else
	{
		--m_numnotes;
		m_bUserScale[SI]=FALSE;
	}
	
}

void CV1UsrSclDlg::OnVOICE1USERSCALEBbCHK() 
{
	UpdateData(TRUE);

	if ( m_Bb_ON )
	{
		++m_numnotes;
		m_bUserScale[SIb]=TRUE;
	}
	else
	{
		--m_numnotes;
		m_bUserScale[SIb]=FALSE;
	}
	
}

void CV1UsrSclDlg::OnVoice1UserscaleCChk() 
{
	UpdateData(TRUE);

	if ( m_C_ON )
	{
		++m_numnotes;
		m_bUserScale[DO]=TRUE;
	}
	else
	{
		--m_numnotes;
		m_bUserScale[DO]=FALSE;
	}
	
}

void CV1UsrSclDlg::OnVoice1UserscaleDChk() 
{
	UpdateData(TRUE);

	if ( m_D_ON )
	{
		++m_numnotes;
		m_bUserScale[RE]=TRUE;
	}
	else
	{
		--m_numnotes;
		m_bUserScale[RE]=FALSE;
	}
	
}

void CV1UsrSclDlg::OnVOICE1USERSCALEDbCHK() 
{
	UpdateData(TRUE);

	if ( m_Db_ON )
	{
		++m_numnotes;
		m_bUserScale[REb]=TRUE;
	}
	else
	{
		--m_numnotes;
		m_bUserScale[REb]=FALSE;
	}
	
}

void CV1UsrSclDlg::OnVoice1UserscaleEChk() 
{
	UpdateData(TRUE);

	if ( m_E_ON )
	{
		++m_numnotes;
		m_bUserScale[MI]=TRUE;
	}
	else
	{
		--m_numnotes;
		m_bUserScale[MI]=FALSE;
	}
	
}

void CV1UsrSclDlg::OnVOICE1USERSCALEEbCHK() 
{
	UpdateData(TRUE);

	if ( m_Eb_ON )
	{
		++m_numnotes;
		m_bUserScale[MIb]=TRUE;
	}
	else
	{
		--m_numnotes;
		m_bUserScale[MIb]=FALSE;
	}
	
}

void CV1UsrSclDlg::OnVoice1UserscaleFChk() 
{
	UpdateData(TRUE);
	
	if ( m_F_ON )
	{
		++m_numnotes;
		m_bUserScale[FA]=TRUE;
	}
	else
	{
		--m_numnotes;
		m_bUserScale[FA]=FALSE;
	}
	
}

void CV1UsrSclDlg::OnVoice1UserscaleGChk() 
{
	UpdateData(TRUE);
	
	if ( m_G_ON )
	{
		++m_numnotes;
		m_bUserScale[SOL]=TRUE;
	}
	else
	{
		--m_numnotes;
		m_bUserScale[SOL]=FALSE;
	}
	
}

void CV1UsrSclDlg::OnVOICE1USERSCALEGbCHK() 
{
	UpdateData(TRUE);
	
	if ( m_Gb_ON )
	{
		++m_numnotes;
		m_bUserScale[SOLb]=TRUE;
	}
	else
	{
		--m_numnotes;
		m_bUserScale[SOLb]=FALSE;
	}
	
}
