
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


// WolframDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FractMus.h"
#include "WolframDlg.h"
#include "WolframGraph.h"

#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWolframDlg dialog

BOOL running = FALSE;
BOOL start = FALSE;
UINT ShowWolfram(LPVOID pObj);
extern float RanDev();

BYTE* wolfArray1;
BYTE* wolfArray2;



CWolframDlg::CWolframDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWolframDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWolframDlg)
	m_initconfig = 0;
	m_universesize = 0;
	m_rules = 0;
	m_bit0 = FALSE;
	m_bit1 = FALSE;
	m_bit2 = FALSE;
	m_bit3 = FALSE;
	m_bit4 = FALSE;
	m_bit5 = FALSE;
	m_bit6 = FALSE;
	m_bit7 = FALSE;
	//}}AFX_DATA_INIT

	m_pGraph = NULL;
	start = TRUE;
	wolfArray1 = NULL;
	wolfArray2 = NULL;
}


void CWolframDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWolframDlg)
	DDX_Text(pDX, IDC_INITCONFIG_ED, m_initconfig);
	DDV_MinMaxLong(pDX, m_initconfig, 1, 10000000000);
	DDX_Text(pDX, IDC_UNIVERSE_SIZE_ED, m_universesize);
	DDV_MinMaxInt(pDX, m_universesize, 128, 512);
	DDX_Text(pDX, IDC_RULES_ED, m_rules);
	DDV_MinMaxByte(pDX, m_rules, 0, 255);
	DDX_Check(pDX, IDC_RULES1, m_bit0);
	DDX_Check(pDX, IDC_RULES2, m_bit1);
	DDX_Check(pDX, IDC_RULES3, m_bit2);
	DDX_Check(pDX, IDC_RULES4, m_bit3);
	DDX_Check(pDX, IDC_RULES5, m_bit4);
	DDX_Check(pDX, IDC_RULES6, m_bit5);
	DDX_Check(pDX, IDC_RULES7, m_bit6);
	DDX_Check(pDX, IDC_RULES8, m_bit7);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CWolframDlg, CDialog)
	//{{AFX_MSG_MAP(CWolframDlg)
	ON_BN_CLICKED(IDC_RULES1, OnRules1)
	ON_BN_CLICKED(IDC_RULES2, OnRules2)
	ON_BN_CLICKED(IDC_RULES3, OnRules3)
	ON_BN_CLICKED(IDC_RULES4, OnRules4)
	ON_BN_CLICKED(IDC_RULES5, OnRules5)
	ON_BN_CLICKED(IDC_RULES6, OnRules6)
	ON_BN_CLICKED(IDC_RULES7, OnRules7)
	ON_BN_CLICKED(IDC_RULES8, OnRules8)
	ON_EN_CHANGE(IDC_RULES_ED, OnChangeRulesEd)
	ON_BN_CLICKED(IDC_VISUALIZE, OnVisualize)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWolframDlg message handlers

void CWolframDlg::OnRules1() 
{
	UpdateRules();
	
}

void CWolframDlg::OnRules2() 
{

	UpdateRules();
	
}

void CWolframDlg::OnRules3() 
{

	UpdateRules();
	
}

void CWolframDlg::OnRules4() 
{

	UpdateRules();
	
}

void CWolframDlg::OnRules5() 
{

	UpdateRules();
	
}

void CWolframDlg::OnRules6() 
{

	UpdateRules();
	
}

void CWolframDlg::OnRules7() 
{

	UpdateRules();
	
}

void CWolframDlg::OnRules8() 
{
	UpdateRules();
	
}

void CWolframDlg::OnChangeRulesEd() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_CHANGE flag ORed into the lParam mask.
	
	UpdateBits();
	
}

void CWolframDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	if (m_pGraph)
		m_pGraph->PostMessage(WM_CLOSE);
	
	CDialog::OnCancel();

}

void CWolframDlg::OnOK() 
{
	if (!UpdateData())
		return;
	if (m_pGraph)
		m_pGraph->PostMessage(WM_CLOSE);
	
	CDialog::OnOK();
}

BOOL CWolframDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	SetWindowText(title);
	
	UpdateBits();



	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CWolframDlg::UpdateBits() 
{
	if (!UpdateData())
		return;

	m_bit0 = m_rules&0x01 ? TRUE : FALSE;
	m_bit1 = m_rules&0x02 ? TRUE : FALSE;
	m_bit2 = m_rules&0x04 ? TRUE : FALSE;
	m_bit3 = m_rules&0x08 ? TRUE : FALSE;
	m_bit4 = m_rules&0x10 ? TRUE : FALSE;
	m_bit5 = m_rules&0x20 ? TRUE : FALSE;
	m_bit6 = m_rules&0x40 ? TRUE : FALSE;
	m_bit7 = m_rules&0x80 ? TRUE : FALSE;

	UpdateData(FALSE);
	start = TRUE;
	if (m_pGraph)
		m_pGraph->PostMessage(WM_CLOSE);

}

void CWolframDlg::UpdateRules() 
{
	if (!UpdateData())
		return;

	m_rules = 0;

	m_rules += (unsigned)pow(2,0)*m_bit0;
	m_rules += (unsigned)pow(2,1)*m_bit1;
	m_rules += (unsigned)pow(2,2)*m_bit2;
	m_rules += (unsigned)pow(2,3)*m_bit3;
	m_rules += (unsigned)pow(2,4)*m_bit4;
	m_rules += (unsigned)pow(2,5)*m_bit5;
	m_rules += (unsigned)pow(2,6)*m_bit6;
	m_rules += (unsigned)pow(2,7)*m_bit7;

	UpdateData(FALSE);

	start = TRUE;

	if (m_pGraph)
		m_pGraph->PostMessage(WM_CLOSE);



}



void CWolframDlg::OnVisualize() 
{

	if (!UpdateData())
		return;


	running = !running;

	
		

	if (m_pGraph!=NULL)
	{
		m_pGraph->SetForegroundWindow();
		if (running)
		{
			GetDlgItem(IDC_VISUALIZE)->SetWindowText("Stop");
			AfxBeginThread(ShowWolfram, this);
		}


		if (!running)
			GetDlgItem(IDC_VISUALIZE)->SetWindowText("Run");

		return;
	}
	start = TRUE;
	int maxX = m_universesize + ::GetSystemMetrics(SM_CXSIZEFRAME)*2;
	int maxY = 300 + ::GetSystemMetrics(SM_CYCAPTION)+::GetSystemMetrics(SM_CXSIZEFRAME);


	CClientDC dc(m_pGraph);
	m_pGraph = new CWolframGraph;
	CRect r(0,0,maxX,maxY);
	/*LOGBRUSH lb;

	lb.lbStyle = BS_SOLID;
	lb.lbColor = RGB(0,0,0);
	lb.lbHatch = HS_CROSS;*/


	m_pGraph->m_memDC.CreateCompatibleDC(&dc);
	m_pGraph->m_bmp.CreateCompatibleBitmap(&dc, m_universesize, 300);
	m_pGraph->m_memDC.SelectObject(&(m_pGraph->m_bmp));
	m_pGraph->m_bkbrush.CreateSolidBrush(RGB(0,0,0));
	m_pGraph->m_memDC.SelectObject(&(m_pGraph->m_bkbrush));
	m_pGraph->m_Pen.CreatePen(PS_SOLID, 0, RGB(255,0,0));
	m_pGraph->m_memDC.SelectObject(&(m_pGraph->m_Pen));
	m_pGraph->m_memDC.PatBlt(0,0,m_universesize,300,PATCOPY);
	m_pGraph->m_pParent = this;
	m_pGraph->Create(	NULL, "",
						WS_CAPTION|WS_SYSMENU|WS_VISIBLE, r
						   );

	GetDlgItem(IDC_UNIVERSE_SIZE_ED)->EnableWindow(FALSE);
	GetDlgItem(IDC_INITCONFIG_ED)->EnableWindow(FALSE);
	GetDlgItem(IDOK)->EnableWindow(FALSE);
	GetDlgItem(IDCANCEL)->EnableWindow(FALSE);

	running = TRUE;
	GetDlgItem(IDC_VISUALIZE)->SetWindowText("Stop");
	

	AfxBeginThread(ShowWolfram, this);

		
}

UINT ShowWolfram(LPVOID pObj)
{
	CWolframDlg* Wp = (CWolframDlg*)pObj;

	static counter=0;

	if (start)
	{
		counter =0;
		if (wolfArray1)
		{
			delete wolfArray1;
			wolfArray1 = NULL;
		}
		if (wolfArray2)
		{
			delete wolfArray2;
			wolfArray2 = NULL;
		}
		wolfArray1 = new BYTE[Wp->m_universesize];
		wolfArray2 = new BYTE[Wp->m_universesize];

		for (int idx = 0; idx<32; idx++)
				wolfArray1[idx] = Wp->m_initconfig & unsigned long (pow(2, idx)) ? 1 : 0;

		if (Wp->m_universesize>32)
		{
			for (idx = 32; idx<Wp->m_universesize; idx++)
				wolfArray1[idx] = 0;
		}


	}


	while (running)
	{
		int type;
		unsigned char cellLEFT, cellRIGHT, cell;
		unsigned left, right;

		for(int x = 0; x<Wp->m_universesize; x++)
		{
			COLORREF color;
			color = wolfArray1[x] ? RGB(255,128,64) : RGB(0,0,0);
			if (::IsWindow(Wp->m_pGraph->m_hWnd))
				Wp->m_pGraph->m_memDC.SetPixel(x, counter, color);
		}
		if (::IsWindow(Wp->m_pGraph->m_hWnd))
			Wp->m_pGraph->RedrawWindow(NULL,NULL,RDW_INVALIDATE|RDW_UPDATENOW|RDW_NOERASE);	
		counter++;
		if (counter>299)
			counter =0;



				for (int i=0; i<Wp->m_universesize; i++)
				{
					cell = wolfArray1[i];
					
					right = (i+1)<Wp->m_universesize ? i+1: 0;
					left  = (i-1)>-1 ?  i-1: Wp->m_universesize-1;

					cellLEFT = wolfArray1[left];
					cellRIGHT = wolfArray1[right];

					if (!cellLEFT&&!cell&&!cellRIGHT)
						type = 0;
					if (!cellLEFT&&!cell&&cellRIGHT)
						type = 1;
					if (!cellLEFT&&cell&&!cellRIGHT)
						type = 2;
					if (!cellLEFT&&cell&&cellRIGHT)
						type = 3;
					if (cellLEFT&&!cell&&!cellRIGHT)
						type = 4;
					if (cellLEFT&&!cell&&cellRIGHT)
						type = 5;
					if (cellLEFT&&cell&&!cellRIGHT)
						type = 6;
					if (cellLEFT&&cell&&cellRIGHT)
						type = 7;

					switch (type)

					{
						case 0:
							wolfArray2[i] = Wp->m_rules&0x01? 1 : 0;
							break;
						case 1:
							wolfArray2[i] = Wp->m_rules&0x02? 1 : 0;
							break;
						case 2:
							wolfArray2[i] = Wp->m_rules&0x04? 1 : 0;
							break;
						case 3:
							wolfArray2[i] = Wp->m_rules&0x08? 1 : 0;
							break;
						case 4:
							wolfArray2[i] = Wp->m_rules&0x10? 1 : 0;
							break;
						case 5:
							wolfArray2[i] = Wp->m_rules&0x20? 1 : 0;
							break;
						case 6:
							wolfArray2[i] = Wp->m_rules&0x40? 1 : 0;
							break;
						case 7:
							wolfArray2[i] = Wp->m_rules&0x80? 1 : 0;
							break;
					}
				}

				for (i = 0; i<Wp->m_universesize; i++)
					wolfArray1[i] = wolfArray2[i];


	}

	start = FALSE;

	return 0;
	


}
