
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


// WolframGraph.cpp : implementation file
//

#include "stdafx.h"
#include "FractMus.h"
#include "WolframGraph.h"
#include "WolframDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern running;
extern start;

/////////////////////////////////////////////////////////////////////////////
// CWolframGraph

IMPLEMENT_DYNCREATE(CWolframGraph, CFrameWnd)

CWolframGraph::CWolframGraph()
{
}

CWolframGraph::~CWolframGraph()
{
}


BEGIN_MESSAGE_MAP(CWolframGraph, CFrameWnd)
	//{{AFX_MSG_MAP(CWolframGraph)
	ON_WM_PAINT()
	ON_WM_DESTROY()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWolframGraph message handlers

void CWolframGraph::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	if ( ::IsWindow(((CWolframDlg*)m_pParent)->m_pGraph->m_hWnd) )
		dc.BitBlt(0,0,((CWolframDlg*)m_pParent)->m_universesize,300,&m_memDC,0,0,SRCCOPY);
	
	
	// Do not call CFrameWnd::OnPaint() for painting messages
}

void CWolframGraph::PostNcDestroy() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	//CFrameWnd::PostNcDestroy();
	delete this;
}

void CWolframGraph::OnDestroy() 
{
	//CFrameWnd::OnDestroy();
	
	CFrameWnd::OnDestroy();
	running = FALSE;
	start = TRUE;

	Sleep(100);
	
	((CWolframDlg*)m_pParent)->m_pGraph = NULL;


	if (::IsWindow(m_pParent->m_hWnd))
	{
		((CWolframDlg*)m_pParent)->GetDlgItem(IDC_VISUALIZE)->SetWindowText("Visualize");	
		((CWolframDlg*)m_pParent)->GetDlgItem(IDC_UNIVERSE_SIZE_ED)->EnableWindow(TRUE);
		((CWolframDlg*)m_pParent)->GetDlgItem(IDC_INITCONFIG_ED)->EnableWindow(TRUE);
		((CWolframDlg*)m_pParent)->GetDlgItem(IDOK)->EnableWindow(TRUE);
		((CWolframDlg*)m_pParent)->GetDlgItem(IDCANCEL)->EnableWindow(TRUE);
	}



}

void CWolframGraph::OnClose() 
{
	running = FALSE;
	Sleep(100);
	
	CFrameWnd::OnClose();
}

BOOL CWolframGraph::Create(	LPCTSTR lpszClassName, 
						LPCTSTR lpszWindowName, 
						DWORD dwStyle, 
						const RECT& rect, 
						CWnd* pParentWnd, 
						LPCTSTR lpszMenuName,
						DWORD dwExStyle, 
						CCreateContext* pContext)
{

	return CFrameWnd::Create(	lpszClassName,lpszWindowName,
								dwStyle, rect, pParentWnd,
								lpszMenuName, dwExStyle,
								pContext
							);
}
