
/*************************************************************************


Copyright 1998, 1999, 2000 Gustavo Diaz-Jerez


This file is part of FractMus.

    FractMus is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FractMus is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FractMus; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


**************************************************************************/


#ifndef EVENT_H
#define EVENT_H 

struct tagEvent
{
	long		count; //first Event must start in count 0
	long		genCount;
	BOOL		IsActive[MAXVOICES];
	long		Base[MAXVOICES];
	long		Multi[MAXVOICES];
	long		StartNum[MAXVOICES];
	int			NumOcts[MAXVOICES];
	BOOL		Modulates[MAXVOICES];
	BOOL		ModulRandom[MAXVOICES];
	int			ModulNum[MAXVOICES];
	int			Note[MAXVOICES];
	int*		pScale[MAXVOICES];
	int*		pUserScale[MAXVOICES];
	float		NoteValue[MAXVOICES];
	int			Instrument[MAXVOICES];
	int			Channel[MAXVOICES];
	BOOL		Mode[MAXVOICES];
	int			ScaleID[MAXVOICES];
	int			NumOctsID[MAXVOICES];
	int			NoteValueID[MAXVOICES];
	short		AlgorithmNum[MAXVOICES];
	int			Tempo;
	BOOL		Inverted[MAXVOICES];
	int			Dynamic[MAXVOICES];
	int			DynChoice[MAXVOICES];
	int			Pan[MAXVOICES];
	float		LogMapVar[MAXVOICES];
	float		FNoiseVar[MAXVOICES];
	float		HenonA[MAXVOICES];
	float		HenonB[MAXVOICES];
	float		HopalongVar[MAXVOICES];
	float		MartinVar[MAXVOICES];
	float		GingerX[MAXVOICES];
	float		GingerY[MAXVOICES];
	float		LorentzVar[MAXVOICES];

	unsigned long EarthWormVar[MAXVOICES];
	unsigned long EarthWormMulti[MAXVOICES];
	unsigned EarthWormTruncator[MAXVOICES];
	double	RandomMin[MAXVOICES];
	double	RandomMax[MAXVOICES];

	BYTE	WolframRule[MAXVOICES];
	unsigned long WolframInit[MAXVOICES];
	int	WolframSize[MAXVOICES];
	long	Hailstone[MAXVOICES];

	BOOL		MatchScale[MAXVOICES];
	int			Percussion[MAXVOICES];

	short		TimeSigNum;
	short		TimeSigDen;



tagEvent()
{
	for(int i = VOICE1; i<MAXVOICES; i++)
	{
		pScale[i] = NULL;
	}

	for(i = VOICE1; i<MAXVOICES; i++)
	{
		pUserScale[i] = NULL;
	}
}

~tagEvent()
{
	for(int i = VOICE1; i<MAXVOICES; i++)
		if (pScale[i])
		{
			delete pScale[i];
			pScale[i] = NULL;
		}

	for(i = VOICE1; i<MAXVOICES; i++)
		if (pUserScale[i])
		{
			delete pUserScale[i];
			pUserScale[i] = NULL;
		}
}

	
};

#endif